=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.5.1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXT
  class ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a DHCP Relay Service
    # Creates a dhcp relay service. 
    # @param dhcp_relay_service 
    # @param [Hash] opts the optional parameters
    # @return [DhcpRelayService]
    def create_dhcp_relay(dhcp_relay_service, opts = {})
      data, _status_code, _headers = create_dhcp_relay_with_http_info(dhcp_relay_service, opts)
      data
    end

    # Create a DHCP Relay Service
    # Creates a dhcp relay service. 
    # @param dhcp_relay_service 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DhcpRelayService, Fixnum, Hash)>] DhcpRelayService data, response status code and response headers
    def create_dhcp_relay_with_http_info(dhcp_relay_service, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi.create_dhcp_relay ...'
      end
      # verify the required parameter 'dhcp_relay_service' is set
      if @api_client.config.client_side_validation && dhcp_relay_service.nil?
        fail ArgumentError, "Missing the required parameter 'dhcp_relay_service' when calling ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi.create_dhcp_relay"
      end
      # resource path
      local_var_path = '/dhcp/relays'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(dhcp_relay_service)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DhcpRelayService')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi#create_dhcp_relay\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete a DHCP Relay Service
    # Deletes the specified dhcp relay service.
    # @param relay_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_dhcp_relay(relay_id, opts = {})
      delete_dhcp_relay_with_http_info(relay_id, opts)
      nil
    end

    # Delete a DHCP Relay Service
    # Deletes the specified dhcp relay service.
    # @param relay_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_dhcp_relay_with_http_info(relay_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi.delete_dhcp_relay ...'
      end
      # verify the required parameter 'relay_id' is set
      if @api_client.config.client_side_validation && relay_id.nil?
        fail ArgumentError, "Missing the required parameter 'relay_id' when calling ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi.delete_dhcp_relay"
      end
      # resource path
      local_var_path = '/dhcp/relays/{relay-id}'.sub('{' + 'relay-id' + '}', relay_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi#delete_dhcp_relay\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all DHCP Relay Services
    # Returns information about all configured dhcp relay services. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [DhcpRelayServiceListResult]
    def list_dhcp_relays(opts = {})
      data, _status_code, _headers = list_dhcp_relays_with_http_info(opts)
      data
    end

    # List all DHCP Relay Services
    # Returns information about all configured dhcp relay services. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(DhcpRelayServiceListResult, Fixnum, Hash)>] DhcpRelayServiceListResult data, response status code and response headers
    def list_dhcp_relays_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi.list_dhcp_relays ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi.list_dhcp_relays, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi.list_dhcp_relays, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/dhcp/relays'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DhcpRelayServiceListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi#list_dhcp_relays\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read a DHCP Relay Service
    # Returns the dhcp relay service information.
    # @param relay_id 
    # @param [Hash] opts the optional parameters
    # @return [DhcpRelayService]
    def read_dhcp_relay(relay_id, opts = {})
      data, _status_code, _headers = read_dhcp_relay_with_http_info(relay_id, opts)
      data
    end

    # Read a DHCP Relay Service
    # Returns the dhcp relay service information.
    # @param relay_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DhcpRelayService, Fixnum, Hash)>] DhcpRelayService data, response status code and response headers
    def read_dhcp_relay_with_http_info(relay_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi.read_dhcp_relay ...'
      end
      # verify the required parameter 'relay_id' is set
      if @api_client.config.client_side_validation && relay_id.nil?
        fail ArgumentError, "Missing the required parameter 'relay_id' when calling ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi.read_dhcp_relay"
      end
      # resource path
      local_var_path = '/dhcp/relays/{relay-id}'.sub('{' + 'relay-id' + '}', relay_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DhcpRelayService')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi#read_dhcp_relay\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update a DHCP Relay Service
    # Modifies the specified dhcp relay service. 
    # @param relay_id 
    # @param dhcp_relay_service 
    # @param [Hash] opts the optional parameters
    # @return [DhcpRelayService]
    def update_dhcp_relay(relay_id, dhcp_relay_service, opts = {})
      data, _status_code, _headers = update_dhcp_relay_with_http_info(relay_id, dhcp_relay_service, opts)
      data
    end

    # Update a DHCP Relay Service
    # Modifies the specified dhcp relay service. 
    # @param relay_id 
    # @param dhcp_relay_service 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DhcpRelayService, Fixnum, Hash)>] DhcpRelayService data, response status code and response headers
    def update_dhcp_relay_with_http_info(relay_id, dhcp_relay_service, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi.update_dhcp_relay ...'
      end
      # verify the required parameter 'relay_id' is set
      if @api_client.config.client_side_validation && relay_id.nil?
        fail ArgumentError, "Missing the required parameter 'relay_id' when calling ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi.update_dhcp_relay"
      end
      # verify the required parameter 'dhcp_relay_service' is set
      if @api_client.config.client_side_validation && dhcp_relay_service.nil?
        fail ArgumentError, "Missing the required parameter 'dhcp_relay_service' when calling ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi.update_dhcp_relay"
      end
      # resource path
      local_var_path = '/dhcp/relays/{relay-id}'.sub('{' + 'relay-id' + '}', relay_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(dhcp_relay_service)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DhcpRelayService')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiLogicalRoutingAndServicesDhcpRelayApi#update_dhcp_relay\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
