=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.5.1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXT
  class ManagementPlaneApiMigrationSetupApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # NSX-V setup details
    # Get setup details of NSX-V to be migrated. 
    # @param [Hash] opts the optional parameters
    # @return [MigrationSetupInfo]
    def get_nsxv_setup_details(opts = {})
      data, _status_code, _headers = get_nsxv_setup_details_with_http_info(opts)
      data
    end

    # NSX-V setup details
    # Get setup details of NSX-V to be migrated. 
    # @param [Hash] opts the optional parameters
    # @return [Array<(MigrationSetupInfo, Fixnum, Hash)>] MigrationSetupInfo data, response status code and response headers
    def get_nsxv_setup_details_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiMigrationSetupApi.get_nsxv_setup_details ...'
      end
      # resource path
      local_var_path = '/migration/setup'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'MigrationSetupInfo')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiMigrationSetupApi#get_nsxv_setup_details\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # NSX-V setup details
    # Provide setup details of NSX-V to be migrated. 
    # @param migration_setup_info 
    # @param [Hash] opts the optional parameters
    # @return [MigrationSetupInfo]
    def update_nsxv_setup_details(migration_setup_info, opts = {})
      data, _status_code, _headers = update_nsxv_setup_details_with_http_info(migration_setup_info, opts)
      data
    end

    # NSX-V setup details
    # Provide setup details of NSX-V to be migrated. 
    # @param migration_setup_info 
    # @param [Hash] opts the optional parameters
    # @return [Array<(MigrationSetupInfo, Fixnum, Hash)>] MigrationSetupInfo data, response status code and response headers
    def update_nsxv_setup_details_with_http_info(migration_setup_info, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiMigrationSetupApi.update_nsxv_setup_details ...'
      end
      # verify the required parameter 'migration_setup_info' is set
      if @api_client.config.client_side_validation && migration_setup_info.nil?
        fail ArgumentError, "Missing the required parameter 'migration_setup_info' when calling ManagementPlaneApiMigrationSetupApi.update_nsxv_setup_details"
      end
      # resource path
      local_var_path = '/migration/setup'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(migration_setup_info)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'MigrationSetupInfo')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiMigrationSetupApi#update_nsxv_setup_details\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
