=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.5.1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXT
  class ManagementPlaneApiNsxComponentAdministrationNsxAdministrationApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Read NSX Management nodes global configuration.
    # Returns the NSX Management nodes global configuration. 
    # @param [Hash] opts the optional parameters
    # @return [ManagementConfig]
    def read_management_config(opts = {})
      data, _status_code, _headers = read_management_config_with_http_info(opts)
      data
    end

    # Read NSX Management nodes global configuration.
    # Returns the NSX Management nodes global configuration. 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ManagementConfig, Fixnum, Hash)>] ManagementConfig data, response status code and response headers
    def read_management_config_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiNsxComponentAdministrationNsxAdministrationApi.read_management_config ...'
      end
      # resource path
      local_var_path = '/configs/management'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ManagementConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiNsxComponentAdministrationNsxAdministrationApi#read_management_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update NSX Management nodes global configuration
    # Modifies the NSX Management nodes global configuration.
    # @param management_config 
    # @param [Hash] opts the optional parameters
    # @return [ManagementConfig]
    def update_management_config(management_config, opts = {})
      data, _status_code, _headers = update_management_config_with_http_info(management_config, opts)
      data
    end

    # Update NSX Management nodes global configuration
    # Modifies the NSX Management nodes global configuration.
    # @param management_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ManagementConfig, Fixnum, Hash)>] ManagementConfig data, response status code and response headers
    def update_management_config_with_http_info(management_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiNsxComponentAdministrationNsxAdministrationApi.update_management_config ...'
      end
      # verify the required parameter 'management_config' is set
      if @api_client.config.client_side_validation && management_config.nil?
        fail ArgumentError, "Missing the required parameter 'management_config' when calling ManagementPlaneApiNsxComponentAdministrationNsxAdministrationApi.update_management_config"
      end
      # resource path
      local_var_path = '/configs/management'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(management_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ManagementConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiNsxComponentAdministrationNsxAdministrationApi#update_management_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
