=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.5.1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXT
  class ManagementPlaneApiTroubleshootingAndMonitoringPortConnectionApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Get networking entities between two logical ports with VIF attachment
    # Get networking entities between two logical ports with VIF attachment
    # @param lport_id ID of source port
    # @param peer_port_id ID of peer port
    # @param [Hash] opts the optional parameters
    # @return [PortConnectionEntities]
    def get_forwarding_path(lport_id, peer_port_id, opts = {})
      data, _status_code, _headers = get_forwarding_path_with_http_info(lport_id, peer_port_id, opts)
      data
    end

    # Get networking entities between two logical ports with VIF attachment
    # Get networking entities between two logical ports with VIF attachment
    # @param lport_id ID of source port
    # @param peer_port_id ID of peer port
    # @param [Hash] opts the optional parameters
    # @return [Array<(PortConnectionEntities, Fixnum, Hash)>] PortConnectionEntities data, response status code and response headers
    def get_forwarding_path_with_http_info(lport_id, peer_port_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiTroubleshootingAndMonitoringPortConnectionApi.get_forwarding_path ...'
      end
      # verify the required parameter 'lport_id' is set
      if @api_client.config.client_side_validation && lport_id.nil?
        fail ArgumentError, "Missing the required parameter 'lport_id' when calling ManagementPlaneApiTroubleshootingAndMonitoringPortConnectionApi.get_forwarding_path"
      end
      # verify the required parameter 'peer_port_id' is set
      if @api_client.config.client_side_validation && peer_port_id.nil?
        fail ArgumentError, "Missing the required parameter 'peer_port_id' when calling ManagementPlaneApiTroubleshootingAndMonitoringPortConnectionApi.get_forwarding_path"
      end
      # resource path
      local_var_path = '/logical-ports/{lport-id}/forwarding-path'.sub('{' + 'lport-id' + '}', lport_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'peer_port_id'] = peer_port_id

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PortConnectionEntities')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiTroubleshootingAndMonitoringPortConnectionApi#get_forwarding_path\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
