=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.5.1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXT
  class ManagementPlaneApiVpnIpsecPeerEndpointsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create custom peer endpoint
    # Create custom IPSec peer endpoint.
    # @param ip_sec_vpn_peer_endpoint 
    # @param [Hash] opts the optional parameters
    # @return [IPSecVPNPeerEndpoint]
    def create_ip_sec_vpn_peer_end_point(ip_sec_vpn_peer_endpoint, opts = {})
      data, _status_code, _headers = create_ip_sec_vpn_peer_end_point_with_http_info(ip_sec_vpn_peer_endpoint, opts)
      data
    end

    # Create custom peer endpoint
    # Create custom IPSec peer endpoint.
    # @param ip_sec_vpn_peer_endpoint 
    # @param [Hash] opts the optional parameters
    # @return [Array<(IPSecVPNPeerEndpoint, Fixnum, Hash)>] IPSecVPNPeerEndpoint data, response status code and response headers
    def create_ip_sec_vpn_peer_end_point_with_http_info(ip_sec_vpn_peer_endpoint, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiVpnIpsecPeerEndpointsApi.create_ip_sec_vpn_peer_end_point ...'
      end
      # verify the required parameter 'ip_sec_vpn_peer_endpoint' is set
      if @api_client.config.client_side_validation && ip_sec_vpn_peer_endpoint.nil?
        fail ArgumentError, "Missing the required parameter 'ip_sec_vpn_peer_endpoint' when calling ManagementPlaneApiVpnIpsecPeerEndpointsApi.create_ip_sec_vpn_peer_end_point"
      end
      # resource path
      local_var_path = '/vpn/ipsec/peer-endpoints'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(ip_sec_vpn_peer_endpoint)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'IPSecVPNPeerEndpoint')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiVpnIpsecPeerEndpointsApi#create_ip_sec_vpn_peer_end_point\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete custom IPSec VPN peer endpoint
    # Delete custom IPSec VPN peer endpoint. All references are strong references and dependent peer endpoints can not be deleted if being referenced.
    # @param ipsec_vpn_peer_endpoint_id 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :force Force delete the resource even if it is being used somewhere  (default to false)
    # @return [nil]
    def delete_ip_sec_vpn_peer_endpoint(ipsec_vpn_peer_endpoint_id, opts = {})
      delete_ip_sec_vpn_peer_endpoint_with_http_info(ipsec_vpn_peer_endpoint_id, opts)
      nil
    end

    # Delete custom IPSec VPN peer endpoint
    # Delete custom IPSec VPN peer endpoint. All references are strong references and dependent peer endpoints can not be deleted if being referenced.
    # @param ipsec_vpn_peer_endpoint_id 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :force Force delete the resource even if it is being used somewhere 
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_ip_sec_vpn_peer_endpoint_with_http_info(ipsec_vpn_peer_endpoint_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiVpnIpsecPeerEndpointsApi.delete_ip_sec_vpn_peer_endpoint ...'
      end
      # verify the required parameter 'ipsec_vpn_peer_endpoint_id' is set
      if @api_client.config.client_side_validation && ipsec_vpn_peer_endpoint_id.nil?
        fail ArgumentError, "Missing the required parameter 'ipsec_vpn_peer_endpoint_id' when calling ManagementPlaneApiVpnIpsecPeerEndpointsApi.delete_ip_sec_vpn_peer_endpoint"
      end
      # resource path
      local_var_path = '/vpn/ipsec/peer-endpoints/{ipsec-vpn-peer-endpoint-id}'.sub('{' + 'ipsec-vpn-peer-endpoint-id' + '}', ipsec_vpn_peer_endpoint_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'force'] = opts[:'force'] if !opts[:'force'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiVpnIpsecPeerEndpointsApi#delete_ip_sec_vpn_peer_endpoint\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get IPSec VPN peer endpoint
    # Get custom IPSec VPN peer endpoint.
    # @param ipsec_vpn_peer_endpoint_id 
    # @param [Hash] opts the optional parameters
    # @return [IPSecVPNPeerEndpoint]
    def get_ip_sec_vpn_peer_endpoint(ipsec_vpn_peer_endpoint_id, opts = {})
      data, _status_code, _headers = get_ip_sec_vpn_peer_endpoint_with_http_info(ipsec_vpn_peer_endpoint_id, opts)
      data
    end

    # Get IPSec VPN peer endpoint
    # Get custom IPSec VPN peer endpoint.
    # @param ipsec_vpn_peer_endpoint_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(IPSecVPNPeerEndpoint, Fixnum, Hash)>] IPSecVPNPeerEndpoint data, response status code and response headers
    def get_ip_sec_vpn_peer_endpoint_with_http_info(ipsec_vpn_peer_endpoint_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiVpnIpsecPeerEndpointsApi.get_ip_sec_vpn_peer_endpoint ...'
      end
      # verify the required parameter 'ipsec_vpn_peer_endpoint_id' is set
      if @api_client.config.client_side_validation && ipsec_vpn_peer_endpoint_id.nil?
        fail ArgumentError, "Missing the required parameter 'ipsec_vpn_peer_endpoint_id' when calling ManagementPlaneApiVpnIpsecPeerEndpointsApi.get_ip_sec_vpn_peer_endpoint"
      end
      # resource path
      local_var_path = '/vpn/ipsec/peer-endpoints/{ipsec-vpn-peer-endpoint-id}'.sub('{' + 'ipsec-vpn-peer-endpoint-id' + '}', ipsec_vpn_peer_endpoint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'IPSecVPNPeerEndpoint')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiVpnIpsecPeerEndpointsApi#get_ip_sec_vpn_peer_endpoint\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get IPSec VPN peer endpoint with PSK
    # Get custom IPSec VPN peer endpoint with PSK.
    # @param ipsec_vpn_peer_endpoint_id 
    # @param [Hash] opts the optional parameters
    # @return [IPSecVPNPeerEndpoint]
    def get_ip_sec_vpn_peer_endpoint_with_psk_show_sensitive_data(ipsec_vpn_peer_endpoint_id, opts = {})
      data, _status_code, _headers = get_ip_sec_vpn_peer_endpoint_with_psk_show_sensitive_data_with_http_info(ipsec_vpn_peer_endpoint_id, opts)
      data
    end

    # Get IPSec VPN peer endpoint with PSK
    # Get custom IPSec VPN peer endpoint with PSK.
    # @param ipsec_vpn_peer_endpoint_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(IPSecVPNPeerEndpoint, Fixnum, Hash)>] IPSecVPNPeerEndpoint data, response status code and response headers
    def get_ip_sec_vpn_peer_endpoint_with_psk_show_sensitive_data_with_http_info(ipsec_vpn_peer_endpoint_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiVpnIpsecPeerEndpointsApi.get_ip_sec_vpn_peer_endpoint_with_psk_show_sensitive_data ...'
      end
      # verify the required parameter 'ipsec_vpn_peer_endpoint_id' is set
      if @api_client.config.client_side_validation && ipsec_vpn_peer_endpoint_id.nil?
        fail ArgumentError, "Missing the required parameter 'ipsec_vpn_peer_endpoint_id' when calling ManagementPlaneApiVpnIpsecPeerEndpointsApi.get_ip_sec_vpn_peer_endpoint_with_psk_show_sensitive_data"
      end
      # resource path
      local_var_path = '/vpn/ipsec/peer-endpoints/{ipsec-vpn-peer-endpoint-id}?action=show-sensitive-data'.sub('{' + 'ipsec-vpn-peer-endpoint-id' + '}', ipsec_vpn_peer_endpoint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'IPSecVPNPeerEndpoint')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiVpnIpsecPeerEndpointsApi#get_ip_sec_vpn_peer_endpoint_with_psk_show_sensitive_data\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get IPSecVPNPeerEndpoint List Result
    # Get paginated list of all peer endpoint.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [IPSecVPNPeerEndpointListResult]
    def list_ip_sec_vpn_peer_endpoints(opts = {})
      data, _status_code, _headers = list_ip_sec_vpn_peer_endpoints_with_http_info(opts)
      data
    end

    # Get IPSecVPNPeerEndpoint List Result
    # Get paginated list of all peer endpoint.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(IPSecVPNPeerEndpointListResult, Fixnum, Hash)>] IPSecVPNPeerEndpointListResult data, response status code and response headers
    def list_ip_sec_vpn_peer_endpoints_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiVpnIpsecPeerEndpointsApi.list_ip_sec_vpn_peer_endpoints ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling ManagementPlaneApiVpnIpsecPeerEndpointsApi.list_ip_sec_vpn_peer_endpoints, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling ManagementPlaneApiVpnIpsecPeerEndpointsApi.list_ip_sec_vpn_peer_endpoints, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/vpn/ipsec/peer-endpoints'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'IPSecVPNPeerEndpointListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiVpnIpsecPeerEndpointsApi#list_ip_sec_vpn_peer_endpoints\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Edit custom IPSecPeerEndpoint
    # Edit custom IPSec peer endpoint. System owned endpoints are non editable.
    # @param ipsec_vpn_peer_endpoint_id 
    # @param ip_sec_vpn_peer_endpoint 
    # @param [Hash] opts the optional parameters
    # @return [IPSecVPNPeerEndpoint]
    def update_ip_sec_vpn_peer_endpoint(ipsec_vpn_peer_endpoint_id, ip_sec_vpn_peer_endpoint, opts = {})
      data, _status_code, _headers = update_ip_sec_vpn_peer_endpoint_with_http_info(ipsec_vpn_peer_endpoint_id, ip_sec_vpn_peer_endpoint, opts)
      data
    end

    # Edit custom IPSecPeerEndpoint
    # Edit custom IPSec peer endpoint. System owned endpoints are non editable.
    # @param ipsec_vpn_peer_endpoint_id 
    # @param ip_sec_vpn_peer_endpoint 
    # @param [Hash] opts the optional parameters
    # @return [Array<(IPSecVPNPeerEndpoint, Fixnum, Hash)>] IPSecVPNPeerEndpoint data, response status code and response headers
    def update_ip_sec_vpn_peer_endpoint_with_http_info(ipsec_vpn_peer_endpoint_id, ip_sec_vpn_peer_endpoint, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiVpnIpsecPeerEndpointsApi.update_ip_sec_vpn_peer_endpoint ...'
      end
      # verify the required parameter 'ipsec_vpn_peer_endpoint_id' is set
      if @api_client.config.client_side_validation && ipsec_vpn_peer_endpoint_id.nil?
        fail ArgumentError, "Missing the required parameter 'ipsec_vpn_peer_endpoint_id' when calling ManagementPlaneApiVpnIpsecPeerEndpointsApi.update_ip_sec_vpn_peer_endpoint"
      end
      # verify the required parameter 'ip_sec_vpn_peer_endpoint' is set
      if @api_client.config.client_side_validation && ip_sec_vpn_peer_endpoint.nil?
        fail ArgumentError, "Missing the required parameter 'ip_sec_vpn_peer_endpoint' when calling ManagementPlaneApiVpnIpsecPeerEndpointsApi.update_ip_sec_vpn_peer_endpoint"
      end
      # resource path
      local_var_path = '/vpn/ipsec/peer-endpoints/{ipsec-vpn-peer-endpoint-id}'.sub('{' + 'ipsec-vpn-peer-endpoint-id' + '}', ipsec_vpn_peer_endpoint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(ip_sec_vpn_peer_endpoint)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'IPSecVPNPeerEndpoint')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiVpnIpsecPeerEndpointsApi#update_ip_sec_vpn_peer_endpoint\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
