=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.5.1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXT
  class ManagementPlaneApiVpnL2VpnServicesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create L2VPN service
    # Create L2VPN service for a given logical router
    # @param l2_vpn_service 
    # @param [Hash] opts the optional parameters
    # @return [L2VpnService]
    def create_l2_vpn_service(l2_vpn_service, opts = {})
      data, _status_code, _headers = create_l2_vpn_service_with_http_info(l2_vpn_service, opts)
      data
    end

    # Create L2VPN service
    # Create L2VPN service for a given logical router
    # @param l2_vpn_service 
    # @param [Hash] opts the optional parameters
    # @return [Array<(L2VpnService, Fixnum, Hash)>] L2VpnService data, response status code and response headers
    def create_l2_vpn_service_with_http_info(l2_vpn_service, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiVpnL2VpnServicesApi.create_l2_vpn_service ...'
      end
      # verify the required parameter 'l2_vpn_service' is set
      if @api_client.config.client_side_validation && l2_vpn_service.nil?
        fail ArgumentError, "Missing the required parameter 'l2_vpn_service' when calling ManagementPlaneApiVpnL2VpnServicesApi.create_l2_vpn_service"
      end
      # resource path
      local_var_path = '/vpn/l2vpn/services'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(l2_vpn_service)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'L2VpnService')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiVpnL2VpnServicesApi#create_l2_vpn_service\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete a L2VPN service
    # Delete a specific L2VPN service. If there are any L2VpnSessions on this L2VpnService, those needs to be deleted first.
    # @param l2vpn_service_id 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :force Force delete the resource even if it is being used somewhere  (default to false)
    # @return [nil]
    def delete_l2_vpn_service(l2vpn_service_id, opts = {})
      delete_l2_vpn_service_with_http_info(l2vpn_service_id, opts)
      nil
    end

    # Delete a L2VPN service
    # Delete a specific L2VPN service. If there are any L2VpnSessions on this L2VpnService, those needs to be deleted first.
    # @param l2vpn_service_id 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :force Force delete the resource even if it is being used somewhere 
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_l2_vpn_service_with_http_info(l2vpn_service_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiVpnL2VpnServicesApi.delete_l2_vpn_service ...'
      end
      # verify the required parameter 'l2vpn_service_id' is set
      if @api_client.config.client_side_validation && l2vpn_service_id.nil?
        fail ArgumentError, "Missing the required parameter 'l2vpn_service_id' when calling ManagementPlaneApiVpnL2VpnServicesApi.delete_l2_vpn_service"
      end
      # resource path
      local_var_path = '/vpn/l2vpn/services/{l2vpn-service-id}'.sub('{' + 'l2vpn-service-id' + '}', l2vpn_service_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'force'] = opts[:'force'] if !opts[:'force'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiVpnL2VpnServicesApi#delete_l2_vpn_service\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get L2VPN service
    # Get a specific L2VPN service
    # @param l2vpn_service_id 
    # @param [Hash] opts the optional parameters
    # @return [L2VpnService]
    def get_l2_vpn_service(l2vpn_service_id, opts = {})
      data, _status_code, _headers = get_l2_vpn_service_with_http_info(l2vpn_service_id, opts)
      data
    end

    # Get L2VPN service
    # Get a specific L2VPN service
    # @param l2vpn_service_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(L2VpnService, Fixnum, Hash)>] L2VpnService data, response status code and response headers
    def get_l2_vpn_service_with_http_info(l2vpn_service_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiVpnL2VpnServicesApi.get_l2_vpn_service ...'
      end
      # verify the required parameter 'l2vpn_service_id' is set
      if @api_client.config.client_side_validation && l2vpn_service_id.nil?
        fail ArgumentError, "Missing the required parameter 'l2vpn_service_id' when calling ManagementPlaneApiVpnL2VpnServicesApi.get_l2_vpn_service"
      end
      # resource path
      local_var_path = '/vpn/l2vpn/services/{l2vpn-service-id}'.sub('{' + 'l2vpn-service-id' + '}', l2vpn_service_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'L2VpnService')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiVpnL2VpnServicesApi#get_l2_vpn_service\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get all L2VPN services
    # Get paginated list of all L2VPN services
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [L2VpnServiceListResult]
    def list_l2_vpn_services(opts = {})
      data, _status_code, _headers = list_l2_vpn_services_with_http_info(opts)
      data
    end

    # Get all L2VPN services
    # Get paginated list of all L2VPN services
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(L2VpnServiceListResult, Fixnum, Hash)>] L2VpnServiceListResult data, response status code and response headers
    def list_l2_vpn_services_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiVpnL2VpnServicesApi.list_l2_vpn_services ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling ManagementPlaneApiVpnL2VpnServicesApi.list_l2_vpn_services, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling ManagementPlaneApiVpnL2VpnServicesApi.list_l2_vpn_services, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/vpn/l2vpn/services'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'L2VpnServiceListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiVpnL2VpnServicesApi#list_l2_vpn_services\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Edit a L2VPN service
    # Edit a specific L2VPN service
    # @param l2vpn_service_id 
    # @param l2_vpn_service 
    # @param [Hash] opts the optional parameters
    # @return [L2VpnService]
    def update_l2_vpn_service(l2vpn_service_id, l2_vpn_service, opts = {})
      data, _status_code, _headers = update_l2_vpn_service_with_http_info(l2vpn_service_id, l2_vpn_service, opts)
      data
    end

    # Edit a L2VPN service
    # Edit a specific L2VPN service
    # @param l2vpn_service_id 
    # @param l2_vpn_service 
    # @param [Hash] opts the optional parameters
    # @return [Array<(L2VpnService, Fixnum, Hash)>] L2VpnService data, response status code and response headers
    def update_l2_vpn_service_with_http_info(l2vpn_service_id, l2_vpn_service, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ManagementPlaneApiVpnL2VpnServicesApi.update_l2_vpn_service ...'
      end
      # verify the required parameter 'l2vpn_service_id' is set
      if @api_client.config.client_side_validation && l2vpn_service_id.nil?
        fail ArgumentError, "Missing the required parameter 'l2vpn_service_id' when calling ManagementPlaneApiVpnL2VpnServicesApi.update_l2_vpn_service"
      end
      # verify the required parameter 'l2_vpn_service' is set
      if @api_client.config.client_side_validation && l2_vpn_service.nil?
        fail ArgumentError, "Missing the required parameter 'l2_vpn_service' when calling ManagementPlaneApiVpnL2VpnServicesApi.update_l2_vpn_service"
      end
      # resource path
      local_var_path = '/vpn/l2vpn/services/{l2vpn-service-id}'.sub('{' + 'l2vpn-service-id' + '}', l2vpn_service_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(l2_vpn_service)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'L2VpnService')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ManagementPlaneApiVpnL2VpnServicesApi#update_l2_vpn_service\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
