=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.5.1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module NSXT
  # Source of the Alarm
  class AlarmSource
    # The datapath thread name ID
    attr_accessor :thread_id

    # The NIC interface name
    attr_accessor :interface_name

    # Time in milliseconds that elapsed in blocked state
    attr_accessor :quiesce_blocked_time

    # VPN session/tunnel etc. local Ip(v4 or v6) address
    attr_accessor :local_ip

    # Identifier of the Alarm source entity for e.g. Vpn session id, Vpn tunnel id etc.
    attr_accessor :id

    # Ip address type v4, v6 etc.
    attr_accessor :ip_address_type

    # Name of the process which is blocked from entering quiesce state
    attr_accessor :process_name

    # Ip address
    attr_accessor :ip_address

    # Filesystem mount name
    attr_accessor :mount

    # VPN session/tunnel etc. peer Ip(v4 or v6) address
    attr_accessor :peer_ip

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'thread_id' => :'thread_id',
        :'interface_name' => :'interface_name',
        :'quiesce_blocked_time' => :'quiesce_blocked_time',
        :'local_ip' => :'local_ip',
        :'id' => :'id',
        :'ip_address_type' => :'ip_address_type',
        :'process_name' => :'process_name',
        :'ip_address' => :'ip_address',
        :'mount' => :'mount',
        :'peer_ip' => :'peer_ip'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'thread_id' => :'String',
        :'interface_name' => :'String',
        :'quiesce_blocked_time' => :'Integer',
        :'local_ip' => :'String',
        :'id' => :'String',
        :'ip_address_type' => :'String',
        :'process_name' => :'String',
        :'ip_address' => :'String',
        :'mount' => :'String',
        :'peer_ip' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'thread_id')
        self.thread_id = attributes[:'thread_id']
      end

      if attributes.has_key?(:'interface_name')
        self.interface_name = attributes[:'interface_name']
      end

      if attributes.has_key?(:'quiesce_blocked_time')
        self.quiesce_blocked_time = attributes[:'quiesce_blocked_time']
      end

      if attributes.has_key?(:'local_ip')
        self.local_ip = attributes[:'local_ip']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'ip_address_type')
        self.ip_address_type = attributes[:'ip_address_type']
      end

      if attributes.has_key?(:'process_name')
        self.process_name = attributes[:'process_name']
      end

      if attributes.has_key?(:'ip_address')
        self.ip_address = attributes[:'ip_address']
      end

      if attributes.has_key?(:'mount')
        self.mount = attributes[:'mount']
      end

      if attributes.has_key?(:'peer_ip')
        self.peer_ip = attributes[:'peer_ip']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      ip_address_type_validator = EnumAttributeValidator.new('String', ['IPV4', 'IPV6'])
      return false unless ip_address_type_validator.valid?(@ip_address_type)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] ip_address_type Object to be assigned
    def ip_address_type=(ip_address_type)
      validator = EnumAttributeValidator.new('String', ['IPV4', 'IPV6'])
      unless validator.valid?(ip_address_type)
        fail ArgumentError, 'invalid value for "ip_address_type", must be one of #{validator.allowable_values}.'
      end
      @ip_address_type = ip_address_type
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          thread_id == o.thread_id &&
          interface_name == o.interface_name &&
          quiesce_blocked_time == o.quiesce_blocked_time &&
          local_ip == o.local_ip &&
          id == o.id &&
          ip_address_type == o.ip_address_type &&
          process_name == o.process_name &&
          ip_address == o.ip_address &&
          mount == o.mount &&
          peer_ip == o.peer_ip
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [thread_id, interface_name, quiesce_blocked_time, local_ip, id, ip_address_type, process_name, ip_address, mount, peer_ip].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
