=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.5.1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module NSXT
  class CapacityThreshold
    # Set the maximum threshold percentage. Specify a value between 0 and 100. Usage percentage above this value is tagged as critical. 
    attr_accessor :max_threshold_percentage

    # Indicate the object type for which threshold is to be set. 
    attr_accessor :threshold_type

    # Set the minimum threshold percentage. Specify a value between 0 and 100. Usage percentage above this value is tagged as warning. 
    attr_accessor :min_threshold_percentage

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'max_threshold_percentage' => :'max_threshold_percentage',
        :'threshold_type' => :'threshold_type',
        :'min_threshold_percentage' => :'min_threshold_percentage'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'max_threshold_percentage' => :'Float',
        :'threshold_type' => :'String',
        :'min_threshold_percentage' => :'Float'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'max_threshold_percentage')
        self.max_threshold_percentage = attributes[:'max_threshold_percentage']
      end

      if attributes.has_key?(:'threshold_type')
        self.threshold_type = attributes[:'threshold_type']
      end

      if attributes.has_key?(:'min_threshold_percentage')
        self.min_threshold_percentage = attributes[:'min_threshold_percentage']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @max_threshold_percentage.nil?
        invalid_properties.push('invalid value for "max_threshold_percentage", max_threshold_percentage cannot be nil.')
      end

      if @max_threshold_percentage > 100
        invalid_properties.push('invalid value for "max_threshold_percentage", must be smaller than or equal to 100.')
      end

      if @max_threshold_percentage < 0
        invalid_properties.push('invalid value for "max_threshold_percentage", must be greater than or equal to 0.')
      end

      if @threshold_type.nil?
        invalid_properties.push('invalid value for "threshold_type", threshold_type cannot be nil.')
      end

      if @min_threshold_percentage.nil?
        invalid_properties.push('invalid value for "min_threshold_percentage", min_threshold_percentage cannot be nil.')
      end

      if @min_threshold_percentage > 100
        invalid_properties.push('invalid value for "min_threshold_percentage", must be smaller than or equal to 100.')
      end

      if @min_threshold_percentage < 0
        invalid_properties.push('invalid value for "min_threshold_percentage", must be greater than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @max_threshold_percentage.nil?
      return false if @max_threshold_percentage > 100
      return false if @max_threshold_percentage < 0
      return false if @threshold_type.nil?
      threshold_type_validator = EnumAttributeValidator.new('String', ['NUMBER_OF_LOGICAL_SWITCHES', 'NUMBER_OF_PREPARED_HOSTS', 'NUMBER_OF_SYSTEM_WIDE_VIFS', 'NUMBER_OF_NSGROUP', 'NUMBER_OF_VCENTER_CLUSTERS', 'NUMBER_OF_GI_PROTECTED_HOSTS', 'NUMBER_OF_GI_PROTECTED_VMS', 'NUMBER_OF_DFW_RULES', 'NUMBER_OF_DFW_SECTIONS', 'NUMBER_OF_IPSETS', 'NUMBER_OF_GROUPS_BASED_ON_IP_SETS', 'NUMBER_OF_LOGICAL_PORTS', 'NUMBER_OF_EDGE_CLUSTERS', 'NUMBER_OF_EDGE_NODES', 'NUMBER_OF_TIER0_ROUTERS', 'NUMBER_OF_TIER1_ROUTERS', 'NUMBER_OF_PREFIX_LIST', 'NUMBER_OF_NAT_RULES', 'NUMBER_OF_TIER1_WITH_NAT_RULE', 'NUMBER_OF_DHCP_SERVERS', 'NUMBER_OF_DHCP_IP_POOLS', 'NUMBER_OF_ACTIVE_DIRECTORY_GROUPS', 'NUMBER_OF_ACTIVE_DIRECTORY_DOMAINS', 'NUMBER_OF_FIREWALL_SECTIONS', 'NUMBER_OF_FIREWALL_RULES', 'GLOBAL_DEFAULT'])
      return false unless threshold_type_validator.valid?(@threshold_type)
      return false if @min_threshold_percentage.nil?
      return false if @min_threshold_percentage > 100
      return false if @min_threshold_percentage < 0
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] max_threshold_percentage Value to be assigned
    def max_threshold_percentage=(max_threshold_percentage)
      if max_threshold_percentage.nil?
        fail ArgumentError, 'max_threshold_percentage cannot be nil'
      end

      if max_threshold_percentage > 100
        fail ArgumentError, 'invalid value for "max_threshold_percentage", must be smaller than or equal to 100.'
      end

      if max_threshold_percentage < 0
        fail ArgumentError, 'invalid value for "max_threshold_percentage", must be greater than or equal to 0.'
      end

      @max_threshold_percentage = max_threshold_percentage
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] threshold_type Object to be assigned
    def threshold_type=(threshold_type)
      validator = EnumAttributeValidator.new('String', ['NUMBER_OF_LOGICAL_SWITCHES', 'NUMBER_OF_PREPARED_HOSTS', 'NUMBER_OF_SYSTEM_WIDE_VIFS', 'NUMBER_OF_NSGROUP', 'NUMBER_OF_VCENTER_CLUSTERS', 'NUMBER_OF_GI_PROTECTED_HOSTS', 'NUMBER_OF_GI_PROTECTED_VMS', 'NUMBER_OF_DFW_RULES', 'NUMBER_OF_DFW_SECTIONS', 'NUMBER_OF_IPSETS', 'NUMBER_OF_GROUPS_BASED_ON_IP_SETS', 'NUMBER_OF_LOGICAL_PORTS', 'NUMBER_OF_EDGE_CLUSTERS', 'NUMBER_OF_EDGE_NODES', 'NUMBER_OF_TIER0_ROUTERS', 'NUMBER_OF_TIER1_ROUTERS', 'NUMBER_OF_PREFIX_LIST', 'NUMBER_OF_NAT_RULES', 'NUMBER_OF_TIER1_WITH_NAT_RULE', 'NUMBER_OF_DHCP_SERVERS', 'NUMBER_OF_DHCP_IP_POOLS', 'NUMBER_OF_ACTIVE_DIRECTORY_GROUPS', 'NUMBER_OF_ACTIVE_DIRECTORY_DOMAINS', 'NUMBER_OF_FIREWALL_SECTIONS', 'NUMBER_OF_FIREWALL_RULES', 'GLOBAL_DEFAULT'])
      unless validator.valid?(threshold_type)
        fail ArgumentError, 'invalid value for "threshold_type", must be one of #{validator.allowable_values}.'
      end
      @threshold_type = threshold_type
    end

    # Custom attribute writer method with validation
    # @param [Object] min_threshold_percentage Value to be assigned
    def min_threshold_percentage=(min_threshold_percentage)
      if min_threshold_percentage.nil?
        fail ArgumentError, 'min_threshold_percentage cannot be nil'
      end

      if min_threshold_percentage > 100
        fail ArgumentError, 'invalid value for "min_threshold_percentage", must be smaller than or equal to 100.'
      end

      if min_threshold_percentage < 0
        fail ArgumentError, 'invalid value for "min_threshold_percentage", must be greater than or equal to 0.'
      end

      @min_threshold_percentage = min_threshold_percentage
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          max_threshold_percentage == o.max_threshold_percentage &&
          threshold_type == o.threshold_type &&
          min_threshold_percentage == o.min_threshold_percentage
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [max_threshold_percentage, threshold_type, min_threshold_percentage].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
