=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.5.1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module NSXT
  # The settings are used during deployment and consequent update of an edge, unless indicated otherwise. The settings are preferred over the deprecated settings in VsphereDeploymentConfig. The settings reflect the current configuraton on an edge node. If the settings lag with actual state on the edge, these may be refreshed at NSX Manager using API POST api/v1/transport-nodes /&lt;transport-node-id&gt;?action=refresh_node_configuration&resource_type= EdgeNode 
  class EdgeNodeSettings
    # List of domain names that are used to complete unqualified host names. 
    attr_accessor :search_domains

    # List of DNS servers. 
    attr_accessor :dns_servers

    # List of NTP servers. 
    attr_accessor :ntp_servers

    # Host name or FQDN for edge node.
    attr_accessor :hostname

    # Enabling SSH service is not recommended for security reasons. 
    attr_accessor :enable_ssh

    # Allowing root SSH logins is not recommended for security reasons. Edit of this property is not supported when updating transport node. Use the CLI to change this property. 
    attr_accessor :allow_ssh_root_login

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'search_domains' => :'search_domains',
        :'dns_servers' => :'dns_servers',
        :'ntp_servers' => :'ntp_servers',
        :'hostname' => :'hostname',
        :'enable_ssh' => :'enable_ssh',
        :'allow_ssh_root_login' => :'allow_ssh_root_login'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'search_domains' => :'Array<String>',
        :'dns_servers' => :'Array<String>',
        :'ntp_servers' => :'Array<String>',
        :'hostname' => :'String',
        :'enable_ssh' => :'BOOLEAN',
        :'allow_ssh_root_login' => :'BOOLEAN'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'search_domains')
        if (value = attributes[:'search_domains']).is_a?(Array)
          self.search_domains = value
        end
      end

      if attributes.has_key?(:'dns_servers')
        if (value = attributes[:'dns_servers']).is_a?(Array)
          self.dns_servers = value
        end
      end

      if attributes.has_key?(:'ntp_servers')
        if (value = attributes[:'ntp_servers']).is_a?(Array)
          self.ntp_servers = value
        end
      end

      if attributes.has_key?(:'hostname')
        self.hostname = attributes[:'hostname']
      end

      if attributes.has_key?(:'enable_ssh')
        self.enable_ssh = attributes[:'enable_ssh']
      else
        self.enable_ssh = false
      end

      if attributes.has_key?(:'allow_ssh_root_login')
        self.allow_ssh_root_login = attributes[:'allow_ssh_root_login']
      else
        self.allow_ssh_root_login = false
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          search_domains == o.search_domains &&
          dns_servers == o.dns_servers &&
          ntp_servers == o.ntp_servers &&
          hostname == o.hostname &&
          enable_ssh == o.enable_ssh &&
          allow_ssh_root_login == o.allow_ssh_root_login
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [search_domains, dns_servers, ntp_servers, hostname, enable_ssh, allow_ssh_root_login].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
