=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.5.1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module NSXT
  # A profile holding protection configuration for SYN flood, UDP flood, ICMP flood and other flood attack.
  class FirewallFloodProtectionProfile
    # Link to this resource
    attr_accessor :_self

    # The server will populate this field when returing the resource. Ignored on PUT and POST.
    attr_accessor :_links

    # Schema for this resource
    attr_accessor :_schema

    # The _revision property describes the current revision of the resource. To prevent clients from overwriting each other's changes, PUT operations must include the current _revision of the resource, which clients should obtain by issuing a GET operation. If the _revision provided in a PUT request is missing or stale, the operation will be rejected.
    attr_accessor :_revision

    # Indicates system owned resource
    attr_accessor :_system_owned

    # Defaults to ID if not set
    attr_accessor :display_name

    # Description of this resource
    attr_accessor :description

    # Opaque identifiers meaningful to the API user
    attr_accessor :tags

    # ID of the user who created this resource
    attr_accessor :_create_user

    # Protection status is one of the following: PROTECTED - the client who retrieved the entity is not allowed             to modify it. NOT_PROTECTED - the client who retrieved the entity is allowed                 to modify it REQUIRE_OVERRIDE - the client who retrieved the entity is a super                    user and can modify it, but only when providing                    the request header X-Allow-Overwrite=true. UNKNOWN - the _protection field could not be determined for this           entity. 
    attr_accessor :_protection

    # Timestamp of resource creation
    attr_accessor :_create_time

    # Timestamp of last modification
    attr_accessor :_last_modified_time

    # ID of the user who last modified this resource
    attr_accessor :_last_modified_user

    # Unique identifier of this resource
    attr_accessor :id

    # Resource type to use as profile type
    attr_accessor :resource_type

    # The maximum limit of active icmp connections. If this property is omitted, or set to null, then there is no limit on active icmp connections for those components if it's applied to ESX components (such as segment, segment port, virtual machine, etc); on the other side, if it's applied to EDGE components (such as, gateway), it will be set to default limit (10,000) on the specific components.
    attr_accessor :icmp_active_flow_limit

    # The maximum limit of other active connections besides udp, icmp and half open tcp connections. If this property is omitted, or set to null, then there is no limit on other active connections besides udp, icmp and tcp half open connections for those components if it's applied to ESX components (such as segment, segment port, virtual machine, etc); on the other side, if it's applied to EDGE components (such as, gateway), it will be set to default limit (10,000) on the specific components.
    attr_accessor :other_active_conn_limit

    # The flag to indicate syncache is enabled or not. This option does not apply to EDGE components.
    attr_accessor :enable_syncache

    # The maximum limit of active udp connections. If this property is omitted, or set to null, then there is no limit on active udp connections for those components if it's applied to ESX components (such as segment, segment port, virtual machine, etc); on the other side, if it's applied to EDGE components (such as, gateway), it will be set to default limit (100,000) on the specific component.
    attr_accessor :udp_active_flow_limit

    # The maximum limit of tcp half open connections. If this property is omitted, or set to null, then there is no limit on active tcp half open connections for those components if it's applied to ESX components (such as segment, segment port, virtual machine, etc); on the other side, if it's applied to EDGE components (such as, gateway), it will be set to default limit (1,000,000) on the specific components.
    attr_accessor :tcp_half_open_conn_limit

    # The flag to indicate RST spoofing is enabled or not. This option does not apply to EDGE components. This can be enabled only if syncache is enabled.
    attr_accessor :enable_rst_spoofing

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'_self' => :'_self',
        :'_links' => :'_links',
        :'_schema' => :'_schema',
        :'_revision' => :'_revision',
        :'_system_owned' => :'_system_owned',
        :'display_name' => :'display_name',
        :'description' => :'description',
        :'tags' => :'tags',
        :'_create_user' => :'_create_user',
        :'_protection' => :'_protection',
        :'_create_time' => :'_create_time',
        :'_last_modified_time' => :'_last_modified_time',
        :'_last_modified_user' => :'_last_modified_user',
        :'id' => :'id',
        :'resource_type' => :'resource_type',
        :'icmp_active_flow_limit' => :'icmp_active_flow_limit',
        :'other_active_conn_limit' => :'other_active_conn_limit',
        :'enable_syncache' => :'enable_syncache',
        :'udp_active_flow_limit' => :'udp_active_flow_limit',
        :'tcp_half_open_conn_limit' => :'tcp_half_open_conn_limit',
        :'enable_rst_spoofing' => :'enable_rst_spoofing'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'_self' => :'SelfResourceLink',
        :'_links' => :'Array<ResourceLink>',
        :'_schema' => :'String',
        :'_revision' => :'Integer',
        :'_system_owned' => :'BOOLEAN',
        :'display_name' => :'String',
        :'description' => :'String',
        :'tags' => :'Array<Tag>',
        :'_create_user' => :'String',
        :'_protection' => :'String',
        :'_create_time' => :'Integer',
        :'_last_modified_time' => :'Integer',
        :'_last_modified_user' => :'String',
        :'id' => :'String',
        :'resource_type' => :'String',
        :'icmp_active_flow_limit' => :'Integer',
        :'other_active_conn_limit' => :'Integer',
        :'enable_syncache' => :'BOOLEAN',
        :'udp_active_flow_limit' => :'Integer',
        :'tcp_half_open_conn_limit' => :'Integer',
        :'enable_rst_spoofing' => :'BOOLEAN'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'_self')
        self._self = attributes[:'_self']
      end

      if attributes.has_key?(:'_links')
        if (value = attributes[:'_links']).is_a?(Array)
          self._links = value
        end
      end

      if attributes.has_key?(:'_schema')
        self._schema = attributes[:'_schema']
      end

      if attributes.has_key?(:'_revision')
        self._revision = attributes[:'_revision']
      end

      if attributes.has_key?(:'_system_owned')
        self._system_owned = attributes[:'_system_owned']
      end

      if attributes.has_key?(:'display_name')
        self.display_name = attributes[:'display_name']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end

      if attributes.has_key?(:'_create_user')
        self._create_user = attributes[:'_create_user']
      end

      if attributes.has_key?(:'_protection')
        self._protection = attributes[:'_protection']
      end

      if attributes.has_key?(:'_create_time')
        self._create_time = attributes[:'_create_time']
      end

      if attributes.has_key?(:'_last_modified_time')
        self._last_modified_time = attributes[:'_last_modified_time']
      end

      if attributes.has_key?(:'_last_modified_user')
        self._last_modified_user = attributes[:'_last_modified_user']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'resource_type')
        self.resource_type = attributes[:'resource_type']
      end

      if attributes.has_key?(:'icmp_active_flow_limit')
        self.icmp_active_flow_limit = attributes[:'icmp_active_flow_limit']
      end

      if attributes.has_key?(:'other_active_conn_limit')
        self.other_active_conn_limit = attributes[:'other_active_conn_limit']
      end

      if attributes.has_key?(:'enable_syncache')
        self.enable_syncache = attributes[:'enable_syncache']
      else
        self.enable_syncache = false
      end

      if attributes.has_key?(:'udp_active_flow_limit')
        self.udp_active_flow_limit = attributes[:'udp_active_flow_limit']
      end

      if attributes.has_key?(:'tcp_half_open_conn_limit')
        self.tcp_half_open_conn_limit = attributes[:'tcp_half_open_conn_limit']
      end

      if attributes.has_key?(:'enable_rst_spoofing')
        self.enable_rst_spoofing = attributes[:'enable_rst_spoofing']
      else
        self.enable_rst_spoofing = false
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@display_name.nil? && @display_name.to_s.length > 255
        invalid_properties.push('invalid value for "display_name", the character length must be smaller than or equal to 255.')
      end

      if !@description.nil? && @description.to_s.length > 1024
        invalid_properties.push('invalid value for "description", the character length must be smaller than or equal to 1024.')
      end

      if @resource_type.nil?
        invalid_properties.push('invalid value for "resource_type", resource_type cannot be nil.')
      end

      if !@icmp_active_flow_limit.nil? && @icmp_active_flow_limit > 1000000
        invalid_properties.push('invalid value for "icmp_active_flow_limit", must be smaller than or equal to 1000000.')
      end

      if !@icmp_active_flow_limit.nil? && @icmp_active_flow_limit < 1
        invalid_properties.push('invalid value for "icmp_active_flow_limit", must be greater than or equal to 1.')
      end

      if !@other_active_conn_limit.nil? && @other_active_conn_limit > 1000000
        invalid_properties.push('invalid value for "other_active_conn_limit", must be smaller than or equal to 1000000.')
      end

      if !@other_active_conn_limit.nil? && @other_active_conn_limit < 1
        invalid_properties.push('invalid value for "other_active_conn_limit", must be greater than or equal to 1.')
      end

      if !@udp_active_flow_limit.nil? && @udp_active_flow_limit > 1000000
        invalid_properties.push('invalid value for "udp_active_flow_limit", must be smaller than or equal to 1000000.')
      end

      if !@udp_active_flow_limit.nil? && @udp_active_flow_limit < 1
        invalid_properties.push('invalid value for "udp_active_flow_limit", must be greater than or equal to 1.')
      end

      if !@tcp_half_open_conn_limit.nil? && @tcp_half_open_conn_limit > 1000000
        invalid_properties.push('invalid value for "tcp_half_open_conn_limit", must be smaller than or equal to 1000000.')
      end

      if !@tcp_half_open_conn_limit.nil? && @tcp_half_open_conn_limit < 1
        invalid_properties.push('invalid value for "tcp_half_open_conn_limit", must be greater than or equal to 1.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@display_name.nil? && @display_name.to_s.length > 255
      return false if !@description.nil? && @description.to_s.length > 1024
      return false if @resource_type.nil?
      resource_type_validator = EnumAttributeValidator.new('String', ['FirewallSessionTimerProfile', 'FirewallCpuMemThresholdsProfile', 'FirewallFloodProtectionProfile', 'FirewallDnsProfile'])
      return false unless resource_type_validator.valid?(@resource_type)
      return false if !@icmp_active_flow_limit.nil? && @icmp_active_flow_limit > 1000000
      return false if !@icmp_active_flow_limit.nil? && @icmp_active_flow_limit < 1
      return false if !@other_active_conn_limit.nil? && @other_active_conn_limit > 1000000
      return false if !@other_active_conn_limit.nil? && @other_active_conn_limit < 1
      return false if !@udp_active_flow_limit.nil? && @udp_active_flow_limit > 1000000
      return false if !@udp_active_flow_limit.nil? && @udp_active_flow_limit < 1
      return false if !@tcp_half_open_conn_limit.nil? && @tcp_half_open_conn_limit > 1000000
      return false if !@tcp_half_open_conn_limit.nil? && @tcp_half_open_conn_limit < 1
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] display_name Value to be assigned
    def display_name=(display_name)
      if !display_name.nil? && display_name.to_s.length > 255
        fail ArgumentError, 'invalid value for "display_name", the character length must be smaller than or equal to 255.'
      end

      @display_name = display_name
    end

    # Custom attribute writer method with validation
    # @param [Object] description Value to be assigned
    def description=(description)
      if !description.nil? && description.to_s.length > 1024
        fail ArgumentError, 'invalid value for "description", the character length must be smaller than or equal to 1024.'
      end

      @description = description
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] resource_type Object to be assigned
    def resource_type=(resource_type)
      validator = EnumAttributeValidator.new('String', ['FirewallSessionTimerProfile', 'FirewallCpuMemThresholdsProfile', 'FirewallFloodProtectionProfile', 'FirewallDnsProfile'])
      unless validator.valid?(resource_type)
        fail ArgumentError, 'invalid value for "resource_type", must be one of #{validator.allowable_values}.'
      end
      @resource_type = resource_type
    end

    # Custom attribute writer method with validation
    # @param [Object] icmp_active_flow_limit Value to be assigned
    def icmp_active_flow_limit=(icmp_active_flow_limit)
      if !icmp_active_flow_limit.nil? && icmp_active_flow_limit > 1000000
        fail ArgumentError, 'invalid value for "icmp_active_flow_limit", must be smaller than or equal to 1000000.'
      end

      if !icmp_active_flow_limit.nil? && icmp_active_flow_limit < 1
        fail ArgumentError, 'invalid value for "icmp_active_flow_limit", must be greater than or equal to 1.'
      end

      @icmp_active_flow_limit = icmp_active_flow_limit
    end

    # Custom attribute writer method with validation
    # @param [Object] other_active_conn_limit Value to be assigned
    def other_active_conn_limit=(other_active_conn_limit)
      if !other_active_conn_limit.nil? && other_active_conn_limit > 1000000
        fail ArgumentError, 'invalid value for "other_active_conn_limit", must be smaller than or equal to 1000000.'
      end

      if !other_active_conn_limit.nil? && other_active_conn_limit < 1
        fail ArgumentError, 'invalid value for "other_active_conn_limit", must be greater than or equal to 1.'
      end

      @other_active_conn_limit = other_active_conn_limit
    end

    # Custom attribute writer method with validation
    # @param [Object] udp_active_flow_limit Value to be assigned
    def udp_active_flow_limit=(udp_active_flow_limit)
      if !udp_active_flow_limit.nil? && udp_active_flow_limit > 1000000
        fail ArgumentError, 'invalid value for "udp_active_flow_limit", must be smaller than or equal to 1000000.'
      end

      if !udp_active_flow_limit.nil? && udp_active_flow_limit < 1
        fail ArgumentError, 'invalid value for "udp_active_flow_limit", must be greater than or equal to 1.'
      end

      @udp_active_flow_limit = udp_active_flow_limit
    end

    # Custom attribute writer method with validation
    # @param [Object] tcp_half_open_conn_limit Value to be assigned
    def tcp_half_open_conn_limit=(tcp_half_open_conn_limit)
      if !tcp_half_open_conn_limit.nil? && tcp_half_open_conn_limit > 1000000
        fail ArgumentError, 'invalid value for "tcp_half_open_conn_limit", must be smaller than or equal to 1000000.'
      end

      if !tcp_half_open_conn_limit.nil? && tcp_half_open_conn_limit < 1
        fail ArgumentError, 'invalid value for "tcp_half_open_conn_limit", must be greater than or equal to 1.'
      end

      @tcp_half_open_conn_limit = tcp_half_open_conn_limit
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          _self == o._self &&
          _links == o._links &&
          _schema == o._schema &&
          _revision == o._revision &&
          _system_owned == o._system_owned &&
          display_name == o.display_name &&
          description == o.description &&
          tags == o.tags &&
          _create_user == o._create_user &&
          _protection == o._protection &&
          _create_time == o._create_time &&
          _last_modified_time == o._last_modified_time &&
          _last_modified_user == o._last_modified_user &&
          id == o.id &&
          resource_type == o.resource_type &&
          icmp_active_flow_limit == o.icmp_active_flow_limit &&
          other_active_conn_limit == o.other_active_conn_limit &&
          enable_syncache == o.enable_syncache &&
          udp_active_flow_limit == o.udp_active_flow_limit &&
          tcp_half_open_conn_limit == o.tcp_half_open_conn_limit &&
          enable_rst_spoofing == o.enable_rst_spoofing
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [_self, _links, _schema, _revision, _system_owned, display_name, description, tags, _create_user, _protection, _create_time, _last_modified_time, _last_modified_user, id, resource_type, icmp_active_flow_limit, other_active_conn_limit, enable_syncache, udp_active_flow_limit, tcp_half_open_conn_limit, enable_rst_spoofing].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
