=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.5.1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module NSXT
  class Ipv6Header
    # The source ip address.
    attr_accessor :src_ip

    # The destination ip address.
    attr_accessor :dst_ip

    # Identifies the type of header immediately following the IPv6 header.
    attr_accessor :next_header

    # Decremented by 1 by each node that forwards the packets. The packet is discarded if Hop Limit is decremented to zero.
    attr_accessor :hop_limit

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'src_ip' => :'src_ip',
        :'dst_ip' => :'dst_ip',
        :'next_header' => :'next_header',
        :'hop_limit' => :'hop_limit'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'src_ip' => :'String',
        :'dst_ip' => :'String',
        :'next_header' => :'Integer',
        :'hop_limit' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'src_ip')
        self.src_ip = attributes[:'src_ip']
      end

      if attributes.has_key?(:'dst_ip')
        self.dst_ip = attributes[:'dst_ip']
      end

      if attributes.has_key?(:'next_header')
        self.next_header = attributes[:'next_header']
      else
        self.next_header = 58
      end

      if attributes.has_key?(:'hop_limit')
        self.hop_limit = attributes[:'hop_limit']
      else
        self.hop_limit = 64
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@next_header.nil? && @next_header > 255
        invalid_properties.push('invalid value for "next_header", must be smaller than or equal to 255.')
      end

      if !@next_header.nil? && @next_header < 0
        invalid_properties.push('invalid value for "next_header", must be greater than or equal to 0.')
      end

      if !@hop_limit.nil? && @hop_limit > 255
        invalid_properties.push('invalid value for "hop_limit", must be smaller than or equal to 255.')
      end

      if !@hop_limit.nil? && @hop_limit < 0
        invalid_properties.push('invalid value for "hop_limit", must be greater than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@next_header.nil? && @next_header > 255
      return false if !@next_header.nil? && @next_header < 0
      return false if !@hop_limit.nil? && @hop_limit > 255
      return false if !@hop_limit.nil? && @hop_limit < 0
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] next_header Value to be assigned
    def next_header=(next_header)
      if !next_header.nil? && next_header > 255
        fail ArgumentError, 'invalid value for "next_header", must be smaller than or equal to 255.'
      end

      if !next_header.nil? && next_header < 0
        fail ArgumentError, 'invalid value for "next_header", must be greater than or equal to 0.'
      end

      @next_header = next_header
    end

    # Custom attribute writer method with validation
    # @param [Object] hop_limit Value to be assigned
    def hop_limit=(hop_limit)
      if !hop_limit.nil? && hop_limit > 255
        fail ArgumentError, 'invalid value for "hop_limit", must be smaller than or equal to 255.'
      end

      if !hop_limit.nil? && hop_limit < 0
        fail ArgumentError, 'invalid value for "hop_limit", must be greater than or equal to 0.'
      end

      @hop_limit = hop_limit
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          src_ip == o.src_ip &&
          dst_ip == o.dst_ip &&
          next_header == o.next_header &&
          hop_limit == o.hop_limit
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [src_ip, dst_ip, next_header, hop_limit].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
