=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.5.1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module NSXT
  # The capacity contains basic information and load balancer entity usages and capacity for the given edge node. 
  class LbEdgeNodeUsage
    # The property identifies the node UUID for load balancer node usage. 
    attr_accessor :node_id

    # The property identifies the load balancer node usage type. 
    attr_accessor :type

    # The current credit number reflects the current usage on the node. For example, configuring a medium load balancer on a node consumes 10 credits. If there are 2 medium instances configured on a node, the current credit number is 2 * 10 = 20. 
    attr_accessor :current_credit_number

    # The number of virtual servers configured on the node. 
    attr_accessor :current_virtual_servers

    # The number of small load balancer services configured on the node. 
    attr_accessor :current_small_load_balancer_services

    # The number of pool members configured on the node. 
    attr_accessor :current_pool_members

    # The severity calculation is based on current credit usage percentage of load balancer for one node. 
    attr_accessor :severity

    # The number of pools configured on the node. 
    attr_accessor :current_pools

    # The remaining number of pool members which could be configured on the given edge node. 
    attr_accessor :remaining_pool_members

    # The ID of edge cluster which contains the edge node. 
    attr_accessor :edge_cluster_id

    # The remaining number of small load balancer services which could be configured on the given edge node. 
    attr_accessor :remaining_small_load_balancer_services

    # The form factor of the given edge node. 
    attr_accessor :form_factor

    # The usage percentage of one edge node for the load balancer services. 
    attr_accessor :usage_percentage

    # The number of large load balancer services configured on the node. 
    attr_accessor :current_large_load_balancer_services

    # The remaining credit number is the remaining credits that can be used for load balancer service configuration. For example, an edge node with form factor LARGE_VIRTUAL_MACHINE has 40 credits, and a medium load balancer instance costs 10 credits. If there are currently 3 medium instances configured, the remaining credit number is 40 - (3 * 10) = 10. 
    attr_accessor :remaining_credit_number

    # The remaining number of large load balancer services which could be configured on the given edge node. 
    attr_accessor :remaining_large_load_balancer_services

    # The remaining number of medium load balancer services which could be configured on the given edge node. 
    attr_accessor :remaining_medium_load_balancer_services

    # The number of medium load balancer services configured on the node. 
    attr_accessor :current_medium_load_balancer_services

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'node_id' => :'node_id',
        :'type' => :'type',
        :'current_credit_number' => :'current_credit_number',
        :'current_virtual_servers' => :'current_virtual_servers',
        :'current_small_load_balancer_services' => :'current_small_load_balancer_services',
        :'current_pool_members' => :'current_pool_members',
        :'severity' => :'severity',
        :'current_pools' => :'current_pools',
        :'remaining_pool_members' => :'remaining_pool_members',
        :'edge_cluster_id' => :'edge_cluster_id',
        :'remaining_small_load_balancer_services' => :'remaining_small_load_balancer_services',
        :'form_factor' => :'form_factor',
        :'usage_percentage' => :'usage_percentage',
        :'current_large_load_balancer_services' => :'current_large_load_balancer_services',
        :'remaining_credit_number' => :'remaining_credit_number',
        :'remaining_large_load_balancer_services' => :'remaining_large_load_balancer_services',
        :'remaining_medium_load_balancer_services' => :'remaining_medium_load_balancer_services',
        :'current_medium_load_balancer_services' => :'current_medium_load_balancer_services'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'node_id' => :'String',
        :'type' => :'String',
        :'current_credit_number' => :'Integer',
        :'current_virtual_servers' => :'Integer',
        :'current_small_load_balancer_services' => :'Integer',
        :'current_pool_members' => :'Integer',
        :'severity' => :'String',
        :'current_pools' => :'Integer',
        :'remaining_pool_members' => :'Integer',
        :'edge_cluster_id' => :'String',
        :'remaining_small_load_balancer_services' => :'Integer',
        :'form_factor' => :'String',
        :'usage_percentage' => :'Float',
        :'current_large_load_balancer_services' => :'Integer',
        :'remaining_credit_number' => :'Integer',
        :'remaining_large_load_balancer_services' => :'Integer',
        :'remaining_medium_load_balancer_services' => :'Integer',
        :'current_medium_load_balancer_services' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'node_id')
        self.node_id = attributes[:'node_id']
      end

      if attributes.has_key?(:'type')
        self.type = attributes[:'type']
      end

      if attributes.has_key?(:'current_credit_number')
        self.current_credit_number = attributes[:'current_credit_number']
      end

      if attributes.has_key?(:'current_virtual_servers')
        self.current_virtual_servers = attributes[:'current_virtual_servers']
      end

      if attributes.has_key?(:'current_small_load_balancer_services')
        self.current_small_load_balancer_services = attributes[:'current_small_load_balancer_services']
      end

      if attributes.has_key?(:'current_pool_members')
        self.current_pool_members = attributes[:'current_pool_members']
      end

      if attributes.has_key?(:'severity')
        self.severity = attributes[:'severity']
      end

      if attributes.has_key?(:'current_pools')
        self.current_pools = attributes[:'current_pools']
      end

      if attributes.has_key?(:'remaining_pool_members')
        self.remaining_pool_members = attributes[:'remaining_pool_members']
      end

      if attributes.has_key?(:'edge_cluster_id')
        self.edge_cluster_id = attributes[:'edge_cluster_id']
      end

      if attributes.has_key?(:'remaining_small_load_balancer_services')
        self.remaining_small_load_balancer_services = attributes[:'remaining_small_load_balancer_services']
      end

      if attributes.has_key?(:'form_factor')
        self.form_factor = attributes[:'form_factor']
      end

      if attributes.has_key?(:'usage_percentage')
        self.usage_percentage = attributes[:'usage_percentage']
      end

      if attributes.has_key?(:'current_large_load_balancer_services')
        self.current_large_load_balancer_services = attributes[:'current_large_load_balancer_services']
      end

      if attributes.has_key?(:'remaining_credit_number')
        self.remaining_credit_number = attributes[:'remaining_credit_number']
      end

      if attributes.has_key?(:'remaining_large_load_balancer_services')
        self.remaining_large_load_balancer_services = attributes[:'remaining_large_load_balancer_services']
      end

      if attributes.has_key?(:'remaining_medium_load_balancer_services')
        self.remaining_medium_load_balancer_services = attributes[:'remaining_medium_load_balancer_services']
      end

      if attributes.has_key?(:'current_medium_load_balancer_services')
        self.current_medium_load_balancer_services = attributes[:'current_medium_load_balancer_services']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @node_id.nil?
        invalid_properties.push('invalid value for "node_id", node_id cannot be nil.')
      end

      if @type.nil?
        invalid_properties.push('invalid value for "type", type cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @node_id.nil?
      return false if @type.nil?
      type_validator = EnumAttributeValidator.new('String', ['LbEdgeNodeUsage'])
      return false unless type_validator.valid?(@type)
      severity_validator = EnumAttributeValidator.new('String', ['GREEN', 'ORANGE', 'RED'])
      return false unless severity_validator.valid?(@severity)
      form_factor_validator = EnumAttributeValidator.new('String', ['SMALL_VIRTUAL_MACHINE', 'MEDIUM_VIRTUAL_MACHINE', 'LARGE_VIRTUAL_MACHINE', 'PHYSICAL_MACHINE'])
      return false unless form_factor_validator.valid?(@form_factor)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] type Object to be assigned
    def type=(type)
      validator = EnumAttributeValidator.new('String', ['LbEdgeNodeUsage'])
      unless validator.valid?(type)
        fail ArgumentError, 'invalid value for "type", must be one of #{validator.allowable_values}.'
      end
      @type = type
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] severity Object to be assigned
    def severity=(severity)
      validator = EnumAttributeValidator.new('String', ['GREEN', 'ORANGE', 'RED'])
      unless validator.valid?(severity)
        fail ArgumentError, 'invalid value for "severity", must be one of #{validator.allowable_values}.'
      end
      @severity = severity
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] form_factor Object to be assigned
    def form_factor=(form_factor)
      validator = EnumAttributeValidator.new('String', ['SMALL_VIRTUAL_MACHINE', 'MEDIUM_VIRTUAL_MACHINE', 'LARGE_VIRTUAL_MACHINE', 'PHYSICAL_MACHINE'])
      unless validator.valid?(form_factor)
        fail ArgumentError, 'invalid value for "form_factor", must be one of #{validator.allowable_values}.'
      end
      @form_factor = form_factor
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          node_id == o.node_id &&
          type == o.type &&
          current_credit_number == o.current_credit_number &&
          current_virtual_servers == o.current_virtual_servers &&
          current_small_load_balancer_services == o.current_small_load_balancer_services &&
          current_pool_members == o.current_pool_members &&
          severity == o.severity &&
          current_pools == o.current_pools &&
          remaining_pool_members == o.remaining_pool_members &&
          edge_cluster_id == o.edge_cluster_id &&
          remaining_small_load_balancer_services == o.remaining_small_load_balancer_services &&
          form_factor == o.form_factor &&
          usage_percentage == o.usage_percentage &&
          current_large_load_balancer_services == o.current_large_load_balancer_services &&
          remaining_credit_number == o.remaining_credit_number &&
          remaining_large_load_balancer_services == o.remaining_large_load_balancer_services &&
          remaining_medium_load_balancer_services == o.remaining_medium_load_balancer_services &&
          current_medium_load_balancer_services == o.current_medium_load_balancer_services
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [node_id, type, current_credit_number, current_virtual_servers, current_small_load_balancer_services, current_pool_members, severity, current_pools, remaining_pool_members, edge_cluster_id, remaining_small_load_balancer_services, form_factor, usage_percentage, current_large_load_balancer_services, remaining_credit_number, remaining_large_load_balancer_services, remaining_medium_load_balancer_services, current_medium_load_balancer_services].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
