=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.5.1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module NSXT
  # CSV record for a pre/post-upgrade check
  class UpgradeCheckCsvRecord
    # Status of the pre/post-upgrade check
    attr_accessor :status

    # Description of the pre/post-upgrade check
    attr_accessor :check_description

    # Space-separated list of failure messages
    attr_accessor :failure_messages

    # Display name of the pre/post-upgrade check
    attr_accessor :check_name

    # Identifier of the upgrade unit
    attr_accessor :upgrade_unit_id

    # Meta-data of the upgrade-unit
    attr_accessor :upgrade_unit_metadata

    # Component type of the upgrade unit
    attr_accessor :upgrade_unit_type

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'status' => :'status',
        :'check_description' => :'check_description',
        :'failure_messages' => :'failure_messages',
        :'check_name' => :'check_name',
        :'upgrade_unit_id' => :'upgrade_unit_id',
        :'upgrade_unit_metadata' => :'upgrade_unit_metadata',
        :'upgrade_unit_type' => :'upgrade_unit_type'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'status' => :'String',
        :'check_description' => :'String',
        :'failure_messages' => :'String',
        :'check_name' => :'String',
        :'upgrade_unit_id' => :'String',
        :'upgrade_unit_metadata' => :'String',
        :'upgrade_unit_type' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'check_description')
        self.check_description = attributes[:'check_description']
      end

      if attributes.has_key?(:'failure_messages')
        self.failure_messages = attributes[:'failure_messages']
      end

      if attributes.has_key?(:'check_name')
        self.check_name = attributes[:'check_name']
      end

      if attributes.has_key?(:'upgrade_unit_id')
        self.upgrade_unit_id = attributes[:'upgrade_unit_id']
      end

      if attributes.has_key?(:'upgrade_unit_metadata')
        self.upgrade_unit_metadata = attributes[:'upgrade_unit_metadata']
      end

      if attributes.has_key?(:'upgrade_unit_type')
        self.upgrade_unit_type = attributes[:'upgrade_unit_type']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @check_name.nil?
        invalid_properties.push('invalid value for "check_name", check_name cannot be nil.')
      end

      if @upgrade_unit_type.nil?
        invalid_properties.push('invalid value for "upgrade_unit_type", upgrade_unit_type cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      status_validator = EnumAttributeValidator.new('String', ['SUCCESS', 'FAILURE', 'WARNING'])
      return false unless status_validator.valid?(@status)
      return false if @check_name.nil?
      return false if @upgrade_unit_type.nil?
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('String', ['SUCCESS', 'FAILURE', 'WARNING'])
      unless validator.valid?(status)
        fail ArgumentError, 'invalid value for "status", must be one of #{validator.allowable_values}.'
      end
      @status = status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          status == o.status &&
          check_description == o.check_description &&
          failure_messages == o.failure_messages &&
          check_name == o.check_name &&
          upgrade_unit_id == o.upgrade_unit_id &&
          upgrade_unit_metadata == o.upgrade_unit_metadata &&
          upgrade_unit_type == o.upgrade_unit_type
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [status, check_description, failure_messages, check_name, upgrade_unit_id, upgrade_unit_metadata, upgrade_unit_type].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
