=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyInfraConstraintsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create or update tenant Constraint
    # Create tenant constraint if it does not exist, otherwise replace the existing constraint. 
    # @param constraint_id 
    # @param constraint 
    # @param [Hash] opts the optional parameters
    # @return [Constraint]
    def create_or_replace_tenant_constraint(constraint_id, constraint, opts = {})
      data, _status_code, _headers = create_or_replace_tenant_constraint_with_http_info(constraint_id, constraint, opts)
      data
    end

    # Create or update tenant Constraint
    # Create tenant constraint if it does not exist, otherwise replace the existing constraint. 
    # @param constraint_id 
    # @param constraint 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Constraint, Fixnum, Hash)>] Constraint data, response status code and response headers
    def create_or_replace_tenant_constraint_with_http_info(constraint_id, constraint, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraConstraintsApi.create_or_replace_tenant_constraint ...'
      end
      # verify the required parameter 'constraint_id' is set
      if @api_client.config.client_side_validation && constraint_id.nil?
        fail ArgumentError, "Missing the required parameter 'constraint_id' when calling PolicyInfraConstraintsApi.create_or_replace_tenant_constraint"
      end
      # verify the required parameter 'constraint' is set
      if @api_client.config.client_side_validation && constraint.nil?
        fail ArgumentError, "Missing the required parameter 'constraint' when calling PolicyInfraConstraintsApi.create_or_replace_tenant_constraint"
      end
      # resource path
      local_var_path = '/infra/constraints/{constraint-id}'.sub('{' + 'constraint-id' + '}', constraint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(constraint)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Constraint')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraConstraintsApi#create_or_replace_tenant_constraint\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update tenant Constraint
    # Create tenant constraint if it does not exist, otherwise replace the existing constraint. 
    # @param constraint_id 
    # @param constraint 
    # @param [Hash] opts the optional parameters
    # @return [Constraint]
    def create_or_replace_tenant_constraint_0(constraint_id, constraint, opts = {})
      data, _status_code, _headers = create_or_replace_tenant_constraint_0_with_http_info(constraint_id, constraint, opts)
      data
    end

    # Create or update tenant Constraint
    # Create tenant constraint if it does not exist, otherwise replace the existing constraint. 
    # @param constraint_id 
    # @param constraint 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Constraint, Fixnum, Hash)>] Constraint data, response status code and response headers
    def create_or_replace_tenant_constraint_0_with_http_info(constraint_id, constraint, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraConstraintsApi.create_or_replace_tenant_constraint_0 ...'
      end
      # verify the required parameter 'constraint_id' is set
      if @api_client.config.client_side_validation && constraint_id.nil?
        fail ArgumentError, "Missing the required parameter 'constraint_id' when calling PolicyInfraConstraintsApi.create_or_replace_tenant_constraint_0"
      end
      # verify the required parameter 'constraint' is set
      if @api_client.config.client_side_validation && constraint.nil?
        fail ArgumentError, "Missing the required parameter 'constraint' when calling PolicyInfraConstraintsApi.create_or_replace_tenant_constraint_0"
      end
      # resource path
      local_var_path = '/global-infra/constraints/{constraint-id}'.sub('{' + 'constraint-id' + '}', constraint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(constraint)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Constraint')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraConstraintsApi#create_or_replace_tenant_constraint_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete tenant Constraint.
    # Delete tenant constraint.
    # @param constraint_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_tenant_constraint(constraint_id, opts = {})
      delete_tenant_constraint_with_http_info(constraint_id, opts)
      nil
    end

    # Delete tenant Constraint.
    # Delete tenant constraint.
    # @param constraint_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_tenant_constraint_with_http_info(constraint_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraConstraintsApi.delete_tenant_constraint ...'
      end
      # verify the required parameter 'constraint_id' is set
      if @api_client.config.client_side_validation && constraint_id.nil?
        fail ArgumentError, "Missing the required parameter 'constraint_id' when calling PolicyInfraConstraintsApi.delete_tenant_constraint"
      end
      # resource path
      local_var_path = '/infra/constraints/{constraint-id}'.sub('{' + 'constraint-id' + '}', constraint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraConstraintsApi#delete_tenant_constraint\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete tenant Constraint.
    # Delete tenant constraint.
    # @param constraint_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_tenant_constraint_0(constraint_id, opts = {})
      delete_tenant_constraint_0_with_http_info(constraint_id, opts)
      nil
    end

    # Delete tenant Constraint.
    # Delete tenant constraint.
    # @param constraint_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_tenant_constraint_0_with_http_info(constraint_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraConstraintsApi.delete_tenant_constraint_0 ...'
      end
      # verify the required parameter 'constraint_id' is set
      if @api_client.config.client_side_validation && constraint_id.nil?
        fail ArgumentError, "Missing the required parameter 'constraint_id' when calling PolicyInfraConstraintsApi.delete_tenant_constraint_0"
      end
      # resource path
      local_var_path = '/global-infra/constraints/{constraint-id}'.sub('{' + 'constraint-id' + '}', constraint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraConstraintsApi#delete_tenant_constraint_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List tenant Constraints.
    # List tenant constraints.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [ConstraintListResult]
    def list_tenant_constraints(opts = {})
      data, _status_code, _headers = list_tenant_constraints_with_http_info(opts)
      data
    end

    # List tenant Constraints.
    # List tenant constraints.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(ConstraintListResult, Fixnum, Hash)>] ConstraintListResult data, response status code and response headers
    def list_tenant_constraints_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraConstraintsApi.list_tenant_constraints ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraConstraintsApi.list_tenant_constraints, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraConstraintsApi.list_tenant_constraints, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/constraints'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ConstraintListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraConstraintsApi#list_tenant_constraints\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List tenant Constraints.
    # List tenant constraints.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [ConstraintListResult]
    def list_tenant_constraints_0(opts = {})
      data, _status_code, _headers = list_tenant_constraints_0_with_http_info(opts)
      data
    end

    # List tenant Constraints.
    # List tenant constraints.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(ConstraintListResult, Fixnum, Hash)>] ConstraintListResult data, response status code and response headers
    def list_tenant_constraints_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraConstraintsApi.list_tenant_constraints_0 ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraConstraintsApi.list_tenant_constraints_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraConstraintsApi.list_tenant_constraints_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/constraints'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ConstraintListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraConstraintsApi#list_tenant_constraints_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update tenant Constraint
    # Create tenant constraint if not exists, otherwise update the existing constraint. 
    # @param constraint_id 
    # @param constraint 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_tenant_constraint(constraint_id, constraint, opts = {})
      patch_tenant_constraint_with_http_info(constraint_id, constraint, opts)
      nil
    end

    # Create or update tenant Constraint
    # Create tenant constraint if not exists, otherwise update the existing constraint. 
    # @param constraint_id 
    # @param constraint 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_tenant_constraint_with_http_info(constraint_id, constraint, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraConstraintsApi.patch_tenant_constraint ...'
      end
      # verify the required parameter 'constraint_id' is set
      if @api_client.config.client_side_validation && constraint_id.nil?
        fail ArgumentError, "Missing the required parameter 'constraint_id' when calling PolicyInfraConstraintsApi.patch_tenant_constraint"
      end
      # verify the required parameter 'constraint' is set
      if @api_client.config.client_side_validation && constraint.nil?
        fail ArgumentError, "Missing the required parameter 'constraint' when calling PolicyInfraConstraintsApi.patch_tenant_constraint"
      end
      # resource path
      local_var_path = '/infra/constraints/{constraint-id}'.sub('{' + 'constraint-id' + '}', constraint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(constraint)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraConstraintsApi#patch_tenant_constraint\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update tenant Constraint
    # Create tenant constraint if not exists, otherwise update the existing constraint. 
    # @param constraint_id 
    # @param constraint 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_tenant_constraint_0(constraint_id, constraint, opts = {})
      patch_tenant_constraint_0_with_http_info(constraint_id, constraint, opts)
      nil
    end

    # Create or update tenant Constraint
    # Create tenant constraint if not exists, otherwise update the existing constraint. 
    # @param constraint_id 
    # @param constraint 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_tenant_constraint_0_with_http_info(constraint_id, constraint, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraConstraintsApi.patch_tenant_constraint_0 ...'
      end
      # verify the required parameter 'constraint_id' is set
      if @api_client.config.client_side_validation && constraint_id.nil?
        fail ArgumentError, "Missing the required parameter 'constraint_id' when calling PolicyInfraConstraintsApi.patch_tenant_constraint_0"
      end
      # verify the required parameter 'constraint' is set
      if @api_client.config.client_side_validation && constraint.nil?
        fail ArgumentError, "Missing the required parameter 'constraint' when calling PolicyInfraConstraintsApi.patch_tenant_constraint_0"
      end
      # resource path
      local_var_path = '/global-infra/constraints/{constraint-id}'.sub('{' + 'constraint-id' + '}', constraint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(constraint)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraConstraintsApi#patch_tenant_constraint_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read tenant Constraint.
    # Read tenant constraint.
    # @param constraint_id 
    # @param [Hash] opts the optional parameters
    # @return [Constraint]
    def read_tenant_constraint(constraint_id, opts = {})
      data, _status_code, _headers = read_tenant_constraint_with_http_info(constraint_id, opts)
      data
    end

    # Read tenant Constraint.
    # Read tenant constraint.
    # @param constraint_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Constraint, Fixnum, Hash)>] Constraint data, response status code and response headers
    def read_tenant_constraint_with_http_info(constraint_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraConstraintsApi.read_tenant_constraint ...'
      end
      # verify the required parameter 'constraint_id' is set
      if @api_client.config.client_side_validation && constraint_id.nil?
        fail ArgumentError, "Missing the required parameter 'constraint_id' when calling PolicyInfraConstraintsApi.read_tenant_constraint"
      end
      # resource path
      local_var_path = '/infra/constraints/{constraint-id}'.sub('{' + 'constraint-id' + '}', constraint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Constraint')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraConstraintsApi#read_tenant_constraint\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read tenant Constraint.
    # Read tenant constraint.
    # @param constraint_id 
    # @param [Hash] opts the optional parameters
    # @return [Constraint]
    def read_tenant_constraint_0(constraint_id, opts = {})
      data, _status_code, _headers = read_tenant_constraint_0_with_http_info(constraint_id, opts)
      data
    end

    # Read tenant Constraint.
    # Read tenant constraint.
    # @param constraint_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Constraint, Fixnum, Hash)>] Constraint data, response status code and response headers
    def read_tenant_constraint_0_with_http_info(constraint_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraConstraintsApi.read_tenant_constraint_0 ...'
      end
      # verify the required parameter 'constraint_id' is set
      if @api_client.config.client_side_validation && constraint_id.nil?
        fail ArgumentError, "Missing the required parameter 'constraint_id' when calling PolicyInfraConstraintsApi.read_tenant_constraint_0"
      end
      # resource path
      local_var_path = '/global-infra/constraints/{constraint-id}'.sub('{' + 'constraint-id' + '}', constraint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Constraint')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraConstraintsApi#read_tenant_constraint_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
