=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyInfraDomainsDomainApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete Domain and all the entities contained by this domain
    # Delete the domain along with all the entities contained by this domain. The groups that are a part of this domain are also deleted along with the domain. 
    # @param domain_id Domain ID
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_domain(domain_id, opts = {})
      delete_domain_with_http_info(domain_id, opts)
      nil
    end

    # Delete Domain and all the entities contained by this domain
    # Delete the domain along with all the entities contained by this domain. The groups that are a part of this domain are also deleted along with the domain. 
    # @param domain_id Domain ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_domain_with_http_info(domain_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraDomainsDomainApi.delete_domain ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicyInfraDomainsDomainApi.delete_domain"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraDomainsDomainApi#delete_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete Domain and all the entities contained by this domain
    # Delete the domain along with all the entities contained by this domain. The groups that are a part of this domain are also deleted along with the domain. 
    # @param domain_id Domain ID
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_domain_0(domain_id, opts = {})
      delete_domain_0_with_http_info(domain_id, opts)
      nil
    end

    # Delete Domain and all the entities contained by this domain
    # Delete the domain along with all the entities contained by this domain. The groups that are a part of this domain are also deleted along with the domain. 
    # @param domain_id Domain ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_domain_0_with_http_info(domain_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraDomainsDomainApi.delete_domain_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicyInfraDomainsDomainApi.delete_domain_0"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraDomainsDomainApi#delete_domain_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List domains for infra
    # Paginated list of all domains for infra. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [DomainListResult]
    def list_domain_for_infra(opts = {})
      data, _status_code, _headers = list_domain_for_infra_with_http_info(opts)
      data
    end

    # List domains for infra
    # Paginated list of all domains for infra. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(DomainListResult, Fixnum, Hash)>] DomainListResult data, response status code and response headers
    def list_domain_for_infra_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraDomainsDomainApi.list_domain_for_infra ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraDomainsDomainApi.list_domain_for_infra, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraDomainsDomainApi.list_domain_for_infra, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/domains'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DomainListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraDomainsDomainApi#list_domain_for_infra\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List domains for infra
    # Paginated list of all domains for infra. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [DomainListResult]
    def list_domain_for_infra_0(opts = {})
      data, _status_code, _headers = list_domain_for_infra_0_with_http_info(opts)
      data
    end

    # List domains for infra
    # Paginated list of all domains for infra. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(DomainListResult, Fixnum, Hash)>] DomainListResult data, response status code and response headers
    def list_domain_for_infra_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraDomainsDomainApi.list_domain_for_infra_0 ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraDomainsDomainApi.list_domain_for_infra_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraDomainsDomainApi.list_domain_for_infra_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/domains'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DomainListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraDomainsDomainApi#list_domain_for_infra_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Patch a domain
    # If a domain with the domain-id is not already present, create a new domain. If it already exists, patch the domain 
    # @param domain_id Domain ID
    # @param domain 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_domain_for_infra(domain_id, domain, opts = {})
      patch_domain_for_infra_with_http_info(domain_id, domain, opts)
      nil
    end

    # Patch a domain
    # If a domain with the domain-id is not already present, create a new domain. If it already exists, patch the domain 
    # @param domain_id Domain ID
    # @param domain 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_domain_for_infra_with_http_info(domain_id, domain, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraDomainsDomainApi.patch_domain_for_infra ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicyInfraDomainsDomainApi.patch_domain_for_infra"
      end
      # verify the required parameter 'domain' is set
      if @api_client.config.client_side_validation && domain.nil?
        fail ArgumentError, "Missing the required parameter 'domain' when calling PolicyInfraDomainsDomainApi.patch_domain_for_infra"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(domain)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraDomainsDomainApi#patch_domain_for_infra\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Patch a domain
    # If a domain with the domain-id is not already present, create a new domain. If it already exists, patch the domain 
    # @param domain_id Domain ID
    # @param domain 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_domain_for_infra_0(domain_id, domain, opts = {})
      patch_domain_for_infra_0_with_http_info(domain_id, domain, opts)
      nil
    end

    # Patch a domain
    # If a domain with the domain-id is not already present, create a new domain. If it already exists, patch the domain 
    # @param domain_id Domain ID
    # @param domain 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_domain_for_infra_0_with_http_info(domain_id, domain, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraDomainsDomainApi.patch_domain_for_infra_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicyInfraDomainsDomainApi.patch_domain_for_infra_0"
      end
      # verify the required parameter 'domain' is set
      if @api_client.config.client_side_validation && domain.nil?
        fail ArgumentError, "Missing the required parameter 'domain' when calling PolicyInfraDomainsDomainApi.patch_domain_for_infra_0"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(domain)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraDomainsDomainApi#patch_domain_for_infra_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read domain
    # Read a domain. 
    # @param domain_id Domain ID
    # @param [Hash] opts the optional parameters
    # @return [Domain]
    def read_domain_for_infra(domain_id, opts = {})
      data, _status_code, _headers = read_domain_for_infra_with_http_info(domain_id, opts)
      data
    end

    # Read domain
    # Read a domain. 
    # @param domain_id Domain ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(Domain, Fixnum, Hash)>] Domain data, response status code and response headers
    def read_domain_for_infra_with_http_info(domain_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraDomainsDomainApi.read_domain_for_infra ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicyInfraDomainsDomainApi.read_domain_for_infra"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Domain')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraDomainsDomainApi#read_domain_for_infra\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read domain
    # Read a domain. 
    # @param domain_id Domain ID
    # @param [Hash] opts the optional parameters
    # @return [Domain]
    def read_domain_for_infra_0(domain_id, opts = {})
      data, _status_code, _headers = read_domain_for_infra_0_with_http_info(domain_id, opts)
      data
    end

    # Read domain
    # Read a domain. 
    # @param domain_id Domain ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(Domain, Fixnum, Hash)>] Domain data, response status code and response headers
    def read_domain_for_infra_0_with_http_info(domain_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraDomainsDomainApi.read_domain_for_infra_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicyInfraDomainsDomainApi.read_domain_for_infra_0"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Domain')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraDomainsDomainApi#read_domain_for_infra_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a domain
    # If a domain with the domain-id is not already present, create a new domain. If it already exists, update the domain including the nested groups. This is a full replace 
    # @param domain_id Domain ID
    # @param domain 
    # @param [Hash] opts the optional parameters
    # @return [Domain]
    def update_domain_for_infra(domain_id, domain, opts = {})
      data, _status_code, _headers = update_domain_for_infra_with_http_info(domain_id, domain, opts)
      data
    end

    # Create or update a domain
    # If a domain with the domain-id is not already present, create a new domain. If it already exists, update the domain including the nested groups. This is a full replace 
    # @param domain_id Domain ID
    # @param domain 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Domain, Fixnum, Hash)>] Domain data, response status code and response headers
    def update_domain_for_infra_with_http_info(domain_id, domain, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraDomainsDomainApi.update_domain_for_infra ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicyInfraDomainsDomainApi.update_domain_for_infra"
      end
      # verify the required parameter 'domain' is set
      if @api_client.config.client_side_validation && domain.nil?
        fail ArgumentError, "Missing the required parameter 'domain' when calling PolicyInfraDomainsDomainApi.update_domain_for_infra"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(domain)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Domain')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraDomainsDomainApi#update_domain_for_infra\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a domain
    # If a domain with the domain-id is not already present, create a new domain. If it already exists, update the domain including the nested groups. This is a full replace 
    # @param domain_id Domain ID
    # @param domain 
    # @param [Hash] opts the optional parameters
    # @return [Domain]
    def update_domain_for_infra_0(domain_id, domain, opts = {})
      data, _status_code, _headers = update_domain_for_infra_0_with_http_info(domain_id, domain, opts)
      data
    end

    # Create or update a domain
    # If a domain with the domain-id is not already present, create a new domain. If it already exists, update the domain including the nested groups. This is a full replace 
    # @param domain_id Domain ID
    # @param domain 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Domain, Fixnum, Hash)>] Domain data, response status code and response headers
    def update_domain_for_infra_0_with_http_info(domain_id, domain, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraDomainsDomainApi.update_domain_for_infra_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicyInfraDomainsDomainApi.update_domain_for_infra_0"
      end
      # verify the required parameter 'domain' is set
      if @api_client.config.client_side_validation && domain.nil?
        fail ArgumentError, "Missing the required parameter 'domain' when calling PolicyInfraDomainsDomainApi.update_domain_for_infra_0"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(domain)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Domain')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraDomainsDomainApi#update_domain_for_infra_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
