=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyInfraLabelsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create or replace label
    # Create label if not exists, otherwise replaces the existing label. If label already exists then type attribute cannot be changed. 
    # @param label_id 
    # @param policy_label 
    # @param [Hash] opts the optional parameters
    # @return [PolicyLabel]
    def create_or_replace_policy_label_for_infra(label_id, policy_label, opts = {})
      data, _status_code, _headers = create_or_replace_policy_label_for_infra_with_http_info(label_id, policy_label, opts)
      data
    end

    # Create or replace label
    # Create label if not exists, otherwise replaces the existing label. If label already exists then type attribute cannot be changed. 
    # @param label_id 
    # @param policy_label 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyLabel, Fixnum, Hash)>] PolicyLabel data, response status code and response headers
    def create_or_replace_policy_label_for_infra_with_http_info(label_id, policy_label, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraLabelsApi.create_or_replace_policy_label_for_infra ...'
      end
      # verify the required parameter 'label_id' is set
      if @api_client.config.client_side_validation && label_id.nil?
        fail ArgumentError, "Missing the required parameter 'label_id' when calling PolicyInfraLabelsApi.create_or_replace_policy_label_for_infra"
      end
      # verify the required parameter 'policy_label' is set
      if @api_client.config.client_side_validation && policy_label.nil?
        fail ArgumentError, "Missing the required parameter 'policy_label' when calling PolicyInfraLabelsApi.create_or_replace_policy_label_for_infra"
      end
      # resource path
      local_var_path = '/infra/labels/{label-id}'.sub('{' + 'label-id' + '}', label_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_label)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyLabel')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraLabelsApi#create_or_replace_policy_label_for_infra\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or replace label
    # Create label if not exists, otherwise replaces the existing label. If label already exists then type attribute cannot be changed. 
    # @param label_id 
    # @param policy_label 
    # @param [Hash] opts the optional parameters
    # @return [PolicyLabel]
    def create_or_replace_policy_label_for_infra_0(label_id, policy_label, opts = {})
      data, _status_code, _headers = create_or_replace_policy_label_for_infra_0_with_http_info(label_id, policy_label, opts)
      data
    end

    # Create or replace label
    # Create label if not exists, otherwise replaces the existing label. If label already exists then type attribute cannot be changed. 
    # @param label_id 
    # @param policy_label 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyLabel, Fixnum, Hash)>] PolicyLabel data, response status code and response headers
    def create_or_replace_policy_label_for_infra_0_with_http_info(label_id, policy_label, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraLabelsApi.create_or_replace_policy_label_for_infra_0 ...'
      end
      # verify the required parameter 'label_id' is set
      if @api_client.config.client_side_validation && label_id.nil?
        fail ArgumentError, "Missing the required parameter 'label_id' when calling PolicyInfraLabelsApi.create_or_replace_policy_label_for_infra_0"
      end
      # verify the required parameter 'policy_label' is set
      if @api_client.config.client_side_validation && policy_label.nil?
        fail ArgumentError, "Missing the required parameter 'policy_label' when calling PolicyInfraLabelsApi.create_or_replace_policy_label_for_infra_0"
      end
      # resource path
      local_var_path = '/global-infra/labels/{label-id}'.sub('{' + 'label-id' + '}', label_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_label)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyLabel')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraLabelsApi#create_or_replace_policy_label_for_infra_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete PolicyLabel object
    # Delete PolicyLabel object
    # @param label_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_policy_label_for_infra(label_id, opts = {})
      delete_policy_label_for_infra_with_http_info(label_id, opts)
      nil
    end

    # Delete PolicyLabel object
    # Delete PolicyLabel object
    # @param label_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_policy_label_for_infra_with_http_info(label_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraLabelsApi.delete_policy_label_for_infra ...'
      end
      # verify the required parameter 'label_id' is set
      if @api_client.config.client_side_validation && label_id.nil?
        fail ArgumentError, "Missing the required parameter 'label_id' when calling PolicyInfraLabelsApi.delete_policy_label_for_infra"
      end
      # resource path
      local_var_path = '/infra/labels/{label-id}'.sub('{' + 'label-id' + '}', label_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraLabelsApi#delete_policy_label_for_infra\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete PolicyLabel object
    # Delete PolicyLabel object
    # @param label_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_policy_label_for_infra_0(label_id, opts = {})
      delete_policy_label_for_infra_0_with_http_info(label_id, opts)
      nil
    end

    # Delete PolicyLabel object
    # Delete PolicyLabel object
    # @param label_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_policy_label_for_infra_0_with_http_info(label_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraLabelsApi.delete_policy_label_for_infra_0 ...'
      end
      # verify the required parameter 'label_id' is set
      if @api_client.config.client_side_validation && label_id.nil?
        fail ArgumentError, "Missing the required parameter 'label_id' when calling PolicyInfraLabelsApi.delete_policy_label_for_infra_0"
      end
      # resource path
      local_var_path = '/global-infra/labels/{label-id}'.sub('{' + 'label-id' + '}', label_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraLabelsApi#delete_policy_label_for_infra_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List labels for infra
    # Paginated list of all labels for infra. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [PolicyLabelListResult]
    def list_policy_label_for_infra(opts = {})
      data, _status_code, _headers = list_policy_label_for_infra_with_http_info(opts)
      data
    end

    # List labels for infra
    # Paginated list of all labels for infra. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(PolicyLabelListResult, Fixnum, Hash)>] PolicyLabelListResult data, response status code and response headers
    def list_policy_label_for_infra_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraLabelsApi.list_policy_label_for_infra ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraLabelsApi.list_policy_label_for_infra, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraLabelsApi.list_policy_label_for_infra, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/labels'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyLabelListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraLabelsApi#list_policy_label_for_infra\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List labels for infra
    # Paginated list of all labels for infra. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [PolicyLabelListResult]
    def list_policy_label_for_infra_0(opts = {})
      data, _status_code, _headers = list_policy_label_for_infra_0_with_http_info(opts)
      data
    end

    # List labels for infra
    # Paginated list of all labels for infra. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(PolicyLabelListResult, Fixnum, Hash)>] PolicyLabelListResult data, response status code and response headers
    def list_policy_label_for_infra_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraLabelsApi.list_policy_label_for_infra_0 ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraLabelsApi.list_policy_label_for_infra_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraLabelsApi.list_policy_label_for_infra_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/labels'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyLabelListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraLabelsApi#list_policy_label_for_infra_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read lable
    # Read a label. 
    # @param label_id 
    # @param [Hash] opts the optional parameters
    # @return [PolicyLabel]
    def read_policy_label_for_infra(label_id, opts = {})
      data, _status_code, _headers = read_policy_label_for_infra_with_http_info(label_id, opts)
      data
    end

    # Read lable
    # Read a label. 
    # @param label_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyLabel, Fixnum, Hash)>] PolicyLabel data, response status code and response headers
    def read_policy_label_for_infra_with_http_info(label_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraLabelsApi.read_policy_label_for_infra ...'
      end
      # verify the required parameter 'label_id' is set
      if @api_client.config.client_side_validation && label_id.nil?
        fail ArgumentError, "Missing the required parameter 'label_id' when calling PolicyInfraLabelsApi.read_policy_label_for_infra"
      end
      # resource path
      local_var_path = '/infra/labels/{label-id}'.sub('{' + 'label-id' + '}', label_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyLabel')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraLabelsApi#read_policy_label_for_infra\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read lable
    # Read a label. 
    # @param label_id 
    # @param [Hash] opts the optional parameters
    # @return [PolicyLabel]
    def read_policy_label_for_infra_0(label_id, opts = {})
      data, _status_code, _headers = read_policy_label_for_infra_0_with_http_info(label_id, opts)
      data
    end

    # Read lable
    # Read a label. 
    # @param label_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyLabel, Fixnum, Hash)>] PolicyLabel data, response status code and response headers
    def read_policy_label_for_infra_0_with_http_info(label_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraLabelsApi.read_policy_label_for_infra_0 ...'
      end
      # verify the required parameter 'label_id' is set
      if @api_client.config.client_side_validation && label_id.nil?
        fail ArgumentError, "Missing the required parameter 'label_id' when calling PolicyInfraLabelsApi.read_policy_label_for_infra_0"
      end
      # resource path
      local_var_path = '/global-infra/labels/{label-id}'.sub('{' + 'label-id' + '}', label_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyLabel')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraLabelsApi#read_policy_label_for_infra_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Patch an existing label object
    # Create label if not exists, otherwise take the partial updates. Note, once the label is created type attribute can not be changed. 
    # @param label_id 
    # @param policy_label 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def update_policy_label_for_infra(label_id, policy_label, opts = {})
      update_policy_label_for_infra_with_http_info(label_id, policy_label, opts)
      nil
    end

    # Patch an existing label object
    # Create label if not exists, otherwise take the partial updates. Note, once the label is created type attribute can not be changed. 
    # @param label_id 
    # @param policy_label 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def update_policy_label_for_infra_with_http_info(label_id, policy_label, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraLabelsApi.update_policy_label_for_infra ...'
      end
      # verify the required parameter 'label_id' is set
      if @api_client.config.client_side_validation && label_id.nil?
        fail ArgumentError, "Missing the required parameter 'label_id' when calling PolicyInfraLabelsApi.update_policy_label_for_infra"
      end
      # verify the required parameter 'policy_label' is set
      if @api_client.config.client_side_validation && policy_label.nil?
        fail ArgumentError, "Missing the required parameter 'policy_label' when calling PolicyInfraLabelsApi.update_policy_label_for_infra"
      end
      # resource path
      local_var_path = '/infra/labels/{label-id}'.sub('{' + 'label-id' + '}', label_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_label)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraLabelsApi#update_policy_label_for_infra\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Patch an existing label object
    # Create label if not exists, otherwise take the partial updates. Note, once the label is created type attribute can not be changed. 
    # @param label_id 
    # @param policy_label 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def update_policy_label_for_infra_0(label_id, policy_label, opts = {})
      update_policy_label_for_infra_0_with_http_info(label_id, policy_label, opts)
      nil
    end

    # Patch an existing label object
    # Create label if not exists, otherwise take the partial updates. Note, once the label is created type attribute can not be changed. 
    # @param label_id 
    # @param policy_label 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def update_policy_label_for_infra_0_with_http_info(label_id, policy_label, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraLabelsApi.update_policy_label_for_infra_0 ...'
      end
      # verify the required parameter 'label_id' is set
      if @api_client.config.client_side_validation && label_id.nil?
        fail ArgumentError, "Missing the required parameter 'label_id' when calling PolicyInfraLabelsApi.update_policy_label_for_infra_0"
      end
      # verify the required parameter 'policy_label' is set
      if @api_client.config.client_side_validation && policy_label.nil?
        fail ArgumentError, "Missing the required parameter 'policy_label' when calling PolicyInfraLabelsApi.update_policy_label_for_infra_0"
      end
      # resource path
      local_var_path = '/global-infra/labels/{label-id}'.sub('{' + 'label-id' + '}', label_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_label)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraLabelsApi#update_policy_label_for_infra_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
