=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyInfraTagsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Get details of tag bulk operation request
    # Get details of tag bulk operation request with which tag is applied or removed on virtual machines. 
    # @param operation_id 
    # @param [Hash] opts the optional parameters
    # @return [TagBulkOperation]
    def get_tag_bulk_operation(operation_id, opts = {})
      data, _status_code, _headers = get_tag_bulk_operation_with_http_info(operation_id, opts)
      data
    end

    # Get details of tag bulk operation request
    # Get details of tag bulk operation request with which tag is applied or removed on virtual machines. 
    # @param operation_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TagBulkOperation, Fixnum, Hash)>] TagBulkOperation data, response status code and response headers
    def get_tag_bulk_operation_with_http_info(operation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraTagsApi.get_tag_bulk_operation ...'
      end
      # verify the required parameter 'operation_id' is set
      if @api_client.config.client_side_validation && operation_id.nil?
        fail ArgumentError, "Missing the required parameter 'operation_id' when calling PolicyInfraTagsApi.get_tag_bulk_operation"
      end
      # resource path
      local_var_path = '/infra/tags/tag-operations/{operation-id}'.sub('{' + 'operation-id' + '}', operation_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TagBulkOperation')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraTagsApi#get_tag_bulk_operation\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get details of tag bulk operation request
    # Get details of tag bulk operation request with which tag is applied or removed on virtual machines. 
    # @param operation_id 
    # @param [Hash] opts the optional parameters
    # @return [TagBulkOperation]
    def get_tag_bulk_operation_0(operation_id, opts = {})
      data, _status_code, _headers = get_tag_bulk_operation_0_with_http_info(operation_id, opts)
      data
    end

    # Get details of tag bulk operation request
    # Get details of tag bulk operation request with which tag is applied or removed on virtual machines. 
    # @param operation_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TagBulkOperation, Fixnum, Hash)>] TagBulkOperation data, response status code and response headers
    def get_tag_bulk_operation_0_with_http_info(operation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraTagsApi.get_tag_bulk_operation_0 ...'
      end
      # verify the required parameter 'operation_id' is set
      if @api_client.config.client_side_validation && operation_id.nil?
        fail ArgumentError, "Missing the required parameter 'operation_id' when calling PolicyInfraTagsApi.get_tag_bulk_operation_0"
      end
      # resource path
      local_var_path = '/global-infra/tags/tag-operations/{operation-id}'.sub('{' + 'operation-id' + '}', operation_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TagBulkOperation')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraTagsApi#get_tag_bulk_operation_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get status of tag bulk operation
    # Get status of tag bulk operation with details of tag operation on each virtual machine. 
    # @param operation_id 
    # @param [Hash] opts the optional parameters
    # @return [TagBulkOperationStatus]
    def get_tag_bulk_operation_status(operation_id, opts = {})
      data, _status_code, _headers = get_tag_bulk_operation_status_with_http_info(operation_id, opts)
      data
    end

    # Get status of tag bulk operation
    # Get status of tag bulk operation with details of tag operation on each virtual machine. 
    # @param operation_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TagBulkOperationStatus, Fixnum, Hash)>] TagBulkOperationStatus data, response status code and response headers
    def get_tag_bulk_operation_status_with_http_info(operation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraTagsApi.get_tag_bulk_operation_status ...'
      end
      # verify the required parameter 'operation_id' is set
      if @api_client.config.client_side_validation && operation_id.nil?
        fail ArgumentError, "Missing the required parameter 'operation_id' when calling PolicyInfraTagsApi.get_tag_bulk_operation_status"
      end
      # resource path
      local_var_path = '/global-infra/tags/tag-operations/{operation-id}/status'.sub('{' + 'operation-id' + '}', operation_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TagBulkOperationStatus')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraTagsApi#get_tag_bulk_operation_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get status of tag bulk operation
    # Get status of tag bulk operation with details of tag operation on each virtual machine. 
    # @param operation_id 
    # @param [Hash] opts the optional parameters
    # @return [TagBulkOperationStatus]
    def get_tag_bulk_operation_status_0(operation_id, opts = {})
      data, _status_code, _headers = get_tag_bulk_operation_status_0_with_http_info(operation_id, opts)
      data
    end

    # Get status of tag bulk operation
    # Get status of tag bulk operation with details of tag operation on each virtual machine. 
    # @param operation_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TagBulkOperationStatus, Fixnum, Hash)>] TagBulkOperationStatus data, response status code and response headers
    def get_tag_bulk_operation_status_0_with_http_info(operation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraTagsApi.get_tag_bulk_operation_status_0 ...'
      end
      # verify the required parameter 'operation_id' is set
      if @api_client.config.client_side_validation && operation_id.nil?
        fail ArgumentError, "Missing the required parameter 'operation_id' when calling PolicyInfraTagsApi.get_tag_bulk_operation_status_0"
      end
      # resource path
      local_var_path = '/infra/tags/tag-operations/{operation-id}/status'.sub('{' + 'operation-id' + '}', operation_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TagBulkOperationStatus')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraTagsApi#get_tag_bulk_operation_status_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all unique tags.
    # Returns paginated list of all unique tags. Supports filtering by scope, tag and source from which tags are synched. Supports starts with, equals and contains operators on scope and tag values. To filter tags by starts with on scope or tag, use '*' as prefix before the value. To filter tags by ends with on scope or tag, use '*' as suffix after the value. To filter tags by contain on scope or tag, use '*' as prefix and suffix on the value. Below special characters in the filter value needs to be escaped with hex values. - Character '&' needs to be escaped as '%26' - Character '[' needs to be escaped as '%5B' - Character ']' needs to be escaped as '%5D' - Character '+' needs to be escaped as '%2B' - Character '#' needs to be escaped as '%23' Sort option for list of unique tags is available only on tag and scope properties. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [String] :scope Tag scope
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @option opts [String] :source Source from which tags are synced.
    # @option opts [String] :tag Tag value
    # @return [TagInfoListResult]
    def list_all_tags(opts = {})
      data, _status_code, _headers = list_all_tags_with_http_info(opts)
      data
    end

    # List all unique tags.
    # Returns paginated list of all unique tags. Supports filtering by scope, tag and source from which tags are synched. Supports starts with, equals and contains operators on scope and tag values. To filter tags by starts with on scope or tag, use &#39;*&#39; as prefix before the value. To filter tags by ends with on scope or tag, use &#39;*&#39; as suffix after the value. To filter tags by contain on scope or tag, use &#39;*&#39; as prefix and suffix on the value. Below special characters in the filter value needs to be escaped with hex values. - Character &#39;&amp;&#39; needs to be escaped as &#39;%26&#39; - Character &#39;[&#39; needs to be escaped as &#39;%5B&#39; - Character &#39;]&#39; needs to be escaped as &#39;%5D&#39; - Character &#39;+&#39; needs to be escaped as &#39;%2B&#39; - Character &#39;#&#39; needs to be escaped as &#39;%23&#39; Sort option for list of unique tags is available only on tag and scope properties. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [String] :scope Tag scope
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @option opts [String] :source Source from which tags are synced.
    # @option opts [String] :tag Tag value
    # @return [Array<(TagInfoListResult, Fixnum, Hash)>] TagInfoListResult data, response status code and response headers
    def list_all_tags_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraTagsApi.list_all_tags ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraTagsApi.list_all_tags, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraTagsApi.list_all_tags, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && opts[:'source'] && !['Amazon', 'Azure', 'NSX', 'ANY'].include?(opts[:'source'])
        fail ArgumentError, 'invalid value for "source", must be one of Amazon, Azure, NSX, ANY'
      end
      # resource path
      local_var_path = '/infra/tags'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'scope'] = opts[:'scope'] if !opts[:'scope'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?
      query_params[:'source'] = opts[:'source'] if !opts[:'source'].nil?
      query_params[:'tag'] = opts[:'tag'] if !opts[:'tag'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TagInfoListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraTagsApi#list_all_tags\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all unique tags.
    # Returns paginated list of all unique tags. Supports filtering by scope, tag and source from which tags are synched. Supports starts with, equals and contains operators on scope and tag values. To filter tags by starts with on scope or tag, use '*' as prefix before the value. To filter tags by ends with on scope or tag, use '*' as suffix after the value. To filter tags by contain on scope or tag, use '*' as prefix and suffix on the value. Below special characters in the filter value needs to be escaped with hex values. - Character '&' needs to be escaped as '%26' - Character '[' needs to be escaped as '%5B' - Character ']' needs to be escaped as '%5D' - Character '+' needs to be escaped as '%2B' - Character '#' needs to be escaped as '%23' Sort option for list of unique tags is available only on tag and scope properties. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [String] :scope Tag scope
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @option opts [String] :source Source from which tags are synced.
    # @option opts [String] :tag Tag value
    # @return [TagInfoListResult]
    def list_all_tags_0(opts = {})
      data, _status_code, _headers = list_all_tags_0_with_http_info(opts)
      data
    end

    # List all unique tags.
    # Returns paginated list of all unique tags. Supports filtering by scope, tag and source from which tags are synched. Supports starts with, equals and contains operators on scope and tag values. To filter tags by starts with on scope or tag, use &#39;*&#39; as prefix before the value. To filter tags by ends with on scope or tag, use &#39;*&#39; as suffix after the value. To filter tags by contain on scope or tag, use &#39;*&#39; as prefix and suffix on the value. Below special characters in the filter value needs to be escaped with hex values. - Character &#39;&amp;&#39; needs to be escaped as &#39;%26&#39; - Character &#39;[&#39; needs to be escaped as &#39;%5B&#39; - Character &#39;]&#39; needs to be escaped as &#39;%5D&#39; - Character &#39;+&#39; needs to be escaped as &#39;%2B&#39; - Character &#39;#&#39; needs to be escaped as &#39;%23&#39; Sort option for list of unique tags is available only on tag and scope properties. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [String] :scope Tag scope
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @option opts [String] :source Source from which tags are synced.
    # @option opts [String] :tag Tag value
    # @return [Array<(TagInfoListResult, Fixnum, Hash)>] TagInfoListResult data, response status code and response headers
    def list_all_tags_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraTagsApi.list_all_tags_0 ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraTagsApi.list_all_tags_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraTagsApi.list_all_tags_0, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && opts[:'source'] && !['Amazon', 'Azure', 'NSX', 'ANY'].include?(opts[:'source'])
        fail ArgumentError, 'invalid value for "source", must be one of Amazon, Azure, NSX, ANY'
      end
      # resource path
      local_var_path = '/global-infra/tags'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'scope'] = opts[:'scope'] if !opts[:'scope'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?
      query_params[:'source'] = opts[:'source'] if !opts[:'source'].nil?
      query_params[:'tag'] = opts[:'tag'] if !opts[:'tag'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TagInfoListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraTagsApi#list_all_tags_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all objects assigned with matching scope and tag values
    # Paginated list of all objects assigned with matching scope and tag values. Objects are represented in form of resource reference. Sort option is available only on target_type and target_display_name properties. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :filter_text Filter text to restrict tagged objects list with matching filter text.
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [String] :scope Tag scope
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @option opts [String] :tag Tag value
    # @return [PolicyResourceReferenceListResult]
    def list_tagged_objects(opts = {})
      data, _status_code, _headers = list_tagged_objects_with_http_info(opts)
      data
    end

    # List all objects assigned with matching scope and tag values
    # Paginated list of all objects assigned with matching scope and tag values. Objects are represented in form of resource reference. Sort option is available only on target_type and target_display_name properties. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :filter_text Filter text to restrict tagged objects list with matching filter text.
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [String] :scope Tag scope
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @option opts [String] :tag Tag value
    # @return [Array<(PolicyResourceReferenceListResult, Fixnum, Hash)>] PolicyResourceReferenceListResult data, response status code and response headers
    def list_tagged_objects_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraTagsApi.list_tagged_objects ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraTagsApi.list_tagged_objects, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraTagsApi.list_tagged_objects, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/tags/effective-resources'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'filter_text'] = opts[:'filter_text'] if !opts[:'filter_text'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'scope'] = opts[:'scope'] if !opts[:'scope'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?
      query_params[:'tag'] = opts[:'tag'] if !opts[:'tag'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyResourceReferenceListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraTagsApi#list_tagged_objects\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all objects assigned with matching scope and tag values
    # Paginated list of all objects assigned with matching scope and tag values. Objects are represented in form of resource reference. Sort option is available only on target_type and target_display_name properties. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :filter_text Filter text to restrict tagged objects list with matching filter text.
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [String] :scope Tag scope
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @option opts [String] :tag Tag value
    # @return [PolicyResourceReferenceListResult]
    def list_tagged_objects_0(opts = {})
      data, _status_code, _headers = list_tagged_objects_0_with_http_info(opts)
      data
    end

    # List all objects assigned with matching scope and tag values
    # Paginated list of all objects assigned with matching scope and tag values. Objects are represented in form of resource reference. Sort option is available only on target_type and target_display_name properties. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :filter_text Filter text to restrict tagged objects list with matching filter text.
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [String] :scope Tag scope
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @option opts [String] :tag Tag value
    # @return [Array<(PolicyResourceReferenceListResult, Fixnum, Hash)>] PolicyResourceReferenceListResult data, response status code and response headers
    def list_tagged_objects_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraTagsApi.list_tagged_objects_0 ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraTagsApi.list_tagged_objects_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyInfraTagsApi.list_tagged_objects_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/tags/effective-resources'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'filter_text'] = opts[:'filter_text'] if !opts[:'filter_text'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'scope'] = opts[:'scope'] if !opts[:'scope'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?
      query_params[:'tag'] = opts[:'tag'] if !opts[:'tag'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyResourceReferenceListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraTagsApi#list_tagged_objects_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Assign or Unassign tag on multiple Virtual Machines.
    # Tag can be assigned or unassigned on multiple objects. Supported object type is  restricted to Virtual Machine for now and support for other objects will be added  later. Permissions for tag bulk operation would be similar to virtual machine tag permissions. 
    # @param operation_id 
    # @param tag_bulk_operation 
    # @param [Hash] opts the optional parameters
    # @return [TagBulkOperation]
    def tag_bulk_update(operation_id, tag_bulk_operation, opts = {})
      data, _status_code, _headers = tag_bulk_update_with_http_info(operation_id, tag_bulk_operation, opts)
      data
    end

    # Assign or Unassign tag on multiple Virtual Machines.
    # Tag can be assigned or unassigned on multiple objects. Supported object type is  restricted to Virtual Machine for now and support for other objects will be added  later. Permissions for tag bulk operation would be similar to virtual machine tag permissions. 
    # @param operation_id 
    # @param tag_bulk_operation 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TagBulkOperation, Fixnum, Hash)>] TagBulkOperation data, response status code and response headers
    def tag_bulk_update_with_http_info(operation_id, tag_bulk_operation, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraTagsApi.tag_bulk_update ...'
      end
      # verify the required parameter 'operation_id' is set
      if @api_client.config.client_side_validation && operation_id.nil?
        fail ArgumentError, "Missing the required parameter 'operation_id' when calling PolicyInfraTagsApi.tag_bulk_update"
      end
      # verify the required parameter 'tag_bulk_operation' is set
      if @api_client.config.client_side_validation && tag_bulk_operation.nil?
        fail ArgumentError, "Missing the required parameter 'tag_bulk_operation' when calling PolicyInfraTagsApi.tag_bulk_update"
      end
      # resource path
      local_var_path = '/infra/tags/tag-operations/{operation-id}'.sub('{' + 'operation-id' + '}', operation_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(tag_bulk_operation)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TagBulkOperation')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraTagsApi#tag_bulk_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Assign or Unassign tag on multiple Virtual Machines.
    # Tag can be assigned or unassigned on multiple objects. Supported object type is  restricted to Virtual Machine for now and support for other objects will be added  later. Permissions for tag bulk operation would be similar to virtual machine tag permissions. 
    # @param operation_id 
    # @param tag_bulk_operation 
    # @param [Hash] opts the optional parameters
    # @return [TagBulkOperation]
    def tag_bulk_update_0(operation_id, tag_bulk_operation, opts = {})
      data, _status_code, _headers = tag_bulk_update_0_with_http_info(operation_id, tag_bulk_operation, opts)
      data
    end

    # Assign or Unassign tag on multiple Virtual Machines.
    # Tag can be assigned or unassigned on multiple objects. Supported object type is  restricted to Virtual Machine for now and support for other objects will be added  later. Permissions for tag bulk operation would be similar to virtual machine tag permissions. 
    # @param operation_id 
    # @param tag_bulk_operation 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TagBulkOperation, Fixnum, Hash)>] TagBulkOperation data, response status code and response headers
    def tag_bulk_update_0_with_http_info(operation_id, tag_bulk_operation, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyInfraTagsApi.tag_bulk_update_0 ...'
      end
      # verify the required parameter 'operation_id' is set
      if @api_client.config.client_side_validation && operation_id.nil?
        fail ArgumentError, "Missing the required parameter 'operation_id' when calling PolicyInfraTagsApi.tag_bulk_update_0"
      end
      # verify the required parameter 'tag_bulk_operation' is set
      if @api_client.config.client_side_validation && tag_bulk_operation.nil?
        fail ArgumentError, "Missing the required parameter 'tag_bulk_operation' when calling PolicyInfraTagsApi.tag_bulk_update_0"
      end
      # resource path
      local_var_path = '/global-infra/tags/tag-operations/{operation-id}'.sub('{' + 'operation-id' + '}', operation_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(tag_bulk_operation)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TagBulkOperation')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyInfraTagsApi#tag_bulk_update_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
