=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete L2 Bridge Endpoint Profile
    # API will delete L2 bridge profile with ID profile-id
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_l2_bridge_profile(site_id, enforcement_point_id, profile_id, opts = {})
      delete_l2_bridge_profile_with_http_info(site_id, enforcement_point_id, profile_id, opts)
      nil
    end

    # Delete L2 Bridge Endpoint Profile
    # API will delete L2 bridge profile with ID profile-id
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_l2_bridge_profile_with_http_info(site_id, enforcement_point_id, profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.delete_l2_bridge_profile ...'
      end
      # verify the required parameter 'site_id' is set
      if @api_client.config.client_side_validation && site_id.nil?
        fail ArgumentError, "Missing the required parameter 'site_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.delete_l2_bridge_profile"
      end
      # verify the required parameter 'enforcement_point_id' is set
      if @api_client.config.client_side_validation && enforcement_point_id.nil?
        fail ArgumentError, "Missing the required parameter 'enforcement_point_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.delete_l2_bridge_profile"
      end
      # verify the required parameter 'profile_id' is set
      if @api_client.config.client_side_validation && profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'profile_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.delete_l2_bridge_profile"
      end
      # resource path
      local_var_path = '/global-infra/sites/{site-id}/enforcement-points/{enforcement-point-id}/edge-bridge-profiles/{profile-id}'.sub('{' + 'site-id' + '}', site_id.to_s).sub('{' + 'enforcement-point-id' + '}', enforcement_point_id.to_s).sub('{' + 'profile-id' + '}', profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi#delete_l2_bridge_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete L2 Bridge Endpoint Profile
    # API will delete L2 bridge profile with ID profile-id
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_l2_bridge_profile_0(site_id, enforcement_point_id, profile_id, opts = {})
      delete_l2_bridge_profile_0_with_http_info(site_id, enforcement_point_id, profile_id, opts)
      nil
    end

    # Delete L2 Bridge Endpoint Profile
    # API will delete L2 bridge profile with ID profile-id
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_l2_bridge_profile_0_with_http_info(site_id, enforcement_point_id, profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.delete_l2_bridge_profile_0 ...'
      end
      # verify the required parameter 'site_id' is set
      if @api_client.config.client_side_validation && site_id.nil?
        fail ArgumentError, "Missing the required parameter 'site_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.delete_l2_bridge_profile_0"
      end
      # verify the required parameter 'enforcement_point_id' is set
      if @api_client.config.client_side_validation && enforcement_point_id.nil?
        fail ArgumentError, "Missing the required parameter 'enforcement_point_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.delete_l2_bridge_profile_0"
      end
      # verify the required parameter 'profile_id' is set
      if @api_client.config.client_side_validation && profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'profile_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.delete_l2_bridge_profile_0"
      end
      # resource path
      local_var_path = '/infra/sites/{site-id}/enforcement-points/{enforcement-point-id}/edge-bridge-profiles/{profile-id}'.sub('{' + 'site-id' + '}', site_id.to_s).sub('{' + 'enforcement-point-id' + '}', enforcement_point_id.to_s).sub('{' + 'profile-id' + '}', profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi#delete_l2_bridge_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List L2 Bridge Endpoint Profiles
    # List all L2 bridge profiles
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [L2BridgeEndpointProfileListResult]
    def list_l2_bridge_profiles(site_id, enforcement_point_id, opts = {})
      data, _status_code, _headers = list_l2_bridge_profiles_with_http_info(site_id, enforcement_point_id, opts)
      data
    end

    # List L2 Bridge Endpoint Profiles
    # List all L2 bridge profiles
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(L2BridgeEndpointProfileListResult, Fixnum, Hash)>] L2BridgeEndpointProfileListResult data, response status code and response headers
    def list_l2_bridge_profiles_with_http_info(site_id, enforcement_point_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.list_l2_bridge_profiles ...'
      end
      # verify the required parameter 'site_id' is set
      if @api_client.config.client_side_validation && site_id.nil?
        fail ArgumentError, "Missing the required parameter 'site_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.list_l2_bridge_profiles"
      end
      # verify the required parameter 'enforcement_point_id' is set
      if @api_client.config.client_side_validation && enforcement_point_id.nil?
        fail ArgumentError, "Missing the required parameter 'enforcement_point_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.list_l2_bridge_profiles"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.list_l2_bridge_profiles, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.list_l2_bridge_profiles, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/sites/{site-id}/enforcement-points/{enforcement-point-id}/edge-bridge-profiles'.sub('{' + 'site-id' + '}', site_id.to_s).sub('{' + 'enforcement-point-id' + '}', enforcement_point_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'L2BridgeEndpointProfileListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi#list_l2_bridge_profiles\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List L2 Bridge Endpoint Profiles
    # List all L2 bridge profiles
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [L2BridgeEndpointProfileListResult]
    def list_l2_bridge_profiles_0(site_id, enforcement_point_id, opts = {})
      data, _status_code, _headers = list_l2_bridge_profiles_0_with_http_info(site_id, enforcement_point_id, opts)
      data
    end

    # List L2 Bridge Endpoint Profiles
    # List all L2 bridge profiles
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(L2BridgeEndpointProfileListResult, Fixnum, Hash)>] L2BridgeEndpointProfileListResult data, response status code and response headers
    def list_l2_bridge_profiles_0_with_http_info(site_id, enforcement_point_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.list_l2_bridge_profiles_0 ...'
      end
      # verify the required parameter 'site_id' is set
      if @api_client.config.client_side_validation && site_id.nil?
        fail ArgumentError, "Missing the required parameter 'site_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.list_l2_bridge_profiles_0"
      end
      # verify the required parameter 'enforcement_point_id' is set
      if @api_client.config.client_side_validation && enforcement_point_id.nil?
        fail ArgumentError, "Missing the required parameter 'enforcement_point_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.list_l2_bridge_profiles_0"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.list_l2_bridge_profiles_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.list_l2_bridge_profiles_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/sites/{site-id}/enforcement-points/{enforcement-point-id}/edge-bridge-profiles'.sub('{' + 'site-id' + '}', site_id.to_s).sub('{' + 'enforcement-point-id' + '}', enforcement_point_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'L2BridgeEndpointProfileListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi#list_l2_bridge_profiles_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update L2 Bridge Endpoint Profile
    # API will create or update L2 bridge profile with ID profile-id. L2 Bridge profile is only allowed under an enforcement-point with path /infra/sites/default/enforcement-points/default. 
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param l2_bridge_endpoint_profile 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_l2_bridge_profile(site_id, enforcement_point_id, profile_id, l2_bridge_endpoint_profile, opts = {})
      patch_l2_bridge_profile_with_http_info(site_id, enforcement_point_id, profile_id, l2_bridge_endpoint_profile, opts)
      nil
    end

    # Create or update L2 Bridge Endpoint Profile
    # API will create or update L2 bridge profile with ID profile-id. L2 Bridge profile is only allowed under an enforcement-point with path /infra/sites/default/enforcement-points/default. 
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param l2_bridge_endpoint_profile 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_l2_bridge_profile_with_http_info(site_id, enforcement_point_id, profile_id, l2_bridge_endpoint_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.patch_l2_bridge_profile ...'
      end
      # verify the required parameter 'site_id' is set
      if @api_client.config.client_side_validation && site_id.nil?
        fail ArgumentError, "Missing the required parameter 'site_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.patch_l2_bridge_profile"
      end
      # verify the required parameter 'enforcement_point_id' is set
      if @api_client.config.client_side_validation && enforcement_point_id.nil?
        fail ArgumentError, "Missing the required parameter 'enforcement_point_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.patch_l2_bridge_profile"
      end
      # verify the required parameter 'profile_id' is set
      if @api_client.config.client_side_validation && profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'profile_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.patch_l2_bridge_profile"
      end
      # verify the required parameter 'l2_bridge_endpoint_profile' is set
      if @api_client.config.client_side_validation && l2_bridge_endpoint_profile.nil?
        fail ArgumentError, "Missing the required parameter 'l2_bridge_endpoint_profile' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.patch_l2_bridge_profile"
      end
      # resource path
      local_var_path = '/global-infra/sites/{site-id}/enforcement-points/{enforcement-point-id}/edge-bridge-profiles/{profile-id}'.sub('{' + 'site-id' + '}', site_id.to_s).sub('{' + 'enforcement-point-id' + '}', enforcement_point_id.to_s).sub('{' + 'profile-id' + '}', profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(l2_bridge_endpoint_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi#patch_l2_bridge_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update L2 Bridge Endpoint Profile
    # API will create or update L2 bridge profile with ID profile-id. L2 Bridge profile is only allowed under an enforcement-point with path /infra/sites/default/enforcement-points/default. 
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param l2_bridge_endpoint_profile 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_l2_bridge_profile_0(site_id, enforcement_point_id, profile_id, l2_bridge_endpoint_profile, opts = {})
      patch_l2_bridge_profile_0_with_http_info(site_id, enforcement_point_id, profile_id, l2_bridge_endpoint_profile, opts)
      nil
    end

    # Create or update L2 Bridge Endpoint Profile
    # API will create or update L2 bridge profile with ID profile-id. L2 Bridge profile is only allowed under an enforcement-point with path /infra/sites/default/enforcement-points/default. 
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param l2_bridge_endpoint_profile 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_l2_bridge_profile_0_with_http_info(site_id, enforcement_point_id, profile_id, l2_bridge_endpoint_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.patch_l2_bridge_profile_0 ...'
      end
      # verify the required parameter 'site_id' is set
      if @api_client.config.client_side_validation && site_id.nil?
        fail ArgumentError, "Missing the required parameter 'site_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.patch_l2_bridge_profile_0"
      end
      # verify the required parameter 'enforcement_point_id' is set
      if @api_client.config.client_side_validation && enforcement_point_id.nil?
        fail ArgumentError, "Missing the required parameter 'enforcement_point_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.patch_l2_bridge_profile_0"
      end
      # verify the required parameter 'profile_id' is set
      if @api_client.config.client_side_validation && profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'profile_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.patch_l2_bridge_profile_0"
      end
      # verify the required parameter 'l2_bridge_endpoint_profile' is set
      if @api_client.config.client_side_validation && l2_bridge_endpoint_profile.nil?
        fail ArgumentError, "Missing the required parameter 'l2_bridge_endpoint_profile' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.patch_l2_bridge_profile_0"
      end
      # resource path
      local_var_path = '/infra/sites/{site-id}/enforcement-points/{enforcement-point-id}/edge-bridge-profiles/{profile-id}'.sub('{' + 'site-id' + '}', site_id.to_s).sub('{' + 'enforcement-point-id' + '}', enforcement_point_id.to_s).sub('{' + 'profile-id' + '}', profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(l2_bridge_endpoint_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi#patch_l2_bridge_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get L2 Bridge Endpoint Profile
    # Read L2 bridge profile with ID profile-id
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param [Hash] opts the optional parameters
    # @return [L2BridgeEndpointProfile]
    def read_l2_bridge_profile(site_id, enforcement_point_id, profile_id, opts = {})
      data, _status_code, _headers = read_l2_bridge_profile_with_http_info(site_id, enforcement_point_id, profile_id, opts)
      data
    end

    # Get L2 Bridge Endpoint Profile
    # Read L2 bridge profile with ID profile-id
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(L2BridgeEndpointProfile, Fixnum, Hash)>] L2BridgeEndpointProfile data, response status code and response headers
    def read_l2_bridge_profile_with_http_info(site_id, enforcement_point_id, profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.read_l2_bridge_profile ...'
      end
      # verify the required parameter 'site_id' is set
      if @api_client.config.client_side_validation && site_id.nil?
        fail ArgumentError, "Missing the required parameter 'site_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.read_l2_bridge_profile"
      end
      # verify the required parameter 'enforcement_point_id' is set
      if @api_client.config.client_side_validation && enforcement_point_id.nil?
        fail ArgumentError, "Missing the required parameter 'enforcement_point_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.read_l2_bridge_profile"
      end
      # verify the required parameter 'profile_id' is set
      if @api_client.config.client_side_validation && profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'profile_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.read_l2_bridge_profile"
      end
      # resource path
      local_var_path = '/global-infra/sites/{site-id}/enforcement-points/{enforcement-point-id}/edge-bridge-profiles/{profile-id}'.sub('{' + 'site-id' + '}', site_id.to_s).sub('{' + 'enforcement-point-id' + '}', enforcement_point_id.to_s).sub('{' + 'profile-id' + '}', profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'L2BridgeEndpointProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi#read_l2_bridge_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get L2 Bridge Endpoint Profile
    # Read L2 bridge profile with ID profile-id
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param [Hash] opts the optional parameters
    # @return [L2BridgeEndpointProfile]
    def read_l2_bridge_profile_0(site_id, enforcement_point_id, profile_id, opts = {})
      data, _status_code, _headers = read_l2_bridge_profile_0_with_http_info(site_id, enforcement_point_id, profile_id, opts)
      data
    end

    # Get L2 Bridge Endpoint Profile
    # Read L2 bridge profile with ID profile-id
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(L2BridgeEndpointProfile, Fixnum, Hash)>] L2BridgeEndpointProfile data, response status code and response headers
    def read_l2_bridge_profile_0_with_http_info(site_id, enforcement_point_id, profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.read_l2_bridge_profile_0 ...'
      end
      # verify the required parameter 'site_id' is set
      if @api_client.config.client_side_validation && site_id.nil?
        fail ArgumentError, "Missing the required parameter 'site_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.read_l2_bridge_profile_0"
      end
      # verify the required parameter 'enforcement_point_id' is set
      if @api_client.config.client_side_validation && enforcement_point_id.nil?
        fail ArgumentError, "Missing the required parameter 'enforcement_point_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.read_l2_bridge_profile_0"
      end
      # verify the required parameter 'profile_id' is set
      if @api_client.config.client_side_validation && profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'profile_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.read_l2_bridge_profile_0"
      end
      # resource path
      local_var_path = '/infra/sites/{site-id}/enforcement-points/{enforcement-point-id}/edge-bridge-profiles/{profile-id}'.sub('{' + 'site-id' + '}', site_id.to_s).sub('{' + 'enforcement-point-id' + '}', enforcement_point_id.to_s).sub('{' + 'profile-id' + '}', profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'L2BridgeEndpointProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi#read_l2_bridge_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update L2 Bridge Endpoint Profile
    # API will create or update L2 bridge profile with ID profile-id. L2 Bridge profile is only allowed under an enforcement-point with path /infra/sites/default/enforcement-points/default. 
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param l2_bridge_endpoint_profile 
    # @param [Hash] opts the optional parameters
    # @return [L2BridgeEndpointProfile]
    def update_l2_bridge_profile(site_id, enforcement_point_id, profile_id, l2_bridge_endpoint_profile, opts = {})
      data, _status_code, _headers = update_l2_bridge_profile_with_http_info(site_id, enforcement_point_id, profile_id, l2_bridge_endpoint_profile, opts)
      data
    end

    # Create or update L2 Bridge Endpoint Profile
    # API will create or update L2 bridge profile with ID profile-id. L2 Bridge profile is only allowed under an enforcement-point with path /infra/sites/default/enforcement-points/default. 
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param l2_bridge_endpoint_profile 
    # @param [Hash] opts the optional parameters
    # @return [Array<(L2BridgeEndpointProfile, Fixnum, Hash)>] L2BridgeEndpointProfile data, response status code and response headers
    def update_l2_bridge_profile_with_http_info(site_id, enforcement_point_id, profile_id, l2_bridge_endpoint_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.update_l2_bridge_profile ...'
      end
      # verify the required parameter 'site_id' is set
      if @api_client.config.client_side_validation && site_id.nil?
        fail ArgumentError, "Missing the required parameter 'site_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.update_l2_bridge_profile"
      end
      # verify the required parameter 'enforcement_point_id' is set
      if @api_client.config.client_side_validation && enforcement_point_id.nil?
        fail ArgumentError, "Missing the required parameter 'enforcement_point_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.update_l2_bridge_profile"
      end
      # verify the required parameter 'profile_id' is set
      if @api_client.config.client_side_validation && profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'profile_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.update_l2_bridge_profile"
      end
      # verify the required parameter 'l2_bridge_endpoint_profile' is set
      if @api_client.config.client_side_validation && l2_bridge_endpoint_profile.nil?
        fail ArgumentError, "Missing the required parameter 'l2_bridge_endpoint_profile' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.update_l2_bridge_profile"
      end
      # resource path
      local_var_path = '/global-infra/sites/{site-id}/enforcement-points/{enforcement-point-id}/edge-bridge-profiles/{profile-id}'.sub('{' + 'site-id' + '}', site_id.to_s).sub('{' + 'enforcement-point-id' + '}', enforcement_point_id.to_s).sub('{' + 'profile-id' + '}', profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(l2_bridge_endpoint_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'L2BridgeEndpointProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi#update_l2_bridge_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update L2 Bridge Endpoint Profile
    # API will create or update L2 bridge profile with ID profile-id. L2 Bridge profile is only allowed under an enforcement-point with path /infra/sites/default/enforcement-points/default. 
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param l2_bridge_endpoint_profile 
    # @param [Hash] opts the optional parameters
    # @return [L2BridgeEndpointProfile]
    def update_l2_bridge_profile_0(site_id, enforcement_point_id, profile_id, l2_bridge_endpoint_profile, opts = {})
      data, _status_code, _headers = update_l2_bridge_profile_0_with_http_info(site_id, enforcement_point_id, profile_id, l2_bridge_endpoint_profile, opts)
      data
    end

    # Create or update L2 Bridge Endpoint Profile
    # API will create or update L2 bridge profile with ID profile-id. L2 Bridge profile is only allowed under an enforcement-point with path /infra/sites/default/enforcement-points/default. 
    # @param site_id site ID
    # @param enforcement_point_id enforcement point ID
    # @param profile_id profile ID
    # @param l2_bridge_endpoint_profile 
    # @param [Hash] opts the optional parameters
    # @return [Array<(L2BridgeEndpointProfile, Fixnum, Hash)>] L2BridgeEndpointProfile data, response status code and response headers
    def update_l2_bridge_profile_0_with_http_info(site_id, enforcement_point_id, profile_id, l2_bridge_endpoint_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.update_l2_bridge_profile_0 ...'
      end
      # verify the required parameter 'site_id' is set
      if @api_client.config.client_side_validation && site_id.nil?
        fail ArgumentError, "Missing the required parameter 'site_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.update_l2_bridge_profile_0"
      end
      # verify the required parameter 'enforcement_point_id' is set
      if @api_client.config.client_side_validation && enforcement_point_id.nil?
        fail ArgumentError, "Missing the required parameter 'enforcement_point_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.update_l2_bridge_profile_0"
      end
      # verify the required parameter 'profile_id' is set
      if @api_client.config.client_side_validation && profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'profile_id' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.update_l2_bridge_profile_0"
      end
      # verify the required parameter 'l2_bridge_endpoint_profile' is set
      if @api_client.config.client_side_validation && l2_bridge_endpoint_profile.nil?
        fail ArgumentError, "Missing the required parameter 'l2_bridge_endpoint_profile' when calling PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi.update_l2_bridge_profile_0"
      end
      # resource path
      local_var_path = '/infra/sites/{site-id}/enforcement-points/{enforcement-point-id}/edge-bridge-profiles/{profile-id}'.sub('{' + 'site-id' + '}', site_id.to_s).sub('{' + 'enforcement-point-id' + '}', enforcement_point_id.to_s).sub('{' + 'profile-id' + '}', profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(l2_bridge_endpoint_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'L2BridgeEndpointProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsEdgeBridgeProfilesApi#update_l2_bridge_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
