=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyNetworkingConnectivitySegmentsServiceSegmentsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create service segment
    # A service segment with the service-segment-id is created. Modification of service segment is not supported. 
    # @param service_segment_id Service Segment ID
    # @param service_segment 
    # @param [Hash] opts the optional parameters
    # @return [ServiceSegment]
    def create_service_segment(service_segment_id, service_segment, opts = {})
      data, _status_code, _headers = create_service_segment_with_http_info(service_segment_id, service_segment, opts)
      data
    end

    # Create service segment
    # A service segment with the service-segment-id is created. Modification of service segment is not supported. 
    # @param service_segment_id Service Segment ID
    # @param service_segment 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ServiceSegment, Fixnum, Hash)>] ServiceSegment data, response status code and response headers
    def create_service_segment_with_http_info(service_segment_id, service_segment, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.create_service_segment ...'
      end
      # verify the required parameter 'service_segment_id' is set
      if @api_client.config.client_side_validation && service_segment_id.nil?
        fail ArgumentError, "Missing the required parameter 'service_segment_id' when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.create_service_segment"
      end
      # verify the required parameter 'service_segment' is set
      if @api_client.config.client_side_validation && service_segment.nil?
        fail ArgumentError, "Missing the required parameter 'service_segment' when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.create_service_segment"
      end
      # resource path
      local_var_path = '/infra/segments/service-segments/{service-segment-id}'.sub('{' + 'service-segment-id' + '}', service_segment_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(service_segment)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ServiceSegment')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi#create_service_segment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create service segment
    # A service segment with the service-segment-id is created. Modification of service segment is not supported. 
    # @param service_segment_id Service Segment ID
    # @param service_segment 
    # @param [Hash] opts the optional parameters
    # @return [ServiceSegment]
    def create_service_segment_0(service_segment_id, service_segment, opts = {})
      data, _status_code, _headers = create_service_segment_0_with_http_info(service_segment_id, service_segment, opts)
      data
    end

    # Create service segment
    # A service segment with the service-segment-id is created. Modification of service segment is not supported. 
    # @param service_segment_id Service Segment ID
    # @param service_segment 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ServiceSegment, Fixnum, Hash)>] ServiceSegment data, response status code and response headers
    def create_service_segment_0_with_http_info(service_segment_id, service_segment, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.create_service_segment_0 ...'
      end
      # verify the required parameter 'service_segment_id' is set
      if @api_client.config.client_side_validation && service_segment_id.nil?
        fail ArgumentError, "Missing the required parameter 'service_segment_id' when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.create_service_segment_0"
      end
      # verify the required parameter 'service_segment' is set
      if @api_client.config.client_side_validation && service_segment.nil?
        fail ArgumentError, "Missing the required parameter 'service_segment' when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.create_service_segment_0"
      end
      # resource path
      local_var_path = '/global-infra/segments/service-segments/{service-segment-id}'.sub('{' + 'service-segment-id' + '}', service_segment_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(service_segment)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ServiceSegment')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi#create_service_segment_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete Service Segment
    # Delete Service Segment with given ID
    # @param service_segment_id Service Segment ID
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_service_segment(service_segment_id, opts = {})
      delete_service_segment_with_http_info(service_segment_id, opts)
      nil
    end

    # Delete Service Segment
    # Delete Service Segment with given ID
    # @param service_segment_id Service Segment ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_service_segment_with_http_info(service_segment_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.delete_service_segment ...'
      end
      # verify the required parameter 'service_segment_id' is set
      if @api_client.config.client_side_validation && service_segment_id.nil?
        fail ArgumentError, "Missing the required parameter 'service_segment_id' when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.delete_service_segment"
      end
      # resource path
      local_var_path = '/infra/segments/service-segments/{service-segment-id}'.sub('{' + 'service-segment-id' + '}', service_segment_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi#delete_service_segment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete Service Segment
    # Delete Service Segment with given ID
    # @param service_segment_id Service Segment ID
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_service_segment_0(service_segment_id, opts = {})
      delete_service_segment_0_with_http_info(service_segment_id, opts)
      nil
    end

    # Delete Service Segment
    # Delete Service Segment with given ID
    # @param service_segment_id Service Segment ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_service_segment_0_with_http_info(service_segment_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.delete_service_segment_0 ...'
      end
      # verify the required parameter 'service_segment_id' is set
      if @api_client.config.client_side_validation && service_segment_id.nil?
        fail ArgumentError, "Missing the required parameter 'service_segment_id' when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.delete_service_segment_0"
      end
      # resource path
      local_var_path = '/global-infra/segments/service-segments/{service-segment-id}'.sub('{' + 'service-segment-id' + '}', service_segment_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi#delete_service_segment_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Service Segments
    # Paginated list of all Service Segments 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [ServiceSegmentListResult]
    def list_service_segments(opts = {})
      data, _status_code, _headers = list_service_segments_with_http_info(opts)
      data
    end

    # List Service Segments
    # Paginated list of all Service Segments 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(ServiceSegmentListResult, Fixnum, Hash)>] ServiceSegmentListResult data, response status code and response headers
    def list_service_segments_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.list_service_segments ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.list_service_segments, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.list_service_segments, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/segments/service-segments'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ServiceSegmentListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi#list_service_segments\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Service Segments
    # Paginated list of all Service Segments 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [ServiceSegmentListResult]
    def list_service_segments_0(opts = {})
      data, _status_code, _headers = list_service_segments_0_with_http_info(opts)
      data
    end

    # List Service Segments
    # Paginated list of all Service Segments 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(ServiceSegmentListResult, Fixnum, Hash)>] ServiceSegmentListResult data, response status code and response headers
    def list_service_segments_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.list_service_segments_0 ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.list_service_segments_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.list_service_segments_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/segments/service-segments'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ServiceSegmentListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi#list_service_segments_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create a service segment
    # A service segment with the service-segment-id is created. Modification of service segment is not supported. 
    # @param service_segment_id Service Segment ID
    # @param service_segment 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_service_segment(service_segment_id, service_segment, opts = {})
      patch_service_segment_with_http_info(service_segment_id, service_segment, opts)
      nil
    end

    # Create a service segment
    # A service segment with the service-segment-id is created. Modification of service segment is not supported. 
    # @param service_segment_id Service Segment ID
    # @param service_segment 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_service_segment_with_http_info(service_segment_id, service_segment, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.patch_service_segment ...'
      end
      # verify the required parameter 'service_segment_id' is set
      if @api_client.config.client_side_validation && service_segment_id.nil?
        fail ArgumentError, "Missing the required parameter 'service_segment_id' when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.patch_service_segment"
      end
      # verify the required parameter 'service_segment' is set
      if @api_client.config.client_side_validation && service_segment.nil?
        fail ArgumentError, "Missing the required parameter 'service_segment' when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.patch_service_segment"
      end
      # resource path
      local_var_path = '/infra/segments/service-segments/{service-segment-id}'.sub('{' + 'service-segment-id' + '}', service_segment_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(service_segment)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi#patch_service_segment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create a service segment
    # A service segment with the service-segment-id is created. Modification of service segment is not supported. 
    # @param service_segment_id Service Segment ID
    # @param service_segment 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_service_segment_0(service_segment_id, service_segment, opts = {})
      patch_service_segment_0_with_http_info(service_segment_id, service_segment, opts)
      nil
    end

    # Create a service segment
    # A service segment with the service-segment-id is created. Modification of service segment is not supported. 
    # @param service_segment_id Service Segment ID
    # @param service_segment 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_service_segment_0_with_http_info(service_segment_id, service_segment, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.patch_service_segment_0 ...'
      end
      # verify the required parameter 'service_segment_id' is set
      if @api_client.config.client_side_validation && service_segment_id.nil?
        fail ArgumentError, "Missing the required parameter 'service_segment_id' when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.patch_service_segment_0"
      end
      # verify the required parameter 'service_segment' is set
      if @api_client.config.client_side_validation && service_segment.nil?
        fail ArgumentError, "Missing the required parameter 'service_segment' when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.patch_service_segment_0"
      end
      # resource path
      local_var_path = '/global-infra/segments/service-segments/{service-segment-id}'.sub('{' + 'service-segment-id' + '}', service_segment_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(service_segment)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi#patch_service_segment_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read Service Segment
    # Read a Service Segment with the given id
    # @param service_segment_id Service Segment ID
    # @param [Hash] opts the optional parameters
    # @return [ServiceSegment]
    def read_service_segment(service_segment_id, opts = {})
      data, _status_code, _headers = read_service_segment_with_http_info(service_segment_id, opts)
      data
    end

    # Read Service Segment
    # Read a Service Segment with the given id
    # @param service_segment_id Service Segment ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(ServiceSegment, Fixnum, Hash)>] ServiceSegment data, response status code and response headers
    def read_service_segment_with_http_info(service_segment_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.read_service_segment ...'
      end
      # verify the required parameter 'service_segment_id' is set
      if @api_client.config.client_side_validation && service_segment_id.nil?
        fail ArgumentError, "Missing the required parameter 'service_segment_id' when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.read_service_segment"
      end
      # resource path
      local_var_path = '/infra/segments/service-segments/{service-segment-id}'.sub('{' + 'service-segment-id' + '}', service_segment_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ServiceSegment')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi#read_service_segment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read Service Segment
    # Read a Service Segment with the given id
    # @param service_segment_id Service Segment ID
    # @param [Hash] opts the optional parameters
    # @return [ServiceSegment]
    def read_service_segment_0(service_segment_id, opts = {})
      data, _status_code, _headers = read_service_segment_0_with_http_info(service_segment_id, opts)
      data
    end

    # Read Service Segment
    # Read a Service Segment with the given id
    # @param service_segment_id Service Segment ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(ServiceSegment, Fixnum, Hash)>] ServiceSegment data, response status code and response headers
    def read_service_segment_0_with_http_info(service_segment_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.read_service_segment_0 ...'
      end
      # verify the required parameter 'service_segment_id' is set
      if @api_client.config.client_side_validation && service_segment_id.nil?
        fail ArgumentError, "Missing the required parameter 'service_segment_id' when calling PolicyNetworkingConnectivitySegmentsServiceSegmentsApi.read_service_segment_0"
      end
      # resource path
      local_var_path = '/global-infra/segments/service-segments/{service-segment-id}'.sub('{' + 'service-segment-id' + '}', service_segment_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ServiceSegment')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivitySegmentsServiceSegmentsApi#read_service_segment_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
