=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create or Update evpn tunnel endpoint configuration
    # Create or update evpn tunnel endpoint configuration. 
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param evpn_tunnel_endpoint_config 
    # @param [Hash] opts the optional parameters
    # @return [EvpnTunnelEndpointConfig]
    def create_or_update_evpn_tunnel_endpoint_config(tier_0_id, locale_services_id, tunnel_endpoint_id, evpn_tunnel_endpoint_config, opts = {})
      data, _status_code, _headers = create_or_update_evpn_tunnel_endpoint_config_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, evpn_tunnel_endpoint_config, opts)
      data
    end

    # Create or Update evpn tunnel endpoint configuration
    # Create or update evpn tunnel endpoint configuration. 
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param evpn_tunnel_endpoint_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(EvpnTunnelEndpointConfig, Fixnum, Hash)>] EvpnTunnelEndpointConfig data, response status code and response headers
    def create_or_update_evpn_tunnel_endpoint_config_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, evpn_tunnel_endpoint_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.create_or_update_evpn_tunnel_endpoint_config ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.create_or_update_evpn_tunnel_endpoint_config"
      end
      # verify the required parameter 'locale_services_id' is set
      if @api_client.config.client_side_validation && locale_services_id.nil?
        fail ArgumentError, "Missing the required parameter 'locale_services_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.create_or_update_evpn_tunnel_endpoint_config"
      end
      # verify the required parameter 'tunnel_endpoint_id' is set
      if @api_client.config.client_side_validation && tunnel_endpoint_id.nil?
        fail ArgumentError, "Missing the required parameter 'tunnel_endpoint_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.create_or_update_evpn_tunnel_endpoint_config"
      end
      # verify the required parameter 'evpn_tunnel_endpoint_config' is set
      if @api_client.config.client_side_validation && evpn_tunnel_endpoint_config.nil?
        fail ArgumentError, "Missing the required parameter 'evpn_tunnel_endpoint_config' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.create_or_update_evpn_tunnel_endpoint_config"
      end
      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/locale-services/{locale-services-id}/evpn-tunnel-endpoints/{tunnel-endpoint-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'locale-services-id' + '}', locale_services_id.to_s).sub('{' + 'tunnel-endpoint-id' + '}', tunnel_endpoint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(evpn_tunnel_endpoint_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'EvpnTunnelEndpointConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#create_or_update_evpn_tunnel_endpoint_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or Update evpn tunnel endpoint configuration
    # Create or update evpn tunnel endpoint configuration. 
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param evpn_tunnel_endpoint_config 
    # @param [Hash] opts the optional parameters
    # @return [EvpnTunnelEndpointConfig]
    def create_or_update_evpn_tunnel_endpoint_config_0(tier_0_id, locale_services_id, tunnel_endpoint_id, evpn_tunnel_endpoint_config, opts = {})
      data, _status_code, _headers = create_or_update_evpn_tunnel_endpoint_config_0_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, evpn_tunnel_endpoint_config, opts)
      data
    end

    # Create or Update evpn tunnel endpoint configuration
    # Create or update evpn tunnel endpoint configuration. 
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param evpn_tunnel_endpoint_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(EvpnTunnelEndpointConfig, Fixnum, Hash)>] EvpnTunnelEndpointConfig data, response status code and response headers
    def create_or_update_evpn_tunnel_endpoint_config_0_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, evpn_tunnel_endpoint_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.create_or_update_evpn_tunnel_endpoint_config_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.create_or_update_evpn_tunnel_endpoint_config_0"
      end
      # verify the required parameter 'locale_services_id' is set
      if @api_client.config.client_side_validation && locale_services_id.nil?
        fail ArgumentError, "Missing the required parameter 'locale_services_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.create_or_update_evpn_tunnel_endpoint_config_0"
      end
      # verify the required parameter 'tunnel_endpoint_id' is set
      if @api_client.config.client_side_validation && tunnel_endpoint_id.nil?
        fail ArgumentError, "Missing the required parameter 'tunnel_endpoint_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.create_or_update_evpn_tunnel_endpoint_config_0"
      end
      # verify the required parameter 'evpn_tunnel_endpoint_config' is set
      if @api_client.config.client_side_validation && evpn_tunnel_endpoint_config.nil?
        fail ArgumentError, "Missing the required parameter 'evpn_tunnel_endpoint_config' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.create_or_update_evpn_tunnel_endpoint_config_0"
      end
      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/locale-services/{locale-services-id}/evpn-tunnel-endpoints/{tunnel-endpoint-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'locale-services-id' + '}', locale_services_id.to_s).sub('{' + 'tunnel-endpoint-id' + '}', tunnel_endpoint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(evpn_tunnel_endpoint_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'EvpnTunnelEndpointConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#create_or_update_evpn_tunnel_endpoint_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete evpn tunnel endpoint configuration
    # Delete evpn tunnel endpoint configuration.
    # @param config_id tier0 id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_evpn_tenant_config(config_id, opts = {})
      delete_evpn_tenant_config_with_http_info(config_id, opts)
      nil
    end

    # Delete evpn tunnel endpoint configuration
    # Delete evpn tunnel endpoint configuration.
    # @param config_id tier0 id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_evpn_tenant_config_with_http_info(config_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.delete_evpn_tenant_config ...'
      end
      # verify the required parameter 'config_id' is set
      if @api_client.config.client_side_validation && config_id.nil?
        fail ArgumentError, "Missing the required parameter 'config_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.delete_evpn_tenant_config"
      end
      # resource path
      local_var_path = '/global-infra/evpn-tenant-configs/{config-id}'.sub('{' + 'config-id' + '}', config_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#delete_evpn_tenant_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete evpn tunnel endpoint configuration
    # Delete evpn tunnel endpoint configuration.
    # @param config_id tier0 id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_evpn_tenant_config_0(config_id, opts = {})
      delete_evpn_tenant_config_0_with_http_info(config_id, opts)
      nil
    end

    # Delete evpn tunnel endpoint configuration
    # Delete evpn tunnel endpoint configuration.
    # @param config_id tier0 id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_evpn_tenant_config_0_with_http_info(config_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.delete_evpn_tenant_config_0 ...'
      end
      # verify the required parameter 'config_id' is set
      if @api_client.config.client_side_validation && config_id.nil?
        fail ArgumentError, "Missing the required parameter 'config_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.delete_evpn_tenant_config_0"
      end
      # resource path
      local_var_path = '/infra/evpn-tenant-configs/{config-id}'.sub('{' + 'config-id' + '}', config_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#delete_evpn_tenant_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete evpn tunnel endpoint configuration
    # Delete evpn tunnel endpoint configuration.
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_evpn_tunnel_endpoint_config(tier_0_id, locale_services_id, tunnel_endpoint_id, opts = {})
      delete_evpn_tunnel_endpoint_config_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, opts)
      nil
    end

    # Delete evpn tunnel endpoint configuration
    # Delete evpn tunnel endpoint configuration.
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_evpn_tunnel_endpoint_config_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.delete_evpn_tunnel_endpoint_config ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.delete_evpn_tunnel_endpoint_config"
      end
      # verify the required parameter 'locale_services_id' is set
      if @api_client.config.client_side_validation && locale_services_id.nil?
        fail ArgumentError, "Missing the required parameter 'locale_services_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.delete_evpn_tunnel_endpoint_config"
      end
      # verify the required parameter 'tunnel_endpoint_id' is set
      if @api_client.config.client_side_validation && tunnel_endpoint_id.nil?
        fail ArgumentError, "Missing the required parameter 'tunnel_endpoint_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.delete_evpn_tunnel_endpoint_config"
      end
      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/locale-services/{locale-services-id}/evpn-tunnel-endpoints/{tunnel-endpoint-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'locale-services-id' + '}', locale_services_id.to_s).sub('{' + 'tunnel-endpoint-id' + '}', tunnel_endpoint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#delete_evpn_tunnel_endpoint_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete evpn tunnel endpoint configuration
    # Delete evpn tunnel endpoint configuration.
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_evpn_tunnel_endpoint_config_0(tier_0_id, locale_services_id, tunnel_endpoint_id, opts = {})
      delete_evpn_tunnel_endpoint_config_0_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, opts)
      nil
    end

    # Delete evpn tunnel endpoint configuration
    # Delete evpn tunnel endpoint configuration.
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_evpn_tunnel_endpoint_config_0_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.delete_evpn_tunnel_endpoint_config_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.delete_evpn_tunnel_endpoint_config_0"
      end
      # verify the required parameter 'locale_services_id' is set
      if @api_client.config.client_side_validation && locale_services_id.nil?
        fail ArgumentError, "Missing the required parameter 'locale_services_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.delete_evpn_tunnel_endpoint_config_0"
      end
      # verify the required parameter 'tunnel_endpoint_id' is set
      if @api_client.config.client_side_validation && tunnel_endpoint_id.nil?
        fail ArgumentError, "Missing the required parameter 'tunnel_endpoint_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.delete_evpn_tunnel_endpoint_config_0"
      end
      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/locale-services/{locale-services-id}/evpn-tunnel-endpoints/{tunnel-endpoint-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'locale-services-id' + '}', locale_services_id.to_s).sub('{' + 'tunnel-endpoint-id' + '}', tunnel_endpoint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#delete_evpn_tunnel_endpoint_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Evpn Tenant Configuration
    # List all evpn tunnel endpoint configuration. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [EvpnTenantConfigListResult]
    def list_evpn_tenant_config(opts = {})
      data, _status_code, _headers = list_evpn_tenant_config_with_http_info(opts)
      data
    end

    # List Evpn Tenant Configuration
    # List all evpn tunnel endpoint configuration. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(EvpnTenantConfigListResult, Fixnum, Hash)>] EvpnTenantConfigListResult data, response status code and response headers
    def list_evpn_tenant_config_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tenant_config ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tenant_config, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tenant_config, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/evpn-tenant-configs'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'EvpnTenantConfigListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#list_evpn_tenant_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Evpn Tenant Configuration
    # List all evpn tunnel endpoint configuration. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [EvpnTenantConfigListResult]
    def list_evpn_tenant_config_0(opts = {})
      data, _status_code, _headers = list_evpn_tenant_config_0_with_http_info(opts)
      data
    end

    # List Evpn Tenant Configuration
    # List all evpn tunnel endpoint configuration. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(EvpnTenantConfigListResult, Fixnum, Hash)>] EvpnTenantConfigListResult data, response status code and response headers
    def list_evpn_tenant_config_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tenant_config_0 ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tenant_config_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tenant_config_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/evpn-tenant-configs'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'EvpnTenantConfigListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#list_evpn_tenant_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List evpn tunnel endpoint configuration
    # List all evpn tunnel endpoint configuration. 
    # @param tier_0_id 
    # @param locale_services_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [EvpnTunnelEndpointConfigListResult]
    def list_evpn_tunnel_endpoint_config(tier_0_id, locale_services_id, opts = {})
      data, _status_code, _headers = list_evpn_tunnel_endpoint_config_with_http_info(tier_0_id, locale_services_id, opts)
      data
    end

    # List evpn tunnel endpoint configuration
    # List all evpn tunnel endpoint configuration. 
    # @param tier_0_id 
    # @param locale_services_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(EvpnTunnelEndpointConfigListResult, Fixnum, Hash)>] EvpnTunnelEndpointConfigListResult data, response status code and response headers
    def list_evpn_tunnel_endpoint_config_with_http_info(tier_0_id, locale_services_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tunnel_endpoint_config ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tunnel_endpoint_config"
      end
      # verify the required parameter 'locale_services_id' is set
      if @api_client.config.client_side_validation && locale_services_id.nil?
        fail ArgumentError, "Missing the required parameter 'locale_services_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tunnel_endpoint_config"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tunnel_endpoint_config, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tunnel_endpoint_config, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/locale-services/{locale-services-id}/evpn-tunnel-endpoints'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'locale-services-id' + '}', locale_services_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'EvpnTunnelEndpointConfigListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#list_evpn_tunnel_endpoint_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List evpn tunnel endpoint configuration
    # List all evpn tunnel endpoint configuration. 
    # @param tier_0_id 
    # @param locale_services_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [EvpnTunnelEndpointConfigListResult]
    def list_evpn_tunnel_endpoint_config_0(tier_0_id, locale_services_id, opts = {})
      data, _status_code, _headers = list_evpn_tunnel_endpoint_config_0_with_http_info(tier_0_id, locale_services_id, opts)
      data
    end

    # List evpn tunnel endpoint configuration
    # List all evpn tunnel endpoint configuration. 
    # @param tier_0_id 
    # @param locale_services_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(EvpnTunnelEndpointConfigListResult, Fixnum, Hash)>] EvpnTunnelEndpointConfigListResult data, response status code and response headers
    def list_evpn_tunnel_endpoint_config_0_with_http_info(tier_0_id, locale_services_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tunnel_endpoint_config_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tunnel_endpoint_config_0"
      end
      # verify the required parameter 'locale_services_id' is set
      if @api_client.config.client_side_validation && locale_services_id.nil?
        fail ArgumentError, "Missing the required parameter 'locale_services_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tunnel_endpoint_config_0"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tunnel_endpoint_config_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.list_evpn_tunnel_endpoint_config_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/locale-services/{locale-services-id}/evpn-tunnel-endpoints'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'locale-services-id' + '}', locale_services_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'EvpnTunnelEndpointConfigListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#list_evpn_tunnel_endpoint_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or Update evpn tunnel endpoint configuration
    # Create a evpn tunnel endpoint config if the tunnel-endpoint-id is not already present, otherwise update the tunnel endpoint configuration. 
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param evpn_tunnel_endpoint_config 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_evpn_tunnel_endpoint_config(tier_0_id, locale_services_id, tunnel_endpoint_id, evpn_tunnel_endpoint_config, opts = {})
      patch_evpn_tunnel_endpoint_config_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, evpn_tunnel_endpoint_config, opts)
      nil
    end

    # Create or Update evpn tunnel endpoint configuration
    # Create a evpn tunnel endpoint config if the tunnel-endpoint-id is not already present, otherwise update the tunnel endpoint configuration. 
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param evpn_tunnel_endpoint_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_evpn_tunnel_endpoint_config_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, evpn_tunnel_endpoint_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.patch_evpn_tunnel_endpoint_config ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.patch_evpn_tunnel_endpoint_config"
      end
      # verify the required parameter 'locale_services_id' is set
      if @api_client.config.client_side_validation && locale_services_id.nil?
        fail ArgumentError, "Missing the required parameter 'locale_services_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.patch_evpn_tunnel_endpoint_config"
      end
      # verify the required parameter 'tunnel_endpoint_id' is set
      if @api_client.config.client_side_validation && tunnel_endpoint_id.nil?
        fail ArgumentError, "Missing the required parameter 'tunnel_endpoint_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.patch_evpn_tunnel_endpoint_config"
      end
      # verify the required parameter 'evpn_tunnel_endpoint_config' is set
      if @api_client.config.client_side_validation && evpn_tunnel_endpoint_config.nil?
        fail ArgumentError, "Missing the required parameter 'evpn_tunnel_endpoint_config' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.patch_evpn_tunnel_endpoint_config"
      end
      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/locale-services/{locale-services-id}/evpn-tunnel-endpoints/{tunnel-endpoint-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'locale-services-id' + '}', locale_services_id.to_s).sub('{' + 'tunnel-endpoint-id' + '}', tunnel_endpoint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(evpn_tunnel_endpoint_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#patch_evpn_tunnel_endpoint_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or Update evpn tunnel endpoint configuration
    # Create a evpn tunnel endpoint config if the tunnel-endpoint-id is not already present, otherwise update the tunnel endpoint configuration. 
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param evpn_tunnel_endpoint_config 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_evpn_tunnel_endpoint_config_0(tier_0_id, locale_services_id, tunnel_endpoint_id, evpn_tunnel_endpoint_config, opts = {})
      patch_evpn_tunnel_endpoint_config_0_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, evpn_tunnel_endpoint_config, opts)
      nil
    end

    # Create or Update evpn tunnel endpoint configuration
    # Create a evpn tunnel endpoint config if the tunnel-endpoint-id is not already present, otherwise update the tunnel endpoint configuration. 
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param evpn_tunnel_endpoint_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_evpn_tunnel_endpoint_config_0_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, evpn_tunnel_endpoint_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.patch_evpn_tunnel_endpoint_config_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.patch_evpn_tunnel_endpoint_config_0"
      end
      # verify the required parameter 'locale_services_id' is set
      if @api_client.config.client_side_validation && locale_services_id.nil?
        fail ArgumentError, "Missing the required parameter 'locale_services_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.patch_evpn_tunnel_endpoint_config_0"
      end
      # verify the required parameter 'tunnel_endpoint_id' is set
      if @api_client.config.client_side_validation && tunnel_endpoint_id.nil?
        fail ArgumentError, "Missing the required parameter 'tunnel_endpoint_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.patch_evpn_tunnel_endpoint_config_0"
      end
      # verify the required parameter 'evpn_tunnel_endpoint_config' is set
      if @api_client.config.client_side_validation && evpn_tunnel_endpoint_config.nil?
        fail ArgumentError, "Missing the required parameter 'evpn_tunnel_endpoint_config' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.patch_evpn_tunnel_endpoint_config_0"
      end
      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/locale-services/{locale-services-id}/evpn-tunnel-endpoints/{tunnel-endpoint-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'locale-services-id' + '}', locale_services_id.to_s).sub('{' + 'tunnel-endpoint-id' + '}', tunnel_endpoint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(evpn_tunnel_endpoint_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#patch_evpn_tunnel_endpoint_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read evpn tunnel endpoint configuration
    # Read evpn tunnel endpoint configuration. 
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param [Hash] opts the optional parameters
    # @return [EvpnTunnelEndpointConfig]
    def read_evpn_tunnel_endpoint_config(tier_0_id, locale_services_id, tunnel_endpoint_id, opts = {})
      data, _status_code, _headers = read_evpn_tunnel_endpoint_config_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, opts)
      data
    end

    # Read evpn tunnel endpoint configuration
    # Read evpn tunnel endpoint configuration. 
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param [Hash] opts the optional parameters
    # @return [Array<(EvpnTunnelEndpointConfig, Fixnum, Hash)>] EvpnTunnelEndpointConfig data, response status code and response headers
    def read_evpn_tunnel_endpoint_config_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.read_evpn_tunnel_endpoint_config ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.read_evpn_tunnel_endpoint_config"
      end
      # verify the required parameter 'locale_services_id' is set
      if @api_client.config.client_side_validation && locale_services_id.nil?
        fail ArgumentError, "Missing the required parameter 'locale_services_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.read_evpn_tunnel_endpoint_config"
      end
      # verify the required parameter 'tunnel_endpoint_id' is set
      if @api_client.config.client_side_validation && tunnel_endpoint_id.nil?
        fail ArgumentError, "Missing the required parameter 'tunnel_endpoint_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.read_evpn_tunnel_endpoint_config"
      end
      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/locale-services/{locale-services-id}/evpn-tunnel-endpoints/{tunnel-endpoint-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'locale-services-id' + '}', locale_services_id.to_s).sub('{' + 'tunnel-endpoint-id' + '}', tunnel_endpoint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'EvpnTunnelEndpointConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#read_evpn_tunnel_endpoint_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read evpn tunnel endpoint configuration
    # Read evpn tunnel endpoint configuration. 
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param [Hash] opts the optional parameters
    # @return [EvpnTunnelEndpointConfig]
    def read_evpn_tunnel_endpoint_config_0(tier_0_id, locale_services_id, tunnel_endpoint_id, opts = {})
      data, _status_code, _headers = read_evpn_tunnel_endpoint_config_0_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, opts)
      data
    end

    # Read evpn tunnel endpoint configuration
    # Read evpn tunnel endpoint configuration. 
    # @param tier_0_id tier0 id
    # @param locale_services_id locale services id
    # @param tunnel_endpoint_id tunnel endpoint id
    # @param [Hash] opts the optional parameters
    # @return [Array<(EvpnTunnelEndpointConfig, Fixnum, Hash)>] EvpnTunnelEndpointConfig data, response status code and response headers
    def read_evpn_tunnel_endpoint_config_0_with_http_info(tier_0_id, locale_services_id, tunnel_endpoint_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.read_evpn_tunnel_endpoint_config_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.read_evpn_tunnel_endpoint_config_0"
      end
      # verify the required parameter 'locale_services_id' is set
      if @api_client.config.client_side_validation && locale_services_id.nil?
        fail ArgumentError, "Missing the required parameter 'locale_services_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.read_evpn_tunnel_endpoint_config_0"
      end
      # verify the required parameter 'tunnel_endpoint_id' is set
      if @api_client.config.client_side_validation && tunnel_endpoint_id.nil?
        fail ArgumentError, "Missing the required parameter 'tunnel_endpoint_id' when calling PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi.read_evpn_tunnel_endpoint_config_0"
      end
      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/locale-services/{locale-services-id}/evpn-tunnel-endpoints/{tunnel-endpoint-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'locale-services-id' + '}', locale_services_id.to_s).sub('{' + 'tunnel-endpoint-id' + '}', tunnel_endpoint_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'EvpnTunnelEndpointConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysEVPNSettingEVPNTunnelEndpointsApi#read_evpn_tunnel_endpoint_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
