=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create or update a BGP community list
    # If a community list with the community-list-id is not already present, create a new community list. If it already exists, replace the community list instance with the new object. 
    # @param tier_0_id 
    # @param community_list_id 
    # @param community_list 
    # @param [Hash] opts the optional parameters
    # @return [CommunityList]
    def create_or_replace_community_list(tier_0_id, community_list_id, community_list, opts = {})
      data, _status_code, _headers = create_or_replace_community_list_with_http_info(tier_0_id, community_list_id, community_list, opts)
      data
    end

    # Create or update a BGP community list
    # If a community list with the community-list-id is not already present, create a new community list. If it already exists, replace the community list instance with the new object. 
    # @param tier_0_id 
    # @param community_list_id 
    # @param community_list 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CommunityList, Fixnum, Hash)>] CommunityList data, response status code and response headers
    def create_or_replace_community_list_with_http_info(tier_0_id, community_list_id, community_list, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.create_or_replace_community_list ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.create_or_replace_community_list"
      end
      # verify the required parameter 'community_list_id' is set
      if @api_client.config.client_side_validation && community_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'community_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.create_or_replace_community_list"
      end
      # verify the required parameter 'community_list' is set
      if @api_client.config.client_side_validation && community_list.nil?
        fail ArgumentError, "Missing the required parameter 'community_list' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.create_or_replace_community_list"
      end
      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/community-lists/{community-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'community-list-id' + '}', community_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(community_list)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunityList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi#create_or_replace_community_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a BGP community list
    # If a community list with the community-list-id is not already present, create a new community list. If it already exists, replace the community list instance with the new object. 
    # @param tier_0_id 
    # @param community_list_id 
    # @param community_list 
    # @param [Hash] opts the optional parameters
    # @return [CommunityList]
    def create_or_replace_community_list_0(tier_0_id, community_list_id, community_list, opts = {})
      data, _status_code, _headers = create_or_replace_community_list_0_with_http_info(tier_0_id, community_list_id, community_list, opts)
      data
    end

    # Create or update a BGP community list
    # If a community list with the community-list-id is not already present, create a new community list. If it already exists, replace the community list instance with the new object. 
    # @param tier_0_id 
    # @param community_list_id 
    # @param community_list 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CommunityList, Fixnum, Hash)>] CommunityList data, response status code and response headers
    def create_or_replace_community_list_0_with_http_info(tier_0_id, community_list_id, community_list, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.create_or_replace_community_list_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.create_or_replace_community_list_0"
      end
      # verify the required parameter 'community_list_id' is set
      if @api_client.config.client_side_validation && community_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'community_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.create_or_replace_community_list_0"
      end
      # verify the required parameter 'community_list' is set
      if @api_client.config.client_side_validation && community_list.nil?
        fail ArgumentError, "Missing the required parameter 'community_list' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.create_or_replace_community_list_0"
      end
      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/community-lists/{community-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'community-list-id' + '}', community_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(community_list)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunityList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi#create_or_replace_community_list_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete a BGP community list
    # Delete a BGP community list
    # @param tier_0_id 
    # @param community_list_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_community_list(tier_0_id, community_list_id, opts = {})
      delete_community_list_with_http_info(tier_0_id, community_list_id, opts)
      nil
    end

    # Delete a BGP community list
    # Delete a BGP community list
    # @param tier_0_id 
    # @param community_list_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_community_list_with_http_info(tier_0_id, community_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.delete_community_list ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.delete_community_list"
      end
      # verify the required parameter 'community_list_id' is set
      if @api_client.config.client_side_validation && community_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'community_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.delete_community_list"
      end
      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/community-lists/{community-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'community-list-id' + '}', community_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi#delete_community_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete a BGP community list
    # Delete a BGP community list
    # @param tier_0_id 
    # @param community_list_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_community_list_0(tier_0_id, community_list_id, opts = {})
      delete_community_list_0_with_http_info(tier_0_id, community_list_id, opts)
      nil
    end

    # Delete a BGP community list
    # Delete a BGP community list
    # @param tier_0_id 
    # @param community_list_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_community_list_0_with_http_info(tier_0_id, community_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.delete_community_list_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.delete_community_list_0"
      end
      # verify the required parameter 'community_list_id' is set
      if @api_client.config.client_side_validation && community_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'community_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.delete_community_list_0"
      end
      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/community-lists/{community-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'community-list-id' + '}', community_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi#delete_community_list_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List BGP community lists
    # Paginated list of all community lists under a tier-0 
    # @param tier_0_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [CommunityListListResult]
    def list_community_list(tier_0_id, opts = {})
      data, _status_code, _headers = list_community_list_with_http_info(tier_0_id, opts)
      data
    end

    # List BGP community lists
    # Paginated list of all community lists under a tier-0 
    # @param tier_0_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(CommunityListListResult, Fixnum, Hash)>] CommunityListListResult data, response status code and response headers
    def list_community_list_with_http_info(tier_0_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.list_community_list ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.list_community_list"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.list_community_list, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.list_community_list, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/community-lists'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunityListListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi#list_community_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List BGP community lists
    # Paginated list of all community lists under a tier-0 
    # @param tier_0_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [CommunityListListResult]
    def list_community_list_0(tier_0_id, opts = {})
      data, _status_code, _headers = list_community_list_0_with_http_info(tier_0_id, opts)
      data
    end

    # List BGP community lists
    # Paginated list of all community lists under a tier-0 
    # @param tier_0_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(CommunityListListResult, Fixnum, Hash)>] CommunityListListResult data, response status code and response headers
    def list_community_list_0_with_http_info(tier_0_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.list_community_list_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.list_community_list_0"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.list_community_list_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.list_community_list_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/community-lists'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunityListListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi#list_community_list_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a BGP community list
    # If a community list with the community-list-id is not already present, create a new community list. If it already exists, update the community list for specified attributes. 
    # @param tier_0_id 
    # @param community_list_id 
    # @param community_list 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_community_list(tier_0_id, community_list_id, community_list, opts = {})
      patch_community_list_with_http_info(tier_0_id, community_list_id, community_list, opts)
      nil
    end

    # Create or update a BGP community list
    # If a community list with the community-list-id is not already present, create a new community list. If it already exists, update the community list for specified attributes. 
    # @param tier_0_id 
    # @param community_list_id 
    # @param community_list 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_community_list_with_http_info(tier_0_id, community_list_id, community_list, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.patch_community_list ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.patch_community_list"
      end
      # verify the required parameter 'community_list_id' is set
      if @api_client.config.client_side_validation && community_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'community_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.patch_community_list"
      end
      # verify the required parameter 'community_list' is set
      if @api_client.config.client_side_validation && community_list.nil?
        fail ArgumentError, "Missing the required parameter 'community_list' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.patch_community_list"
      end
      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/community-lists/{community-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'community-list-id' + '}', community_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(community_list)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi#patch_community_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a BGP community list
    # If a community list with the community-list-id is not already present, create a new community list. If it already exists, update the community list for specified attributes. 
    # @param tier_0_id 
    # @param community_list_id 
    # @param community_list 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_community_list_0(tier_0_id, community_list_id, community_list, opts = {})
      patch_community_list_0_with_http_info(tier_0_id, community_list_id, community_list, opts)
      nil
    end

    # Create or update a BGP community list
    # If a community list with the community-list-id is not already present, create a new community list. If it already exists, update the community list for specified attributes. 
    # @param tier_0_id 
    # @param community_list_id 
    # @param community_list 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_community_list_0_with_http_info(tier_0_id, community_list_id, community_list, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.patch_community_list_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.patch_community_list_0"
      end
      # verify the required parameter 'community_list_id' is set
      if @api_client.config.client_side_validation && community_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'community_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.patch_community_list_0"
      end
      # verify the required parameter 'community_list' is set
      if @api_client.config.client_side_validation && community_list.nil?
        fail ArgumentError, "Missing the required parameter 'community_list' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.patch_community_list_0"
      end
      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/community-lists/{community-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'community-list-id' + '}', community_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(community_list)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi#patch_community_list_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read a BGP community list
    # Read a BGP community list
    # @param tier_0_id 
    # @param community_list_id 
    # @param [Hash] opts the optional parameters
    # @return [CommunityList]
    def read_community_list(tier_0_id, community_list_id, opts = {})
      data, _status_code, _headers = read_community_list_with_http_info(tier_0_id, community_list_id, opts)
      data
    end

    # Read a BGP community list
    # Read a BGP community list
    # @param tier_0_id 
    # @param community_list_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CommunityList, Fixnum, Hash)>] CommunityList data, response status code and response headers
    def read_community_list_with_http_info(tier_0_id, community_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.read_community_list ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.read_community_list"
      end
      # verify the required parameter 'community_list_id' is set
      if @api_client.config.client_side_validation && community_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'community_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.read_community_list"
      end
      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/community-lists/{community-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'community-list-id' + '}', community_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunityList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi#read_community_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read a BGP community list
    # Read a BGP community list
    # @param tier_0_id 
    # @param community_list_id 
    # @param [Hash] opts the optional parameters
    # @return [CommunityList]
    def read_community_list_0(tier_0_id, community_list_id, opts = {})
      data, _status_code, _headers = read_community_list_0_with_http_info(tier_0_id, community_list_id, opts)
      data
    end

    # Read a BGP community list
    # Read a BGP community list
    # @param tier_0_id 
    # @param community_list_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CommunityList, Fixnum, Hash)>] CommunityList data, response status code and response headers
    def read_community_list_0_with_http_info(tier_0_id, community_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.read_community_list_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.read_community_list_0"
      end
      # verify the required parameter 'community_list_id' is set
      if @api_client.config.client_side_validation && community_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'community_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi.read_community_list_0"
      end
      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/community-lists/{community-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'community-list-id' + '}', community_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunityList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingCommunityListsApi#read_community_list_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
