=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create or update a prefix list
    # If prefix list for prefix-list-id is not already present, create a prefix list. If it already exists, replace the prefix list for prefix-list-id. 
    # @param tier_0_id Tier-0 ID
    # @param prefix_list_id Prefix List ID
    # @param prefix_list 
    # @param [Hash] opts the optional parameters
    # @return [PrefixList]
    def create_or_replace_prefix_list(tier_0_id, prefix_list_id, prefix_list, opts = {})
      data, _status_code, _headers = create_or_replace_prefix_list_with_http_info(tier_0_id, prefix_list_id, prefix_list, opts)
      data
    end

    # Create or update a prefix list
    # If prefix list for prefix-list-id is not already present, create a prefix list. If it already exists, replace the prefix list for prefix-list-id. 
    # @param tier_0_id Tier-0 ID
    # @param prefix_list_id Prefix List ID
    # @param prefix_list 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PrefixList, Fixnum, Hash)>] PrefixList data, response status code and response headers
    def create_or_replace_prefix_list_with_http_info(tier_0_id, prefix_list_id, prefix_list, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.create_or_replace_prefix_list ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.create_or_replace_prefix_list"
      end
      # verify the required parameter 'prefix_list_id' is set
      if @api_client.config.client_side_validation && prefix_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'prefix_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.create_or_replace_prefix_list"
      end
      # verify the required parameter 'prefix_list' is set
      if @api_client.config.client_side_validation && prefix_list.nil?
        fail ArgumentError, "Missing the required parameter 'prefix_list' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.create_or_replace_prefix_list"
      end
      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/prefix-lists/{prefix-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'prefix-list-id' + '}', prefix_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(prefix_list)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PrefixList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi#create_or_replace_prefix_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a prefix list
    # If prefix list for prefix-list-id is not already present, create a prefix list. If it already exists, replace the prefix list for prefix-list-id. 
    # @param tier_0_id Tier-0 ID
    # @param prefix_list_id Prefix List ID
    # @param prefix_list 
    # @param [Hash] opts the optional parameters
    # @return [PrefixList]
    def create_or_replace_prefix_list_0(tier_0_id, prefix_list_id, prefix_list, opts = {})
      data, _status_code, _headers = create_or_replace_prefix_list_0_with_http_info(tier_0_id, prefix_list_id, prefix_list, opts)
      data
    end

    # Create or update a prefix list
    # If prefix list for prefix-list-id is not already present, create a prefix list. If it already exists, replace the prefix list for prefix-list-id. 
    # @param tier_0_id Tier-0 ID
    # @param prefix_list_id Prefix List ID
    # @param prefix_list 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PrefixList, Fixnum, Hash)>] PrefixList data, response status code and response headers
    def create_or_replace_prefix_list_0_with_http_info(tier_0_id, prefix_list_id, prefix_list, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.create_or_replace_prefix_list_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.create_or_replace_prefix_list_0"
      end
      # verify the required parameter 'prefix_list_id' is set
      if @api_client.config.client_side_validation && prefix_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'prefix_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.create_or_replace_prefix_list_0"
      end
      # verify the required parameter 'prefix_list' is set
      if @api_client.config.client_side_validation && prefix_list.nil?
        fail ArgumentError, "Missing the required parameter 'prefix_list' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.create_or_replace_prefix_list_0"
      end
      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/prefix-lists/{prefix-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'prefix-list-id' + '}', prefix_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(prefix_list)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PrefixList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi#create_or_replace_prefix_list_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete a prefix list
    # Delete a prefix list
    # @param tier_0_id 
    # @param prefix_list_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_prefix_list(tier_0_id, prefix_list_id, opts = {})
      delete_prefix_list_with_http_info(tier_0_id, prefix_list_id, opts)
      nil
    end

    # Delete a prefix list
    # Delete a prefix list
    # @param tier_0_id 
    # @param prefix_list_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_prefix_list_with_http_info(tier_0_id, prefix_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.delete_prefix_list ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.delete_prefix_list"
      end
      # verify the required parameter 'prefix_list_id' is set
      if @api_client.config.client_side_validation && prefix_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'prefix_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.delete_prefix_list"
      end
      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/prefix-lists/{prefix-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'prefix-list-id' + '}', prefix_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi#delete_prefix_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete a prefix list
    # Delete a prefix list
    # @param tier_0_id 
    # @param prefix_list_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_prefix_list_0(tier_0_id, prefix_list_id, opts = {})
      delete_prefix_list_0_with_http_info(tier_0_id, prefix_list_id, opts)
      nil
    end

    # Delete a prefix list
    # Delete a prefix list
    # @param tier_0_id 
    # @param prefix_list_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_prefix_list_0_with_http_info(tier_0_id, prefix_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.delete_prefix_list_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.delete_prefix_list_0"
      end
      # verify the required parameter 'prefix_list_id' is set
      if @api_client.config.client_side_validation && prefix_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'prefix_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.delete_prefix_list_0"
      end
      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/prefix-lists/{prefix-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'prefix-list-id' + '}', prefix_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi#delete_prefix_list_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List prefix lists
    # Paginated list of all prefix lists 
    # @param tier_0_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [PrefixListResult]
    def list_prefix_lists(tier_0_id, opts = {})
      data, _status_code, _headers = list_prefix_lists_with_http_info(tier_0_id, opts)
      data
    end

    # List prefix lists
    # Paginated list of all prefix lists 
    # @param tier_0_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(PrefixListResult, Fixnum, Hash)>] PrefixListResult data, response status code and response headers
    def list_prefix_lists_with_http_info(tier_0_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.list_prefix_lists ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.list_prefix_lists"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.list_prefix_lists, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.list_prefix_lists, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/prefix-lists'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PrefixListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi#list_prefix_lists\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List prefix lists
    # Paginated list of all prefix lists 
    # @param tier_0_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [PrefixListResult]
    def list_prefix_lists_0(tier_0_id, opts = {})
      data, _status_code, _headers = list_prefix_lists_0_with_http_info(tier_0_id, opts)
      data
    end

    # List prefix lists
    # Paginated list of all prefix lists 
    # @param tier_0_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(PrefixListResult, Fixnum, Hash)>] PrefixListResult data, response status code and response headers
    def list_prefix_lists_0_with_http_info(tier_0_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.list_prefix_lists_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.list_prefix_lists_0"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.list_prefix_lists_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.list_prefix_lists_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/prefix-lists'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PrefixListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi#list_prefix_lists_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a prefix list
    # If prefix list for prefix-list-id is not already present, create a prefix list. If it already exists, update prefix list for prefix-list-id. 
    # @param tier_0_id 
    # @param prefix_list_id 
    # @param prefix_list 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_prefix_list(tier_0_id, prefix_list_id, prefix_list, opts = {})
      patch_prefix_list_with_http_info(tier_0_id, prefix_list_id, prefix_list, opts)
      nil
    end

    # Create or update a prefix list
    # If prefix list for prefix-list-id is not already present, create a prefix list. If it already exists, update prefix list for prefix-list-id. 
    # @param tier_0_id 
    # @param prefix_list_id 
    # @param prefix_list 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_prefix_list_with_http_info(tier_0_id, prefix_list_id, prefix_list, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.patch_prefix_list ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.patch_prefix_list"
      end
      # verify the required parameter 'prefix_list_id' is set
      if @api_client.config.client_side_validation && prefix_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'prefix_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.patch_prefix_list"
      end
      # verify the required parameter 'prefix_list' is set
      if @api_client.config.client_side_validation && prefix_list.nil?
        fail ArgumentError, "Missing the required parameter 'prefix_list' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.patch_prefix_list"
      end
      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/prefix-lists/{prefix-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'prefix-list-id' + '}', prefix_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(prefix_list)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi#patch_prefix_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a prefix list
    # If prefix list for prefix-list-id is not already present, create a prefix list. If it already exists, update prefix list for prefix-list-id. 
    # @param tier_0_id 
    # @param prefix_list_id 
    # @param prefix_list 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_prefix_list_0(tier_0_id, prefix_list_id, prefix_list, opts = {})
      patch_prefix_list_0_with_http_info(tier_0_id, prefix_list_id, prefix_list, opts)
      nil
    end

    # Create or update a prefix list
    # If prefix list for prefix-list-id is not already present, create a prefix list. If it already exists, update prefix list for prefix-list-id. 
    # @param tier_0_id 
    # @param prefix_list_id 
    # @param prefix_list 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_prefix_list_0_with_http_info(tier_0_id, prefix_list_id, prefix_list, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.patch_prefix_list_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.patch_prefix_list_0"
      end
      # verify the required parameter 'prefix_list_id' is set
      if @api_client.config.client_side_validation && prefix_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'prefix_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.patch_prefix_list_0"
      end
      # verify the required parameter 'prefix_list' is set
      if @api_client.config.client_side_validation && prefix_list.nil?
        fail ArgumentError, "Missing the required parameter 'prefix_list' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.patch_prefix_list_0"
      end
      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/prefix-lists/{prefix-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'prefix-list-id' + '}', prefix_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(prefix_list)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi#patch_prefix_list_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read a prefix list
    # Read a prefix list
    # @param tier_0_id 
    # @param prefix_list_id 
    # @param [Hash] opts the optional parameters
    # @return [PrefixList]
    def read_prefix_list(tier_0_id, prefix_list_id, opts = {})
      data, _status_code, _headers = read_prefix_list_with_http_info(tier_0_id, prefix_list_id, opts)
      data
    end

    # Read a prefix list
    # Read a prefix list
    # @param tier_0_id 
    # @param prefix_list_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PrefixList, Fixnum, Hash)>] PrefixList data, response status code and response headers
    def read_prefix_list_with_http_info(tier_0_id, prefix_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.read_prefix_list ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.read_prefix_list"
      end
      # verify the required parameter 'prefix_list_id' is set
      if @api_client.config.client_side_validation && prefix_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'prefix_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.read_prefix_list"
      end
      # resource path
      local_var_path = '/infra/tier-0s/{tier-0-id}/prefix-lists/{prefix-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'prefix-list-id' + '}', prefix_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PrefixList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi#read_prefix_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read a prefix list
    # Read a prefix list
    # @param tier_0_id 
    # @param prefix_list_id 
    # @param [Hash] opts the optional parameters
    # @return [PrefixList]
    def read_prefix_list_0(tier_0_id, prefix_list_id, opts = {})
      data, _status_code, _headers = read_prefix_list_0_with_http_info(tier_0_id, prefix_list_id, opts)
      data
    end

    # Read a prefix list
    # Read a prefix list
    # @param tier_0_id 
    # @param prefix_list_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PrefixList, Fixnum, Hash)>] PrefixList data, response status code and response headers
    def read_prefix_list_0_with_http_info(tier_0_id, prefix_list_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.read_prefix_list_0 ...'
      end
      # verify the required parameter 'tier_0_id' is set
      if @api_client.config.client_side_validation && tier_0_id.nil?
        fail ArgumentError, "Missing the required parameter 'tier_0_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.read_prefix_list_0"
      end
      # verify the required parameter 'prefix_list_id' is set
      if @api_client.config.client_side_validation && prefix_list_id.nil?
        fail ArgumentError, "Missing the required parameter 'prefix_list_id' when calling PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi.read_prefix_list_0"
      end
      # resource path
      local_var_path = '/global-infra/tier-0s/{tier-0-id}/prefix-lists/{prefix-list-id}'.sub('{' + 'tier-0-id' + '}', tier_0_id.to_s).sub('{' + 'prefix-list-id' + '}', prefix_list_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PrefixList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingConnectivityTier0GatewaysRoutingPrefixListApi#read_prefix_list_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
