=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete the DNS Forwarder Zone
    # Delete the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_policy_dns_forwarder_zone(dns_forwarder_zone_id, opts = {})
      delete_policy_dns_forwarder_zone_with_http_info(dns_forwarder_zone_id, opts)
      nil
    end

    # Delete the DNS Forwarder Zone
    # Delete the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_policy_dns_forwarder_zone_with_http_info(dns_forwarder_zone_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.delete_policy_dns_forwarder_zone ...'
      end
      # verify the required parameter 'dns_forwarder_zone_id' is set
      if @api_client.config.client_side_validation && dns_forwarder_zone_id.nil?
        fail ArgumentError, "Missing the required parameter 'dns_forwarder_zone_id' when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.delete_policy_dns_forwarder_zone"
      end
      # resource path
      local_var_path = '/infra/dns-forwarder-zones/{dns-forwarder-zone-id}'.sub('{' + 'dns-forwarder-zone-id' + '}', dns_forwarder_zone_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi#delete_policy_dns_forwarder_zone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete the DNS Forwarder Zone
    # Delete the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_policy_dns_forwarder_zone_0(dns_forwarder_zone_id, opts = {})
      delete_policy_dns_forwarder_zone_0_with_http_info(dns_forwarder_zone_id, opts)
      nil
    end

    # Delete the DNS Forwarder Zone
    # Delete the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_policy_dns_forwarder_zone_0_with_http_info(dns_forwarder_zone_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.delete_policy_dns_forwarder_zone_0 ...'
      end
      # verify the required parameter 'dns_forwarder_zone_id' is set
      if @api_client.config.client_side_validation && dns_forwarder_zone_id.nil?
        fail ArgumentError, "Missing the required parameter 'dns_forwarder_zone_id' when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.delete_policy_dns_forwarder_zone_0"
      end
      # resource path
      local_var_path = '/global-infra/dns-forwarder-zones/{dns-forwarder-zone-id}'.sub('{' + 'dns-forwarder-zone-id' + '}', dns_forwarder_zone_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi#delete_policy_dns_forwarder_zone_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Dns Forwarder Zones
    # Paginated list of all Dns Forwarder Zones 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [PolicyDnsForwarderZoneListResult]
    def list_policy_dns_forwarder_zone(opts = {})
      data, _status_code, _headers = list_policy_dns_forwarder_zone_with_http_info(opts)
      data
    end

    # List Dns Forwarder Zones
    # Paginated list of all Dns Forwarder Zones 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(PolicyDnsForwarderZoneListResult, Fixnum, Hash)>] PolicyDnsForwarderZoneListResult data, response status code and response headers
    def list_policy_dns_forwarder_zone_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.list_policy_dns_forwarder_zone ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.list_policy_dns_forwarder_zone, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.list_policy_dns_forwarder_zone, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/dns-forwarder-zones'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyDnsForwarderZoneListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi#list_policy_dns_forwarder_zone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Dns Forwarder Zones
    # Paginated list of all Dns Forwarder Zones 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [PolicyDnsForwarderZoneListResult]
    def list_policy_dns_forwarder_zone_0(opts = {})
      data, _status_code, _headers = list_policy_dns_forwarder_zone_0_with_http_info(opts)
      data
    end

    # List Dns Forwarder Zones
    # Paginated list of all Dns Forwarder Zones 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(PolicyDnsForwarderZoneListResult, Fixnum, Hash)>] PolicyDnsForwarderZoneListResult data, response status code and response headers
    def list_policy_dns_forwarder_zone_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.list_policy_dns_forwarder_zone_0 ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.list_policy_dns_forwarder_zone_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.list_policy_dns_forwarder_zone_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/dns-forwarder-zones'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyDnsForwarderZoneListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi#list_policy_dns_forwarder_zone_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update the DNS Forwarder Zone
    # Create or update the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param policy_dns_forwarder_zone 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_policy_dns_forwarder_zone(dns_forwarder_zone_id, policy_dns_forwarder_zone, opts = {})
      patch_policy_dns_forwarder_zone_with_http_info(dns_forwarder_zone_id, policy_dns_forwarder_zone, opts)
      nil
    end

    # Create or update the DNS Forwarder Zone
    # Create or update the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param policy_dns_forwarder_zone 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_policy_dns_forwarder_zone_with_http_info(dns_forwarder_zone_id, policy_dns_forwarder_zone, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.patch_policy_dns_forwarder_zone ...'
      end
      # verify the required parameter 'dns_forwarder_zone_id' is set
      if @api_client.config.client_side_validation && dns_forwarder_zone_id.nil?
        fail ArgumentError, "Missing the required parameter 'dns_forwarder_zone_id' when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.patch_policy_dns_forwarder_zone"
      end
      # verify the required parameter 'policy_dns_forwarder_zone' is set
      if @api_client.config.client_side_validation && policy_dns_forwarder_zone.nil?
        fail ArgumentError, "Missing the required parameter 'policy_dns_forwarder_zone' when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.patch_policy_dns_forwarder_zone"
      end
      # resource path
      local_var_path = '/infra/dns-forwarder-zones/{dns-forwarder-zone-id}'.sub('{' + 'dns-forwarder-zone-id' + '}', dns_forwarder_zone_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_dns_forwarder_zone)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi#patch_policy_dns_forwarder_zone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update the DNS Forwarder Zone
    # Create or update the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param policy_dns_forwarder_zone 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_policy_dns_forwarder_zone_0(dns_forwarder_zone_id, policy_dns_forwarder_zone, opts = {})
      patch_policy_dns_forwarder_zone_0_with_http_info(dns_forwarder_zone_id, policy_dns_forwarder_zone, opts)
      nil
    end

    # Create or update the DNS Forwarder Zone
    # Create or update the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param policy_dns_forwarder_zone 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_policy_dns_forwarder_zone_0_with_http_info(dns_forwarder_zone_id, policy_dns_forwarder_zone, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.patch_policy_dns_forwarder_zone_0 ...'
      end
      # verify the required parameter 'dns_forwarder_zone_id' is set
      if @api_client.config.client_side_validation && dns_forwarder_zone_id.nil?
        fail ArgumentError, "Missing the required parameter 'dns_forwarder_zone_id' when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.patch_policy_dns_forwarder_zone_0"
      end
      # verify the required parameter 'policy_dns_forwarder_zone' is set
      if @api_client.config.client_side_validation && policy_dns_forwarder_zone.nil?
        fail ArgumentError, "Missing the required parameter 'policy_dns_forwarder_zone' when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.patch_policy_dns_forwarder_zone_0"
      end
      # resource path
      local_var_path = '/global-infra/dns-forwarder-zones/{dns-forwarder-zone-id}'.sub('{' + 'dns-forwarder-zone-id' + '}', dns_forwarder_zone_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_dns_forwarder_zone)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi#patch_policy_dns_forwarder_zone_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read the DNS Forwarder Zone
    # Read the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param [Hash] opts the optional parameters
    # @return [PolicyDnsForwarderZone]
    def read_policy_dns_forwarder_zone(dns_forwarder_zone_id, opts = {})
      data, _status_code, _headers = read_policy_dns_forwarder_zone_with_http_info(dns_forwarder_zone_id, opts)
      data
    end

    # Read the DNS Forwarder Zone
    # Read the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyDnsForwarderZone, Fixnum, Hash)>] PolicyDnsForwarderZone data, response status code and response headers
    def read_policy_dns_forwarder_zone_with_http_info(dns_forwarder_zone_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.read_policy_dns_forwarder_zone ...'
      end
      # verify the required parameter 'dns_forwarder_zone_id' is set
      if @api_client.config.client_side_validation && dns_forwarder_zone_id.nil?
        fail ArgumentError, "Missing the required parameter 'dns_forwarder_zone_id' when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.read_policy_dns_forwarder_zone"
      end
      # resource path
      local_var_path = '/infra/dns-forwarder-zones/{dns-forwarder-zone-id}'.sub('{' + 'dns-forwarder-zone-id' + '}', dns_forwarder_zone_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyDnsForwarderZone')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi#read_policy_dns_forwarder_zone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read the DNS Forwarder Zone
    # Read the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param [Hash] opts the optional parameters
    # @return [PolicyDnsForwarderZone]
    def read_policy_dns_forwarder_zone_0(dns_forwarder_zone_id, opts = {})
      data, _status_code, _headers = read_policy_dns_forwarder_zone_0_with_http_info(dns_forwarder_zone_id, opts)
      data
    end

    # Read the DNS Forwarder Zone
    # Read the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyDnsForwarderZone, Fixnum, Hash)>] PolicyDnsForwarderZone data, response status code and response headers
    def read_policy_dns_forwarder_zone_0_with_http_info(dns_forwarder_zone_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.read_policy_dns_forwarder_zone_0 ...'
      end
      # verify the required parameter 'dns_forwarder_zone_id' is set
      if @api_client.config.client_side_validation && dns_forwarder_zone_id.nil?
        fail ArgumentError, "Missing the required parameter 'dns_forwarder_zone_id' when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.read_policy_dns_forwarder_zone_0"
      end
      # resource path
      local_var_path = '/global-infra/dns-forwarder-zones/{dns-forwarder-zone-id}'.sub('{' + 'dns-forwarder-zone-id' + '}', dns_forwarder_zone_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyDnsForwarderZone')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi#read_policy_dns_forwarder_zone_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update the DNS Forwarder Zone
    # Create or update the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param policy_dns_forwarder_zone 
    # @param [Hash] opts the optional parameters
    # @return [PolicyDnsForwarderZone]
    def update_policy_dns_forwarder_zone(dns_forwarder_zone_id, policy_dns_forwarder_zone, opts = {})
      data, _status_code, _headers = update_policy_dns_forwarder_zone_with_http_info(dns_forwarder_zone_id, policy_dns_forwarder_zone, opts)
      data
    end

    # Create or update the DNS Forwarder Zone
    # Create or update the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param policy_dns_forwarder_zone 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyDnsForwarderZone, Fixnum, Hash)>] PolicyDnsForwarderZone data, response status code and response headers
    def update_policy_dns_forwarder_zone_with_http_info(dns_forwarder_zone_id, policy_dns_forwarder_zone, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.update_policy_dns_forwarder_zone ...'
      end
      # verify the required parameter 'dns_forwarder_zone_id' is set
      if @api_client.config.client_side_validation && dns_forwarder_zone_id.nil?
        fail ArgumentError, "Missing the required parameter 'dns_forwarder_zone_id' when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.update_policy_dns_forwarder_zone"
      end
      # verify the required parameter 'policy_dns_forwarder_zone' is set
      if @api_client.config.client_side_validation && policy_dns_forwarder_zone.nil?
        fail ArgumentError, "Missing the required parameter 'policy_dns_forwarder_zone' when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.update_policy_dns_forwarder_zone"
      end
      # resource path
      local_var_path = '/infra/dns-forwarder-zones/{dns-forwarder-zone-id}'.sub('{' + 'dns-forwarder-zone-id' + '}', dns_forwarder_zone_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_dns_forwarder_zone)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyDnsForwarderZone')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi#update_policy_dns_forwarder_zone\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update the DNS Forwarder Zone
    # Create or update the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param policy_dns_forwarder_zone 
    # @param [Hash] opts the optional parameters
    # @return [PolicyDnsForwarderZone]
    def update_policy_dns_forwarder_zone_0(dns_forwarder_zone_id, policy_dns_forwarder_zone, opts = {})
      data, _status_code, _headers = update_policy_dns_forwarder_zone_0_with_http_info(dns_forwarder_zone_id, policy_dns_forwarder_zone, opts)
      data
    end

    # Create or update the DNS Forwarder Zone
    # Create or update the DNS Forwarder Zone
    # @param dns_forwarder_zone_id DNS Forwarder Zone ID
    # @param policy_dns_forwarder_zone 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyDnsForwarderZone, Fixnum, Hash)>] PolicyDnsForwarderZone data, response status code and response headers
    def update_policy_dns_forwarder_zone_0_with_http_info(dns_forwarder_zone_id, policy_dns_forwarder_zone, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.update_policy_dns_forwarder_zone_0 ...'
      end
      # verify the required parameter 'dns_forwarder_zone_id' is set
      if @api_client.config.client_side_validation && dns_forwarder_zone_id.nil?
        fail ArgumentError, "Missing the required parameter 'dns_forwarder_zone_id' when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.update_policy_dns_forwarder_zone_0"
      end
      # verify the required parameter 'policy_dns_forwarder_zone' is set
      if @api_client.config.client_side_validation && policy_dns_forwarder_zone.nil?
        fail ArgumentError, "Missing the required parameter 'policy_dns_forwarder_zone' when calling PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi.update_policy_dns_forwarder_zone_0"
      end
      # resource path
      local_var_path = '/global-infra/dns-forwarder-zones/{dns-forwarder-zone-id}'.sub('{' + 'dns-forwarder-zone-id' + '}', dns_forwarder_zone_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_dns_forwarder_zone)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyDnsForwarderZone')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingIPManagementDNSDNSForwarderDNSZonesApi#update_policy_dns_forwarder_zone_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
