=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete LBPersistenceProfile and all the entities contained by this LBPersistenceProfile
    # Delete the LBPersistenceProfile along with all the entities contained by this LBPersistenceProfile. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :force Force delete the resource even if it is being used somewhere  (default to false)
    # @return [nil]
    def delete_lb_persistence_profile(lb_persistence_profile_id, opts = {})
      delete_lb_persistence_profile_with_http_info(lb_persistence_profile_id, opts)
      nil
    end

    # Delete LBPersistenceProfile and all the entities contained by this LBPersistenceProfile
    # Delete the LBPersistenceProfile along with all the entities contained by this LBPersistenceProfile. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :force Force delete the resource even if it is being used somewhere 
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_lb_persistence_profile_with_http_info(lb_persistence_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.delete_lb_persistence_profile ...'
      end
      # verify the required parameter 'lb_persistence_profile_id' is set
      if @api_client.config.client_side_validation && lb_persistence_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'lb_persistence_profile_id' when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.delete_lb_persistence_profile"
      end
      # resource path
      local_var_path = '/infra/lb-persistence-profiles/{lb-persistence-profile-id}'.sub('{' + 'lb-persistence-profile-id' + '}', lb_persistence_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'force'] = opts[:'force'] if !opts[:'force'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi#delete_lb_persistence_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete LBPersistenceProfile and all the entities contained by this LBPersistenceProfile
    # Delete the LBPersistenceProfile along with all the entities contained by this LBPersistenceProfile. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :force Force delete the resource even if it is being used somewhere  (default to false)
    # @return [nil]
    def delete_lb_persistence_profile_0(lb_persistence_profile_id, opts = {})
      delete_lb_persistence_profile_0_with_http_info(lb_persistence_profile_id, opts)
      nil
    end

    # Delete LBPersistenceProfile and all the entities contained by this LBPersistenceProfile
    # Delete the LBPersistenceProfile along with all the entities contained by this LBPersistenceProfile. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :force Force delete the resource even if it is being used somewhere 
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_lb_persistence_profile_0_with_http_info(lb_persistence_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.delete_lb_persistence_profile_0 ...'
      end
      # verify the required parameter 'lb_persistence_profile_id' is set
      if @api_client.config.client_side_validation && lb_persistence_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'lb_persistence_profile_id' when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.delete_lb_persistence_profile_0"
      end
      # resource path
      local_var_path = '/global-infra/lb-persistence-profiles/{lb-persistence-profile-id}'.sub('{' + 'lb-persistence-profile-id' + '}', lb_persistence_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'force'] = opts[:'force'] if !opts[:'force'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi#delete_lb_persistence_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List LBPersistenceProfiles for infra
    # Paginated list of all LBPersistenceProfiles for infra. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [LBPersistenceProfileListResult]
    def list_lb_persistence_profiles(opts = {})
      data, _status_code, _headers = list_lb_persistence_profiles_with_http_info(opts)
      data
    end

    # List LBPersistenceProfiles for infra
    # Paginated list of all LBPersistenceProfiles for infra. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(LBPersistenceProfileListResult, Fixnum, Hash)>] LBPersistenceProfileListResult data, response status code and response headers
    def list_lb_persistence_profiles_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.list_lb_persistence_profiles ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.list_lb_persistence_profiles, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.list_lb_persistence_profiles, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/lb-persistence-profiles'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'LBPersistenceProfileListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi#list_lb_persistence_profiles\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List LBPersistenceProfiles for infra
    # Paginated list of all LBPersistenceProfiles for infra. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [LBPersistenceProfileListResult]
    def list_lb_persistence_profiles_0(opts = {})
      data, _status_code, _headers = list_lb_persistence_profiles_0_with_http_info(opts)
      data
    end

    # List LBPersistenceProfiles for infra
    # Paginated list of all LBPersistenceProfiles for infra. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(LBPersistenceProfileListResult, Fixnum, Hash)>] LBPersistenceProfileListResult data, response status code and response headers
    def list_lb_persistence_profiles_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.list_lb_persistence_profiles_0 ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.list_lb_persistence_profiles_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.list_lb_persistence_profiles_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/lb-persistence-profiles'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'LBPersistenceProfileListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi#list_lb_persistence_profiles_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a LBPersistenceProfile
    # If a LBPersistenceProfile with the lb-persistence-profile-id is not already present, create a new LBPersistenceProfile. If it already exists, update the LBPersistenceProfile. This is a full replace. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param lb_persistence_profile 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_lb_persistence_profile(lb_persistence_profile_id, lb_persistence_profile, opts = {})
      patch_lb_persistence_profile_with_http_info(lb_persistence_profile_id, lb_persistence_profile, opts)
      nil
    end

    # Create or update a LBPersistenceProfile
    # If a LBPersistenceProfile with the lb-persistence-profile-id is not already present, create a new LBPersistenceProfile. If it already exists, update the LBPersistenceProfile. This is a full replace. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param lb_persistence_profile 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_lb_persistence_profile_with_http_info(lb_persistence_profile_id, lb_persistence_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.patch_lb_persistence_profile ...'
      end
      # verify the required parameter 'lb_persistence_profile_id' is set
      if @api_client.config.client_side_validation && lb_persistence_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'lb_persistence_profile_id' when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.patch_lb_persistence_profile"
      end
      # verify the required parameter 'lb_persistence_profile' is set
      if @api_client.config.client_side_validation && lb_persistence_profile.nil?
        fail ArgumentError, "Missing the required parameter 'lb_persistence_profile' when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.patch_lb_persistence_profile"
      end
      # resource path
      local_var_path = '/infra/lb-persistence-profiles/{lb-persistence-profile-id}'.sub('{' + 'lb-persistence-profile-id' + '}', lb_persistence_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(lb_persistence_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi#patch_lb_persistence_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a LBPersistenceProfile
    # If a LBPersistenceProfile with the lb-persistence-profile-id is not already present, create a new LBPersistenceProfile. If it already exists, update the LBPersistenceProfile. This is a full replace. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param lb_persistence_profile 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_lb_persistence_profile_0(lb_persistence_profile_id, lb_persistence_profile, opts = {})
      patch_lb_persistence_profile_0_with_http_info(lb_persistence_profile_id, lb_persistence_profile, opts)
      nil
    end

    # Create or update a LBPersistenceProfile
    # If a LBPersistenceProfile with the lb-persistence-profile-id is not already present, create a new LBPersistenceProfile. If it already exists, update the LBPersistenceProfile. This is a full replace. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param lb_persistence_profile 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_lb_persistence_profile_0_with_http_info(lb_persistence_profile_id, lb_persistence_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.patch_lb_persistence_profile_0 ...'
      end
      # verify the required parameter 'lb_persistence_profile_id' is set
      if @api_client.config.client_side_validation && lb_persistence_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'lb_persistence_profile_id' when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.patch_lb_persistence_profile_0"
      end
      # verify the required parameter 'lb_persistence_profile' is set
      if @api_client.config.client_side_validation && lb_persistence_profile.nil?
        fail ArgumentError, "Missing the required parameter 'lb_persistence_profile' when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.patch_lb_persistence_profile_0"
      end
      # resource path
      local_var_path = '/global-infra/lb-persistence-profiles/{lb-persistence-profile-id}'.sub('{' + 'lb-persistence-profile-id' + '}', lb_persistence_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(lb_persistence_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi#patch_lb_persistence_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read LBPersistenceProfile
    # Read a LBPersistenceProfile. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param [Hash] opts the optional parameters
    # @return [LBPersistenceProfile]
    def read_lb_persistence_profile(lb_persistence_profile_id, opts = {})
      data, _status_code, _headers = read_lb_persistence_profile_with_http_info(lb_persistence_profile_id, opts)
      data
    end

    # Read LBPersistenceProfile
    # Read a LBPersistenceProfile. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(LBPersistenceProfile, Fixnum, Hash)>] LBPersistenceProfile data, response status code and response headers
    def read_lb_persistence_profile_with_http_info(lb_persistence_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.read_lb_persistence_profile ...'
      end
      # verify the required parameter 'lb_persistence_profile_id' is set
      if @api_client.config.client_side_validation && lb_persistence_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'lb_persistence_profile_id' when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.read_lb_persistence_profile"
      end
      # resource path
      local_var_path = '/infra/lb-persistence-profiles/{lb-persistence-profile-id}'.sub('{' + 'lb-persistence-profile-id' + '}', lb_persistence_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'LBPersistenceProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi#read_lb_persistence_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read LBPersistenceProfile
    # Read a LBPersistenceProfile. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param [Hash] opts the optional parameters
    # @return [LBPersistenceProfile]
    def read_lb_persistence_profile_0(lb_persistence_profile_id, opts = {})
      data, _status_code, _headers = read_lb_persistence_profile_0_with_http_info(lb_persistence_profile_id, opts)
      data
    end

    # Read LBPersistenceProfile
    # Read a LBPersistenceProfile. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(LBPersistenceProfile, Fixnum, Hash)>] LBPersistenceProfile data, response status code and response headers
    def read_lb_persistence_profile_0_with_http_info(lb_persistence_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.read_lb_persistence_profile_0 ...'
      end
      # verify the required parameter 'lb_persistence_profile_id' is set
      if @api_client.config.client_side_validation && lb_persistence_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'lb_persistence_profile_id' when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.read_lb_persistence_profile_0"
      end
      # resource path
      local_var_path = '/global-infra/lb-persistence-profiles/{lb-persistence-profile-id}'.sub('{' + 'lb-persistence-profile-id' + '}', lb_persistence_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'LBPersistenceProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi#read_lb_persistence_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a LBPersistenceProfile
    # If a LBPersistenceProfile with the lb-persistence-profile-id is not already present, create a new LBPersistenceProfile. If it already exists, update the LBPersistenceProfile. This is a full replace. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param lb_persistence_profile 
    # @param [Hash] opts the optional parameters
    # @return [LBPersistenceProfile]
    def update_lb_persistence_profile(lb_persistence_profile_id, lb_persistence_profile, opts = {})
      data, _status_code, _headers = update_lb_persistence_profile_with_http_info(lb_persistence_profile_id, lb_persistence_profile, opts)
      data
    end

    # Create or update a LBPersistenceProfile
    # If a LBPersistenceProfile with the lb-persistence-profile-id is not already present, create a new LBPersistenceProfile. If it already exists, update the LBPersistenceProfile. This is a full replace. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param lb_persistence_profile 
    # @param [Hash] opts the optional parameters
    # @return [Array<(LBPersistenceProfile, Fixnum, Hash)>] LBPersistenceProfile data, response status code and response headers
    def update_lb_persistence_profile_with_http_info(lb_persistence_profile_id, lb_persistence_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.update_lb_persistence_profile ...'
      end
      # verify the required parameter 'lb_persistence_profile_id' is set
      if @api_client.config.client_side_validation && lb_persistence_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'lb_persistence_profile_id' when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.update_lb_persistence_profile"
      end
      # verify the required parameter 'lb_persistence_profile' is set
      if @api_client.config.client_side_validation && lb_persistence_profile.nil?
        fail ArgumentError, "Missing the required parameter 'lb_persistence_profile' when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.update_lb_persistence_profile"
      end
      # resource path
      local_var_path = '/infra/lb-persistence-profiles/{lb-persistence-profile-id}'.sub('{' + 'lb-persistence-profile-id' + '}', lb_persistence_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(lb_persistence_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'LBPersistenceProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi#update_lb_persistence_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a LBPersistenceProfile
    # If a LBPersistenceProfile with the lb-persistence-profile-id is not already present, create a new LBPersistenceProfile. If it already exists, update the LBPersistenceProfile. This is a full replace. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param lb_persistence_profile 
    # @param [Hash] opts the optional parameters
    # @return [LBPersistenceProfile]
    def update_lb_persistence_profile_0(lb_persistence_profile_id, lb_persistence_profile, opts = {})
      data, _status_code, _headers = update_lb_persistence_profile_0_with_http_info(lb_persistence_profile_id, lb_persistence_profile, opts)
      data
    end

    # Create or update a LBPersistenceProfile
    # If a LBPersistenceProfile with the lb-persistence-profile-id is not already present, create a new LBPersistenceProfile. If it already exists, update the LBPersistenceProfile. This is a full replace. 
    # @param lb_persistence_profile_id LBPersistenceProfile ID
    # @param lb_persistence_profile 
    # @param [Hash] opts the optional parameters
    # @return [Array<(LBPersistenceProfile, Fixnum, Hash)>] LBPersistenceProfile data, response status code and response headers
    def update_lb_persistence_profile_0_with_http_info(lb_persistence_profile_id, lb_persistence_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.update_lb_persistence_profile_0 ...'
      end
      # verify the required parameter 'lb_persistence_profile_id' is set
      if @api_client.config.client_side_validation && lb_persistence_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'lb_persistence_profile_id' when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.update_lb_persistence_profile_0"
      end
      # verify the required parameter 'lb_persistence_profile' is set
      if @api_client.config.client_side_validation && lb_persistence_profile.nil?
        fail ArgumentError, "Missing the required parameter 'lb_persistence_profile' when calling PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi.update_lb_persistence_profile_0"
      end
      # resource path
      local_var_path = '/global-infra/lb-persistence-profiles/{lb-persistence-profile-id}'.sub('{' + 'lb-persistence-profile-id' + '}', lb_persistence_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(lb_persistence_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'LBPersistenceProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkServicesLoadBalancingLoadBalancerProfilesLoadBalancerPersistenceProfilesApi#update_lb_persistence_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
