=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyNetworkingNetworkingProfilesBFDProfilesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete BFD Config and all the entities contained by this BfdProfile
    # Delete BFD Config and all the entities contained by this BfdProfile.
    # @param bfd_profile_id BfdProfile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [nil]
    def delete_bfd_profile(bfd_profile_id, opts = {})
      delete_bfd_profile_with_http_info(bfd_profile_id, opts)
      nil
    end

    # Delete BFD Config and all the entities contained by this BfdProfile
    # Delete BFD Config and all the entities contained by this BfdProfile.
    # @param bfd_profile_id BfdProfile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_bfd_profile_with_http_info(bfd_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesBFDProfilesApi.delete_bfd_profile ...'
      end
      # verify the required parameter 'bfd_profile_id' is set
      if @api_client.config.client_side_validation && bfd_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'bfd_profile_id' when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.delete_bfd_profile"
      end
      # resource path
      local_var_path = '/infra/bfd-profiles/{bfd-profile-id}'.sub('{' + 'bfd-profile-id' + '}', bfd_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesBFDProfilesApi#delete_bfd_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete BFD Config and all the entities contained by this BfdProfile
    # Delete BFD Config and all the entities contained by this BfdProfile.
    # @param bfd_profile_id BfdProfile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [nil]
    def delete_bfd_profile_0(bfd_profile_id, opts = {})
      delete_bfd_profile_0_with_http_info(bfd_profile_id, opts)
      nil
    end

    # Delete BFD Config and all the entities contained by this BfdProfile
    # Delete BFD Config and all the entities contained by this BfdProfile.
    # @param bfd_profile_id BfdProfile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_bfd_profile_0_with_http_info(bfd_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesBFDProfilesApi.delete_bfd_profile_0 ...'
      end
      # verify the required parameter 'bfd_profile_id' is set
      if @api_client.config.client_side_validation && bfd_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'bfd_profile_id' when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.delete_bfd_profile_0"
      end
      # resource path
      local_var_path = '/global-infra/bfd-profiles/{bfd-profile-id}'.sub('{' + 'bfd-profile-id' + '}', bfd_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesBFDProfilesApi#delete_bfd_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List BfdProfiles
    # Paginated list of all BfdProfiles. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [BfdProfileListResult]
    def list_bfd_profile(opts = {})
      data, _status_code, _headers = list_bfd_profile_with_http_info(opts)
      data
    end

    # List BfdProfiles
    # Paginated list of all BfdProfiles. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(BfdProfileListResult, Fixnum, Hash)>] BfdProfileListResult data, response status code and response headers
    def list_bfd_profile_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesBFDProfilesApi.list_bfd_profile ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.list_bfd_profile, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.list_bfd_profile, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/bfd-profiles'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BfdProfileListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesBFDProfilesApi#list_bfd_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List BfdProfiles
    # Paginated list of all BfdProfiles. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [BfdProfileListResult]
    def list_bfd_profile_0(opts = {})
      data, _status_code, _headers = list_bfd_profile_0_with_http_info(opts)
      data
    end

    # List BfdProfiles
    # Paginated list of all BfdProfiles. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(BfdProfileListResult, Fixnum, Hash)>] BfdProfileListResult data, response status code and response headers
    def list_bfd_profile_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesBFDProfilesApi.list_bfd_profile_0 ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.list_bfd_profile_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.list_bfd_profile_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/bfd-profiles'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BfdProfileListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesBFDProfilesApi#list_bfd_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a BfdProfile
    # If a BfdProfile with the bfd-profile-id is not already present, create a new BfdProfile. If it already exists, update the BfdProfile. This operation will fully replace the object. 
    # @param bfd_profile_id BfdProfile ID
    # @param bfd_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [nil]
    def patch_bfd_profile(bfd_profile_id, bfd_profile, opts = {})
      patch_bfd_profile_with_http_info(bfd_profile_id, bfd_profile, opts)
      nil
    end

    # Create or update a BfdProfile
    # If a BfdProfile with the bfd-profile-id is not already present, create a new BfdProfile. If it already exists, update the BfdProfile. This operation will fully replace the object. 
    # @param bfd_profile_id BfdProfile ID
    # @param bfd_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_bfd_profile_with_http_info(bfd_profile_id, bfd_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesBFDProfilesApi.patch_bfd_profile ...'
      end
      # verify the required parameter 'bfd_profile_id' is set
      if @api_client.config.client_side_validation && bfd_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'bfd_profile_id' when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.patch_bfd_profile"
      end
      # verify the required parameter 'bfd_profile' is set
      if @api_client.config.client_side_validation && bfd_profile.nil?
        fail ArgumentError, "Missing the required parameter 'bfd_profile' when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.patch_bfd_profile"
      end
      # resource path
      local_var_path = '/infra/bfd-profiles/{bfd-profile-id}'.sub('{' + 'bfd-profile-id' + '}', bfd_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(bfd_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesBFDProfilesApi#patch_bfd_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a BfdProfile
    # If a BfdProfile with the bfd-profile-id is not already present, create a new BfdProfile. If it already exists, update the BfdProfile. This operation will fully replace the object. 
    # @param bfd_profile_id BfdProfile ID
    # @param bfd_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [nil]
    def patch_bfd_profile_0(bfd_profile_id, bfd_profile, opts = {})
      patch_bfd_profile_0_with_http_info(bfd_profile_id, bfd_profile, opts)
      nil
    end

    # Create or update a BfdProfile
    # If a BfdProfile with the bfd-profile-id is not already present, create a new BfdProfile. If it already exists, update the BfdProfile. This operation will fully replace the object. 
    # @param bfd_profile_id BfdProfile ID
    # @param bfd_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_bfd_profile_0_with_http_info(bfd_profile_id, bfd_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesBFDProfilesApi.patch_bfd_profile_0 ...'
      end
      # verify the required parameter 'bfd_profile_id' is set
      if @api_client.config.client_side_validation && bfd_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'bfd_profile_id' when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.patch_bfd_profile_0"
      end
      # verify the required parameter 'bfd_profile' is set
      if @api_client.config.client_side_validation && bfd_profile.nil?
        fail ArgumentError, "Missing the required parameter 'bfd_profile' when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.patch_bfd_profile_0"
      end
      # resource path
      local_var_path = '/global-infra/bfd-profiles/{bfd-profile-id}'.sub('{' + 'bfd-profile-id' + '}', bfd_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(bfd_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesBFDProfilesApi#patch_bfd_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read a BfdProfile
    # Read a BfdProfile.
    # @param bfd_profile_id BfdProfile ID
    # @param [Hash] opts the optional parameters
    # @return [BfdProfile]
    def read_bfd_profile(bfd_profile_id, opts = {})
      data, _status_code, _headers = read_bfd_profile_with_http_info(bfd_profile_id, opts)
      data
    end

    # Read a BfdProfile
    # Read a BfdProfile.
    # @param bfd_profile_id BfdProfile ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(BfdProfile, Fixnum, Hash)>] BfdProfile data, response status code and response headers
    def read_bfd_profile_with_http_info(bfd_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesBFDProfilesApi.read_bfd_profile ...'
      end
      # verify the required parameter 'bfd_profile_id' is set
      if @api_client.config.client_side_validation && bfd_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'bfd_profile_id' when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.read_bfd_profile"
      end
      # resource path
      local_var_path = '/infra/bfd-profiles/{bfd-profile-id}'.sub('{' + 'bfd-profile-id' + '}', bfd_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BfdProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesBFDProfilesApi#read_bfd_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read a BfdProfile
    # Read a BfdProfile.
    # @param bfd_profile_id BfdProfile ID
    # @param [Hash] opts the optional parameters
    # @return [BfdProfile]
    def read_bfd_profile_0(bfd_profile_id, opts = {})
      data, _status_code, _headers = read_bfd_profile_0_with_http_info(bfd_profile_id, opts)
      data
    end

    # Read a BfdProfile
    # Read a BfdProfile.
    # @param bfd_profile_id BfdProfile ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(BfdProfile, Fixnum, Hash)>] BfdProfile data, response status code and response headers
    def read_bfd_profile_0_with_http_info(bfd_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesBFDProfilesApi.read_bfd_profile_0 ...'
      end
      # verify the required parameter 'bfd_profile_id' is set
      if @api_client.config.client_side_validation && bfd_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'bfd_profile_id' when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.read_bfd_profile_0"
      end
      # resource path
      local_var_path = '/global-infra/bfd-profiles/{bfd-profile-id}'.sub('{' + 'bfd-profile-id' + '}', bfd_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BfdProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesBFDProfilesApi#read_bfd_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a BfdProfile
    # If a BfdProfile with the bfd-profile-id is not already present, create a new BfdProfile. If it already exists, update the BfdProfile. This operation will fully replace the object. 
    # @param bfd_profile_id BfdProfile ID
    # @param bfd_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [BfdProfile]
    def update_bfd_profile(bfd_profile_id, bfd_profile, opts = {})
      data, _status_code, _headers = update_bfd_profile_with_http_info(bfd_profile_id, bfd_profile, opts)
      data
    end

    # Create or update a BfdProfile
    # If a BfdProfile with the bfd-profile-id is not already present, create a new BfdProfile. If it already exists, update the BfdProfile. This operation will fully replace the object. 
    # @param bfd_profile_id BfdProfile ID
    # @param bfd_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(BfdProfile, Fixnum, Hash)>] BfdProfile data, response status code and response headers
    def update_bfd_profile_with_http_info(bfd_profile_id, bfd_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesBFDProfilesApi.update_bfd_profile ...'
      end
      # verify the required parameter 'bfd_profile_id' is set
      if @api_client.config.client_side_validation && bfd_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'bfd_profile_id' when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.update_bfd_profile"
      end
      # verify the required parameter 'bfd_profile' is set
      if @api_client.config.client_side_validation && bfd_profile.nil?
        fail ArgumentError, "Missing the required parameter 'bfd_profile' when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.update_bfd_profile"
      end
      # resource path
      local_var_path = '/infra/bfd-profiles/{bfd-profile-id}'.sub('{' + 'bfd-profile-id' + '}', bfd_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(bfd_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BfdProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesBFDProfilesApi#update_bfd_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a BfdProfile
    # If a BfdProfile with the bfd-profile-id is not already present, create a new BfdProfile. If it already exists, update the BfdProfile. This operation will fully replace the object. 
    # @param bfd_profile_id BfdProfile ID
    # @param bfd_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [BfdProfile]
    def update_bfd_profile_0(bfd_profile_id, bfd_profile, opts = {})
      data, _status_code, _headers = update_bfd_profile_0_with_http_info(bfd_profile_id, bfd_profile, opts)
      data
    end

    # Create or update a BfdProfile
    # If a BfdProfile with the bfd-profile-id is not already present, create a new BfdProfile. If it already exists, update the BfdProfile. This operation will fully replace the object. 
    # @param bfd_profile_id BfdProfile ID
    # @param bfd_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(BfdProfile, Fixnum, Hash)>] BfdProfile data, response status code and response headers
    def update_bfd_profile_0_with_http_info(bfd_profile_id, bfd_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesBFDProfilesApi.update_bfd_profile_0 ...'
      end
      # verify the required parameter 'bfd_profile_id' is set
      if @api_client.config.client_side_validation && bfd_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'bfd_profile_id' when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.update_bfd_profile_0"
      end
      # verify the required parameter 'bfd_profile' is set
      if @api_client.config.client_side_validation && bfd_profile.nil?
        fail ArgumentError, "Missing the required parameter 'bfd_profile' when calling PolicyNetworkingNetworkingProfilesBFDProfilesApi.update_bfd_profile_0"
      end
      # resource path
      local_var_path = '/global-infra/bfd-profiles/{bfd-profile-id}'.sub('{' + 'bfd-profile-id' + '}', bfd_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(bfd_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BfdProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesBFDProfilesApi#update_bfd_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
