=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create or Update Evpn Tenant Configuration
    # Create or update Evpn Tenant configuration. 
    # @param config_id Evpn Tenant config id
    # @param evpn_tenant_config 
    # @param [Hash] opts the optional parameters
    # @return [EvpnTenantConfig]
    def create_or_update_evpn_tenant_config(config_id, evpn_tenant_config, opts = {})
      data, _status_code, _headers = create_or_update_evpn_tenant_config_with_http_info(config_id, evpn_tenant_config, opts)
      data
    end

    # Create or Update Evpn Tenant Configuration
    # Create or update Evpn Tenant configuration. 
    # @param config_id Evpn Tenant config id
    # @param evpn_tenant_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(EvpnTenantConfig, Fixnum, Hash)>] EvpnTenantConfig data, response status code and response headers
    def create_or_update_evpn_tenant_config_with_http_info(config_id, evpn_tenant_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.create_or_update_evpn_tenant_config ...'
      end
      # verify the required parameter 'config_id' is set
      if @api_client.config.client_side_validation && config_id.nil?
        fail ArgumentError, "Missing the required parameter 'config_id' when calling PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.create_or_update_evpn_tenant_config"
      end
      # verify the required parameter 'evpn_tenant_config' is set
      if @api_client.config.client_side_validation && evpn_tenant_config.nil?
        fail ArgumentError, "Missing the required parameter 'evpn_tenant_config' when calling PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.create_or_update_evpn_tenant_config"
      end
      # resource path
      local_var_path = '/global-infra/evpn-tenant-configs/{config-id}'.sub('{' + 'config-id' + '}', config_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(evpn_tenant_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'EvpnTenantConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi#create_or_update_evpn_tenant_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or Update Evpn Tenant Configuration
    # Create or update Evpn Tenant configuration. 
    # @param config_id Evpn Tenant config id
    # @param evpn_tenant_config 
    # @param [Hash] opts the optional parameters
    # @return [EvpnTenantConfig]
    def create_or_update_evpn_tenant_config_0(config_id, evpn_tenant_config, opts = {})
      data, _status_code, _headers = create_or_update_evpn_tenant_config_0_with_http_info(config_id, evpn_tenant_config, opts)
      data
    end

    # Create or Update Evpn Tenant Configuration
    # Create or update Evpn Tenant configuration. 
    # @param config_id Evpn Tenant config id
    # @param evpn_tenant_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(EvpnTenantConfig, Fixnum, Hash)>] EvpnTenantConfig data, response status code and response headers
    def create_or_update_evpn_tenant_config_0_with_http_info(config_id, evpn_tenant_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.create_or_update_evpn_tenant_config_0 ...'
      end
      # verify the required parameter 'config_id' is set
      if @api_client.config.client_side_validation && config_id.nil?
        fail ArgumentError, "Missing the required parameter 'config_id' when calling PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.create_or_update_evpn_tenant_config_0"
      end
      # verify the required parameter 'evpn_tenant_config' is set
      if @api_client.config.client_side_validation && evpn_tenant_config.nil?
        fail ArgumentError, "Missing the required parameter 'evpn_tenant_config' when calling PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.create_or_update_evpn_tenant_config_0"
      end
      # resource path
      local_var_path = '/infra/evpn-tenant-configs/{config-id}'.sub('{' + 'config-id' + '}', config_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(evpn_tenant_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'EvpnTenantConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi#create_or_update_evpn_tenant_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or Update Evpn Tenant Configuration
    # Create a global evpn tenant configuration if it is not already present, otherwise update the evpn tenant configuration. 
    # @param config_id Evpn Tenant config id
    # @param evpn_tenant_config 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_evpn_tenant_config(config_id, evpn_tenant_config, opts = {})
      patch_evpn_tenant_config_with_http_info(config_id, evpn_tenant_config, opts)
      nil
    end

    # Create or Update Evpn Tenant Configuration
    # Create a global evpn tenant configuration if it is not already present, otherwise update the evpn tenant configuration. 
    # @param config_id Evpn Tenant config id
    # @param evpn_tenant_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_evpn_tenant_config_with_http_info(config_id, evpn_tenant_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.patch_evpn_tenant_config ...'
      end
      # verify the required parameter 'config_id' is set
      if @api_client.config.client_side_validation && config_id.nil?
        fail ArgumentError, "Missing the required parameter 'config_id' when calling PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.patch_evpn_tenant_config"
      end
      # verify the required parameter 'evpn_tenant_config' is set
      if @api_client.config.client_side_validation && evpn_tenant_config.nil?
        fail ArgumentError, "Missing the required parameter 'evpn_tenant_config' when calling PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.patch_evpn_tenant_config"
      end
      # resource path
      local_var_path = '/global-infra/evpn-tenant-configs/{config-id}'.sub('{' + 'config-id' + '}', config_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(evpn_tenant_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi#patch_evpn_tenant_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or Update Evpn Tenant Configuration
    # Create a global evpn tenant configuration if it is not already present, otherwise update the evpn tenant configuration. 
    # @param config_id Evpn Tenant config id
    # @param evpn_tenant_config 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_evpn_tenant_config_0(config_id, evpn_tenant_config, opts = {})
      patch_evpn_tenant_config_0_with_http_info(config_id, evpn_tenant_config, opts)
      nil
    end

    # Create or Update Evpn Tenant Configuration
    # Create a global evpn tenant configuration if it is not already present, otherwise update the evpn tenant configuration. 
    # @param config_id Evpn Tenant config id
    # @param evpn_tenant_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_evpn_tenant_config_0_with_http_info(config_id, evpn_tenant_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.patch_evpn_tenant_config_0 ...'
      end
      # verify the required parameter 'config_id' is set
      if @api_client.config.client_side_validation && config_id.nil?
        fail ArgumentError, "Missing the required parameter 'config_id' when calling PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.patch_evpn_tenant_config_0"
      end
      # verify the required parameter 'evpn_tenant_config' is set
      if @api_client.config.client_side_validation && evpn_tenant_config.nil?
        fail ArgumentError, "Missing the required parameter 'evpn_tenant_config' when calling PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.patch_evpn_tenant_config_0"
      end
      # resource path
      local_var_path = '/infra/evpn-tenant-configs/{config-id}'.sub('{' + 'config-id' + '}', config_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(evpn_tenant_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi#patch_evpn_tenant_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read Evpn Tenant Configuration
    # Read Evpn Tenant Configuration. 
    # @param config_id config id
    # @param [Hash] opts the optional parameters
    # @return [EvpnTenantConfig]
    def read_evpn_tenant_config(config_id, opts = {})
      data, _status_code, _headers = read_evpn_tenant_config_with_http_info(config_id, opts)
      data
    end

    # Read Evpn Tenant Configuration
    # Read Evpn Tenant Configuration. 
    # @param config_id config id
    # @param [Hash] opts the optional parameters
    # @return [Array<(EvpnTenantConfig, Fixnum, Hash)>] EvpnTenantConfig data, response status code and response headers
    def read_evpn_tenant_config_with_http_info(config_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.read_evpn_tenant_config ...'
      end
      # verify the required parameter 'config_id' is set
      if @api_client.config.client_side_validation && config_id.nil?
        fail ArgumentError, "Missing the required parameter 'config_id' when calling PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.read_evpn_tenant_config"
      end
      # resource path
      local_var_path = '/global-infra/evpn-tenant-configs/{config-id}'.sub('{' + 'config-id' + '}', config_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'EvpnTenantConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi#read_evpn_tenant_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read Evpn Tenant Configuration
    # Read Evpn Tenant Configuration. 
    # @param config_id config id
    # @param [Hash] opts the optional parameters
    # @return [EvpnTenantConfig]
    def read_evpn_tenant_config_0(config_id, opts = {})
      data, _status_code, _headers = read_evpn_tenant_config_0_with_http_info(config_id, opts)
      data
    end

    # Read Evpn Tenant Configuration
    # Read Evpn Tenant Configuration. 
    # @param config_id config id
    # @param [Hash] opts the optional parameters
    # @return [Array<(EvpnTenantConfig, Fixnum, Hash)>] EvpnTenantConfig data, response status code and response headers
    def read_evpn_tenant_config_0_with_http_info(config_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.read_evpn_tenant_config_0 ...'
      end
      # verify the required parameter 'config_id' is set
      if @api_client.config.client_side_validation && config_id.nil?
        fail ArgumentError, "Missing the required parameter 'config_id' when calling PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi.read_evpn_tenant_config_0"
      end
      # resource path
      local_var_path = '/infra/evpn-tenant-configs/{config-id}'.sub('{' + 'config-id' + '}', config_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'EvpnTenantConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNTenantConfigurationApi#read_evpn_tenant_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
