=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create or Update Vni Pool Configuration
    # Create or update VniPool configuration. 
    # @param vni_pool_id vni pool id
    # @param vni_pool_config 
    # @param [Hash] opts the optional parameters
    # @return [VniPoolConfig]
    def create_or_update_vni_pool_config(vni_pool_id, vni_pool_config, opts = {})
      data, _status_code, _headers = create_or_update_vni_pool_config_with_http_info(vni_pool_id, vni_pool_config, opts)
      data
    end

    # Create or Update Vni Pool Configuration
    # Create or update VniPool configuration. 
    # @param vni_pool_id vni pool id
    # @param vni_pool_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(VniPoolConfig, Fixnum, Hash)>] VniPoolConfig data, response status code and response headers
    def create_or_update_vni_pool_config_with_http_info(vni_pool_id, vni_pool_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.create_or_update_vni_pool_config ...'
      end
      # verify the required parameter 'vni_pool_id' is set
      if @api_client.config.client_side_validation && vni_pool_id.nil?
        fail ArgumentError, "Missing the required parameter 'vni_pool_id' when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.create_or_update_vni_pool_config"
      end
      # verify the required parameter 'vni_pool_config' is set
      if @api_client.config.client_side_validation && vni_pool_config.nil?
        fail ArgumentError, "Missing the required parameter 'vni_pool_config' when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.create_or_update_vni_pool_config"
      end
      # resource path
      local_var_path = '/infra/vni-pools/{vni-pool-id}'.sub('{' + 'vni-pool-id' + '}', vni_pool_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(vni_pool_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'VniPoolConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi#create_or_update_vni_pool_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or Update Vni Pool Configuration
    # Create or update VniPool configuration. 
    # @param vni_pool_id vni pool id
    # @param vni_pool_config 
    # @param [Hash] opts the optional parameters
    # @return [VniPoolConfig]
    def create_or_update_vni_pool_config_0(vni_pool_id, vni_pool_config, opts = {})
      data, _status_code, _headers = create_or_update_vni_pool_config_0_with_http_info(vni_pool_id, vni_pool_config, opts)
      data
    end

    # Create or Update Vni Pool Configuration
    # Create or update VniPool configuration. 
    # @param vni_pool_id vni pool id
    # @param vni_pool_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(VniPoolConfig, Fixnum, Hash)>] VniPoolConfig data, response status code and response headers
    def create_or_update_vni_pool_config_0_with_http_info(vni_pool_id, vni_pool_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.create_or_update_vni_pool_config_0 ...'
      end
      # verify the required parameter 'vni_pool_id' is set
      if @api_client.config.client_side_validation && vni_pool_id.nil?
        fail ArgumentError, "Missing the required parameter 'vni_pool_id' when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.create_or_update_vni_pool_config_0"
      end
      # verify the required parameter 'vni_pool_config' is set
      if @api_client.config.client_side_validation && vni_pool_config.nil?
        fail ArgumentError, "Missing the required parameter 'vni_pool_config' when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.create_or_update_vni_pool_config_0"
      end
      # resource path
      local_var_path = '/global-infra/vni-pools/{vni-pool-id}'.sub('{' + 'vni-pool-id' + '}', vni_pool_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(vni_pool_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'VniPoolConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi#create_or_update_vni_pool_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete Vni Pool Configuration
    # Delete Vni Pool Configuration.
    # @param vni_pool_id vni pool id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_vni_pool_config(vni_pool_id, opts = {})
      delete_vni_pool_config_with_http_info(vni_pool_id, opts)
      nil
    end

    # Delete Vni Pool Configuration
    # Delete Vni Pool Configuration.
    # @param vni_pool_id vni pool id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_vni_pool_config_with_http_info(vni_pool_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.delete_vni_pool_config ...'
      end
      # verify the required parameter 'vni_pool_id' is set
      if @api_client.config.client_side_validation && vni_pool_id.nil?
        fail ArgumentError, "Missing the required parameter 'vni_pool_id' when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.delete_vni_pool_config"
      end
      # resource path
      local_var_path = '/infra/vni-pools/{vni-pool-id}'.sub('{' + 'vni-pool-id' + '}', vni_pool_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi#delete_vni_pool_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete Vni Pool Configuration
    # Delete Vni Pool Configuration.
    # @param vni_pool_id vni pool id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_vni_pool_config_0(vni_pool_id, opts = {})
      delete_vni_pool_config_0_with_http_info(vni_pool_id, opts)
      nil
    end

    # Delete Vni Pool Configuration
    # Delete Vni Pool Configuration.
    # @param vni_pool_id vni pool id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_vni_pool_config_0_with_http_info(vni_pool_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.delete_vni_pool_config_0 ...'
      end
      # verify the required parameter 'vni_pool_id' is set
      if @api_client.config.client_side_validation && vni_pool_id.nil?
        fail ArgumentError, "Missing the required parameter 'vni_pool_id' when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.delete_vni_pool_config_0"
      end
      # resource path
      local_var_path = '/global-infra/vni-pools/{vni-pool-id}'.sub('{' + 'vni-pool-id' + '}', vni_pool_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi#delete_vni_pool_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Vni Pool Configuration
    # List all Vni Pool configuration. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [VniPoolConfigListResult]
    def list_vni_pool_config(opts = {})
      data, _status_code, _headers = list_vni_pool_config_with_http_info(opts)
      data
    end

    # List Vni Pool Configuration
    # List all Vni Pool configuration. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(VniPoolConfigListResult, Fixnum, Hash)>] VniPoolConfigListResult data, response status code and response headers
    def list_vni_pool_config_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.list_vni_pool_config ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.list_vni_pool_config, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.list_vni_pool_config, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/vni-pools'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'VniPoolConfigListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi#list_vni_pool_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Vni Pool Configuration
    # List all Vni Pool configuration. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [VniPoolConfigListResult]
    def list_vni_pool_config_0(opts = {})
      data, _status_code, _headers = list_vni_pool_config_0_with_http_info(opts)
      data
    end

    # List Vni Pool Configuration
    # List all Vni Pool configuration. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(VniPoolConfigListResult, Fixnum, Hash)>] VniPoolConfigListResult data, response status code and response headers
    def list_vni_pool_config_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.list_vni_pool_config_0 ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.list_vni_pool_config_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.list_vni_pool_config_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/vni-pools'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'VniPoolConfigListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi#list_vni_pool_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or Update Vni Pool Configuration
    # Create a Vni Pool config if it is not already present, otherwise update the Vni Pool configuration. 
    # @param vni_pool_id vni pool id
    # @param vni_pool_config 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_vni_pool_config(vni_pool_id, vni_pool_config, opts = {})
      patch_vni_pool_config_with_http_info(vni_pool_id, vni_pool_config, opts)
      nil
    end

    # Create or Update Vni Pool Configuration
    # Create a Vni Pool config if it is not already present, otherwise update the Vni Pool configuration. 
    # @param vni_pool_id vni pool id
    # @param vni_pool_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_vni_pool_config_with_http_info(vni_pool_id, vni_pool_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.patch_vni_pool_config ...'
      end
      # verify the required parameter 'vni_pool_id' is set
      if @api_client.config.client_side_validation && vni_pool_id.nil?
        fail ArgumentError, "Missing the required parameter 'vni_pool_id' when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.patch_vni_pool_config"
      end
      # verify the required parameter 'vni_pool_config' is set
      if @api_client.config.client_side_validation && vni_pool_config.nil?
        fail ArgumentError, "Missing the required parameter 'vni_pool_config' when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.patch_vni_pool_config"
      end
      # resource path
      local_var_path = '/infra/vni-pools/{vni-pool-id}'.sub('{' + 'vni-pool-id' + '}', vni_pool_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(vni_pool_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi#patch_vni_pool_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or Update Vni Pool Configuration
    # Create a Vni Pool config if it is not already present, otherwise update the Vni Pool configuration. 
    # @param vni_pool_id vni pool id
    # @param vni_pool_config 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_vni_pool_config_0(vni_pool_id, vni_pool_config, opts = {})
      patch_vni_pool_config_0_with_http_info(vni_pool_id, vni_pool_config, opts)
      nil
    end

    # Create or Update Vni Pool Configuration
    # Create a Vni Pool config if it is not already present, otherwise update the Vni Pool configuration. 
    # @param vni_pool_id vni pool id
    # @param vni_pool_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_vni_pool_config_0_with_http_info(vni_pool_id, vni_pool_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.patch_vni_pool_config_0 ...'
      end
      # verify the required parameter 'vni_pool_id' is set
      if @api_client.config.client_side_validation && vni_pool_id.nil?
        fail ArgumentError, "Missing the required parameter 'vni_pool_id' when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.patch_vni_pool_config_0"
      end
      # verify the required parameter 'vni_pool_config' is set
      if @api_client.config.client_side_validation && vni_pool_config.nil?
        fail ArgumentError, "Missing the required parameter 'vni_pool_config' when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.patch_vni_pool_config_0"
      end
      # resource path
      local_var_path = '/global-infra/vni-pools/{vni-pool-id}'.sub('{' + 'vni-pool-id' + '}', vni_pool_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(vni_pool_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi#patch_vni_pool_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read Vni Pool Configuration
    # Read Vni Pool Configuration. 
    # @param vni_pool_id vni pool id
    # @param [Hash] opts the optional parameters
    # @return [VniPoolConfig]
    def read_vni_pool_config(vni_pool_id, opts = {})
      data, _status_code, _headers = read_vni_pool_config_with_http_info(vni_pool_id, opts)
      data
    end

    # Read Vni Pool Configuration
    # Read Vni Pool Configuration. 
    # @param vni_pool_id vni pool id
    # @param [Hash] opts the optional parameters
    # @return [Array<(VniPoolConfig, Fixnum, Hash)>] VniPoolConfig data, response status code and response headers
    def read_vni_pool_config_with_http_info(vni_pool_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.read_vni_pool_config ...'
      end
      # verify the required parameter 'vni_pool_id' is set
      if @api_client.config.client_side_validation && vni_pool_id.nil?
        fail ArgumentError, "Missing the required parameter 'vni_pool_id' when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.read_vni_pool_config"
      end
      # resource path
      local_var_path = '/infra/vni-pools/{vni-pool-id}'.sub('{' + 'vni-pool-id' + '}', vni_pool_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'VniPoolConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi#read_vni_pool_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read Vni Pool Configuration
    # Read Vni Pool Configuration. 
    # @param vni_pool_id vni pool id
    # @param [Hash] opts the optional parameters
    # @return [VniPoolConfig]
    def read_vni_pool_config_0(vni_pool_id, opts = {})
      data, _status_code, _headers = read_vni_pool_config_0_with_http_info(vni_pool_id, opts)
      data
    end

    # Read Vni Pool Configuration
    # Read Vni Pool Configuration. 
    # @param vni_pool_id vni pool id
    # @param [Hash] opts the optional parameters
    # @return [Array<(VniPoolConfig, Fixnum, Hash)>] VniPoolConfig data, response status code and response headers
    def read_vni_pool_config_0_with_http_info(vni_pool_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.read_vni_pool_config_0 ...'
      end
      # verify the required parameter 'vni_pool_id' is set
      if @api_client.config.client_side_validation && vni_pool_id.nil?
        fail ArgumentError, "Missing the required parameter 'vni_pool_id' when calling PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi.read_vni_pool_config_0"
      end
      # resource path
      local_var_path = '/global-infra/vni-pools/{vni-pool-id}'.sub('{' + 'vni-pool-id' + '}', vni_pool_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'VniPoolConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesEVPNVNIPoolsApi#read_vni_pool_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
