=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Update the global configuration
    # Update the global configuration
    # @param global_config 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_global_config(global_config, opts = {})
      patch_global_config_with_http_info(global_config, opts)
      nil
    end

    # Update the global configuration
    # Update the global configuration
    # @param global_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_global_config_with_http_info(global_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi.patch_global_config ...'
      end
      # verify the required parameter 'global_config' is set
      if @api_client.config.client_side_validation && global_config.nil?
        fail ArgumentError, "Missing the required parameter 'global_config' when calling PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi.patch_global_config"
      end
      # resource path
      local_var_path = '/infra/global-config'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(global_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi#patch_global_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update the global configuration
    # Update the global configuration
    # @param global_config 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_global_config_0(global_config, opts = {})
      patch_global_config_0_with_http_info(global_config, opts)
      nil
    end

    # Update the global configuration
    # Update the global configuration
    # @param global_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_global_config_0_with_http_info(global_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi.patch_global_config_0 ...'
      end
      # verify the required parameter 'global_config' is set
      if @api_client.config.client_side_validation && global_config.nil?
        fail ArgumentError, "Missing the required parameter 'global_config' when calling PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi.patch_global_config_0"
      end
      # resource path
      local_var_path = '/global-infra/global-config'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(global_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi#patch_global_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read global configuration
    # Read global configuration 
    # @param [Hash] opts the optional parameters
    # @return [GlobalConfig]
    def read_global_config(opts = {})
      data, _status_code, _headers = read_global_config_with_http_info(opts)
      data
    end

    # Read global configuration
    # Read global configuration 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GlobalConfig, Fixnum, Hash)>] GlobalConfig data, response status code and response headers
    def read_global_config_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi.read_global_config ...'
      end
      # resource path
      local_var_path = '/infra/global-config'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GlobalConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi#read_global_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read global configuration
    # Read global configuration 
    # @param [Hash] opts the optional parameters
    # @return [GlobalConfig]
    def read_global_config_0(opts = {})
      data, _status_code, _headers = read_global_config_0_with_http_info(opts)
      data
    end

    # Read global configuration
    # Read global configuration 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GlobalConfig, Fixnum, Hash)>] GlobalConfig data, response status code and response headers
    def read_global_config_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi.read_global_config_0 ...'
      end
      # resource path
      local_var_path = '/global-infra/global-config'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GlobalConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi#read_global_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update the global configuration
    # Update the global configuration
    # @param global_config 
    # @param [Hash] opts the optional parameters
    # @return [GlobalConfig]
    def update_global_config(global_config, opts = {})
      data, _status_code, _headers = update_global_config_with_http_info(global_config, opts)
      data
    end

    # Update the global configuration
    # Update the global configuration
    # @param global_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GlobalConfig, Fixnum, Hash)>] GlobalConfig data, response status code and response headers
    def update_global_config_with_http_info(global_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi.update_global_config ...'
      end
      # verify the required parameter 'global_config' is set
      if @api_client.config.client_side_validation && global_config.nil?
        fail ArgumentError, "Missing the required parameter 'global_config' when calling PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi.update_global_config"
      end
      # resource path
      local_var_path = '/infra/global-config'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(global_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GlobalConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi#update_global_config\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update the global configuration
    # Update the global configuration
    # @param global_config 
    # @param [Hash] opts the optional parameters
    # @return [GlobalConfig]
    def update_global_config_0(global_config, opts = {})
      data, _status_code, _headers = update_global_config_0_with_http_info(global_config, opts)
      data
    end

    # Update the global configuration
    # Update the global configuration
    # @param global_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GlobalConfig, Fixnum, Hash)>] GlobalConfig data, response status code and response headers
    def update_global_config_0_with_http_info(global_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi.update_global_config_0 ...'
      end
      # verify the required parameter 'global_config' is set
      if @api_client.config.client_side_validation && global_config.nil?
        fail ArgumentError, "Missing the required parameter 'global_config' when calling PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi.update_global_config_0"
      end
      # resource path
      local_var_path = '/global-infra/global-config'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(global_config)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GlobalConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyNetworkingNetworkingProfilesGlobalGatewayConfigurationApi#update_global_config_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
