=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete CommunicationEntry
    # Delete CommunicationEntry This API is deprecated. Please use the following API instead. DELETE /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_communication_entry(domain_id, communication_map_id, communication_entry_id, opts = {})
      delete_communication_entry_with_http_info(domain_id, communication_map_id, communication_entry_id, opts)
      nil
    end

    # Delete CommunicationEntry
    # Delete CommunicationEntry This API is deprecated. Please use the following API instead. DELETE /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_communication_entry_with_http_info(domain_id, communication_map_id, communication_entry_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_entry ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_entry"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_entry"
      end
      # verify the required parameter 'communication_entry_id' is set
      if @api_client.config.client_side_validation && communication_entry_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_entry"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/communication-maps/{communication-map-id}/communication-entries/{communication-entry-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s).sub('{' + 'communication-entry-id' + '}', communication_entry_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#delete_communication_entry\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete CommunicationEntry
    # Delete CommunicationEntry This API is deprecated. Please use the following API instead. DELETE /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_communication_entry_0(domain_id, communication_map_id, communication_entry_id, opts = {})
      delete_communication_entry_0_with_http_info(domain_id, communication_map_id, communication_entry_id, opts)
      nil
    end

    # Delete CommunicationEntry
    # Delete CommunicationEntry This API is deprecated. Please use the following API instead. DELETE /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_communication_entry_0_with_http_info(domain_id, communication_map_id, communication_entry_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_entry_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_entry_0"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_entry_0"
      end
      # verify the required parameter 'communication_entry_id' is set
      if @api_client.config.client_side_validation && communication_entry_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_entry_0"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/communication-maps/{communication-map-id}/communication-entries/{communication-entry-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s).sub('{' + 'communication-entry-id' + '}', communication_entry_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#delete_communication_entry_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Deletes a communication map from this domain
    # Deletes the communication map along with all the communication entries This API is deprecated. Please use the following API instead. DELETE /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_communication_map_for_domain(domain_id, communication_map_id, opts = {})
      delete_communication_map_for_domain_with_http_info(domain_id, communication_map_id, opts)
      nil
    end

    # Deletes a communication map from this domain
    # Deletes the communication map along with all the communication entries This API is deprecated. Please use the following API instead. DELETE /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_communication_map_for_domain_with_http_info(domain_id, communication_map_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_map_for_domain ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_map_for_domain"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_map_for_domain"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/communication-maps/{communication-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#delete_communication_map_for_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Deletes a communication map from this domain
    # Deletes the communication map along with all the communication entries This API is deprecated. Please use the following API instead. DELETE /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_communication_map_for_domain_0(domain_id, communication_map_id, opts = {})
      delete_communication_map_for_domain_0_with_http_info(domain_id, communication_map_id, opts)
      nil
    end

    # Deletes a communication map from this domain
    # Deletes the communication map along with all the communication entries This API is deprecated. Please use the following API instead. DELETE /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_communication_map_for_domain_0_with_http_info(domain_id, communication_map_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_map_for_domain_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_map_for_domain_0"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.delete_communication_map_for_domain_0"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/communication-maps/{communication-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#delete_communication_map_for_domain_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List CommunicationEntries
    # List CommunicationEntries This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies/security-policy-id/rules 
    # @param domain_id 
    # @param communication_map_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [CommunicationEntryListResult]
    def list_communication_entry(domain_id, communication_map_id, opts = {})
      data, _status_code, _headers = list_communication_entry_with_http_info(domain_id, communication_map_id, opts)
      data
    end

    # List CommunicationEntries
    # List CommunicationEntries This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies/security-policy-id/rules 
    # @param domain_id 
    # @param communication_map_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(CommunicationEntryListResult, Fixnum, Hash)>] CommunicationEntryListResult data, response status code and response headers
    def list_communication_entry_with_http_info(domain_id, communication_map_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_entry ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_entry"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_entry"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_entry, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_entry, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/communication-maps/{communication-map-id}/communication-entries'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationEntryListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#list_communication_entry\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List CommunicationEntries
    # List CommunicationEntries This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies/security-policy-id/rules 
    # @param domain_id 
    # @param communication_map_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [CommunicationEntryListResult]
    def list_communication_entry_0(domain_id, communication_map_id, opts = {})
      data, _status_code, _headers = list_communication_entry_0_with_http_info(domain_id, communication_map_id, opts)
      data
    end

    # List CommunicationEntries
    # List CommunicationEntries This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies/security-policy-id/rules 
    # @param domain_id 
    # @param communication_map_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(CommunicationEntryListResult, Fixnum, Hash)>] CommunicationEntryListResult data, response status code and response headers
    def list_communication_entry_0_with_http_info(domain_id, communication_map_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_entry_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_entry_0"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_entry_0"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_entry_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_entry_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/domains/{domain-id}/communication-maps/{communication-map-id}/communication-entries'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationEntryListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#list_communication_entry_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List communication maps
    # List all communication maps for a domain. This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies 
    # @param domain_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [CommunicationMapListResult]
    def list_communication_maps_for_domain(domain_id, opts = {})
      data, _status_code, _headers = list_communication_maps_for_domain_with_http_info(domain_id, opts)
      data
    end

    # List communication maps
    # List all communication maps for a domain. This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies 
    # @param domain_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(CommunicationMapListResult, Fixnum, Hash)>] CommunicationMapListResult data, response status code and response headers
    def list_communication_maps_for_domain_with_http_info(domain_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_maps_for_domain ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_maps_for_domain"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_maps_for_domain, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_maps_for_domain, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/communication-maps'.sub('{' + 'domain-id' + '}', domain_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationMapListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#list_communication_maps_for_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List communication maps
    # List all communication maps for a domain. This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies 
    # @param domain_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [CommunicationMapListResult]
    def list_communication_maps_for_domain_0(domain_id, opts = {})
      data, _status_code, _headers = list_communication_maps_for_domain_0_with_http_info(domain_id, opts)
      data
    end

    # List communication maps
    # List all communication maps for a domain. This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies 
    # @param domain_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(CommunicationMapListResult, Fixnum, Hash)>] CommunicationMapListResult data, response status code and response headers
    def list_communication_maps_for_domain_0_with_http_info(domain_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_maps_for_domain_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_maps_for_domain_0"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_maps_for_domain_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.list_communication_maps_for_domain_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/domains/{domain-id}/communication-maps'.sub('{' + 'domain-id' + '}', domain_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationMapListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#list_communication_maps_for_domain_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Patch a CommunicationEntry
    # Patch the CommunicationEntry. If a communication entry for the given communication-entry-id is not present, the object will get created and if it is present it will be updated. This is a full replace  This API is deprecated. Please use the following API instead. PATCH /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param communication_entry 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_communication_entry(domain_id, communication_map_id, communication_entry_id, communication_entry, opts = {})
      patch_communication_entry_with_http_info(domain_id, communication_map_id, communication_entry_id, communication_entry, opts)
      nil
    end

    # Patch a CommunicationEntry
    # Patch the CommunicationEntry. If a communication entry for the given communication-entry-id is not present, the object will get created and if it is present it will be updated. This is a full replace  This API is deprecated. Please use the following API instead. PATCH /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param communication_entry 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_communication_entry_with_http_info(domain_id, communication_map_id, communication_entry_id, communication_entry, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_entry ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_entry"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_entry"
      end
      # verify the required parameter 'communication_entry_id' is set
      if @api_client.config.client_side_validation && communication_entry_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_entry"
      end
      # verify the required parameter 'communication_entry' is set
      if @api_client.config.client_side_validation && communication_entry.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_entry"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/communication-maps/{communication-map-id}/communication-entries/{communication-entry-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s).sub('{' + 'communication-entry-id' + '}', communication_entry_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(communication_entry)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#patch_communication_entry\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Patch a CommunicationEntry
    # Patch the CommunicationEntry. If a communication entry for the given communication-entry-id is not present, the object will get created and if it is present it will be updated. This is a full replace  This API is deprecated. Please use the following API instead. PATCH /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param communication_entry 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_communication_entry_0(domain_id, communication_map_id, communication_entry_id, communication_entry, opts = {})
      patch_communication_entry_0_with_http_info(domain_id, communication_map_id, communication_entry_id, communication_entry, opts)
      nil
    end

    # Patch a CommunicationEntry
    # Patch the CommunicationEntry. If a communication entry for the given communication-entry-id is not present, the object will get created and if it is present it will be updated. This is a full replace  This API is deprecated. Please use the following API instead. PATCH /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param communication_entry 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_communication_entry_0_with_http_info(domain_id, communication_map_id, communication_entry_id, communication_entry, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_entry_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_entry_0"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_entry_0"
      end
      # verify the required parameter 'communication_entry_id' is set
      if @api_client.config.client_side_validation && communication_entry_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_entry_0"
      end
      # verify the required parameter 'communication_entry' is set
      if @api_client.config.client_side_validation && communication_entry.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_entry_0"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/communication-maps/{communication-map-id}/communication-entries/{communication-entry-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s).sub('{' + 'communication-entry-id' + '}', communication_entry_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(communication_entry)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#patch_communication_entry_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Patch communication map
    # Patch the communication map for a domain. If a communication map for the given communication-map-id is not present, the object will get created and if it is present it will be updated. This is a full replace This API is deprecated. Please use the following API instead. PATCH /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_map 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_communication_map_for_domain(domain_id, communication_map_id, communication_map, opts = {})
      patch_communication_map_for_domain_with_http_info(domain_id, communication_map_id, communication_map, opts)
      nil
    end

    # Patch communication map
    # Patch the communication map for a domain. If a communication map for the given communication-map-id is not present, the object will get created and if it is present it will be updated. This is a full replace This API is deprecated. Please use the following API instead. PATCH /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_map 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_communication_map_for_domain_with_http_info(domain_id, communication_map_id, communication_map, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_map_for_domain ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_map_for_domain"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_map_for_domain"
      end
      # verify the required parameter 'communication_map' is set
      if @api_client.config.client_side_validation && communication_map.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_map_for_domain"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/communication-maps/{communication-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(communication_map)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#patch_communication_map_for_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Patch communication map
    # Patch the communication map for a domain. If a communication map for the given communication-map-id is not present, the object will get created and if it is present it will be updated. This is a full replace This API is deprecated. Please use the following API instead. PATCH /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_map 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_communication_map_for_domain_0(domain_id, communication_map_id, communication_map, opts = {})
      patch_communication_map_for_domain_0_with_http_info(domain_id, communication_map_id, communication_map, opts)
      nil
    end

    # Patch communication map
    # Patch the communication map for a domain. If a communication map for the given communication-map-id is not present, the object will get created and if it is present it will be updated. This is a full replace This API is deprecated. Please use the following API instead. PATCH /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_map 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_communication_map_for_domain_0_with_http_info(domain_id, communication_map_id, communication_map, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_map_for_domain_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_map_for_domain_0"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_map_for_domain_0"
      end
      # verify the required parameter 'communication_map' is set
      if @api_client.config.client_side_validation && communication_map.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.patch_communication_map_for_domain_0"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/communication-maps/{communication-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(communication_map)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#patch_communication_map_for_domain_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read CommunicationEntry
    # Read CommunicationEntry This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param [Hash] opts the optional parameters
    # @return [CommunicationEntry]
    def read_communication_entry(domain_id, communication_map_id, communication_entry_id, opts = {})
      data, _status_code, _headers = read_communication_entry_with_http_info(domain_id, communication_map_id, communication_entry_id, opts)
      data
    end

    # Read CommunicationEntry
    # Read CommunicationEntry This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CommunicationEntry, Fixnum, Hash)>] CommunicationEntry data, response status code and response headers
    def read_communication_entry_with_http_info(domain_id, communication_map_id, communication_entry_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_entry ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_entry"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_entry"
      end
      # verify the required parameter 'communication_entry_id' is set
      if @api_client.config.client_side_validation && communication_entry_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_entry"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/communication-maps/{communication-map-id}/communication-entries/{communication-entry-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s).sub('{' + 'communication-entry-id' + '}', communication_entry_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationEntry')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#read_communication_entry\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read CommunicationEntry
    # Read CommunicationEntry This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param [Hash] opts the optional parameters
    # @return [CommunicationEntry]
    def read_communication_entry_0(domain_id, communication_map_id, communication_entry_id, opts = {})
      data, _status_code, _headers = read_communication_entry_0_with_http_info(domain_id, communication_map_id, communication_entry_id, opts)
      data
    end

    # Read CommunicationEntry
    # Read CommunicationEntry This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CommunicationEntry, Fixnum, Hash)>] CommunicationEntry data, response status code and response headers
    def read_communication_entry_0_with_http_info(domain_id, communication_map_id, communication_entry_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_entry_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_entry_0"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_entry_0"
      end
      # verify the required parameter 'communication_entry_id' is set
      if @api_client.config.client_side_validation && communication_entry_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_entry_0"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/communication-maps/{communication-map-id}/communication-entries/{communication-entry-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s).sub('{' + 'communication-entry-id' + '}', communication_entry_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationEntry')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#read_communication_entry_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read communication-map
    # Read communication-map for a domain. This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param [Hash] opts the optional parameters
    # @return [CommunicationMap]
    def read_communication_map_for_domain(domain_id, communication_map_id, opts = {})
      data, _status_code, _headers = read_communication_map_for_domain_with_http_info(domain_id, communication_map_id, opts)
      data
    end

    # Read communication-map
    # Read communication-map for a domain. This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CommunicationMap, Fixnum, Hash)>] CommunicationMap data, response status code and response headers
    def read_communication_map_for_domain_with_http_info(domain_id, communication_map_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_map_for_domain ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_map_for_domain"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_map_for_domain"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/communication-maps/{communication-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationMap')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#read_communication_map_for_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read communication-map
    # Read communication-map for a domain. This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param [Hash] opts the optional parameters
    # @return [CommunicationMap]
    def read_communication_map_for_domain_0(domain_id, communication_map_id, opts = {})
      data, _status_code, _headers = read_communication_map_for_domain_0_with_http_info(domain_id, communication_map_id, opts)
      data
    end

    # Read communication-map
    # Read communication-map for a domain. This API is deprecated. Please use the following API instead. GET /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CommunicationMap, Fixnum, Hash)>] CommunicationMap data, response status code and response headers
    def read_communication_map_for_domain_0_with_http_info(domain_id, communication_map_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_map_for_domain_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_map_for_domain_0"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.read_communication_map_for_domain_0"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/communication-maps/{communication-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationMap')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#read_communication_map_for_domain_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Revise the positioning of communication entry
    # This is used to re-order a communictation entry within a communication map. This API is deprecated. Please use the following API instead. POST /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id?action=revise 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param communication_entry 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :anchor_path The communication map/communication entry path if operation is &#39;insert_after&#39; or &#39;insert_before&#39; 
    # @option opts [String] :operation Operation (default to insert_top)
    # @return [CommunicationEntry]
    def revise_communication_entry_revise(domain_id, communication_map_id, communication_entry_id, communication_entry, opts = {})
      data, _status_code, _headers = revise_communication_entry_revise_with_http_info(domain_id, communication_map_id, communication_entry_id, communication_entry, opts)
      data
    end

    # Revise the positioning of communication entry
    # This is used to re-order a communictation entry within a communication map. This API is deprecated. Please use the following API instead. POST /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id?action&#x3D;revise 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param communication_entry 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :anchor_path The communication map/communication entry path if operation is &#39;insert_after&#39; or &#39;insert_before&#39; 
    # @option opts [String] :operation Operation
    # @return [Array<(CommunicationEntry, Fixnum, Hash)>] CommunicationEntry data, response status code and response headers
    def revise_communication_entry_revise_with_http_info(domain_id, communication_map_id, communication_entry_id, communication_entry, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_entry_revise ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_entry_revise"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_entry_revise"
      end
      # verify the required parameter 'communication_entry_id' is set
      if @api_client.config.client_side_validation && communication_entry_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_entry_revise"
      end
      # verify the required parameter 'communication_entry' is set
      if @api_client.config.client_side_validation && communication_entry.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_entry_revise"
      end
      if @api_client.config.client_side_validation && opts[:'operation'] && !['insert_top', 'insert_bottom', 'insert_after', 'insert_before'].include?(opts[:'operation'])
        fail ArgumentError, 'invalid value for "operation", must be one of insert_top, insert_bottom, insert_after, insert_before'
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/communication-maps/{communication-map-id}/communication-entries/{communication-entry-id}?action=revise'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s).sub('{' + 'communication-entry-id' + '}', communication_entry_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'anchor_path'] = opts[:'anchor_path'] if !opts[:'anchor_path'].nil?
      query_params[:'operation'] = opts[:'operation'] if !opts[:'operation'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(communication_entry)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationEntry')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#revise_communication_entry_revise\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Revise the positioning of communication entry
    # This is used to re-order a communictation entry within a communication map. This API is deprecated. Please use the following API instead. POST /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id?action=revise 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param communication_entry 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :anchor_path The communication map/communication entry path if operation is &#39;insert_after&#39; or &#39;insert_before&#39; 
    # @option opts [String] :operation Operation (default to insert_top)
    # @return [CommunicationEntry]
    def revise_communication_entry_revise_0(domain_id, communication_map_id, communication_entry_id, communication_entry, opts = {})
      data, _status_code, _headers = revise_communication_entry_revise_0_with_http_info(domain_id, communication_map_id, communication_entry_id, communication_entry, opts)
      data
    end

    # Revise the positioning of communication entry
    # This is used to re-order a communictation entry within a communication map. This API is deprecated. Please use the following API instead. POST /infra/domains/domain-id/security-policies/security-policy-id/rules/rule-id?action&#x3D;revise 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param communication_entry 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :anchor_path The communication map/communication entry path if operation is &#39;insert_after&#39; or &#39;insert_before&#39; 
    # @option opts [String] :operation Operation
    # @return [Array<(CommunicationEntry, Fixnum, Hash)>] CommunicationEntry data, response status code and response headers
    def revise_communication_entry_revise_0_with_http_info(domain_id, communication_map_id, communication_entry_id, communication_entry, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_entry_revise_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_entry_revise_0"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_entry_revise_0"
      end
      # verify the required parameter 'communication_entry_id' is set
      if @api_client.config.client_side_validation && communication_entry_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_entry_revise_0"
      end
      # verify the required parameter 'communication_entry' is set
      if @api_client.config.client_side_validation && communication_entry.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_entry_revise_0"
      end
      if @api_client.config.client_side_validation && opts[:'operation'] && !['insert_top', 'insert_bottom', 'insert_after', 'insert_before'].include?(opts[:'operation'])
        fail ArgumentError, 'invalid value for "operation", must be one of insert_top, insert_bottom, insert_after, insert_before'
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/communication-maps/{communication-map-id}/communication-entries/{communication-entry-id}?action=revise'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s).sub('{' + 'communication-entry-id' + '}', communication_entry_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'anchor_path'] = opts[:'anchor_path'] if !opts[:'anchor_path'].nil?
      query_params[:'operation'] = opts[:'operation'] if !opts[:'operation'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(communication_entry)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationEntry')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#revise_communication_entry_revise_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Revise the positioning of communication maps
    # This is used to set a precedence of a communication map w.r.t others. This API is deprecated. Please use the following API instead. POST /infra/domains/domain-id/security-policies/security-policy-id?action=revise 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_map 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :anchor_path The communication map/communication entry path if operation is &#39;insert_after&#39; or &#39;insert_before&#39; 
    # @option opts [String] :operation Operation (default to insert_top)
    # @return [CommunicationMap]
    def revise_communication_maps_revise(domain_id, communication_map_id, communication_map, opts = {})
      data, _status_code, _headers = revise_communication_maps_revise_with_http_info(domain_id, communication_map_id, communication_map, opts)
      data
    end

    # Revise the positioning of communication maps
    # This is used to set a precedence of a communication map w.r.t others. This API is deprecated. Please use the following API instead. POST /infra/domains/domain-id/security-policies/security-policy-id?action&#x3D;revise 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_map 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :anchor_path The communication map/communication entry path if operation is &#39;insert_after&#39; or &#39;insert_before&#39; 
    # @option opts [String] :operation Operation
    # @return [Array<(CommunicationMap, Fixnum, Hash)>] CommunicationMap data, response status code and response headers
    def revise_communication_maps_revise_with_http_info(domain_id, communication_map_id, communication_map, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_maps_revise ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_maps_revise"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_maps_revise"
      end
      # verify the required parameter 'communication_map' is set
      if @api_client.config.client_side_validation && communication_map.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_maps_revise"
      end
      if @api_client.config.client_side_validation && opts[:'operation'] && !['insert_top', 'insert_bottom', 'insert_after', 'insert_before'].include?(opts[:'operation'])
        fail ArgumentError, 'invalid value for "operation", must be one of insert_top, insert_bottom, insert_after, insert_before'
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/communication-maps/{communication-map-id}?action=revise'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'anchor_path'] = opts[:'anchor_path'] if !opts[:'anchor_path'].nil?
      query_params[:'operation'] = opts[:'operation'] if !opts[:'operation'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(communication_map)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationMap')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#revise_communication_maps_revise\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Revise the positioning of communication maps
    # This is used to set a precedence of a communication map w.r.t others. This API is deprecated. Please use the following API instead. POST /infra/domains/domain-id/security-policies/security-policy-id?action=revise 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_map 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :anchor_path The communication map/communication entry path if operation is &#39;insert_after&#39; or &#39;insert_before&#39; 
    # @option opts [String] :operation Operation (default to insert_top)
    # @return [CommunicationMap]
    def revise_communication_maps_revise_0(domain_id, communication_map_id, communication_map, opts = {})
      data, _status_code, _headers = revise_communication_maps_revise_0_with_http_info(domain_id, communication_map_id, communication_map, opts)
      data
    end

    # Revise the positioning of communication maps
    # This is used to set a precedence of a communication map w.r.t others. This API is deprecated. Please use the following API instead. POST /infra/domains/domain-id/security-policies/security-policy-id?action&#x3D;revise 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_map 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :anchor_path The communication map/communication entry path if operation is &#39;insert_after&#39; or &#39;insert_before&#39; 
    # @option opts [String] :operation Operation
    # @return [Array<(CommunicationMap, Fixnum, Hash)>] CommunicationMap data, response status code and response headers
    def revise_communication_maps_revise_0_with_http_info(domain_id, communication_map_id, communication_map, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_maps_revise_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_maps_revise_0"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_maps_revise_0"
      end
      # verify the required parameter 'communication_map' is set
      if @api_client.config.client_side_validation && communication_map.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.revise_communication_maps_revise_0"
      end
      if @api_client.config.client_side_validation && opts[:'operation'] && !['insert_top', 'insert_bottom', 'insert_after', 'insert_before'].include?(opts[:'operation'])
        fail ArgumentError, 'invalid value for "operation", must be one of insert_top, insert_bottom, insert_after, insert_before'
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/communication-maps/{communication-map-id}?action=revise'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'anchor_path'] = opts[:'anchor_path'] if !opts[:'anchor_path'].nil?
      query_params[:'operation'] = opts[:'operation'] if !opts[:'operation'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(communication_map)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationMap')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#revise_communication_maps_revise_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a CommunicationEntry
    # Update the CommunicationEntry. If a CommunicationEntry with the communication-entry-id is not already present, this API fails with a 404. Creation of CommunicationEntries is not allowed using this API. This API is deprecated. Please use the following API instead PUT /infra/domains/domain-id/security-policies/securit-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param communication_entry 
    # @param [Hash] opts the optional parameters
    # @return [CommunicationEntry]
    def update_communication_entry(domain_id, communication_map_id, communication_entry_id, communication_entry, opts = {})
      data, _status_code, _headers = update_communication_entry_with_http_info(domain_id, communication_map_id, communication_entry_id, communication_entry, opts)
      data
    end

    # Create or update a CommunicationEntry
    # Update the CommunicationEntry. If a CommunicationEntry with the communication-entry-id is not already present, this API fails with a 404. Creation of CommunicationEntries is not allowed using this API. This API is deprecated. Please use the following API instead PUT /infra/domains/domain-id/security-policies/securit-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param communication_entry 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CommunicationEntry, Fixnum, Hash)>] CommunicationEntry data, response status code and response headers
    def update_communication_entry_with_http_info(domain_id, communication_map_id, communication_entry_id, communication_entry, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_entry ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_entry"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_entry"
      end
      # verify the required parameter 'communication_entry_id' is set
      if @api_client.config.client_side_validation && communication_entry_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_entry"
      end
      # verify the required parameter 'communication_entry' is set
      if @api_client.config.client_side_validation && communication_entry.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_entry"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/communication-maps/{communication-map-id}/communication-entries/{communication-entry-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s).sub('{' + 'communication-entry-id' + '}', communication_entry_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(communication_entry)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationEntry')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#update_communication_entry\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update a CommunicationEntry
    # Update the CommunicationEntry. If a CommunicationEntry with the communication-entry-id is not already present, this API fails with a 404. Creation of CommunicationEntries is not allowed using this API. This API is deprecated. Please use the following API instead PUT /infra/domains/domain-id/security-policies/securit-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param communication_entry 
    # @param [Hash] opts the optional parameters
    # @return [CommunicationEntry]
    def update_communication_entry_0(domain_id, communication_map_id, communication_entry_id, communication_entry, opts = {})
      data, _status_code, _headers = update_communication_entry_0_with_http_info(domain_id, communication_map_id, communication_entry_id, communication_entry, opts)
      data
    end

    # Create or update a CommunicationEntry
    # Update the CommunicationEntry. If a CommunicationEntry with the communication-entry-id is not already present, this API fails with a 404. Creation of CommunicationEntries is not allowed using this API. This API is deprecated. Please use the following API instead PUT /infra/domains/domain-id/security-policies/securit-policy-id/rules/rule-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_entry_id 
    # @param communication_entry 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CommunicationEntry, Fixnum, Hash)>] CommunicationEntry data, response status code and response headers
    def update_communication_entry_0_with_http_info(domain_id, communication_map_id, communication_entry_id, communication_entry, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_entry_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_entry_0"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_entry_0"
      end
      # verify the required parameter 'communication_entry_id' is set
      if @api_client.config.client_side_validation && communication_entry_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_entry_0"
      end
      # verify the required parameter 'communication_entry' is set
      if @api_client.config.client_side_validation && communication_entry.nil?
        fail ArgumentError, "Missing the required parameter 'communication_entry' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_entry_0"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/communication-maps/{communication-map-id}/communication-entries/{communication-entry-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s).sub('{' + 'communication-entry-id' + '}', communication_entry_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(communication_entry)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationEntry')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#update_communication_entry_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or Update communication map
    # Create or Update the communication map for a domain. This is a full replace. All the CommunicationEntries are replaced. This API is deprecated. Please use the following API instead. PUT /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_map 
    # @param [Hash] opts the optional parameters
    # @return [CommunicationMap]
    def update_communication_map_for_domain(domain_id, communication_map_id, communication_map, opts = {})
      data, _status_code, _headers = update_communication_map_for_domain_with_http_info(domain_id, communication_map_id, communication_map, opts)
      data
    end

    # Create or Update communication map
    # Create or Update the communication map for a domain. This is a full replace. All the CommunicationEntries are replaced. This API is deprecated. Please use the following API instead. PUT /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_map 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CommunicationMap, Fixnum, Hash)>] CommunicationMap data, response status code and response headers
    def update_communication_map_for_domain_with_http_info(domain_id, communication_map_id, communication_map, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_map_for_domain ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_map_for_domain"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_map_for_domain"
      end
      # verify the required parameter 'communication_map' is set
      if @api_client.config.client_side_validation && communication_map.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_map_for_domain"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/communication-maps/{communication-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(communication_map)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationMap')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#update_communication_map_for_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or Update communication map
    # Create or Update the communication map for a domain. This is a full replace. All the CommunicationEntries are replaced. This API is deprecated. Please use the following API instead. PUT /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_map 
    # @param [Hash] opts the optional parameters
    # @return [CommunicationMap]
    def update_communication_map_for_domain_0(domain_id, communication_map_id, communication_map, opts = {})
      data, _status_code, _headers = update_communication_map_for_domain_0_with_http_info(domain_id, communication_map_id, communication_map, opts)
      data
    end

    # Create or Update communication map
    # Create or Update the communication map for a domain. This is a full replace. All the CommunicationEntries are replaced. This API is deprecated. Please use the following API instead. PUT /infra/domains/domain-id/security-policies/security-policy-id 
    # @param domain_id 
    # @param communication_map_id 
    # @param communication_map 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CommunicationMap, Fixnum, Hash)>] CommunicationMap data, response status code and response headers
    def update_communication_map_for_domain_0_with_http_info(domain_id, communication_map_id, communication_map, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_map_for_domain_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_map_for_domain_0"
      end
      # verify the required parameter 'communication_map_id' is set
      if @api_client.config.client_side_validation && communication_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map_id' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_map_for_domain_0"
      end
      # verify the required parameter 'communication_map' is set
      if @api_client.config.client_side_validation && communication_map.nil?
        fail ArgumentError, "Missing the required parameter 'communication_map' when calling PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi.update_communication_map_for_domain_0"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/communication-maps/{communication-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'communication-map-id' + '}', communication_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(communication_map)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommunicationMap')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallCommunicationMapsApi#update_communication_map_for_domain_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
