=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Get dfw firewall configuration
    # Get the current dfw firewall configurations.
    # @param [Hash] opts the optional parameters
    # @return [DfwFirewallConfiguration]
    def get_dfw_firewall_configuration(opts = {})
      data, _status_code, _headers = get_dfw_firewall_configuration_with_http_info(opts)
      data
    end

    # Get dfw firewall configuration
    # Get the current dfw firewall configurations.
    # @param [Hash] opts the optional parameters
    # @return [Array<(DfwFirewallConfiguration, Fixnum, Hash)>] DfwFirewallConfiguration data, response status code and response headers
    def get_dfw_firewall_configuration_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi.get_dfw_firewall_configuration ...'
      end
      # resource path
      local_var_path = '/infra/settings/firewall/security'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DfwFirewallConfiguration')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi#get_dfw_firewall_configuration\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get dfw firewall configuration
    # Get the current dfw firewall configurations.
    # @param [Hash] opts the optional parameters
    # @return [DfwFirewallConfiguration]
    def get_dfw_firewall_configuration_0(opts = {})
      data, _status_code, _headers = get_dfw_firewall_configuration_0_with_http_info(opts)
      data
    end

    # Get dfw firewall configuration
    # Get the current dfw firewall configurations.
    # @param [Hash] opts the optional parameters
    # @return [Array<(DfwFirewallConfiguration, Fixnum, Hash)>] DfwFirewallConfiguration data, response status code and response headers
    def get_dfw_firewall_configuration_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi.get_dfw_firewall_configuration_0 ...'
      end
      # resource path
      local_var_path = '/global-infra/settings/firewall/security'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DfwFirewallConfiguration')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi#get_dfw_firewall_configuration_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update dfw firewall configuration
    # Update dfw firewall related configurations. 
    # @param dfw_firewall_configuration 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_dfw_firewall_configuration(dfw_firewall_configuration, opts = {})
      patch_dfw_firewall_configuration_with_http_info(dfw_firewall_configuration, opts)
      nil
    end

    # Update dfw firewall configuration
    # Update dfw firewall related configurations. 
    # @param dfw_firewall_configuration 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_dfw_firewall_configuration_with_http_info(dfw_firewall_configuration, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi.patch_dfw_firewall_configuration ...'
      end
      # verify the required parameter 'dfw_firewall_configuration' is set
      if @api_client.config.client_side_validation && dfw_firewall_configuration.nil?
        fail ArgumentError, "Missing the required parameter 'dfw_firewall_configuration' when calling PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi.patch_dfw_firewall_configuration"
      end
      # resource path
      local_var_path = '/infra/settings/firewall/security'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(dfw_firewall_configuration)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi#patch_dfw_firewall_configuration\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update dfw firewall configuration
    # Update dfw firewall related configurations. 
    # @param dfw_firewall_configuration 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_dfw_firewall_configuration_0(dfw_firewall_configuration, opts = {})
      patch_dfw_firewall_configuration_0_with_http_info(dfw_firewall_configuration, opts)
      nil
    end

    # Update dfw firewall configuration
    # Update dfw firewall related configurations. 
    # @param dfw_firewall_configuration 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_dfw_firewall_configuration_0_with_http_info(dfw_firewall_configuration, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi.patch_dfw_firewall_configuration_0 ...'
      end
      # verify the required parameter 'dfw_firewall_configuration' is set
      if @api_client.config.client_side_validation && dfw_firewall_configuration.nil?
        fail ArgumentError, "Missing the required parameter 'dfw_firewall_configuration' when calling PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi.patch_dfw_firewall_configuration_0"
      end
      # resource path
      local_var_path = '/global-infra/settings/firewall/security'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(dfw_firewall_configuration)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi#patch_dfw_firewall_configuration_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update dfw firewall configuration
    # Update dfw firewall related configurations. 
    # @param dfw_firewall_configuration 
    # @param [Hash] opts the optional parameters
    # @return [DfwFirewallConfiguration]
    def put_dfw_firewall_configuration(dfw_firewall_configuration, opts = {})
      data, _status_code, _headers = put_dfw_firewall_configuration_with_http_info(dfw_firewall_configuration, opts)
      data
    end

    # Update dfw firewall configuration
    # Update dfw firewall related configurations. 
    # @param dfw_firewall_configuration 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DfwFirewallConfiguration, Fixnum, Hash)>] DfwFirewallConfiguration data, response status code and response headers
    def put_dfw_firewall_configuration_with_http_info(dfw_firewall_configuration, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi.put_dfw_firewall_configuration ...'
      end
      # verify the required parameter 'dfw_firewall_configuration' is set
      if @api_client.config.client_side_validation && dfw_firewall_configuration.nil?
        fail ArgumentError, "Missing the required parameter 'dfw_firewall_configuration' when calling PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi.put_dfw_firewall_configuration"
      end
      # resource path
      local_var_path = '/infra/settings/firewall/security'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(dfw_firewall_configuration)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DfwFirewallConfiguration')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi#put_dfw_firewall_configuration\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update dfw firewall configuration
    # Update dfw firewall related configurations. 
    # @param dfw_firewall_configuration 
    # @param [Hash] opts the optional parameters
    # @return [DfwFirewallConfiguration]
    def put_dfw_firewall_configuration_0(dfw_firewall_configuration, opts = {})
      data, _status_code, _headers = put_dfw_firewall_configuration_0_with_http_info(dfw_firewall_configuration, opts)
      data
    end

    # Update dfw firewall configuration
    # Update dfw firewall related configurations. 
    # @param dfw_firewall_configuration 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DfwFirewallConfiguration, Fixnum, Hash)>] DfwFirewallConfiguration data, response status code and response headers
    def put_dfw_firewall_configuration_0_with_http_info(dfw_firewall_configuration, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi.put_dfw_firewall_configuration_0 ...'
      end
      # verify the required parameter 'dfw_firewall_configuration' is set
      if @api_client.config.client_side_validation && dfw_firewall_configuration.nil?
        fail ArgumentError, "Missing the required parameter 'dfw_firewall_configuration' when calling PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi.put_dfw_firewall_configuration_0"
      end
      # resource path
      local_var_path = '/global-infra/settings/firewall/security'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(dfw_firewall_configuration)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DfwFirewallConfiguration')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsDistributedFirewallSettingsApi#put_dfw_firewall_configuration_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
