=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Filter the firewall exclude list
    # Filter the firewall exclude list by the given object, to check whether the object is a member of this exclude list. 
    # @param intent_path Path of the intent object to be searched in the exclude list
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :deep_check Check all parents (default to false)
    # @option opts [String] :enforcement_point_path Path of the enforcement point
    # @return [PolicyResourceReference]
    def filter_firewall_exclude_list_filter(intent_path, opts = {})
      data, _status_code, _headers = filter_firewall_exclude_list_filter_with_http_info(intent_path, opts)
      data
    end

    # Filter the firewall exclude list
    # Filter the firewall exclude list by the given object, to check whether the object is a member of this exclude list. 
    # @param intent_path Path of the intent object to be searched in the exclude list
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :deep_check Check all parents
    # @option opts [String] :enforcement_point_path Path of the enforcement point
    # @return [Array<(PolicyResourceReference, Fixnum, Hash)>] PolicyResourceReference data, response status code and response headers
    def filter_firewall_exclude_list_filter_with_http_info(intent_path, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.filter_firewall_exclude_list_filter ...'
      end
      # verify the required parameter 'intent_path' is set
      if @api_client.config.client_side_validation && intent_path.nil?
        fail ArgumentError, "Missing the required parameter 'intent_path' when calling PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.filter_firewall_exclude_list_filter"
      end
      # resource path
      local_var_path = '/global-infra/settings/firewall/security/exclude-list?action=filter'

      # query parameters
      query_params = {}
      query_params[:'intent_path'] = intent_path
      query_params[:'deep_check'] = opts[:'deep_check'] if !opts[:'deep_check'].nil?
      query_params[:'enforcement_point_path'] = opts[:'enforcement_point_path'] if !opts[:'enforcement_point_path'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyResourceReference')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi#filter_firewall_exclude_list_filter\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Filter the firewall exclude list
    # Filter the firewall exclude list by the given object, to check whether the object is a member of this exclude list. 
    # @param intent_path Path of the intent object to be searched in the exclude list
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :deep_check Check all parents (default to false)
    # @option opts [String] :enforcement_point_path Path of the enforcement point
    # @return [PolicyResourceReference]
    def filter_firewall_exclude_list_filter_0(intent_path, opts = {})
      data, _status_code, _headers = filter_firewall_exclude_list_filter_0_with_http_info(intent_path, opts)
      data
    end

    # Filter the firewall exclude list
    # Filter the firewall exclude list by the given object, to check whether the object is a member of this exclude list. 
    # @param intent_path Path of the intent object to be searched in the exclude list
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :deep_check Check all parents
    # @option opts [String] :enforcement_point_path Path of the enforcement point
    # @return [Array<(PolicyResourceReference, Fixnum, Hash)>] PolicyResourceReference data, response status code and response headers
    def filter_firewall_exclude_list_filter_0_with_http_info(intent_path, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.filter_firewall_exclude_list_filter_0 ...'
      end
      # verify the required parameter 'intent_path' is set
      if @api_client.config.client_side_validation && intent_path.nil?
        fail ArgumentError, "Missing the required parameter 'intent_path' when calling PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.filter_firewall_exclude_list_filter_0"
      end
      # resource path
      local_var_path = '/infra/settings/firewall/security/exclude-list?action=filter'

      # query parameters
      query_params = {}
      query_params[:'intent_path'] = intent_path
      query_params[:'deep_check'] = opts[:'deep_check'] if !opts[:'deep_check'].nil?
      query_params[:'enforcement_point_path'] = opts[:'enforcement_point_path'] if !opts[:'enforcement_point_path'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyResourceReference')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi#filter_firewall_exclude_list_filter_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read security policy exclude list
    # Read exclude list for firewall 
    # @param [Hash] opts the optional parameters
    # @return [PolicyExcludeList]
    def get_firewall_exclude_list(opts = {})
      data, _status_code, _headers = get_firewall_exclude_list_with_http_info(opts)
      data
    end

    # Read security policy exclude list
    # Read exclude list for firewall 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyExcludeList, Fixnum, Hash)>] PolicyExcludeList data, response status code and response headers
    def get_firewall_exclude_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.get_firewall_exclude_list ...'
      end
      # resource path
      local_var_path = '/global-infra/settings/firewall/security/exclude-list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyExcludeList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi#get_firewall_exclude_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Read security policy exclude list
    # Read exclude list for firewall 
    # @param [Hash] opts the optional parameters
    # @return [PolicyExcludeList]
    def get_firewall_exclude_list_0(opts = {})
      data, _status_code, _headers = get_firewall_exclude_list_0_with_http_info(opts)
      data
    end

    # Read security policy exclude list
    # Read exclude list for firewall 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyExcludeList, Fixnum, Hash)>] PolicyExcludeList data, response status code and response headers
    def get_firewall_exclude_list_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.get_firewall_exclude_list_0 ...'
      end
      # resource path
      local_var_path = '/infra/settings/firewall/security/exclude-list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyExcludeList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi#get_firewall_exclude_list_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Patch exclusion list for security policy
    # Patch exclusion list for security policy. 
    # @param policy_exclude_list 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_exclude_list(policy_exclude_list, opts = {})
      patch_exclude_list_with_http_info(policy_exclude_list, opts)
      nil
    end

    # Patch exclusion list for security policy
    # Patch exclusion list for security policy. 
    # @param policy_exclude_list 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_exclude_list_with_http_info(policy_exclude_list, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.patch_exclude_list ...'
      end
      # verify the required parameter 'policy_exclude_list' is set
      if @api_client.config.client_side_validation && policy_exclude_list.nil?
        fail ArgumentError, "Missing the required parameter 'policy_exclude_list' when calling PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.patch_exclude_list"
      end
      # resource path
      local_var_path = '/global-infra/settings/firewall/security/exclude-list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_exclude_list)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi#patch_exclude_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Patch exclusion list for security policy
    # Patch exclusion list for security policy. 
    # @param policy_exclude_list 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_exclude_list_0(policy_exclude_list, opts = {})
      patch_exclude_list_0_with_http_info(policy_exclude_list, opts)
      nil
    end

    # Patch exclusion list for security policy
    # Patch exclusion list for security policy. 
    # @param policy_exclude_list 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_exclude_list_0_with_http_info(policy_exclude_list, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.patch_exclude_list_0 ...'
      end
      # verify the required parameter 'policy_exclude_list' is set
      if @api_client.config.client_side_validation && policy_exclude_list.nil?
        fail ArgumentError, "Missing the required parameter 'policy_exclude_list' when calling PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.patch_exclude_list_0"
      end
      # resource path
      local_var_path = '/infra/settings/firewall/security/exclude-list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_exclude_list)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi#patch_exclude_list_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update exclusion list for security policy
    # Update the exclusion list for security policy 
    # @param policy_exclude_list 
    # @param [Hash] opts the optional parameters
    # @return [PolicyExcludeList]
    def put_exclude_list(policy_exclude_list, opts = {})
      data, _status_code, _headers = put_exclude_list_with_http_info(policy_exclude_list, opts)
      data
    end

    # Create or update exclusion list for security policy
    # Update the exclusion list for security policy 
    # @param policy_exclude_list 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyExcludeList, Fixnum, Hash)>] PolicyExcludeList data, response status code and response headers
    def put_exclude_list_with_http_info(policy_exclude_list, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.put_exclude_list ...'
      end
      # verify the required parameter 'policy_exclude_list' is set
      if @api_client.config.client_side_validation && policy_exclude_list.nil?
        fail ArgumentError, "Missing the required parameter 'policy_exclude_list' when calling PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.put_exclude_list"
      end
      # resource path
      local_var_path = '/global-infra/settings/firewall/security/exclude-list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_exclude_list)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyExcludeList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi#put_exclude_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update exclusion list for security policy
    # Update the exclusion list for security policy 
    # @param policy_exclude_list 
    # @param [Hash] opts the optional parameters
    # @return [PolicyExcludeList]
    def put_exclude_list_0(policy_exclude_list, opts = {})
      data, _status_code, _headers = put_exclude_list_0_with_http_info(policy_exclude_list, opts)
      data
    end

    # Create or update exclusion list for security policy
    # Update the exclusion list for security policy 
    # @param policy_exclude_list 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyExcludeList, Fixnum, Hash)>] PolicyExcludeList data, response status code and response headers
    def put_exclude_list_0_with_http_info(policy_exclude_list, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.put_exclude_list_0 ...'
      end
      # verify the required parameter 'policy_exclude_list' is set
      if @api_client.config.client_side_validation && policy_exclude_list.nil?
        fail ArgumentError, "Missing the required parameter 'policy_exclude_list' when calling PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi.put_exclude_list_0"
      end
      # resource path
      local_var_path = '/infra/settings/firewall/security/exclude-list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_exclude_list)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyExcludeList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityEastWestSecurityDistributedFirewallSettingsExclusionListApi#put_exclude_list_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
