=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicySecuritySecurityProfilesFloodProtectionProfilesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete Flood Protection Profile
    # API will delete Flood Protection Profile
    # @param flood_protection_profile_id Flood Protection Profile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [nil]
    def delete_flood_protection_profile(flood_protection_profile_id, opts = {})
      delete_flood_protection_profile_with_http_info(flood_protection_profile_id, opts)
      nil
    end

    # Delete Flood Protection Profile
    # API will delete Flood Protection Profile
    # @param flood_protection_profile_id Flood Protection Profile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_flood_protection_profile_with_http_info(flood_protection_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesFloodProtectionProfilesApi.delete_flood_protection_profile ...'
      end
      # verify the required parameter 'flood_protection_profile_id' is set
      if @api_client.config.client_side_validation && flood_protection_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile_id' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.delete_flood_protection_profile"
      end
      # resource path
      local_var_path = '/infra/flood-protection-profiles/{flood-protection-profile-id}'.sub('{' + 'flood-protection-profile-id' + '}', flood_protection_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesFloodProtectionProfilesApi#delete_flood_protection_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete Flood Protection Profile
    # API will delete Flood Protection Profile
    # @param flood_protection_profile_id Flood Protection Profile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [nil]
    def delete_flood_protection_profile_0(flood_protection_profile_id, opts = {})
      delete_flood_protection_profile_0_with_http_info(flood_protection_profile_id, opts)
      nil
    end

    # Delete Flood Protection Profile
    # API will delete Flood Protection Profile
    # @param flood_protection_profile_id Flood Protection Profile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_flood_protection_profile_0_with_http_info(flood_protection_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesFloodProtectionProfilesApi.delete_flood_protection_profile_0 ...'
      end
      # verify the required parameter 'flood_protection_profile_id' is set
      if @api_client.config.client_side_validation && flood_protection_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile_id' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.delete_flood_protection_profile_0"
      end
      # resource path
      local_var_path = '/global-infra/flood-protection-profiles/{flood-protection-profile-id}'.sub('{' + 'flood-protection-profile-id' + '}', flood_protection_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesFloodProtectionProfilesApi#delete_flood_protection_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get Flood Protection Profile
    # API will get Flood Protection Profile
    # @param flood_protection_profile_id Flood Protection Profile ID
    # @param [Hash] opts the optional parameters
    # @return [FloodProtectionProfile]
    def get_flood_protection_profile(flood_protection_profile_id, opts = {})
      data, _status_code, _headers = get_flood_protection_profile_with_http_info(flood_protection_profile_id, opts)
      data
    end

    # Get Flood Protection Profile
    # API will get Flood Protection Profile
    # @param flood_protection_profile_id Flood Protection Profile ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(FloodProtectionProfile, Fixnum, Hash)>] FloodProtectionProfile data, response status code and response headers
    def get_flood_protection_profile_with_http_info(flood_protection_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesFloodProtectionProfilesApi.get_flood_protection_profile ...'
      end
      # verify the required parameter 'flood_protection_profile_id' is set
      if @api_client.config.client_side_validation && flood_protection_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile_id' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.get_flood_protection_profile"
      end
      # resource path
      local_var_path = '/infra/flood-protection-profiles/{flood-protection-profile-id}'.sub('{' + 'flood-protection-profile-id' + '}', flood_protection_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FloodProtectionProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesFloodProtectionProfilesApi#get_flood_protection_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get Flood Protection Profile
    # API will get Flood Protection Profile
    # @param flood_protection_profile_id Flood Protection Profile ID
    # @param [Hash] opts the optional parameters
    # @return [FloodProtectionProfile]
    def get_flood_protection_profile_0(flood_protection_profile_id, opts = {})
      data, _status_code, _headers = get_flood_protection_profile_0_with_http_info(flood_protection_profile_id, opts)
      data
    end

    # Get Flood Protection Profile
    # API will get Flood Protection Profile
    # @param flood_protection_profile_id Flood Protection Profile ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(FloodProtectionProfile, Fixnum, Hash)>] FloodProtectionProfile data, response status code and response headers
    def get_flood_protection_profile_0_with_http_info(flood_protection_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesFloodProtectionProfilesApi.get_flood_protection_profile_0 ...'
      end
      # verify the required parameter 'flood_protection_profile_id' is set
      if @api_client.config.client_side_validation && flood_protection_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile_id' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.get_flood_protection_profile_0"
      end
      # resource path
      local_var_path = '/global-infra/flood-protection-profiles/{flood-protection-profile-id}'.sub('{' + 'flood-protection-profile-id' + '}', flood_protection_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FloodProtectionProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesFloodProtectionProfilesApi#get_flood_protection_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Flood Protection Profiles
    # API will list all Flood Protection Profiles bindings.
    # @param flood_protection_profile_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [FloodProtectionProfileBindingListResult]
    def list_flood_protection_profile_bindings(flood_protection_profile_id, opts = {})
      data, _status_code, _headers = list_flood_protection_profile_bindings_with_http_info(flood_protection_profile_id, opts)
      data
    end

    # List Flood Protection Profiles
    # API will list all Flood Protection Profiles bindings.
    # @param flood_protection_profile_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(FloodProtectionProfileBindingListResult, Fixnum, Hash)>] FloodProtectionProfileBindingListResult data, response status code and response headers
    def list_flood_protection_profile_bindings_with_http_info(flood_protection_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profile_bindings ...'
      end
      # verify the required parameter 'flood_protection_profile_id' is set
      if @api_client.config.client_side_validation && flood_protection_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile_id' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profile_bindings"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profile_bindings, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profile_bindings, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/flood-protection-profiles/{flood-protection-profile-id}/bindings'.sub('{' + 'flood-protection-profile-id' + '}', flood_protection_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FloodProtectionProfileBindingListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesFloodProtectionProfilesApi#list_flood_protection_profile_bindings\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Flood Protection Profiles
    # API will list all Flood Protection Profiles bindings.
    # @param flood_protection_profile_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [FloodProtectionProfileBindingListResult]
    def list_flood_protection_profile_bindings_0(flood_protection_profile_id, opts = {})
      data, _status_code, _headers = list_flood_protection_profile_bindings_0_with_http_info(flood_protection_profile_id, opts)
      data
    end

    # List Flood Protection Profiles
    # API will list all Flood Protection Profiles bindings.
    # @param flood_protection_profile_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(FloodProtectionProfileBindingListResult, Fixnum, Hash)>] FloodProtectionProfileBindingListResult data, response status code and response headers
    def list_flood_protection_profile_bindings_0_with_http_info(flood_protection_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profile_bindings_0 ...'
      end
      # verify the required parameter 'flood_protection_profile_id' is set
      if @api_client.config.client_side_validation && flood_protection_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile_id' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profile_bindings_0"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profile_bindings_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profile_bindings_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/flood-protection-profiles/{flood-protection-profile-id}/bindings'.sub('{' + 'flood-protection-profile-id' + '}', flood_protection_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FloodProtectionProfileBindingListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesFloodProtectionProfilesApi#list_flood_protection_profile_bindings_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Flood Protection Profiles
    # API will list all Flood Protection Profiles
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [FloodProtectionProfileListResult]
    def list_flood_protection_profiles(opts = {})
      data, _status_code, _headers = list_flood_protection_profiles_with_http_info(opts)
      data
    end

    # List Flood Protection Profiles
    # API will list all Flood Protection Profiles
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(FloodProtectionProfileListResult, Fixnum, Hash)>] FloodProtectionProfileListResult data, response status code and response headers
    def list_flood_protection_profiles_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profiles ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profiles, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profiles, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/flood-protection-profiles'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FloodProtectionProfileListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesFloodProtectionProfilesApi#list_flood_protection_profiles\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Flood Protection Profiles
    # API will list all Flood Protection Profiles
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [FloodProtectionProfileListResult]
    def list_flood_protection_profiles_0(opts = {})
      data, _status_code, _headers = list_flood_protection_profiles_0_with_http_info(opts)
      data
    end

    # List Flood Protection Profiles
    # API will list all Flood Protection Profiles
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(FloodProtectionProfileListResult, Fixnum, Hash)>] FloodProtectionProfileListResult data, response status code and response headers
    def list_flood_protection_profiles_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profiles_0 ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profiles_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.list_flood_protection_profiles_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/flood-protection-profiles'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FloodProtectionProfileListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesFloodProtectionProfilesApi#list_flood_protection_profiles_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update Flood Protection Profile
    # API will create/update Flood Protection Profile
    # @param flood_protection_profile_id Firewall Flood Protection Profile ID
    # @param flood_protection_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [nil]
    def patch_flood_protection_profile(flood_protection_profile_id, flood_protection_profile, opts = {})
      patch_flood_protection_profile_with_http_info(flood_protection_profile_id, flood_protection_profile, opts)
      nil
    end

    # Create or update Flood Protection Profile
    # API will create/update Flood Protection Profile
    # @param flood_protection_profile_id Firewall Flood Protection Profile ID
    # @param flood_protection_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_flood_protection_profile_with_http_info(flood_protection_profile_id, flood_protection_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesFloodProtectionProfilesApi.patch_flood_protection_profile ...'
      end
      # verify the required parameter 'flood_protection_profile_id' is set
      if @api_client.config.client_side_validation && flood_protection_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile_id' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.patch_flood_protection_profile"
      end
      # verify the required parameter 'flood_protection_profile' is set
      if @api_client.config.client_side_validation && flood_protection_profile.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.patch_flood_protection_profile"
      end
      # resource path
      local_var_path = '/infra/flood-protection-profiles/{flood-protection-profile-id}'.sub('{' + 'flood-protection-profile-id' + '}', flood_protection_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(flood_protection_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesFloodProtectionProfilesApi#patch_flood_protection_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update Flood Protection Profile
    # API will create/update Flood Protection Profile
    # @param flood_protection_profile_id Firewall Flood Protection Profile ID
    # @param flood_protection_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [nil]
    def patch_flood_protection_profile_0(flood_protection_profile_id, flood_protection_profile, opts = {})
      patch_flood_protection_profile_0_with_http_info(flood_protection_profile_id, flood_protection_profile, opts)
      nil
    end

    # Create or update Flood Protection Profile
    # API will create/update Flood Protection Profile
    # @param flood_protection_profile_id Firewall Flood Protection Profile ID
    # @param flood_protection_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_flood_protection_profile_0_with_http_info(flood_protection_profile_id, flood_protection_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesFloodProtectionProfilesApi.patch_flood_protection_profile_0 ...'
      end
      # verify the required parameter 'flood_protection_profile_id' is set
      if @api_client.config.client_side_validation && flood_protection_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile_id' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.patch_flood_protection_profile_0"
      end
      # verify the required parameter 'flood_protection_profile' is set
      if @api_client.config.client_side_validation && flood_protection_profile.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.patch_flood_protection_profile_0"
      end
      # resource path
      local_var_path = '/global-infra/flood-protection-profiles/{flood-protection-profile-id}'.sub('{' + 'flood-protection-profile-id' + '}', flood_protection_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(flood_protection_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesFloodProtectionProfilesApi#patch_flood_protection_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update Firewall Flood Protection Profile
    # API will update Firewall Flood Protection Profile
    # @param flood_protection_profile_id Flood Protection Profile ID
    # @param flood_protection_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [FloodProtectionProfile]
    def update_flood_protection_profile(flood_protection_profile_id, flood_protection_profile, opts = {})
      data, _status_code, _headers = update_flood_protection_profile_with_http_info(flood_protection_profile_id, flood_protection_profile, opts)
      data
    end

    # Update Firewall Flood Protection Profile
    # API will update Firewall Flood Protection Profile
    # @param flood_protection_profile_id Flood Protection Profile ID
    # @param flood_protection_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(FloodProtectionProfile, Fixnum, Hash)>] FloodProtectionProfile data, response status code and response headers
    def update_flood_protection_profile_with_http_info(flood_protection_profile_id, flood_protection_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesFloodProtectionProfilesApi.update_flood_protection_profile ...'
      end
      # verify the required parameter 'flood_protection_profile_id' is set
      if @api_client.config.client_side_validation && flood_protection_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile_id' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.update_flood_protection_profile"
      end
      # verify the required parameter 'flood_protection_profile' is set
      if @api_client.config.client_side_validation && flood_protection_profile.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.update_flood_protection_profile"
      end
      # resource path
      local_var_path = '/infra/flood-protection-profiles/{flood-protection-profile-id}'.sub('{' + 'flood-protection-profile-id' + '}', flood_protection_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(flood_protection_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FloodProtectionProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesFloodProtectionProfilesApi#update_flood_protection_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update Firewall Flood Protection Profile
    # API will update Firewall Flood Protection Profile
    # @param flood_protection_profile_id Flood Protection Profile ID
    # @param flood_protection_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [FloodProtectionProfile]
    def update_flood_protection_profile_0(flood_protection_profile_id, flood_protection_profile, opts = {})
      data, _status_code, _headers = update_flood_protection_profile_0_with_http_info(flood_protection_profile_id, flood_protection_profile, opts)
      data
    end

    # Update Firewall Flood Protection Profile
    # API will update Firewall Flood Protection Profile
    # @param flood_protection_profile_id Flood Protection Profile ID
    # @param flood_protection_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(FloodProtectionProfile, Fixnum, Hash)>] FloodProtectionProfile data, response status code and response headers
    def update_flood_protection_profile_0_with_http_info(flood_protection_profile_id, flood_protection_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesFloodProtectionProfilesApi.update_flood_protection_profile_0 ...'
      end
      # verify the required parameter 'flood_protection_profile_id' is set
      if @api_client.config.client_side_validation && flood_protection_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile_id' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.update_flood_protection_profile_0"
      end
      # verify the required parameter 'flood_protection_profile' is set
      if @api_client.config.client_side_validation && flood_protection_profile.nil?
        fail ArgumentError, "Missing the required parameter 'flood_protection_profile' when calling PolicySecuritySecurityProfilesFloodProtectionProfilesApi.update_flood_protection_profile_0"
      end
      # resource path
      local_var_path = '/global-infra/flood-protection-profiles/{flood-protection-profile-id}'.sub('{' + 'flood-protection-profile-id' + '}', flood_protection_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(flood_protection_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FloodProtectionProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesFloodProtectionProfilesApi#update_flood_protection_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
