=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicySecuritySecurityProfilesMonitoringProfileBindingApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete Group Monitoring Profile Binding
    # API will delete Group Monitoring Profile Binding
    # @param domain_id Domain ID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_group_monitoring_binding(domain_id, group_id, group_monitoring_profile_binding_map_id, opts = {})
      delete_group_monitoring_binding_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, opts)
      nil
    end

    # Delete Group Monitoring Profile Binding
    # API will delete Group Monitoring Profile Binding
    # @param domain_id Domain ID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_group_monitoring_binding_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesMonitoringProfileBindingApi.delete_group_monitoring_binding ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.delete_group_monitoring_binding"
      end
      # verify the required parameter 'group_id' is set
      if @api_client.config.client_side_validation && group_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.delete_group_monitoring_binding"
      end
      # verify the required parameter 'group_monitoring_profile_binding_map_id' is set
      if @api_client.config.client_side_validation && group_monitoring_profile_binding_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_monitoring_profile_binding_map_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.delete_group_monitoring_binding"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/groups/{group-id}/group-monitoring-profile-binding-maps/{group-monitoring-profile-binding-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'group-id' + '}', group_id.to_s).sub('{' + 'group-monitoring-profile-binding-map-id' + '}', group_monitoring_profile_binding_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesMonitoringProfileBindingApi#delete_group_monitoring_binding\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete Group Monitoring Profile Binding
    # API will delete Group Monitoring Profile Binding
    # @param domain_id Domain ID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_group_monitoring_binding_0(domain_id, group_id, group_monitoring_profile_binding_map_id, opts = {})
      delete_group_monitoring_binding_0_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, opts)
      nil
    end

    # Delete Group Monitoring Profile Binding
    # API will delete Group Monitoring Profile Binding
    # @param domain_id Domain ID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_group_monitoring_binding_0_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesMonitoringProfileBindingApi.delete_group_monitoring_binding_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.delete_group_monitoring_binding_0"
      end
      # verify the required parameter 'group_id' is set
      if @api_client.config.client_side_validation && group_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.delete_group_monitoring_binding_0"
      end
      # verify the required parameter 'group_monitoring_profile_binding_map_id' is set
      if @api_client.config.client_side_validation && group_monitoring_profile_binding_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_monitoring_profile_binding_map_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.delete_group_monitoring_binding_0"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/groups/{group-id}/group-monitoring-profile-binding-maps/{group-monitoring-profile-binding-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'group-id' + '}', group_id.to_s).sub('{' + 'group-monitoring-profile-binding-map-id' + '}', group_monitoring_profile_binding_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesMonitoringProfileBindingApi#delete_group_monitoring_binding_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get Group Monitoring Profile Binding Map
    # API will get Group Monitoring Profile Binding Map 
    # @param domain_id Domain-ID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param [Hash] opts the optional parameters
    # @return [GroupMonitoringProfileBindingMap]
    def get_group_monitoring_binding(domain_id, group_id, group_monitoring_profile_binding_map_id, opts = {})
      data, _status_code, _headers = get_group_monitoring_binding_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, opts)
      data
    end

    # Get Group Monitoring Profile Binding Map
    # API will get Group Monitoring Profile Binding Map 
    # @param domain_id Domain-ID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(GroupMonitoringProfileBindingMap, Fixnum, Hash)>] GroupMonitoringProfileBindingMap data, response status code and response headers
    def get_group_monitoring_binding_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesMonitoringProfileBindingApi.get_group_monitoring_binding ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.get_group_monitoring_binding"
      end
      # verify the required parameter 'group_id' is set
      if @api_client.config.client_side_validation && group_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.get_group_monitoring_binding"
      end
      # verify the required parameter 'group_monitoring_profile_binding_map_id' is set
      if @api_client.config.client_side_validation && group_monitoring_profile_binding_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_monitoring_profile_binding_map_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.get_group_monitoring_binding"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/groups/{group-id}/group-monitoring-profile-binding-maps/{group-monitoring-profile-binding-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'group-id' + '}', group_id.to_s).sub('{' + 'group-monitoring-profile-binding-map-id' + '}', group_monitoring_profile_binding_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GroupMonitoringProfileBindingMap')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesMonitoringProfileBindingApi#get_group_monitoring_binding\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get Group Monitoring Profile Binding Map
    # API will get Group Monitoring Profile Binding Map 
    # @param domain_id Domain-ID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param [Hash] opts the optional parameters
    # @return [GroupMonitoringProfileBindingMap]
    def get_group_monitoring_binding_0(domain_id, group_id, group_monitoring_profile_binding_map_id, opts = {})
      data, _status_code, _headers = get_group_monitoring_binding_0_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, opts)
      data
    end

    # Get Group Monitoring Profile Binding Map
    # API will get Group Monitoring Profile Binding Map 
    # @param domain_id Domain-ID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(GroupMonitoringProfileBindingMap, Fixnum, Hash)>] GroupMonitoringProfileBindingMap data, response status code and response headers
    def get_group_monitoring_binding_0_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesMonitoringProfileBindingApi.get_group_monitoring_binding_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.get_group_monitoring_binding_0"
      end
      # verify the required parameter 'group_id' is set
      if @api_client.config.client_side_validation && group_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.get_group_monitoring_binding_0"
      end
      # verify the required parameter 'group_monitoring_profile_binding_map_id' is set
      if @api_client.config.client_side_validation && group_monitoring_profile_binding_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_monitoring_profile_binding_map_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.get_group_monitoring_binding_0"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/groups/{group-id}/group-monitoring-profile-binding-maps/{group-monitoring-profile-binding-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'group-id' + '}', group_id.to_s).sub('{' + 'group-monitoring-profile-binding-map-id' + '}', group_monitoring_profile_binding_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GroupMonitoringProfileBindingMap')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesMonitoringProfileBindingApi#get_group_monitoring_binding_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Group Monitoring Profile Binding Maps
    # API will list all Group Monitoring Profile Binding Maps in current group id. 
    # @param domain_id 
    # @param group_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [GroupMonitoringProfileBindingMapListResult]
    def list_group_monitoring_bindings(domain_id, group_id, opts = {})
      data, _status_code, _headers = list_group_monitoring_bindings_with_http_info(domain_id, group_id, opts)
      data
    end

    # List Group Monitoring Profile Binding Maps
    # API will list all Group Monitoring Profile Binding Maps in current group id. 
    # @param domain_id 
    # @param group_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(GroupMonitoringProfileBindingMapListResult, Fixnum, Hash)>] GroupMonitoringProfileBindingMapListResult data, response status code and response headers
    def list_group_monitoring_bindings_with_http_info(domain_id, group_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesMonitoringProfileBindingApi.list_group_monitoring_bindings ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.list_group_monitoring_bindings"
      end
      # verify the required parameter 'group_id' is set
      if @api_client.config.client_side_validation && group_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.list_group_monitoring_bindings"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.list_group_monitoring_bindings, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.list_group_monitoring_bindings, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/domains/{domain-id}/groups/{group-id}/group-monitoring-profile-binding-maps'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'group-id' + '}', group_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GroupMonitoringProfileBindingMapListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesMonitoringProfileBindingApi#list_group_monitoring_bindings\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Group Monitoring Profile Binding Maps
    # API will list all Group Monitoring Profile Binding Maps in current group id. 
    # @param domain_id 
    # @param group_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [GroupMonitoringProfileBindingMapListResult]
    def list_group_monitoring_bindings_0(domain_id, group_id, opts = {})
      data, _status_code, _headers = list_group_monitoring_bindings_0_with_http_info(domain_id, group_id, opts)
      data
    end

    # List Group Monitoring Profile Binding Maps
    # API will list all Group Monitoring Profile Binding Maps in current group id. 
    # @param domain_id 
    # @param group_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(GroupMonitoringProfileBindingMapListResult, Fixnum, Hash)>] GroupMonitoringProfileBindingMapListResult data, response status code and response headers
    def list_group_monitoring_bindings_0_with_http_info(domain_id, group_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesMonitoringProfileBindingApi.list_group_monitoring_bindings_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.list_group_monitoring_bindings_0"
      end
      # verify the required parameter 'group_id' is set
      if @api_client.config.client_side_validation && group_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.list_group_monitoring_bindings_0"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.list_group_monitoring_bindings_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.list_group_monitoring_bindings_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/groups/{group-id}/group-monitoring-profile-binding-maps'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'group-id' + '}', group_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GroupMonitoringProfileBindingMapListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesMonitoringProfileBindingApi#list_group_monitoring_bindings_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create Group Monitoring Profile Binding Map
    # API will create group monitoring profile binding map
    # @param domain_id Domain ID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param group_monitoring_profile_binding_map 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_group_monitoring_binding(domain_id, group_id, group_monitoring_profile_binding_map_id, group_monitoring_profile_binding_map, opts = {})
      patch_group_monitoring_binding_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, group_monitoring_profile_binding_map, opts)
      nil
    end

    # Create Group Monitoring Profile Binding Map
    # API will create group monitoring profile binding map
    # @param domain_id Domain ID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param group_monitoring_profile_binding_map 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_group_monitoring_binding_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, group_monitoring_profile_binding_map, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesMonitoringProfileBindingApi.patch_group_monitoring_binding ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.patch_group_monitoring_binding"
      end
      # verify the required parameter 'group_id' is set
      if @api_client.config.client_side_validation && group_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.patch_group_monitoring_binding"
      end
      # verify the required parameter 'group_monitoring_profile_binding_map_id' is set
      if @api_client.config.client_side_validation && group_monitoring_profile_binding_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_monitoring_profile_binding_map_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.patch_group_monitoring_binding"
      end
      # verify the required parameter 'group_monitoring_profile_binding_map' is set
      if @api_client.config.client_side_validation && group_monitoring_profile_binding_map.nil?
        fail ArgumentError, "Missing the required parameter 'group_monitoring_profile_binding_map' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.patch_group_monitoring_binding"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/groups/{group-id}/group-monitoring-profile-binding-maps/{group-monitoring-profile-binding-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'group-id' + '}', group_id.to_s).sub('{' + 'group-monitoring-profile-binding-map-id' + '}', group_monitoring_profile_binding_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(group_monitoring_profile_binding_map)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesMonitoringProfileBindingApi#patch_group_monitoring_binding\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create Group Monitoring Profile Binding Map
    # API will create group monitoring profile binding map
    # @param domain_id Domain ID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param group_monitoring_profile_binding_map 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_group_monitoring_binding_0(domain_id, group_id, group_monitoring_profile_binding_map_id, group_monitoring_profile_binding_map, opts = {})
      patch_group_monitoring_binding_0_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, group_monitoring_profile_binding_map, opts)
      nil
    end

    # Create Group Monitoring Profile Binding Map
    # API will create group monitoring profile binding map
    # @param domain_id Domain ID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param group_monitoring_profile_binding_map 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_group_monitoring_binding_0_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, group_monitoring_profile_binding_map, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesMonitoringProfileBindingApi.patch_group_monitoring_binding_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.patch_group_monitoring_binding_0"
      end
      # verify the required parameter 'group_id' is set
      if @api_client.config.client_side_validation && group_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.patch_group_monitoring_binding_0"
      end
      # verify the required parameter 'group_monitoring_profile_binding_map_id' is set
      if @api_client.config.client_side_validation && group_monitoring_profile_binding_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_monitoring_profile_binding_map_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.patch_group_monitoring_binding_0"
      end
      # verify the required parameter 'group_monitoring_profile_binding_map' is set
      if @api_client.config.client_side_validation && group_monitoring_profile_binding_map.nil?
        fail ArgumentError, "Missing the required parameter 'group_monitoring_profile_binding_map' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.patch_group_monitoring_binding_0"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/groups/{group-id}/group-monitoring-profile-binding-maps/{group-monitoring-profile-binding-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'group-id' + '}', group_id.to_s).sub('{' + 'group-monitoring-profile-binding-map-id' + '}', group_monitoring_profile_binding_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(group_monitoring_profile_binding_map)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesMonitoringProfileBindingApi#patch_group_monitoring_binding_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update Group Monitoring Profile Binding Map
    # API will update Group Monitoring Profile Binding Map
    # @param domain_id DomainID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param group_monitoring_profile_binding_map 
    # @param [Hash] opts the optional parameters
    # @return [GroupMonitoringProfileBindingMap]
    def update_group_monitoring_binding(domain_id, group_id, group_monitoring_profile_binding_map_id, group_monitoring_profile_binding_map, opts = {})
      data, _status_code, _headers = update_group_monitoring_binding_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, group_monitoring_profile_binding_map, opts)
      data
    end

    # Update Group Monitoring Profile Binding Map
    # API will update Group Monitoring Profile Binding Map
    # @param domain_id DomainID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param group_monitoring_profile_binding_map 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GroupMonitoringProfileBindingMap, Fixnum, Hash)>] GroupMonitoringProfileBindingMap data, response status code and response headers
    def update_group_monitoring_binding_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, group_monitoring_profile_binding_map, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesMonitoringProfileBindingApi.update_group_monitoring_binding ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.update_group_monitoring_binding"
      end
      # verify the required parameter 'group_id' is set
      if @api_client.config.client_side_validation && group_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.update_group_monitoring_binding"
      end
      # verify the required parameter 'group_monitoring_profile_binding_map_id' is set
      if @api_client.config.client_side_validation && group_monitoring_profile_binding_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_monitoring_profile_binding_map_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.update_group_monitoring_binding"
      end
      # verify the required parameter 'group_monitoring_profile_binding_map' is set
      if @api_client.config.client_side_validation && group_monitoring_profile_binding_map.nil?
        fail ArgumentError, "Missing the required parameter 'group_monitoring_profile_binding_map' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.update_group_monitoring_binding"
      end
      # resource path
      local_var_path = '/global-infra/domains/{domain-id}/groups/{group-id}/group-monitoring-profile-binding-maps/{group-monitoring-profile-binding-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'group-id' + '}', group_id.to_s).sub('{' + 'group-monitoring-profile-binding-map-id' + '}', group_monitoring_profile_binding_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(group_monitoring_profile_binding_map)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GroupMonitoringProfileBindingMap')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesMonitoringProfileBindingApi#update_group_monitoring_binding\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update Group Monitoring Profile Binding Map
    # API will update Group Monitoring Profile Binding Map
    # @param domain_id DomainID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param group_monitoring_profile_binding_map 
    # @param [Hash] opts the optional parameters
    # @return [GroupMonitoringProfileBindingMap]
    def update_group_monitoring_binding_0(domain_id, group_id, group_monitoring_profile_binding_map_id, group_monitoring_profile_binding_map, opts = {})
      data, _status_code, _headers = update_group_monitoring_binding_0_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, group_monitoring_profile_binding_map, opts)
      data
    end

    # Update Group Monitoring Profile Binding Map
    # API will update Group Monitoring Profile Binding Map
    # @param domain_id DomainID
    # @param group_id Group ID
    # @param group_monitoring_profile_binding_map_id Group Monitoring Profile Binding Map ID
    # @param group_monitoring_profile_binding_map 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GroupMonitoringProfileBindingMap, Fixnum, Hash)>] GroupMonitoringProfileBindingMap data, response status code and response headers
    def update_group_monitoring_binding_0_with_http_info(domain_id, group_id, group_monitoring_profile_binding_map_id, group_monitoring_profile_binding_map, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesMonitoringProfileBindingApi.update_group_monitoring_binding_0 ...'
      end
      # verify the required parameter 'domain_id' is set
      if @api_client.config.client_side_validation && domain_id.nil?
        fail ArgumentError, "Missing the required parameter 'domain_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.update_group_monitoring_binding_0"
      end
      # verify the required parameter 'group_id' is set
      if @api_client.config.client_side_validation && group_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.update_group_monitoring_binding_0"
      end
      # verify the required parameter 'group_monitoring_profile_binding_map_id' is set
      if @api_client.config.client_side_validation && group_monitoring_profile_binding_map_id.nil?
        fail ArgumentError, "Missing the required parameter 'group_monitoring_profile_binding_map_id' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.update_group_monitoring_binding_0"
      end
      # verify the required parameter 'group_monitoring_profile_binding_map' is set
      if @api_client.config.client_side_validation && group_monitoring_profile_binding_map.nil?
        fail ArgumentError, "Missing the required parameter 'group_monitoring_profile_binding_map' when calling PolicySecuritySecurityProfilesMonitoringProfileBindingApi.update_group_monitoring_binding_0"
      end
      # resource path
      local_var_path = '/infra/domains/{domain-id}/groups/{group-id}/group-monitoring-profile-binding-maps/{group-monitoring-profile-binding-map-id}'.sub('{' + 'domain-id' + '}', domain_id.to_s).sub('{' + 'group-id' + '}', group_id.to_s).sub('{' + 'group-monitoring-profile-binding-map-id' + '}', group_monitoring_profile_binding_map_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(group_monitoring_profile_binding_map)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GroupMonitoringProfileBindingMap')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesMonitoringProfileBindingApi#update_group_monitoring_binding_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
