=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicySecuritySecurityProfilesSessionTimerProfilesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete Firewall Session Timer Profile
    # API will delete Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [nil]
    def delete_policy_firewall_session_timer_profile(firewall_session_timer_profile_id, opts = {})
      delete_policy_firewall_session_timer_profile_with_http_info(firewall_session_timer_profile_id, opts)
      nil
    end

    # Delete Firewall Session Timer Profile
    # API will delete Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_policy_firewall_session_timer_profile_with_http_info(firewall_session_timer_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesSessionTimerProfilesApi.delete_policy_firewall_session_timer_profile ...'
      end
      # verify the required parameter 'firewall_session_timer_profile_id' is set
      if @api_client.config.client_side_validation && firewall_session_timer_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'firewall_session_timer_profile_id' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.delete_policy_firewall_session_timer_profile"
      end
      # resource path
      local_var_path = '/global-infra/firewall-session-timer-profiles/{firewall-session-timer-profile-id}'.sub('{' + 'firewall-session-timer-profile-id' + '}', firewall_session_timer_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesSessionTimerProfilesApi#delete_policy_firewall_session_timer_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete Firewall Session Timer Profile
    # API will delete Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [nil]
    def delete_policy_firewall_session_timer_profile_0(firewall_session_timer_profile_id, opts = {})
      delete_policy_firewall_session_timer_profile_0_with_http_info(firewall_session_timer_profile_id, opts)
      nil
    end

    # Delete Firewall Session Timer Profile
    # API will delete Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_policy_firewall_session_timer_profile_0_with_http_info(firewall_session_timer_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesSessionTimerProfilesApi.delete_policy_firewall_session_timer_profile_0 ...'
      end
      # verify the required parameter 'firewall_session_timer_profile_id' is set
      if @api_client.config.client_side_validation && firewall_session_timer_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'firewall_session_timer_profile_id' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.delete_policy_firewall_session_timer_profile_0"
      end
      # resource path
      local_var_path = '/infra/firewall-session-timer-profiles/{firewall-session-timer-profile-id}'.sub('{' + 'firewall-session-timer-profile-id' + '}', firewall_session_timer_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesSessionTimerProfilesApi#delete_policy_firewall_session_timer_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get Firewall Session Timer Profile
    # API will get Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param [Hash] opts the optional parameters
    # @return [PolicyFirewallSessionTimerProfile]
    def get_policy_firewall_session_timer_profile(firewall_session_timer_profile_id, opts = {})
      data, _status_code, _headers = get_policy_firewall_session_timer_profile_with_http_info(firewall_session_timer_profile_id, opts)
      data
    end

    # Get Firewall Session Timer Profile
    # API will get Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyFirewallSessionTimerProfile, Fixnum, Hash)>] PolicyFirewallSessionTimerProfile data, response status code and response headers
    def get_policy_firewall_session_timer_profile_with_http_info(firewall_session_timer_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesSessionTimerProfilesApi.get_policy_firewall_session_timer_profile ...'
      end
      # verify the required parameter 'firewall_session_timer_profile_id' is set
      if @api_client.config.client_side_validation && firewall_session_timer_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'firewall_session_timer_profile_id' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.get_policy_firewall_session_timer_profile"
      end
      # resource path
      local_var_path = '/global-infra/firewall-session-timer-profiles/{firewall-session-timer-profile-id}'.sub('{' + 'firewall-session-timer-profile-id' + '}', firewall_session_timer_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyFirewallSessionTimerProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesSessionTimerProfilesApi#get_policy_firewall_session_timer_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get Firewall Session Timer Profile
    # API will get Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param [Hash] opts the optional parameters
    # @return [PolicyFirewallSessionTimerProfile]
    def get_policy_firewall_session_timer_profile_0(firewall_session_timer_profile_id, opts = {})
      data, _status_code, _headers = get_policy_firewall_session_timer_profile_0_with_http_info(firewall_session_timer_profile_id, opts)
      data
    end

    # Get Firewall Session Timer Profile
    # API will get Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicyFirewallSessionTimerProfile, Fixnum, Hash)>] PolicyFirewallSessionTimerProfile data, response status code and response headers
    def get_policy_firewall_session_timer_profile_0_with_http_info(firewall_session_timer_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesSessionTimerProfilesApi.get_policy_firewall_session_timer_profile_0 ...'
      end
      # verify the required parameter 'firewall_session_timer_profile_id' is set
      if @api_client.config.client_side_validation && firewall_session_timer_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'firewall_session_timer_profile_id' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.get_policy_firewall_session_timer_profile_0"
      end
      # resource path
      local_var_path = '/infra/firewall-session-timer-profiles/{firewall-session-timer-profile-id}'.sub('{' + 'firewall-session-timer-profile-id' + '}', firewall_session_timer_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyFirewallSessionTimerProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesSessionTimerProfilesApi#get_policy_firewall_session_timer_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Firewall Session Timer Profiles
    # API will list all Firewall Session Timer Profiles
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [PolicyFirewallSessionTimerProfileListResult]
    def list_policy_firewall_session_timer_profiles(opts = {})
      data, _status_code, _headers = list_policy_firewall_session_timer_profiles_with_http_info(opts)
      data
    end

    # List Firewall Session Timer Profiles
    # API will list all Firewall Session Timer Profiles
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(PolicyFirewallSessionTimerProfileListResult, Fixnum, Hash)>] PolicyFirewallSessionTimerProfileListResult data, response status code and response headers
    def list_policy_firewall_session_timer_profiles_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_policy_firewall_session_timer_profiles ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_policy_firewall_session_timer_profiles, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_policy_firewall_session_timer_profiles, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/firewall-session-timer-profiles'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyFirewallSessionTimerProfileListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesSessionTimerProfilesApi#list_policy_firewall_session_timer_profiles\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Firewall Session Timer Profiles
    # API will list all Firewall Session Timer Profiles
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [PolicyFirewallSessionTimerProfileListResult]
    def list_policy_firewall_session_timer_profiles_0(opts = {})
      data, _status_code, _headers = list_policy_firewall_session_timer_profiles_0_with_http_info(opts)
      data
    end

    # List Firewall Session Timer Profiles
    # API will list all Firewall Session Timer Profiles
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(PolicyFirewallSessionTimerProfileListResult, Fixnum, Hash)>] PolicyFirewallSessionTimerProfileListResult data, response status code and response headers
    def list_policy_firewall_session_timer_profiles_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_policy_firewall_session_timer_profiles_0 ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_policy_firewall_session_timer_profiles_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_policy_firewall_session_timer_profiles_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/firewall-session-timer-profiles'

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyFirewallSessionTimerProfileListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesSessionTimerProfilesApi#list_policy_firewall_session_timer_profiles_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Session Timer Profiles
    # API will list all Session Timer Profiles bindings.
    # @param session_timer_profile_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [SessionTimerProfileBindingListResult]
    def list_session_timer_profile_bindings(session_timer_profile_id, opts = {})
      data, _status_code, _headers = list_session_timer_profile_bindings_with_http_info(session_timer_profile_id, opts)
      data
    end

    # List Session Timer Profiles
    # API will list all Session Timer Profiles bindings.
    # @param session_timer_profile_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(SessionTimerProfileBindingListResult, Fixnum, Hash)>] SessionTimerProfileBindingListResult data, response status code and response headers
    def list_session_timer_profile_bindings_with_http_info(session_timer_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_session_timer_profile_bindings ...'
      end
      # verify the required parameter 'session_timer_profile_id' is set
      if @api_client.config.client_side_validation && session_timer_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'session_timer_profile_id' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_session_timer_profile_bindings"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_session_timer_profile_bindings, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_session_timer_profile_bindings, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/global-infra/session-timer-profiles/{session-timer-profile-id}/bindings'.sub('{' + 'session-timer-profile-id' + '}', session_timer_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SessionTimerProfileBindingListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesSessionTimerProfilesApi#list_session_timer_profile_bindings\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Session Timer Profiles
    # API will list all Session Timer Profiles bindings.
    # @param session_timer_profile_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results (default to false)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [SessionTimerProfileBindingListResult]
    def list_session_timer_profile_bindings_0(session_timer_profile_id, opts = {})
      data, _status_code, _headers = list_session_timer_profile_bindings_0_with_http_info(session_timer_profile_id, opts)
      data
    end

    # List Session Timer Profiles
    # API will list all Session Timer Profiles bindings.
    # @param session_timer_profile_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [BOOLEAN] :include_mark_for_delete_objects Include objects that are marked for deletion in results
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(SessionTimerProfileBindingListResult, Fixnum, Hash)>] SessionTimerProfileBindingListResult data, response status code and response headers
    def list_session_timer_profile_bindings_0_with_http_info(session_timer_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_session_timer_profile_bindings_0 ...'
      end
      # verify the required parameter 'session_timer_profile_id' is set
      if @api_client.config.client_side_validation && session_timer_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'session_timer_profile_id' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_session_timer_profile_bindings_0"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_session_timer_profile_bindings_0, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.list_session_timer_profile_bindings_0, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/infra/session-timer-profiles/{session-timer-profile-id}/bindings'.sub('{' + 'session-timer-profile-id' + '}', session_timer_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'include_mark_for_delete_objects'] = opts[:'include_mark_for_delete_objects'] if !opts[:'include_mark_for_delete_objects'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SessionTimerProfileBindingListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesSessionTimerProfilesApi#list_session_timer_profile_bindings_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update Firewall Session Timer Profile
    # API will create/update Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param policy_firewall_session_timer_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [nil]
    def patch_policy_firewall_session_timer_profile(firewall_session_timer_profile_id, policy_firewall_session_timer_profile, opts = {})
      patch_policy_firewall_session_timer_profile_with_http_info(firewall_session_timer_profile_id, policy_firewall_session_timer_profile, opts)
      nil
    end

    # Create or update Firewall Session Timer Profile
    # API will create/update Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param policy_firewall_session_timer_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_policy_firewall_session_timer_profile_with_http_info(firewall_session_timer_profile_id, policy_firewall_session_timer_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesSessionTimerProfilesApi.patch_policy_firewall_session_timer_profile ...'
      end
      # verify the required parameter 'firewall_session_timer_profile_id' is set
      if @api_client.config.client_side_validation && firewall_session_timer_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'firewall_session_timer_profile_id' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.patch_policy_firewall_session_timer_profile"
      end
      # verify the required parameter 'policy_firewall_session_timer_profile' is set
      if @api_client.config.client_side_validation && policy_firewall_session_timer_profile.nil?
        fail ArgumentError, "Missing the required parameter 'policy_firewall_session_timer_profile' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.patch_policy_firewall_session_timer_profile"
      end
      # resource path
      local_var_path = '/global-infra/firewall-session-timer-profiles/{firewall-session-timer-profile-id}'.sub('{' + 'firewall-session-timer-profile-id' + '}', firewall_session_timer_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_firewall_session_timer_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesSessionTimerProfilesApi#patch_policy_firewall_session_timer_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create or update Firewall Session Timer Profile
    # API will create/update Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param policy_firewall_session_timer_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [nil]
    def patch_policy_firewall_session_timer_profile_0(firewall_session_timer_profile_id, policy_firewall_session_timer_profile, opts = {})
      patch_policy_firewall_session_timer_profile_0_with_http_info(firewall_session_timer_profile_id, policy_firewall_session_timer_profile, opts)
      nil
    end

    # Create or update Firewall Session Timer Profile
    # API will create/update Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param policy_firewall_session_timer_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_policy_firewall_session_timer_profile_0_with_http_info(firewall_session_timer_profile_id, policy_firewall_session_timer_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesSessionTimerProfilesApi.patch_policy_firewall_session_timer_profile_0 ...'
      end
      # verify the required parameter 'firewall_session_timer_profile_id' is set
      if @api_client.config.client_side_validation && firewall_session_timer_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'firewall_session_timer_profile_id' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.patch_policy_firewall_session_timer_profile_0"
      end
      # verify the required parameter 'policy_firewall_session_timer_profile' is set
      if @api_client.config.client_side_validation && policy_firewall_session_timer_profile.nil?
        fail ArgumentError, "Missing the required parameter 'policy_firewall_session_timer_profile' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.patch_policy_firewall_session_timer_profile_0"
      end
      # resource path
      local_var_path = '/infra/firewall-session-timer-profiles/{firewall-session-timer-profile-id}'.sub('{' + 'firewall-session-timer-profile-id' + '}', firewall_session_timer_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_firewall_session_timer_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesSessionTimerProfilesApi#patch_policy_firewall_session_timer_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update Firewall Session Timer Profile
    # API will update Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param policy_firewall_session_timer_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [PolicyFirewallSessionTimerProfile]
    def update_policy_firewall_session_timer_profile(firewall_session_timer_profile_id, policy_firewall_session_timer_profile, opts = {})
      data, _status_code, _headers = update_policy_firewall_session_timer_profile_with_http_info(firewall_session_timer_profile_id, policy_firewall_session_timer_profile, opts)
      data
    end

    # Update Firewall Session Timer Profile
    # API will update Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param policy_firewall_session_timer_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(PolicyFirewallSessionTimerProfile, Fixnum, Hash)>] PolicyFirewallSessionTimerProfile data, response status code and response headers
    def update_policy_firewall_session_timer_profile_with_http_info(firewall_session_timer_profile_id, policy_firewall_session_timer_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesSessionTimerProfilesApi.update_policy_firewall_session_timer_profile ...'
      end
      # verify the required parameter 'firewall_session_timer_profile_id' is set
      if @api_client.config.client_side_validation && firewall_session_timer_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'firewall_session_timer_profile_id' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.update_policy_firewall_session_timer_profile"
      end
      # verify the required parameter 'policy_firewall_session_timer_profile' is set
      if @api_client.config.client_side_validation && policy_firewall_session_timer_profile.nil?
        fail ArgumentError, "Missing the required parameter 'policy_firewall_session_timer_profile' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.update_policy_firewall_session_timer_profile"
      end
      # resource path
      local_var_path = '/global-infra/firewall-session-timer-profiles/{firewall-session-timer-profile-id}'.sub('{' + 'firewall-session-timer-profile-id' + '}', firewall_session_timer_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_firewall_session_timer_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyFirewallSessionTimerProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesSessionTimerProfilesApi#update_policy_firewall_session_timer_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update Firewall Session Timer Profile
    # API will update Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param policy_firewall_session_timer_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object (default to false)
    # @return [PolicyFirewallSessionTimerProfile]
    def update_policy_firewall_session_timer_profile_0(firewall_session_timer_profile_id, policy_firewall_session_timer_profile, opts = {})
      data, _status_code, _headers = update_policy_firewall_session_timer_profile_0_with_http_info(firewall_session_timer_profile_id, policy_firewall_session_timer_profile, opts)
      data
    end

    # Update Firewall Session Timer Profile
    # API will update Firewall Session Timer Profile
    # @param firewall_session_timer_profile_id Firewall Session Timer Profile ID
    # @param policy_firewall_session_timer_profile 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :override Locally override the global object
    # @return [Array<(PolicyFirewallSessionTimerProfile, Fixnum, Hash)>] PolicyFirewallSessionTimerProfile data, response status code and response headers
    def update_policy_firewall_session_timer_profile_0_with_http_info(firewall_session_timer_profile_id, policy_firewall_session_timer_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecuritySecurityProfilesSessionTimerProfilesApi.update_policy_firewall_session_timer_profile_0 ...'
      end
      # verify the required parameter 'firewall_session_timer_profile_id' is set
      if @api_client.config.client_side_validation && firewall_session_timer_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'firewall_session_timer_profile_id' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.update_policy_firewall_session_timer_profile_0"
      end
      # verify the required parameter 'policy_firewall_session_timer_profile' is set
      if @api_client.config.client_side_validation && policy_firewall_session_timer_profile.nil?
        fail ArgumentError, "Missing the required parameter 'policy_firewall_session_timer_profile' when calling PolicySecuritySecurityProfilesSessionTimerProfilesApi.update_policy_firewall_session_timer_profile_0"
      end
      # resource path
      local_var_path = '/infra/firewall-session-timer-profiles/{firewall-session-timer-profile-id}'.sub('{' + 'firewall-session-timer-profile-id' + '}', firewall_session_timer_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'override'] = opts[:'override'] if !opts[:'override'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_firewall_session_timer_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicyFirewallSessionTimerProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecuritySecurityProfilesSessionTimerProfilesApi#update_policy_firewall_session_timer_profile_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
