=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NSXTPolicy
  class PolicySecurityServiceInsertionSettingsConfigurationStatusApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Get service insertion configuration status
    # Get the current service insertion status configuration.
    # @param [Hash] opts the optional parameters
    # @return [PolicySIStatusConfiguration]
    def get_si_status(opts = {})
      data, _status_code, _headers = get_si_status_with_http_info(opts)
      data
    end

    # Get service insertion configuration status
    # Get the current service insertion status configuration.
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicySIStatusConfiguration, Fixnum, Hash)>] PolicySIStatusConfiguration data, response status code and response headers
    def get_si_status_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityServiceInsertionSettingsConfigurationStatusApi.get_si_status ...'
      end
      # resource path
      local_var_path = '/global-infra/settings/service-insertion/security/status'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicySIStatusConfiguration')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityServiceInsertionSettingsConfigurationStatusApi#get_si_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get service insertion configuration status
    # Get the current service insertion status configuration.
    # @param [Hash] opts the optional parameters
    # @return [PolicySIStatusConfiguration]
    def get_si_status_0(opts = {})
      data, _status_code, _headers = get_si_status_0_with_http_info(opts)
      data
    end

    # Get service insertion configuration status
    # Get the current service insertion status configuration.
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicySIStatusConfiguration, Fixnum, Hash)>] PolicySIStatusConfiguration data, response status code and response headers
    def get_si_status_0_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityServiceInsertionSettingsConfigurationStatusApi.get_si_status_0 ...'
      end
      # resource path
      local_var_path = '/infra/settings/service-insertion/security/status'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicySIStatusConfiguration')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityServiceInsertionSettingsConfigurationStatusApi#get_si_status_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update service insertion status configuration
    # Update service insertion status. 
    # @param policy_si_status_configuration 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_si_status(policy_si_status_configuration, opts = {})
      patch_si_status_with_http_info(policy_si_status_configuration, opts)
      nil
    end

    # Update service insertion status configuration
    # Update service insertion status. 
    # @param policy_si_status_configuration 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_si_status_with_http_info(policy_si_status_configuration, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityServiceInsertionSettingsConfigurationStatusApi.patch_si_status ...'
      end
      # verify the required parameter 'policy_si_status_configuration' is set
      if @api_client.config.client_side_validation && policy_si_status_configuration.nil?
        fail ArgumentError, "Missing the required parameter 'policy_si_status_configuration' when calling PolicySecurityServiceInsertionSettingsConfigurationStatusApi.patch_si_status"
      end
      # resource path
      local_var_path = '/global-infra/settings/service-insertion/security/status'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_si_status_configuration)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityServiceInsertionSettingsConfigurationStatusApi#patch_si_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update service insertion status configuration
    # Update service insertion status. 
    # @param policy_si_status_configuration 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def patch_si_status_0(policy_si_status_configuration, opts = {})
      patch_si_status_0_with_http_info(policy_si_status_configuration, opts)
      nil
    end

    # Update service insertion status configuration
    # Update service insertion status. 
    # @param policy_si_status_configuration 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def patch_si_status_0_with_http_info(policy_si_status_configuration, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityServiceInsertionSettingsConfigurationStatusApi.patch_si_status_0 ...'
      end
      # verify the required parameter 'policy_si_status_configuration' is set
      if @api_client.config.client_side_validation && policy_si_status_configuration.nil?
        fail ArgumentError, "Missing the required parameter 'policy_si_status_configuration' when calling PolicySecurityServiceInsertionSettingsConfigurationStatusApi.patch_si_status_0"
      end
      # resource path
      local_var_path = '/infra/settings/service-insertion/security/status'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_si_status_configuration)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityServiceInsertionSettingsConfigurationStatusApi#patch_si_status_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update service insertion status configuration
    # Update service insertion status. 
    # @param policy_si_status_configuration 
    # @param [Hash] opts the optional parameters
    # @return [PolicySIStatusConfiguration]
    def update_si_status(policy_si_status_configuration, opts = {})
      data, _status_code, _headers = update_si_status_with_http_info(policy_si_status_configuration, opts)
      data
    end

    # Update service insertion status configuration
    # Update service insertion status. 
    # @param policy_si_status_configuration 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicySIStatusConfiguration, Fixnum, Hash)>] PolicySIStatusConfiguration data, response status code and response headers
    def update_si_status_with_http_info(policy_si_status_configuration, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityServiceInsertionSettingsConfigurationStatusApi.update_si_status ...'
      end
      # verify the required parameter 'policy_si_status_configuration' is set
      if @api_client.config.client_side_validation && policy_si_status_configuration.nil?
        fail ArgumentError, "Missing the required parameter 'policy_si_status_configuration' when calling PolicySecurityServiceInsertionSettingsConfigurationStatusApi.update_si_status"
      end
      # resource path
      local_var_path = '/global-infra/settings/service-insertion/security/status'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_si_status_configuration)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicySIStatusConfiguration')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityServiceInsertionSettingsConfigurationStatusApi#update_si_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update service insertion status configuration
    # Update service insertion status. 
    # @param policy_si_status_configuration 
    # @param [Hash] opts the optional parameters
    # @return [PolicySIStatusConfiguration]
    def update_si_status_0(policy_si_status_configuration, opts = {})
      data, _status_code, _headers = update_si_status_0_with_http_info(policy_si_status_configuration, opts)
      data
    end

    # Update service insertion status configuration
    # Update service insertion status. 
    # @param policy_si_status_configuration 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PolicySIStatusConfiguration, Fixnum, Hash)>] PolicySIStatusConfiguration data, response status code and response headers
    def update_si_status_0_with_http_info(policy_si_status_configuration, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicySecurityServiceInsertionSettingsConfigurationStatusApi.update_si_status_0 ...'
      end
      # verify the required parameter 'policy_si_status_configuration' is set
      if @api_client.config.client_side_validation && policy_si_status_configuration.nil?
        fail ArgumentError, "Missing the required parameter 'policy_si_status_configuration' when calling PolicySecurityServiceInsertionSettingsConfigurationStatusApi.update_si_status_0"
      end
      # resource path
      local_var_path = '/infra/settings/service-insertion/security/status'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(policy_si_status_configuration)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PolicySIStatusConfiguration')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicySecurityServiceInsertionSettingsConfigurationStatusApi#update_si_status_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
