=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module NSXTPolicy
  # Contains information necessary to configure a BGP neighbor. 
  class BgpNeighborConfig
    # Link to this resource
    attr_accessor :_self

    # The server will populate this field when returing the resource. Ignored on PUT and POST.
    attr_accessor :_links

    # Schema for this resource
    attr_accessor :_schema

    # The _revision property describes the current revision of the resource. To prevent clients from overwriting each other's changes, PUT operations must include the current _revision of the resource, which clients should obtain by issuing a GET operation. If the _revision provided in a PUT request is missing or stale, the operation will be rejected.
    attr_accessor :_revision

    # Indicates system owned resource
    attr_accessor :_system_owned

    # Defaults to ID if not set
    attr_accessor :display_name

    # Description of this resource
    attr_accessor :description

    # Opaque identifiers meaningful to the API user
    attr_accessor :tags

    # ID of the user who created this resource
    attr_accessor :_create_user

    # Protection status is one of the following: PROTECTED - the client who retrieved the entity is not allowed             to modify it. NOT_PROTECTED - the client who retrieved the entity is allowed                 to modify it REQUIRE_OVERRIDE - the client who retrieved the entity is a super                    user and can modify it, but only when providing                    the request header X-Allow-Overwrite=true. UNKNOWN - the _protection field could not be determined for this           entity. 
    attr_accessor :_protection

    # Timestamp of resource creation
    attr_accessor :_create_time

    # Timestamp of last modification
    attr_accessor :_last_modified_time

    # ID of the user who last modified this resource
    attr_accessor :_last_modified_user

    # Unique identifier of this resource
    attr_accessor :id

    # The type of this resource.
    attr_accessor :resource_type

    # Absolute path of this object
    attr_accessor :path

    # Path of its parent
    attr_accessor :parent_path

    # This is a UUID generated by the GM/LM to uniquely identify entites in a federated environment. For entities that are stretched across multiple sites, the same ID will be used on all the stretched sites. 
    attr_accessor :unique_id

    # Path relative from its parent
    attr_accessor :relative_path

    # subtree for this type within policy tree containing nested elements. 
    attr_accessor :children

    # Global intent objects cannot be modified by the user. However, certain global intent objects can be overridden locally by use of this property. In such cases, the overridden local values take precedence over the globally defined values for the properties. 
    attr_accessor :overridden

    # Intent objects are not directly deleted from the system when a delete is invoked on them. They are marked for deletion and only when all the realized entities for that intent object gets deleted, the intent object is deleted. Objects that are marked for deletion are not returned in GET call. One can use the search API to get these objects. 
    attr_accessor :marked_for_delete

    # Specify path of prefix-list or route map to filter routes for OUT direction. When not specified, a built-in prefix-list named 'prefixlist-out-default' is automatically applied. This property is deprecated, use route_filtering instead. Specifying different values for both properties will result in error. 
    attr_accessor :out_route_filters

    # If mode is DISABLE, then graceful restart and helper modes are disabled. If mode is GR_AND_HELPER, then both graceful restart and helper modes are enabled. If mode is HELPER_ONLY, then helper mode is enabled. HELPER_ONLY mode is the ability for a BGP speaker to indicate its ability to preserve forwarding state during BGP restart. GRACEFUL_RESTART mode is the ability of a BGP speaker to advertise its restart to its peers. 
    attr_accessor :graceful_restart_mode

    # BFD configuration for failure detection. BFD is enabled with default values when not configured. 
    attr_accessor :bfd

    # Interval (in seconds) between keep alive messages sent to peer. 
    attr_accessor :keep_alive_time

    # Maximum number of hops allowed to reach BGP neighbor. 
    attr_accessor :maximum_hop_limit

    # Wait time in seconds before declaring peer dead. 
    attr_accessor :hold_down_time

    # Specify path of prefix-list or route map to filter routes for IN direction. This property is deprecated, use route_filtering instead. Specifying different values for both properties will result in error. 
    attr_accessor :in_route_filters

    # 4 Byte ASN of the neighbor in ASPLAIN Format
    attr_accessor :remote_as_num

    # Enable address families and route filtering in each direction. 
    attr_accessor :route_filtering

    # Source addresses should belong to Tier0 external or loopback interface IP Addresses . BGP peering is formed from all these addresses. This property is mandatory when maximum_hop_limit is greater than 1. 
    attr_accessor :source_addresses

    # Specify password for BGP neighbor authentication. Empty string (\"\") clears existing password. 
    attr_accessor :password

    # Flag to enable allowas_in option for BGP neighbor
    attr_accessor :allow_as_in

    # Neighbor IP Address
    attr_accessor :neighbor_address

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'_self' => :'_self',
        :'_links' => :'_links',
        :'_schema' => :'_schema',
        :'_revision' => :'_revision',
        :'_system_owned' => :'_system_owned',
        :'display_name' => :'display_name',
        :'description' => :'description',
        :'tags' => :'tags',
        :'_create_user' => :'_create_user',
        :'_protection' => :'_protection',
        :'_create_time' => :'_create_time',
        :'_last_modified_time' => :'_last_modified_time',
        :'_last_modified_user' => :'_last_modified_user',
        :'id' => :'id',
        :'resource_type' => :'resource_type',
        :'path' => :'path',
        :'parent_path' => :'parent_path',
        :'unique_id' => :'unique_id',
        :'relative_path' => :'relative_path',
        :'children' => :'children',
        :'overridden' => :'overridden',
        :'marked_for_delete' => :'marked_for_delete',
        :'out_route_filters' => :'out_route_filters',
        :'graceful_restart_mode' => :'graceful_restart_mode',
        :'bfd' => :'bfd',
        :'keep_alive_time' => :'keep_alive_time',
        :'maximum_hop_limit' => :'maximum_hop_limit',
        :'hold_down_time' => :'hold_down_time',
        :'in_route_filters' => :'in_route_filters',
        :'remote_as_num' => :'remote_as_num',
        :'route_filtering' => :'route_filtering',
        :'source_addresses' => :'source_addresses',
        :'password' => :'password',
        :'allow_as_in' => :'allow_as_in',
        :'neighbor_address' => :'neighbor_address'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'_self' => :'SelfResourceLink',
        :'_links' => :'Array<ResourceLink>',
        :'_schema' => :'String',
        :'_revision' => :'Integer',
        :'_system_owned' => :'BOOLEAN',
        :'display_name' => :'String',
        :'description' => :'String',
        :'tags' => :'Array<Tag>',
        :'_create_user' => :'String',
        :'_protection' => :'String',
        :'_create_time' => :'Integer',
        :'_last_modified_time' => :'Integer',
        :'_last_modified_user' => :'String',
        :'id' => :'String',
        :'resource_type' => :'String',
        :'path' => :'String',
        :'parent_path' => :'String',
        :'unique_id' => :'String',
        :'relative_path' => :'String',
        :'children' => :'Array<ChildPolicyConfigResource>',
        :'overridden' => :'BOOLEAN',
        :'marked_for_delete' => :'BOOLEAN',
        :'out_route_filters' => :'Array<String>',
        :'graceful_restart_mode' => :'String',
        :'bfd' => :'BgpBfdConfig',
        :'keep_alive_time' => :'Integer',
        :'maximum_hop_limit' => :'Integer',
        :'hold_down_time' => :'Integer',
        :'in_route_filters' => :'Array<String>',
        :'remote_as_num' => :'String',
        :'route_filtering' => :'Array<BgpRouteFiltering>',
        :'source_addresses' => :'Array<String>',
        :'password' => :'String',
        :'allow_as_in' => :'BOOLEAN',
        :'neighbor_address' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'_self')
        self._self = attributes[:'_self']
      end

      if attributes.has_key?(:'_links')
        if (value = attributes[:'_links']).is_a?(Array)
          self._links = value
        end
      end

      if attributes.has_key?(:'_schema')
        self._schema = attributes[:'_schema']
      end

      if attributes.has_key?(:'_revision')
        self._revision = attributes[:'_revision']
      end

      if attributes.has_key?(:'_system_owned')
        self._system_owned = attributes[:'_system_owned']
      end

      if attributes.has_key?(:'display_name')
        self.display_name = attributes[:'display_name']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end

      if attributes.has_key?(:'_create_user')
        self._create_user = attributes[:'_create_user']
      end

      if attributes.has_key?(:'_protection')
        self._protection = attributes[:'_protection']
      end

      if attributes.has_key?(:'_create_time')
        self._create_time = attributes[:'_create_time']
      end

      if attributes.has_key?(:'_last_modified_time')
        self._last_modified_time = attributes[:'_last_modified_time']
      end

      if attributes.has_key?(:'_last_modified_user')
        self._last_modified_user = attributes[:'_last_modified_user']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'resource_type')
        self.resource_type = attributes[:'resource_type']
      end

      if attributes.has_key?(:'path')
        self.path = attributes[:'path']
      end

      if attributes.has_key?(:'parent_path')
        self.parent_path = attributes[:'parent_path']
      end

      if attributes.has_key?(:'unique_id')
        self.unique_id = attributes[:'unique_id']
      end

      if attributes.has_key?(:'relative_path')
        self.relative_path = attributes[:'relative_path']
      end

      if attributes.has_key?(:'children')
        if (value = attributes[:'children']).is_a?(Array)
          self.children = value
        end
      end

      if attributes.has_key?(:'overridden')
        self.overridden = attributes[:'overridden']
      else
        self.overridden = false
      end

      if attributes.has_key?(:'marked_for_delete')
        self.marked_for_delete = attributes[:'marked_for_delete']
      else
        self.marked_for_delete = false
      end

      if attributes.has_key?(:'out_route_filters')
        if (value = attributes[:'out_route_filters']).is_a?(Array)
          self.out_route_filters = value
        end
      end

      if attributes.has_key?(:'graceful_restart_mode')
        self.graceful_restart_mode = attributes[:'graceful_restart_mode']
      end

      if attributes.has_key?(:'bfd')
        self.bfd = attributes[:'bfd']
      end

      if attributes.has_key?(:'keep_alive_time')
        self.keep_alive_time = attributes[:'keep_alive_time']
      else
        self.keep_alive_time = 60
      end

      if attributes.has_key?(:'maximum_hop_limit')
        self.maximum_hop_limit = attributes[:'maximum_hop_limit']
      else
        self.maximum_hop_limit = 1
      end

      if attributes.has_key?(:'hold_down_time')
        self.hold_down_time = attributes[:'hold_down_time']
      else
        self.hold_down_time = 180
      end

      if attributes.has_key?(:'in_route_filters')
        if (value = attributes[:'in_route_filters']).is_a?(Array)
          self.in_route_filters = value
        end
      end

      if attributes.has_key?(:'remote_as_num')
        self.remote_as_num = attributes[:'remote_as_num']
      end

      if attributes.has_key?(:'route_filtering')
        if (value = attributes[:'route_filtering']).is_a?(Array)
          self.route_filtering = value
        end
      end

      if attributes.has_key?(:'source_addresses')
        if (value = attributes[:'source_addresses']).is_a?(Array)
          self.source_addresses = value
        end
      end

      if attributes.has_key?(:'password')
        self.password = attributes[:'password']
      end

      if attributes.has_key?(:'allow_as_in')
        self.allow_as_in = attributes[:'allow_as_in']
      else
        self.allow_as_in = false
      end

      if attributes.has_key?(:'neighbor_address')
        self.neighbor_address = attributes[:'neighbor_address']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@display_name.nil? && @display_name.to_s.length > 255
        invalid_properties.push('invalid value for "display_name", the character length must be smaller than or equal to 255.')
      end

      if !@description.nil? && @description.to_s.length > 1024
        invalid_properties.push('invalid value for "description", the character length must be smaller than or equal to 1024.')
      end

      if !@keep_alive_time.nil? && @keep_alive_time > 65535
        invalid_properties.push('invalid value for "keep_alive_time", must be smaller than or equal to 65535.')
      end

      if !@keep_alive_time.nil? && @keep_alive_time < 1
        invalid_properties.push('invalid value for "keep_alive_time", must be greater than or equal to 1.')
      end

      if !@maximum_hop_limit.nil? && @maximum_hop_limit > 255
        invalid_properties.push('invalid value for "maximum_hop_limit", must be smaller than or equal to 255.')
      end

      if !@maximum_hop_limit.nil? && @maximum_hop_limit < 1
        invalid_properties.push('invalid value for "maximum_hop_limit", must be greater than or equal to 1.')
      end

      if !@hold_down_time.nil? && @hold_down_time > 65535
        invalid_properties.push('invalid value for "hold_down_time", must be smaller than or equal to 65535.')
      end

      if !@hold_down_time.nil? && @hold_down_time < 1
        invalid_properties.push('invalid value for "hold_down_time", must be greater than or equal to 1.')
      end

      if @remote_as_num.nil?
        invalid_properties.push('invalid value for "remote_as_num", remote_as_num cannot be nil.')
      end

      if !@password.nil? && @password.to_s.length > 20
        invalid_properties.push('invalid value for "password", the character length must be smaller than or equal to 20.')
      end

      if !@password.nil? && @password.to_s.length < 0
        invalid_properties.push('invalid value for "password", the character length must be great than or equal to 0.')
      end

      if @neighbor_address.nil?
        invalid_properties.push('invalid value for "neighbor_address", neighbor_address cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@display_name.nil? && @display_name.to_s.length > 255
      return false if !@description.nil? && @description.to_s.length > 1024
      graceful_restart_mode_validator = EnumAttributeValidator.new('String', ['DISABLE', 'GR_AND_HELPER', 'HELPER_ONLY'])
      return false unless graceful_restart_mode_validator.valid?(@graceful_restart_mode)
      return false if !@keep_alive_time.nil? && @keep_alive_time > 65535
      return false if !@keep_alive_time.nil? && @keep_alive_time < 1
      return false if !@maximum_hop_limit.nil? && @maximum_hop_limit > 255
      return false if !@maximum_hop_limit.nil? && @maximum_hop_limit < 1
      return false if !@hold_down_time.nil? && @hold_down_time > 65535
      return false if !@hold_down_time.nil? && @hold_down_time < 1
      return false if @remote_as_num.nil?
      return false if !@password.nil? && @password.to_s.length > 20
      return false if !@password.nil? && @password.to_s.length < 0
      return false if @neighbor_address.nil?
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] display_name Value to be assigned
    def display_name=(display_name)
      if !display_name.nil? && display_name.to_s.length > 255
        fail ArgumentError, 'invalid value for "display_name", the character length must be smaller than or equal to 255.'
      end

      @display_name = display_name
    end

    # Custom attribute writer method with validation
    # @param [Object] description Value to be assigned
    def description=(description)
      if !description.nil? && description.to_s.length > 1024
        fail ArgumentError, 'invalid value for "description", the character length must be smaller than or equal to 1024.'
      end

      @description = description
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] graceful_restart_mode Object to be assigned
    def graceful_restart_mode=(graceful_restart_mode)
      validator = EnumAttributeValidator.new('String', ['DISABLE', 'GR_AND_HELPER', 'HELPER_ONLY'])
      unless validator.valid?(graceful_restart_mode)
        fail ArgumentError, 'invalid value for "graceful_restart_mode", must be one of #{validator.allowable_values}.'
      end
      @graceful_restart_mode = graceful_restart_mode
    end

    # Custom attribute writer method with validation
    # @param [Object] keep_alive_time Value to be assigned
    def keep_alive_time=(keep_alive_time)
      if !keep_alive_time.nil? && keep_alive_time > 65535
        fail ArgumentError, 'invalid value for "keep_alive_time", must be smaller than or equal to 65535.'
      end

      if !keep_alive_time.nil? && keep_alive_time < 1
        fail ArgumentError, 'invalid value for "keep_alive_time", must be greater than or equal to 1.'
      end

      @keep_alive_time = keep_alive_time
    end

    # Custom attribute writer method with validation
    # @param [Object] maximum_hop_limit Value to be assigned
    def maximum_hop_limit=(maximum_hop_limit)
      if !maximum_hop_limit.nil? && maximum_hop_limit > 255
        fail ArgumentError, 'invalid value for "maximum_hop_limit", must be smaller than or equal to 255.'
      end

      if !maximum_hop_limit.nil? && maximum_hop_limit < 1
        fail ArgumentError, 'invalid value for "maximum_hop_limit", must be greater than or equal to 1.'
      end

      @maximum_hop_limit = maximum_hop_limit
    end

    # Custom attribute writer method with validation
    # @param [Object] hold_down_time Value to be assigned
    def hold_down_time=(hold_down_time)
      if !hold_down_time.nil? && hold_down_time > 65535
        fail ArgumentError, 'invalid value for "hold_down_time", must be smaller than or equal to 65535.'
      end

      if !hold_down_time.nil? && hold_down_time < 1
        fail ArgumentError, 'invalid value for "hold_down_time", must be greater than or equal to 1.'
      end

      @hold_down_time = hold_down_time
    end

    # Custom attribute writer method with validation
    # @param [Object] password Value to be assigned
    def password=(password)
      if !password.nil? && password.to_s.length > 20
        fail ArgumentError, 'invalid value for "password", the character length must be smaller than or equal to 20.'
      end

      if !password.nil? && password.to_s.length < 0
        fail ArgumentError, 'invalid value for "password", the character length must be great than or equal to 0.'
      end

      @password = password
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          _self == o._self &&
          _links == o._links &&
          _schema == o._schema &&
          _revision == o._revision &&
          _system_owned == o._system_owned &&
          display_name == o.display_name &&
          description == o.description &&
          tags == o.tags &&
          _create_user == o._create_user &&
          _protection == o._protection &&
          _create_time == o._create_time &&
          _last_modified_time == o._last_modified_time &&
          _last_modified_user == o._last_modified_user &&
          id == o.id &&
          resource_type == o.resource_type &&
          path == o.path &&
          parent_path == o.parent_path &&
          unique_id == o.unique_id &&
          relative_path == o.relative_path &&
          children == o.children &&
          overridden == o.overridden &&
          marked_for_delete == o.marked_for_delete &&
          out_route_filters == o.out_route_filters &&
          graceful_restart_mode == o.graceful_restart_mode &&
          bfd == o.bfd &&
          keep_alive_time == o.keep_alive_time &&
          maximum_hop_limit == o.maximum_hop_limit &&
          hold_down_time == o.hold_down_time &&
          in_route_filters == o.in_route_filters &&
          remote_as_num == o.remote_as_num &&
          route_filtering == o.route_filtering &&
          source_addresses == o.source_addresses &&
          password == o.password &&
          allow_as_in == o.allow_as_in &&
          neighbor_address == o.neighbor_address
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [_self, _links, _schema, _revision, _system_owned, display_name, description, tags, _create_user, _protection, _create_time, _last_modified_time, _last_modified_user, id, resource_type, path, parent_path, unique_id, relative_path, children, overridden, marked_for_delete, out_route_filters, graceful_restart_mode, bfd, keep_alive_time, maximum_hop_limit, hold_down_time, in_route_filters, remote_as_num, route_filtering, source_addresses, password, allow_as_in, neighbor_address].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXTPolicy.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
