=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module NSXTPolicy
  class PolicyEdgeClusterInterSiteStatus
    # Timestamp when the edge cluster inter-site status was last updated. 
    attr_accessor :last_update_timestamp

    # Overall status of all edge nodes IBGP status in the edge cluster. 
    attr_accessor :overall_status

    # Name of the edge cluster whose status is being reported.
    attr_accessor :edge_cluster_name

    # Per edge node inter-site status.
    attr_accessor :member_status

    # Policy path of the edge cluster whose status is being reported.
    attr_accessor :edge_cluster_path

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'last_update_timestamp' => :'last_update_timestamp',
        :'overall_status' => :'overall_status',
        :'edge_cluster_name' => :'edge_cluster_name',
        :'member_status' => :'member_status',
        :'edge_cluster_path' => :'edge_cluster_path'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'last_update_timestamp' => :'Integer',
        :'overall_status' => :'String',
        :'edge_cluster_name' => :'String',
        :'member_status' => :'Array<PolicyEdgeClusterMemberInterSiteStatus>',
        :'edge_cluster_path' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'last_update_timestamp')
        self.last_update_timestamp = attributes[:'last_update_timestamp']
      end

      if attributes.has_key?(:'overall_status')
        self.overall_status = attributes[:'overall_status']
      end

      if attributes.has_key?(:'edge_cluster_name')
        self.edge_cluster_name = attributes[:'edge_cluster_name']
      end

      if attributes.has_key?(:'member_status')
        if (value = attributes[:'member_status']).is_a?(Array)
          self.member_status = value
        end
      end

      if attributes.has_key?(:'edge_cluster_path')
        self.edge_cluster_path = attributes[:'edge_cluster_path']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      overall_status_validator = EnumAttributeValidator.new('String', ['UP', 'DOWN', 'DEGRADED', 'UNKNOWN'])
      return false unless overall_status_validator.valid?(@overall_status)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] overall_status Object to be assigned
    def overall_status=(overall_status)
      validator = EnumAttributeValidator.new('String', ['UP', 'DOWN', 'DEGRADED', 'UNKNOWN'])
      unless validator.valid?(overall_status)
        fail ArgumentError, 'invalid value for "overall_status", must be one of #{validator.allowable_values}.'
      end
      @overall_status = overall_status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          last_update_timestamp == o.last_update_timestamp &&
          overall_status == o.overall_status &&
          edge_cluster_name == o.edge_cluster_name &&
          member_status == o.member_status &&
          edge_cluster_path == o.edge_cluster_path
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [last_update_timestamp, overall_status, edge_cluster_name, member_status, edge_cluster_path].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXTPolicy.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
