=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module NSXTPolicy
  # Segment configuration to attach workloads. 
  class Segment
    # Link to this resource
    attr_accessor :_self

    # The server will populate this field when returing the resource. Ignored on PUT and POST.
    attr_accessor :_links

    # Schema for this resource
    attr_accessor :_schema

    # The _revision property describes the current revision of the resource. To prevent clients from overwriting each other's changes, PUT operations must include the current _revision of the resource, which clients should obtain by issuing a GET operation. If the _revision provided in a PUT request is missing or stale, the operation will be rejected.
    attr_accessor :_revision

    # Indicates system owned resource
    attr_accessor :_system_owned

    # Defaults to ID if not set
    attr_accessor :display_name

    # Description of this resource
    attr_accessor :description

    # Opaque identifiers meaningful to the API user
    attr_accessor :tags

    # ID of the user who created this resource
    attr_accessor :_create_user

    # Protection status is one of the following: PROTECTED - the client who retrieved the entity is not allowed             to modify it. NOT_PROTECTED - the client who retrieved the entity is allowed                 to modify it REQUIRE_OVERRIDE - the client who retrieved the entity is a super                    user and can modify it, but only when providing                    the request header X-Allow-Overwrite=true. UNKNOWN - the _protection field could not be determined for this           entity. 
    attr_accessor :_protection

    # Timestamp of resource creation
    attr_accessor :_create_time

    # Timestamp of last modification
    attr_accessor :_last_modified_time

    # ID of the user who last modified this resource
    attr_accessor :_last_modified_user

    # Unique identifier of this resource
    attr_accessor :id

    # The type of this resource.
    attr_accessor :resource_type

    # Absolute path of this object
    attr_accessor :path

    # Path of its parent
    attr_accessor :parent_path

    # This is a UUID generated by the GM/LM to uniquely identify entites in a federated environment. For entities that are stretched across multiple sites, the same ID will be used on all the stretched sites. 
    attr_accessor :unique_id

    # Path relative from its parent
    attr_accessor :relative_path

    # subtree for this type within policy tree containing nested elements. 
    attr_accessor :children

    # Global intent objects cannot be modified by the user. However, certain global intent objects can be overridden locally by use of this property. In such cases, the overridden local values take precedence over the globally defined values for the properties. 
    attr_accessor :overridden

    # Intent objects are not directly deleted from the system when a delete is invoked on them. They are marked for deletion and only when all the realized entities for that intent object gets deleted, the intent object is deleted. Objects that are marked for deletion are not returned in GET call. One can use the search API to get these objects. 
    attr_accessor :marked_for_delete

    # Subnet configuration. Max 1 subnet
    attr_accessor :subnets

    # Policy path to the connecting Tier-0 or Tier-1. Valid only for segments created under Infra. 
    attr_accessor :connectivity_path

    # This property could be used for vendor specific configuration in key value string pairs, the setting in extra_configs will be automatically inheritted by segment ports in the Segment. 
    attr_accessor :extra_configs

    # Advanced configuration for Segment. 
    attr_accessor :advanced_config

    # Static address binding used for the Segment. This field is deprecated and will be removed in a future release. Please use address_bindings in SegmentPort to configure static bindings.
    attr_accessor :address_bindings

    # Additional config for federation.
    attr_accessor :federation_config

    # Policy path to the EvpnTenantConfig resource. Supported only for Route-Server Evpn Mode. Supported only for Overlay Segments. This will be populated for both Parent and Child segments participating in Evpn Route-Server Mode. 
    attr_accessor :evpn_tenant_config_path

    # Mac pool id that associated with a Segment.
    attr_accessor :mac_pool_id

    # Multiple distinct L2 bridge profiles can be configured.
    attr_accessor :bridge_profiles

    # VLAN ids for a VLAN backed Segment. Can be a VLAN id or a range of VLAN ids specified with '-' in between. 
    attr_accessor :vlan_ids

    # DNS domain name
    attr_accessor :domain_name

    # Used for overlay connectivity of segments. The overlay_id should be allocated from the pool as definied by enforcement-point. If not provided, it is auto-allocated from the default pool on the enforcement-point. 
    attr_accessor :overlay_id

    # Policy path to DHCP server or relay configuration to use for all IPv4 & IPv6 subnets configured on this segment. 
    attr_accessor :dhcp_config_path

    # This property is deprecated. The property will continue to work as expected for existing segments. The segments that are newly created with ls_id will be ignored. Sepcify pre-creted logical switch id for Segment. 
    attr_accessor :ls_id

    # Flag to indicate if the Segment is a Child-Segment of type EVPN.
    attr_accessor :evpn_segment

    # Represents Desired state of the Segment
    attr_accessor :admin_state

    # Policy path to metadata proxy configuration. Multiple distinct MD proxies can be configured.
    attr_accessor :metadata_proxy_paths

    # Segment type based on configuration. 
    attr_accessor :type

    # Configuration for extending Segment through L2 VPN
    attr_accessor :l2_extension

    # Policy path to the transport zone. Supported for VLAN backed segments as well as Overlay Segments. - This field is required for VLAN backed Segments. - For overlay Segments, it is auto assigned if only one transport zone   exists in the enforcement point. Default transport zone is auto   assigned for  overlay segments if none specified. 
    attr_accessor :transport_zone_path

    # If this field is not set for overlay segment, then the default of MTEP will be used. 
    attr_accessor :replication_mode

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'_self' => :'_self',
        :'_links' => :'_links',
        :'_schema' => :'_schema',
        :'_revision' => :'_revision',
        :'_system_owned' => :'_system_owned',
        :'display_name' => :'display_name',
        :'description' => :'description',
        :'tags' => :'tags',
        :'_create_user' => :'_create_user',
        :'_protection' => :'_protection',
        :'_create_time' => :'_create_time',
        :'_last_modified_time' => :'_last_modified_time',
        :'_last_modified_user' => :'_last_modified_user',
        :'id' => :'id',
        :'resource_type' => :'resource_type',
        :'path' => :'path',
        :'parent_path' => :'parent_path',
        :'unique_id' => :'unique_id',
        :'relative_path' => :'relative_path',
        :'children' => :'children',
        :'overridden' => :'overridden',
        :'marked_for_delete' => :'marked_for_delete',
        :'subnets' => :'subnets',
        :'connectivity_path' => :'connectivity_path',
        :'extra_configs' => :'extra_configs',
        :'advanced_config' => :'advanced_config',
        :'address_bindings' => :'address_bindings',
        :'federation_config' => :'federation_config',
        :'evpn_tenant_config_path' => :'evpn_tenant_config_path',
        :'mac_pool_id' => :'mac_pool_id',
        :'bridge_profiles' => :'bridge_profiles',
        :'vlan_ids' => :'vlan_ids',
        :'domain_name' => :'domain_name',
        :'overlay_id' => :'overlay_id',
        :'dhcp_config_path' => :'dhcp_config_path',
        :'ls_id' => :'ls_id',
        :'evpn_segment' => :'evpn_segment',
        :'admin_state' => :'admin_state',
        :'metadata_proxy_paths' => :'metadata_proxy_paths',
        :'type' => :'type',
        :'l2_extension' => :'l2_extension',
        :'transport_zone_path' => :'transport_zone_path',
        :'replication_mode' => :'replication_mode'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'_self' => :'SelfResourceLink',
        :'_links' => :'Array<ResourceLink>',
        :'_schema' => :'String',
        :'_revision' => :'Integer',
        :'_system_owned' => :'BOOLEAN',
        :'display_name' => :'String',
        :'description' => :'String',
        :'tags' => :'Array<Tag>',
        :'_create_user' => :'String',
        :'_protection' => :'String',
        :'_create_time' => :'Integer',
        :'_last_modified_time' => :'Integer',
        :'_last_modified_user' => :'String',
        :'id' => :'String',
        :'resource_type' => :'String',
        :'path' => :'String',
        :'parent_path' => :'String',
        :'unique_id' => :'String',
        :'relative_path' => :'String',
        :'children' => :'Array<ChildPolicyConfigResource>',
        :'overridden' => :'BOOLEAN',
        :'marked_for_delete' => :'BOOLEAN',
        :'subnets' => :'Array<SegmentSubnet>',
        :'connectivity_path' => :'String',
        :'extra_configs' => :'Array<SegmentExtraConfig>',
        :'advanced_config' => :'SegmentAdvancedConfig',
        :'address_bindings' => :'Array<PortAddressBindingEntry>',
        :'federation_config' => :'FederationConnectivityConfig',
        :'evpn_tenant_config_path' => :'String',
        :'mac_pool_id' => :'String',
        :'bridge_profiles' => :'Array<BridgeProfileConfig>',
        :'vlan_ids' => :'Array<String>',
        :'domain_name' => :'String',
        :'overlay_id' => :'Integer',
        :'dhcp_config_path' => :'String',
        :'ls_id' => :'String',
        :'evpn_segment' => :'BOOLEAN',
        :'admin_state' => :'String',
        :'metadata_proxy_paths' => :'Array<String>',
        :'type' => :'String',
        :'l2_extension' => :'L2Extension',
        :'transport_zone_path' => :'String',
        :'replication_mode' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'_self')
        self._self = attributes[:'_self']
      end

      if attributes.has_key?(:'_links')
        if (value = attributes[:'_links']).is_a?(Array)
          self._links = value
        end
      end

      if attributes.has_key?(:'_schema')
        self._schema = attributes[:'_schema']
      end

      if attributes.has_key?(:'_revision')
        self._revision = attributes[:'_revision']
      end

      if attributes.has_key?(:'_system_owned')
        self._system_owned = attributes[:'_system_owned']
      end

      if attributes.has_key?(:'display_name')
        self.display_name = attributes[:'display_name']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end

      if attributes.has_key?(:'_create_user')
        self._create_user = attributes[:'_create_user']
      end

      if attributes.has_key?(:'_protection')
        self._protection = attributes[:'_protection']
      end

      if attributes.has_key?(:'_create_time')
        self._create_time = attributes[:'_create_time']
      end

      if attributes.has_key?(:'_last_modified_time')
        self._last_modified_time = attributes[:'_last_modified_time']
      end

      if attributes.has_key?(:'_last_modified_user')
        self._last_modified_user = attributes[:'_last_modified_user']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'resource_type')
        self.resource_type = attributes[:'resource_type']
      end

      if attributes.has_key?(:'path')
        self.path = attributes[:'path']
      end

      if attributes.has_key?(:'parent_path')
        self.parent_path = attributes[:'parent_path']
      end

      if attributes.has_key?(:'unique_id')
        self.unique_id = attributes[:'unique_id']
      end

      if attributes.has_key?(:'relative_path')
        self.relative_path = attributes[:'relative_path']
      end

      if attributes.has_key?(:'children')
        if (value = attributes[:'children']).is_a?(Array)
          self.children = value
        end
      end

      if attributes.has_key?(:'overridden')
        self.overridden = attributes[:'overridden']
      else
        self.overridden = false
      end

      if attributes.has_key?(:'marked_for_delete')
        self.marked_for_delete = attributes[:'marked_for_delete']
      else
        self.marked_for_delete = false
      end

      if attributes.has_key?(:'subnets')
        if (value = attributes[:'subnets']).is_a?(Array)
          self.subnets = value
        end
      end

      if attributes.has_key?(:'connectivity_path')
        self.connectivity_path = attributes[:'connectivity_path']
      end

      if attributes.has_key?(:'extra_configs')
        if (value = attributes[:'extra_configs']).is_a?(Array)
          self.extra_configs = value
        end
      end

      if attributes.has_key?(:'advanced_config')
        self.advanced_config = attributes[:'advanced_config']
      end

      if attributes.has_key?(:'address_bindings')
        if (value = attributes[:'address_bindings']).is_a?(Array)
          self.address_bindings = value
        end
      end

      if attributes.has_key?(:'federation_config')
        self.federation_config = attributes[:'federation_config']
      end

      if attributes.has_key?(:'evpn_tenant_config_path')
        self.evpn_tenant_config_path = attributes[:'evpn_tenant_config_path']
      end

      if attributes.has_key?(:'mac_pool_id')
        self.mac_pool_id = attributes[:'mac_pool_id']
      end

      if attributes.has_key?(:'bridge_profiles')
        if (value = attributes[:'bridge_profiles']).is_a?(Array)
          self.bridge_profiles = value
        end
      end

      if attributes.has_key?(:'vlan_ids')
        if (value = attributes[:'vlan_ids']).is_a?(Array)
          self.vlan_ids = value
        end
      end

      if attributes.has_key?(:'domain_name')
        self.domain_name = attributes[:'domain_name']
      end

      if attributes.has_key?(:'overlay_id')
        self.overlay_id = attributes[:'overlay_id']
      end

      if attributes.has_key?(:'dhcp_config_path')
        self.dhcp_config_path = attributes[:'dhcp_config_path']
      end

      if attributes.has_key?(:'ls_id')
        self.ls_id = attributes[:'ls_id']
      end

      if attributes.has_key?(:'evpn_segment')
        self.evpn_segment = attributes[:'evpn_segment']
      end

      if attributes.has_key?(:'admin_state')
        self.admin_state = attributes[:'admin_state']
      else
        self.admin_state = 'UP'
      end

      if attributes.has_key?(:'metadata_proxy_paths')
        if (value = attributes[:'metadata_proxy_paths']).is_a?(Array)
          self.metadata_proxy_paths = value
        end
      end

      if attributes.has_key?(:'type')
        self.type = attributes[:'type']
      end

      if attributes.has_key?(:'l2_extension')
        self.l2_extension = attributes[:'l2_extension']
      end

      if attributes.has_key?(:'transport_zone_path')
        self.transport_zone_path = attributes[:'transport_zone_path']
      end

      if attributes.has_key?(:'replication_mode')
        self.replication_mode = attributes[:'replication_mode']
      else
        self.replication_mode = 'MTEP'
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@display_name.nil? && @display_name.to_s.length > 255
        invalid_properties.push('invalid value for "display_name", the character length must be smaller than or equal to 255.')
      end

      if !@description.nil? && @description.to_s.length > 1024
        invalid_properties.push('invalid value for "description", the character length must be smaller than or equal to 1024.')
      end

      if !@overlay_id.nil? && @overlay_id > 2147483647
        invalid_properties.push('invalid value for "overlay_id", must be smaller than or equal to 2147483647.')
      end

      if !@overlay_id.nil? && @overlay_id < 0
        invalid_properties.push('invalid value for "overlay_id", must be greater than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@display_name.nil? && @display_name.to_s.length > 255
      return false if !@description.nil? && @description.to_s.length > 1024
      return false if !@overlay_id.nil? && @overlay_id > 2147483647
      return false if !@overlay_id.nil? && @overlay_id < 0
      admin_state_validator = EnumAttributeValidator.new('String', ['UP', 'DOWN'])
      return false unless admin_state_validator.valid?(@admin_state)
      type_validator = EnumAttributeValidator.new('String', ['ROUTED', 'EXTENDED', 'ROUTED_AND_EXTENDED', 'DISCONNECTED'])
      return false unless type_validator.valid?(@type)
      replication_mode_validator = EnumAttributeValidator.new('String', ['MTEP', 'SOURCE'])
      return false unless replication_mode_validator.valid?(@replication_mode)
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] display_name Value to be assigned
    def display_name=(display_name)
      if !display_name.nil? && display_name.to_s.length > 255
        fail ArgumentError, 'invalid value for "display_name", the character length must be smaller than or equal to 255.'
      end

      @display_name = display_name
    end

    # Custom attribute writer method with validation
    # @param [Object] description Value to be assigned
    def description=(description)
      if !description.nil? && description.to_s.length > 1024
        fail ArgumentError, 'invalid value for "description", the character length must be smaller than or equal to 1024.'
      end

      @description = description
    end

    # Custom attribute writer method with validation
    # @param [Object] overlay_id Value to be assigned
    def overlay_id=(overlay_id)
      if !overlay_id.nil? && overlay_id > 2147483647
        fail ArgumentError, 'invalid value for "overlay_id", must be smaller than or equal to 2147483647.'
      end

      if !overlay_id.nil? && overlay_id < 0
        fail ArgumentError, 'invalid value for "overlay_id", must be greater than or equal to 0.'
      end

      @overlay_id = overlay_id
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] admin_state Object to be assigned
    def admin_state=(admin_state)
      validator = EnumAttributeValidator.new('String', ['UP', 'DOWN'])
      unless validator.valid?(admin_state)
        fail ArgumentError, 'invalid value for "admin_state", must be one of #{validator.allowable_values}.'
      end
      @admin_state = admin_state
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] type Object to be assigned
    def type=(type)
      validator = EnumAttributeValidator.new('String', ['ROUTED', 'EXTENDED', 'ROUTED_AND_EXTENDED', 'DISCONNECTED'])
      unless validator.valid?(type)
        fail ArgumentError, 'invalid value for "type", must be one of #{validator.allowable_values}.'
      end
      @type = type
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] replication_mode Object to be assigned
    def replication_mode=(replication_mode)
      validator = EnumAttributeValidator.new('String', ['MTEP', 'SOURCE'])
      unless validator.valid?(replication_mode)
        fail ArgumentError, 'invalid value for "replication_mode", must be one of #{validator.allowable_values}.'
      end
      @replication_mode = replication_mode
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          _self == o._self &&
          _links == o._links &&
          _schema == o._schema &&
          _revision == o._revision &&
          _system_owned == o._system_owned &&
          display_name == o.display_name &&
          description == o.description &&
          tags == o.tags &&
          _create_user == o._create_user &&
          _protection == o._protection &&
          _create_time == o._create_time &&
          _last_modified_time == o._last_modified_time &&
          _last_modified_user == o._last_modified_user &&
          id == o.id &&
          resource_type == o.resource_type &&
          path == o.path &&
          parent_path == o.parent_path &&
          unique_id == o.unique_id &&
          relative_path == o.relative_path &&
          children == o.children &&
          overridden == o.overridden &&
          marked_for_delete == o.marked_for_delete &&
          subnets == o.subnets &&
          connectivity_path == o.connectivity_path &&
          extra_configs == o.extra_configs &&
          advanced_config == o.advanced_config &&
          address_bindings == o.address_bindings &&
          federation_config == o.federation_config &&
          evpn_tenant_config_path == o.evpn_tenant_config_path &&
          mac_pool_id == o.mac_pool_id &&
          bridge_profiles == o.bridge_profiles &&
          vlan_ids == o.vlan_ids &&
          domain_name == o.domain_name &&
          overlay_id == o.overlay_id &&
          dhcp_config_path == o.dhcp_config_path &&
          ls_id == o.ls_id &&
          evpn_segment == o.evpn_segment &&
          admin_state == o.admin_state &&
          metadata_proxy_paths == o.metadata_proxy_paths &&
          type == o.type &&
          l2_extension == o.l2_extension &&
          transport_zone_path == o.transport_zone_path &&
          replication_mode == o.replication_mode
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [_self, _links, _schema, _revision, _system_owned, display_name, description, tags, _create_user, _protection, _create_time, _last_modified_time, _last_modified_user, id, resource_type, path, parent_path, unique_id, relative_path, children, overridden, marked_for_delete, subnets, connectivity_path, extra_configs, advanced_config, address_bindings, federation_config, evpn_tenant_config_path, mac_pool_id, bridge_profiles, vlan_ids, domain_name, overlay_id, dhcp_config_path, ls_id, evpn_segment, admin_state, metadata_proxy_paths, type, l2_extension, transport_zone_path, replication_mode].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXTPolicy.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
