=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module NSXTPolicy
  # Tier-0 interface configuration for external connectivity.
  class Tier0Interface
    # Link to this resource
    attr_accessor :_self

    # The server will populate this field when returing the resource. Ignored on PUT and POST.
    attr_accessor :_links

    # Schema for this resource
    attr_accessor :_schema

    # The _revision property describes the current revision of the resource. To prevent clients from overwriting each other's changes, PUT operations must include the current _revision of the resource, which clients should obtain by issuing a GET operation. If the _revision provided in a PUT request is missing or stale, the operation will be rejected.
    attr_accessor :_revision

    # Indicates system owned resource
    attr_accessor :_system_owned

    # Defaults to ID if not set
    attr_accessor :display_name

    # Description of this resource
    attr_accessor :description

    # Opaque identifiers meaningful to the API user
    attr_accessor :tags

    # ID of the user who created this resource
    attr_accessor :_create_user

    # Protection status is one of the following: PROTECTED - the client who retrieved the entity is not allowed             to modify it. NOT_PROTECTED - the client who retrieved the entity is allowed                 to modify it REQUIRE_OVERRIDE - the client who retrieved the entity is a super                    user and can modify it, but only when providing                    the request header X-Allow-Overwrite=true. UNKNOWN - the _protection field could not be determined for this           entity. 
    attr_accessor :_protection

    # Timestamp of resource creation
    attr_accessor :_create_time

    # Timestamp of last modification
    attr_accessor :_last_modified_time

    # ID of the user who last modified this resource
    attr_accessor :_last_modified_user

    # Unique identifier of this resource
    attr_accessor :id

    # The type of this resource.
    attr_accessor :resource_type

    # Absolute path of this object
    attr_accessor :path

    # Path of its parent
    attr_accessor :parent_path

    # This is a UUID generated by the GM/LM to uniquely identify entites in a federated environment. For entities that are stretched across multiple sites, the same ID will be used on all the stretched sites. 
    attr_accessor :unique_id

    # Path relative from its parent
    attr_accessor :relative_path

    # subtree for this type within policy tree containing nested elements. 
    attr_accessor :children

    # Global intent objects cannot be modified by the user. However, certain global intent objects can be overridden locally by use of this property. In such cases, the overridden local values take precedence over the globally defined values for the properties. 
    attr_accessor :overridden

    # Intent objects are not directly deleted from the system when a delete is invoked on them. They are marked for deletion and only when all the realized entities for that intent object gets deleted, the intent object is deleted. Objects that are marked for deletion are not returned in GET call. One can use the search API to get these objects. 
    attr_accessor :marked_for_delete

    # Specify IP address and network prefix for interface. 
    attr_accessor :subnets

    # OSPF configuration.
    attr_accessor :ospf

    # Specify association of interface with edge cluster member. This property is deprecated, use edge_path instead. When both properties are specifed, only edge_path property is used. 
    attr_accessor :edge_cluster_member_index

    # Unicast Reverse Path Forwarding mode
    attr_accessor :urpf_mode

    # Array of prefix lists used to specify filtering for ARP proxy. Prefixes in this array are used to configure ARP proxy entries on Tier-0 gateway (for uplinks). 
    attr_accessor :proxy_arp_filters

    # Policy path to edge node to handle external connectivity. Required when interface type is EXTERNAL. 
    attr_accessor :edge_path

    # Specify Segment to which this interface is connected to. Either segment_path or ls_id property is required. 
    attr_accessor :segment_path

    # Multicast PIM configuration. 
    attr_accessor :multicast

    # Specify logical switch to which tier-0 interface is connected for external access. This property is deprecated, use segment_path instead. Both properties cannot be used together. 
    attr_accessor :ls_id

    # Configuration IPv6 NDRA profile. Only one NDRA profile can be configured. 
    attr_accessor :ipv6_profile_paths

    # IGMP local join groups configuration. 
    attr_accessor :igmp_local_join_groups

    # Vlan id.
    attr_accessor :access_vlan_id

    # Maximum transmission unit (MTU) specifies the size of the largest packet that a network protocol can transmit. 
    attr_accessor :mtu

    # Interface type 
    attr_accessor :type

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'_self' => :'_self',
        :'_links' => :'_links',
        :'_schema' => :'_schema',
        :'_revision' => :'_revision',
        :'_system_owned' => :'_system_owned',
        :'display_name' => :'display_name',
        :'description' => :'description',
        :'tags' => :'tags',
        :'_create_user' => :'_create_user',
        :'_protection' => :'_protection',
        :'_create_time' => :'_create_time',
        :'_last_modified_time' => :'_last_modified_time',
        :'_last_modified_user' => :'_last_modified_user',
        :'id' => :'id',
        :'resource_type' => :'resource_type',
        :'path' => :'path',
        :'parent_path' => :'parent_path',
        :'unique_id' => :'unique_id',
        :'relative_path' => :'relative_path',
        :'children' => :'children',
        :'overridden' => :'overridden',
        :'marked_for_delete' => :'marked_for_delete',
        :'subnets' => :'subnets',
        :'ospf' => :'ospf',
        :'edge_cluster_member_index' => :'edge_cluster_member_index',
        :'urpf_mode' => :'urpf_mode',
        :'proxy_arp_filters' => :'proxy_arp_filters',
        :'edge_path' => :'edge_path',
        :'segment_path' => :'segment_path',
        :'multicast' => :'multicast',
        :'ls_id' => :'ls_id',
        :'ipv6_profile_paths' => :'ipv6_profile_paths',
        :'igmp_local_join_groups' => :'igmp_local_join_groups',
        :'access_vlan_id' => :'access_vlan_id',
        :'mtu' => :'mtu',
        :'type' => :'type'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'_self' => :'SelfResourceLink',
        :'_links' => :'Array<ResourceLink>',
        :'_schema' => :'String',
        :'_revision' => :'Integer',
        :'_system_owned' => :'BOOLEAN',
        :'display_name' => :'String',
        :'description' => :'String',
        :'tags' => :'Array<Tag>',
        :'_create_user' => :'String',
        :'_protection' => :'String',
        :'_create_time' => :'Integer',
        :'_last_modified_time' => :'Integer',
        :'_last_modified_user' => :'String',
        :'id' => :'String',
        :'resource_type' => :'String',
        :'path' => :'String',
        :'parent_path' => :'String',
        :'unique_id' => :'String',
        :'relative_path' => :'String',
        :'children' => :'Array<ChildPolicyConfigResource>',
        :'overridden' => :'BOOLEAN',
        :'marked_for_delete' => :'BOOLEAN',
        :'subnets' => :'Array<InterfaceSubnet>',
        :'ospf' => :'PolicyInterfaceOspfConfig',
        :'edge_cluster_member_index' => :'Integer',
        :'urpf_mode' => :'String',
        :'proxy_arp_filters' => :'Array<String>',
        :'edge_path' => :'String',
        :'segment_path' => :'String',
        :'multicast' => :'Tier0InterfacePimConfig',
        :'ls_id' => :'String',
        :'ipv6_profile_paths' => :'Array<String>',
        :'igmp_local_join_groups' => :'Array<String>',
        :'access_vlan_id' => :'Integer',
        :'mtu' => :'Integer',
        :'type' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'_self')
        self._self = attributes[:'_self']
      end

      if attributes.has_key?(:'_links')
        if (value = attributes[:'_links']).is_a?(Array)
          self._links = value
        end
      end

      if attributes.has_key?(:'_schema')
        self._schema = attributes[:'_schema']
      end

      if attributes.has_key?(:'_revision')
        self._revision = attributes[:'_revision']
      end

      if attributes.has_key?(:'_system_owned')
        self._system_owned = attributes[:'_system_owned']
      end

      if attributes.has_key?(:'display_name')
        self.display_name = attributes[:'display_name']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end

      if attributes.has_key?(:'_create_user')
        self._create_user = attributes[:'_create_user']
      end

      if attributes.has_key?(:'_protection')
        self._protection = attributes[:'_protection']
      end

      if attributes.has_key?(:'_create_time')
        self._create_time = attributes[:'_create_time']
      end

      if attributes.has_key?(:'_last_modified_time')
        self._last_modified_time = attributes[:'_last_modified_time']
      end

      if attributes.has_key?(:'_last_modified_user')
        self._last_modified_user = attributes[:'_last_modified_user']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'resource_type')
        self.resource_type = attributes[:'resource_type']
      end

      if attributes.has_key?(:'path')
        self.path = attributes[:'path']
      end

      if attributes.has_key?(:'parent_path')
        self.parent_path = attributes[:'parent_path']
      end

      if attributes.has_key?(:'unique_id')
        self.unique_id = attributes[:'unique_id']
      end

      if attributes.has_key?(:'relative_path')
        self.relative_path = attributes[:'relative_path']
      end

      if attributes.has_key?(:'children')
        if (value = attributes[:'children']).is_a?(Array)
          self.children = value
        end
      end

      if attributes.has_key?(:'overridden')
        self.overridden = attributes[:'overridden']
      else
        self.overridden = false
      end

      if attributes.has_key?(:'marked_for_delete')
        self.marked_for_delete = attributes[:'marked_for_delete']
      else
        self.marked_for_delete = false
      end

      if attributes.has_key?(:'subnets')
        if (value = attributes[:'subnets']).is_a?(Array)
          self.subnets = value
        end
      end

      if attributes.has_key?(:'ospf')
        self.ospf = attributes[:'ospf']
      end

      if attributes.has_key?(:'edge_cluster_member_index')
        self.edge_cluster_member_index = attributes[:'edge_cluster_member_index']
      end

      if attributes.has_key?(:'urpf_mode')
        self.urpf_mode = attributes[:'urpf_mode']
      else
        self.urpf_mode = 'STRICT'
      end

      if attributes.has_key?(:'proxy_arp_filters')
        if (value = attributes[:'proxy_arp_filters']).is_a?(Array)
          self.proxy_arp_filters = value
        end
      end

      if attributes.has_key?(:'edge_path')
        self.edge_path = attributes[:'edge_path']
      end

      if attributes.has_key?(:'segment_path')
        self.segment_path = attributes[:'segment_path']
      end

      if attributes.has_key?(:'multicast')
        self.multicast = attributes[:'multicast']
      end

      if attributes.has_key?(:'ls_id')
        self.ls_id = attributes[:'ls_id']
      end

      if attributes.has_key?(:'ipv6_profile_paths')
        if (value = attributes[:'ipv6_profile_paths']).is_a?(Array)
          self.ipv6_profile_paths = value
        end
      end

      if attributes.has_key?(:'igmp_local_join_groups')
        if (value = attributes[:'igmp_local_join_groups']).is_a?(Array)
          self.igmp_local_join_groups = value
        end
      end

      if attributes.has_key?(:'access_vlan_id')
        self.access_vlan_id = attributes[:'access_vlan_id']
      end

      if attributes.has_key?(:'mtu')
        self.mtu = attributes[:'mtu']
      end

      if attributes.has_key?(:'type')
        self.type = attributes[:'type']
      else
        self.type = 'EXTERNAL'
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@display_name.nil? && @display_name.to_s.length > 255
        invalid_properties.push('invalid value for "display_name", the character length must be smaller than or equal to 255.')
      end

      if !@description.nil? && @description.to_s.length > 1024
        invalid_properties.push('invalid value for "description", the character length must be smaller than or equal to 1024.')
      end

      if @subnets.nil?
        invalid_properties.push('invalid value for "subnets", subnets cannot be nil.')
      end

      if !@edge_cluster_member_index.nil? && @edge_cluster_member_index < 0
        invalid_properties.push('invalid value for "edge_cluster_member_index", must be greater than or equal to 0.')
      end

      if !@mtu.nil? && @mtu < 64
        invalid_properties.push('invalid value for "mtu", must be greater than or equal to 64.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@display_name.nil? && @display_name.to_s.length > 255
      return false if !@description.nil? && @description.to_s.length > 1024
      return false if @subnets.nil?
      return false if !@edge_cluster_member_index.nil? && @edge_cluster_member_index < 0
      urpf_mode_validator = EnumAttributeValidator.new('String', ['NONE', 'STRICT'])
      return false unless urpf_mode_validator.valid?(@urpf_mode)
      return false if !@mtu.nil? && @mtu < 64
      type_validator = EnumAttributeValidator.new('String', ['EXTERNAL', 'SERVICE', 'LOOPBACK'])
      return false unless type_validator.valid?(@type)
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] display_name Value to be assigned
    def display_name=(display_name)
      if !display_name.nil? && display_name.to_s.length > 255
        fail ArgumentError, 'invalid value for "display_name", the character length must be smaller than or equal to 255.'
      end

      @display_name = display_name
    end

    # Custom attribute writer method with validation
    # @param [Object] description Value to be assigned
    def description=(description)
      if !description.nil? && description.to_s.length > 1024
        fail ArgumentError, 'invalid value for "description", the character length must be smaller than or equal to 1024.'
      end

      @description = description
    end

    # Custom attribute writer method with validation
    # @param [Object] edge_cluster_member_index Value to be assigned
    def edge_cluster_member_index=(edge_cluster_member_index)
      if !edge_cluster_member_index.nil? && edge_cluster_member_index < 0
        fail ArgumentError, 'invalid value for "edge_cluster_member_index", must be greater than or equal to 0.'
      end

      @edge_cluster_member_index = edge_cluster_member_index
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] urpf_mode Object to be assigned
    def urpf_mode=(urpf_mode)
      validator = EnumAttributeValidator.new('String', ['NONE', 'STRICT'])
      unless validator.valid?(urpf_mode)
        fail ArgumentError, 'invalid value for "urpf_mode", must be one of #{validator.allowable_values}.'
      end
      @urpf_mode = urpf_mode
    end

    # Custom attribute writer method with validation
    # @param [Object] mtu Value to be assigned
    def mtu=(mtu)
      if !mtu.nil? && mtu < 64
        fail ArgumentError, 'invalid value for "mtu", must be greater than or equal to 64.'
      end

      @mtu = mtu
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] type Object to be assigned
    def type=(type)
      validator = EnumAttributeValidator.new('String', ['EXTERNAL', 'SERVICE', 'LOOPBACK'])
      unless validator.valid?(type)
        fail ArgumentError, 'invalid value for "type", must be one of #{validator.allowable_values}.'
      end
      @type = type
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          _self == o._self &&
          _links == o._links &&
          _schema == o._schema &&
          _revision == o._revision &&
          _system_owned == o._system_owned &&
          display_name == o.display_name &&
          description == o.description &&
          tags == o.tags &&
          _create_user == o._create_user &&
          _protection == o._protection &&
          _create_time == o._create_time &&
          _last_modified_time == o._last_modified_time &&
          _last_modified_user == o._last_modified_user &&
          id == o.id &&
          resource_type == o.resource_type &&
          path == o.path &&
          parent_path == o.parent_path &&
          unique_id == o.unique_id &&
          relative_path == o.relative_path &&
          children == o.children &&
          overridden == o.overridden &&
          marked_for_delete == o.marked_for_delete &&
          subnets == o.subnets &&
          ospf == o.ospf &&
          edge_cluster_member_index == o.edge_cluster_member_index &&
          urpf_mode == o.urpf_mode &&
          proxy_arp_filters == o.proxy_arp_filters &&
          edge_path == o.edge_path &&
          segment_path == o.segment_path &&
          multicast == o.multicast &&
          ls_id == o.ls_id &&
          ipv6_profile_paths == o.ipv6_profile_paths &&
          igmp_local_join_groups == o.igmp_local_join_groups &&
          access_vlan_id == o.access_vlan_id &&
          mtu == o.mtu &&
          type == o.type
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [_self, _links, _schema, _revision, _system_owned, display_name, description, tags, _create_user, _protection, _create_time, _last_modified_time, _last_modified_user, id, resource_type, path, parent_path, unique_id, relative_path, children, overridden, marked_for_delete, subnets, ospf, edge_cluster_member_index, urpf_mode, proxy_arp_filters, edge_path, segment_path, multicast, ls_id, ipv6_profile_paths, igmp_local_join_groups, access_vlan_id, mtu, type].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXTPolicy.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
