=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module NSXTPolicy
  # Tier-0 vrf configuration.
  class Tier0VrfConfig
    # Route targets.
    attr_accessor :route_targets

    # L3 VNI associated with the VRF for overlay traffic of ethernet virtual private network (EVPN). It must be unique and available from the VNI pool defined for EVPN service. It is required for VRF to participate in the EVPN service in INLINE mode. 
    attr_accessor :evpn_transit_vni

    # Default tier0 path. Cannot be modified after realization. 
    attr_accessor :tier0_path

    # Route distinguisher with format in IPAddress:<number> or ASN:<number>.
    attr_accessor :route_distinguisher

    # It is required for VRF to participate in the EVPN service in ROUTE_SERVER mode. 
    attr_accessor :evpn_l2_vni_config

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'route_targets' => :'route_targets',
        :'evpn_transit_vni' => :'evpn_transit_vni',
        :'tier0_path' => :'tier0_path',
        :'route_distinguisher' => :'route_distinguisher',
        :'evpn_l2_vni_config' => :'evpn_l2_vni_config'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'route_targets' => :'Array<VrfRouteTargets>',
        :'evpn_transit_vni' => :'Integer',
        :'tier0_path' => :'String',
        :'route_distinguisher' => :'String',
        :'evpn_l2_vni_config' => :'VrfEvpnL2VniConfig'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'route_targets')
        if (value = attributes[:'route_targets']).is_a?(Array)
          self.route_targets = value
        end
      end

      if attributes.has_key?(:'evpn_transit_vni')
        self.evpn_transit_vni = attributes[:'evpn_transit_vni']
      end

      if attributes.has_key?(:'tier0_path')
        self.tier0_path = attributes[:'tier0_path']
      end

      if attributes.has_key?(:'route_distinguisher')
        self.route_distinguisher = attributes[:'route_distinguisher']
      end

      if attributes.has_key?(:'evpn_l2_vni_config')
        self.evpn_l2_vni_config = attributes[:'evpn_l2_vni_config']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @tier0_path.nil?
        invalid_properties.push('invalid value for "tier0_path", tier0_path cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @tier0_path.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          route_targets == o.route_targets &&
          evpn_transit_vni == o.evpn_transit_vni &&
          tier0_path == o.tier0_path &&
          route_distinguisher == o.route_distinguisher &&
          evpn_l2_vni_config == o.evpn_l2_vni_config
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [route_targets, evpn_transit_vni, tier0_path, route_distinguisher, evpn_l2_vni_config].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXTPolicy.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
