=begin
#NSX-T Data Center Policy API

#VMware NSX-T Data Center Policy REST API

OpenAPI spec version: 3.1.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module NSXTPolicy
  # Tier-1 instance configuration. 
  class Tier1
    # Link to this resource
    attr_accessor :_self

    # The server will populate this field when returing the resource. Ignored on PUT and POST.
    attr_accessor :_links

    # Schema for this resource
    attr_accessor :_schema

    # The _revision property describes the current revision of the resource. To prevent clients from overwriting each other's changes, PUT operations must include the current _revision of the resource, which clients should obtain by issuing a GET operation. If the _revision provided in a PUT request is missing or stale, the operation will be rejected.
    attr_accessor :_revision

    # Indicates system owned resource
    attr_accessor :_system_owned

    # Defaults to ID if not set
    attr_accessor :display_name

    # Description of this resource
    attr_accessor :description

    # Opaque identifiers meaningful to the API user
    attr_accessor :tags

    # ID of the user who created this resource
    attr_accessor :_create_user

    # Protection status is one of the following: PROTECTED - the client who retrieved the entity is not allowed             to modify it. NOT_PROTECTED - the client who retrieved the entity is allowed                 to modify it REQUIRE_OVERRIDE - the client who retrieved the entity is a super                    user and can modify it, but only when providing                    the request header X-Allow-Overwrite=true. UNKNOWN - the _protection field could not be determined for this           entity. 
    attr_accessor :_protection

    # Timestamp of resource creation
    attr_accessor :_create_time

    # Timestamp of last modification
    attr_accessor :_last_modified_time

    # ID of the user who last modified this resource
    attr_accessor :_last_modified_user

    # Unique identifier of this resource
    attr_accessor :id

    # The type of this resource.
    attr_accessor :resource_type

    # Absolute path of this object
    attr_accessor :path

    # Path of its parent
    attr_accessor :parent_path

    # This is a UUID generated by the GM/LM to uniquely identify entites in a federated environment. For entities that are stretched across multiple sites, the same ID will be used on all the stretched sites. 
    attr_accessor :unique_id

    # Path relative from its parent
    attr_accessor :relative_path

    # subtree for this type within policy tree containing nested elements. 
    attr_accessor :children

    # Global intent objects cannot be modified by the user. However, certain global intent objects can be overridden locally by use of this property. In such cases, the overridden local values take precedence over the globally defined values for the properties. 
    attr_accessor :overridden

    # Intent objects are not directly deleted from the system when a delete is invoked on them. They are marked for deletion and only when all the realized entities for that intent object gets deleted, the intent object is deleted. Objects that are marked for deletion are not returned in GET call. One can use the search API to get these objects. 
    attr_accessor :marked_for_delete

    # Additional config for federation.
    attr_accessor :federation_config

    # Indicates if logging should be enabled for the default whitelisting rule. This field is deprecated and recommended to change Rule logging field. Note that this field is not synchronized with default logging field. 
    attr_accessor :default_rule_logging

    # Route advertisement rules and filtering
    attr_accessor :route_advertisement_rules

    # Supports edge node allocation at different sizes for routing and load balancer service to meet performance and scalability requirements.   ROUTING: Allocate edge node to provide routing services.   LB_SMALL, LB_MEDIUM, LB_LARGE, LB_XLARGE: Specify size of load balancer service that will be configured on TIER1 gateway. 
    attr_accessor :pool_allocation

    # Specify Tier-1 connectivity to Tier-0 instance. 
    attr_accessor :tier0_path

    # Flag to enable standby service router relocation. Standby relocation is not enabled until edge cluster is configured for Tier1. 
    attr_accessor :enable_standby_relocation

    # Disable or enable gateway fiewall.
    attr_accessor :disable_firewall

    # Determines the behavior when a Tier-1 instance restarts after a failure. If set to PREEMPTIVE, the preferred node will take over, even if it causes another failure. If set to NON_PREEMPTIVE, then the instance that restarted will remain secondary. Only applicable when edge cluster is configured in Tier1 locale-service. 
    attr_accessor :failover_mode

    # Maximum number of ARP entries per transport node. 
    attr_accessor :arp_limit

    # This field is deprecated and recommended to change Rule action field. Note that this field is not synchornied with default rule field. 
    attr_accessor :force_whitelisting

    # Inter site routing configuration when the gateway is streched.
    attr_accessor :intersite_config

    # DHCP configuration for Segments connected to Tier-1. DHCP service is enabled in relay mode. 
    attr_accessor :dhcp_config_paths

    # Configuration IPv6 NDRA and DAD profiles. Either or both NDRA and/or DAD profiles can be configured. 
    attr_accessor :ipv6_profile_paths

    # QoS Profile configuration for Tier1 router link connected to Tier0 gateway. 
    attr_accessor :qos_profile

    # Tier1 connectivity type for reference. Property value is not validated with Tier1 configuration.   ROUTED: Tier1 is connected to Tier0 gateway and routing is enabled.   ISOLATED: Tier1 is not connected to any Tier0 gateway.   NATTED: Tier1 is in ROUTED type with NAT configured locally. 
    attr_accessor :type

    # Enable different types of route advertisements. When not specified, routes to IPSec VPN local-endpoint subnets (TIER1_IPSEC_LOCAL_ENDPOINT) are automatically advertised. 
    attr_accessor :route_advertisement_types

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'_self' => :'_self',
        :'_links' => :'_links',
        :'_schema' => :'_schema',
        :'_revision' => :'_revision',
        :'_system_owned' => :'_system_owned',
        :'display_name' => :'display_name',
        :'description' => :'description',
        :'tags' => :'tags',
        :'_create_user' => :'_create_user',
        :'_protection' => :'_protection',
        :'_create_time' => :'_create_time',
        :'_last_modified_time' => :'_last_modified_time',
        :'_last_modified_user' => :'_last_modified_user',
        :'id' => :'id',
        :'resource_type' => :'resource_type',
        :'path' => :'path',
        :'parent_path' => :'parent_path',
        :'unique_id' => :'unique_id',
        :'relative_path' => :'relative_path',
        :'children' => :'children',
        :'overridden' => :'overridden',
        :'marked_for_delete' => :'marked_for_delete',
        :'federation_config' => :'federation_config',
        :'default_rule_logging' => :'default_rule_logging',
        :'route_advertisement_rules' => :'route_advertisement_rules',
        :'pool_allocation' => :'pool_allocation',
        :'tier0_path' => :'tier0_path',
        :'enable_standby_relocation' => :'enable_standby_relocation',
        :'disable_firewall' => :'disable_firewall',
        :'failover_mode' => :'failover_mode',
        :'arp_limit' => :'arp_limit',
        :'force_whitelisting' => :'force_whitelisting',
        :'intersite_config' => :'intersite_config',
        :'dhcp_config_paths' => :'dhcp_config_paths',
        :'ipv6_profile_paths' => :'ipv6_profile_paths',
        :'qos_profile' => :'qos_profile',
        :'type' => :'type',
        :'route_advertisement_types' => :'route_advertisement_types'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'_self' => :'SelfResourceLink',
        :'_links' => :'Array<ResourceLink>',
        :'_schema' => :'String',
        :'_revision' => :'Integer',
        :'_system_owned' => :'BOOLEAN',
        :'display_name' => :'String',
        :'description' => :'String',
        :'tags' => :'Array<Tag>',
        :'_create_user' => :'String',
        :'_protection' => :'String',
        :'_create_time' => :'Integer',
        :'_last_modified_time' => :'Integer',
        :'_last_modified_user' => :'String',
        :'id' => :'String',
        :'resource_type' => :'String',
        :'path' => :'String',
        :'parent_path' => :'String',
        :'unique_id' => :'String',
        :'relative_path' => :'String',
        :'children' => :'Array<ChildPolicyConfigResource>',
        :'overridden' => :'BOOLEAN',
        :'marked_for_delete' => :'BOOLEAN',
        :'federation_config' => :'FederationGatewayConfig',
        :'default_rule_logging' => :'BOOLEAN',
        :'route_advertisement_rules' => :'Array<RouteAdvertisementRule>',
        :'pool_allocation' => :'String',
        :'tier0_path' => :'String',
        :'enable_standby_relocation' => :'BOOLEAN',
        :'disable_firewall' => :'BOOLEAN',
        :'failover_mode' => :'String',
        :'arp_limit' => :'Integer',
        :'force_whitelisting' => :'BOOLEAN',
        :'intersite_config' => :'IntersiteGatewayConfig',
        :'dhcp_config_paths' => :'Array<String>',
        :'ipv6_profile_paths' => :'Array<String>',
        :'qos_profile' => :'GatewayQosProfileConfig',
        :'type' => :'String',
        :'route_advertisement_types' => :'Array<String>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'_self')
        self._self = attributes[:'_self']
      end

      if attributes.has_key?(:'_links')
        if (value = attributes[:'_links']).is_a?(Array)
          self._links = value
        end
      end

      if attributes.has_key?(:'_schema')
        self._schema = attributes[:'_schema']
      end

      if attributes.has_key?(:'_revision')
        self._revision = attributes[:'_revision']
      end

      if attributes.has_key?(:'_system_owned')
        self._system_owned = attributes[:'_system_owned']
      end

      if attributes.has_key?(:'display_name')
        self.display_name = attributes[:'display_name']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end

      if attributes.has_key?(:'_create_user')
        self._create_user = attributes[:'_create_user']
      end

      if attributes.has_key?(:'_protection')
        self._protection = attributes[:'_protection']
      end

      if attributes.has_key?(:'_create_time')
        self._create_time = attributes[:'_create_time']
      end

      if attributes.has_key?(:'_last_modified_time')
        self._last_modified_time = attributes[:'_last_modified_time']
      end

      if attributes.has_key?(:'_last_modified_user')
        self._last_modified_user = attributes[:'_last_modified_user']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'resource_type')
        self.resource_type = attributes[:'resource_type']
      end

      if attributes.has_key?(:'path')
        self.path = attributes[:'path']
      end

      if attributes.has_key?(:'parent_path')
        self.parent_path = attributes[:'parent_path']
      end

      if attributes.has_key?(:'unique_id')
        self.unique_id = attributes[:'unique_id']
      end

      if attributes.has_key?(:'relative_path')
        self.relative_path = attributes[:'relative_path']
      end

      if attributes.has_key?(:'children')
        if (value = attributes[:'children']).is_a?(Array)
          self.children = value
        end
      end

      if attributes.has_key?(:'overridden')
        self.overridden = attributes[:'overridden']
      else
        self.overridden = false
      end

      if attributes.has_key?(:'marked_for_delete')
        self.marked_for_delete = attributes[:'marked_for_delete']
      else
        self.marked_for_delete = false
      end

      if attributes.has_key?(:'federation_config')
        self.federation_config = attributes[:'federation_config']
      end

      if attributes.has_key?(:'default_rule_logging')
        self.default_rule_logging = attributes[:'default_rule_logging']
      else
        self.default_rule_logging = false
      end

      if attributes.has_key?(:'route_advertisement_rules')
        if (value = attributes[:'route_advertisement_rules']).is_a?(Array)
          self.route_advertisement_rules = value
        end
      end

      if attributes.has_key?(:'pool_allocation')
        self.pool_allocation = attributes[:'pool_allocation']
      else
        self.pool_allocation = 'ROUTING'
      end

      if attributes.has_key?(:'tier0_path')
        self.tier0_path = attributes[:'tier0_path']
      end

      if attributes.has_key?(:'enable_standby_relocation')
        self.enable_standby_relocation = attributes[:'enable_standby_relocation']
      else
        self.enable_standby_relocation = false
      end

      if attributes.has_key?(:'disable_firewall')
        self.disable_firewall = attributes[:'disable_firewall']
      else
        self.disable_firewall = false
      end

      if attributes.has_key?(:'failover_mode')
        self.failover_mode = attributes[:'failover_mode']
      else
        self.failover_mode = 'NON_PREEMPTIVE'
      end

      if attributes.has_key?(:'arp_limit')
        self.arp_limit = attributes[:'arp_limit']
      end

      if attributes.has_key?(:'force_whitelisting')
        self.force_whitelisting = attributes[:'force_whitelisting']
      else
        self.force_whitelisting = false
      end

      if attributes.has_key?(:'intersite_config')
        self.intersite_config = attributes[:'intersite_config']
      end

      if attributes.has_key?(:'dhcp_config_paths')
        if (value = attributes[:'dhcp_config_paths']).is_a?(Array)
          self.dhcp_config_paths = value
        end
      end

      if attributes.has_key?(:'ipv6_profile_paths')
        if (value = attributes[:'ipv6_profile_paths']).is_a?(Array)
          self.ipv6_profile_paths = value
        end
      end

      if attributes.has_key?(:'qos_profile')
        self.qos_profile = attributes[:'qos_profile']
      end

      if attributes.has_key?(:'type')
        self.type = attributes[:'type']
      end

      if attributes.has_key?(:'route_advertisement_types')
        if (value = attributes[:'route_advertisement_types']).is_a?(Array)
          self.route_advertisement_types = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@display_name.nil? && @display_name.to_s.length > 255
        invalid_properties.push('invalid value for "display_name", the character length must be smaller than or equal to 255.')
      end

      if !@description.nil? && @description.to_s.length > 1024
        invalid_properties.push('invalid value for "description", the character length must be smaller than or equal to 1024.')
      end

      if !@arp_limit.nil? && @arp_limit > 50000
        invalid_properties.push('invalid value for "arp_limit", must be smaller than or equal to 50000.')
      end

      if !@arp_limit.nil? && @arp_limit < 5000
        invalid_properties.push('invalid value for "arp_limit", must be greater than or equal to 5000.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@display_name.nil? && @display_name.to_s.length > 255
      return false if !@description.nil? && @description.to_s.length > 1024
      pool_allocation_validator = EnumAttributeValidator.new('String', ['ROUTING', 'LB_SMALL', 'LB_MEDIUM', 'LB_LARGE', 'LB_XLARGE'])
      return false unless pool_allocation_validator.valid?(@pool_allocation)
      failover_mode_validator = EnumAttributeValidator.new('String', ['PREEMPTIVE', 'NON_PREEMPTIVE'])
      return false unless failover_mode_validator.valid?(@failover_mode)
      return false if !@arp_limit.nil? && @arp_limit > 50000
      return false if !@arp_limit.nil? && @arp_limit < 5000
      type_validator = EnumAttributeValidator.new('String', ['ROUTED', 'ISOLATED', 'NATTED'])
      return false unless type_validator.valid?(@type)
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] display_name Value to be assigned
    def display_name=(display_name)
      if !display_name.nil? && display_name.to_s.length > 255
        fail ArgumentError, 'invalid value for "display_name", the character length must be smaller than or equal to 255.'
      end

      @display_name = display_name
    end

    # Custom attribute writer method with validation
    # @param [Object] description Value to be assigned
    def description=(description)
      if !description.nil? && description.to_s.length > 1024
        fail ArgumentError, 'invalid value for "description", the character length must be smaller than or equal to 1024.'
      end

      @description = description
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] pool_allocation Object to be assigned
    def pool_allocation=(pool_allocation)
      validator = EnumAttributeValidator.new('String', ['ROUTING', 'LB_SMALL', 'LB_MEDIUM', 'LB_LARGE', 'LB_XLARGE'])
      unless validator.valid?(pool_allocation)
        fail ArgumentError, 'invalid value for "pool_allocation", must be one of #{validator.allowable_values}.'
      end
      @pool_allocation = pool_allocation
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] failover_mode Object to be assigned
    def failover_mode=(failover_mode)
      validator = EnumAttributeValidator.new('String', ['PREEMPTIVE', 'NON_PREEMPTIVE'])
      unless validator.valid?(failover_mode)
        fail ArgumentError, 'invalid value for "failover_mode", must be one of #{validator.allowable_values}.'
      end
      @failover_mode = failover_mode
    end

    # Custom attribute writer method with validation
    # @param [Object] arp_limit Value to be assigned
    def arp_limit=(arp_limit)
      if !arp_limit.nil? && arp_limit > 50000
        fail ArgumentError, 'invalid value for "arp_limit", must be smaller than or equal to 50000.'
      end

      if !arp_limit.nil? && arp_limit < 5000
        fail ArgumentError, 'invalid value for "arp_limit", must be greater than or equal to 5000.'
      end

      @arp_limit = arp_limit
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] type Object to be assigned
    def type=(type)
      validator = EnumAttributeValidator.new('String', ['ROUTED', 'ISOLATED', 'NATTED'])
      unless validator.valid?(type)
        fail ArgumentError, 'invalid value for "type", must be one of #{validator.allowable_values}.'
      end
      @type = type
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          _self == o._self &&
          _links == o._links &&
          _schema == o._schema &&
          _revision == o._revision &&
          _system_owned == o._system_owned &&
          display_name == o.display_name &&
          description == o.description &&
          tags == o.tags &&
          _create_user == o._create_user &&
          _protection == o._protection &&
          _create_time == o._create_time &&
          _last_modified_time == o._last_modified_time &&
          _last_modified_user == o._last_modified_user &&
          id == o.id &&
          resource_type == o.resource_type &&
          path == o.path &&
          parent_path == o.parent_path &&
          unique_id == o.unique_id &&
          relative_path == o.relative_path &&
          children == o.children &&
          overridden == o.overridden &&
          marked_for_delete == o.marked_for_delete &&
          federation_config == o.federation_config &&
          default_rule_logging == o.default_rule_logging &&
          route_advertisement_rules == o.route_advertisement_rules &&
          pool_allocation == o.pool_allocation &&
          tier0_path == o.tier0_path &&
          enable_standby_relocation == o.enable_standby_relocation &&
          disable_firewall == o.disable_firewall &&
          failover_mode == o.failover_mode &&
          arp_limit == o.arp_limit &&
          force_whitelisting == o.force_whitelisting &&
          intersite_config == o.intersite_config &&
          dhcp_config_paths == o.dhcp_config_paths &&
          ipv6_profile_paths == o.ipv6_profile_paths &&
          qos_profile == o.qos_profile &&
          type == o.type &&
          route_advertisement_types == o.route_advertisement_types
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [_self, _links, _schema, _revision, _system_owned, display_name, description, tags, _create_user, _protection, _create_time, _last_modified_time, _last_modified_user, id, resource_type, path, parent_path, unique_id, relative_path, children, overridden, marked_for_delete, federation_config, default_rule_logging, route_advertisement_rules, pool_allocation, tier0_path, enable_standby_relocation, disable_firewall, failover_mode, arp_limit, force_whitelisting, intersite_config, dhcp_config_paths, ipv6_profile_paths, qos_profile, type, route_advertisement_types].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXTPolicy.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
